<?php
namespace App\Exports;
use App\user;

use Illuminate\Contracts\View\View;
use Maatwebsite\Excel\Concerns\FromView;
use Illuminate\Support\Facades\DB;
use Maatwebsite\Excel\Concerns\WithDrawings;
use PhpOffice\PhpSpreadsheet\Worksheet\Drawing;
use Maatwebsite\Excel\Concerns\ShouldAutoSize;
use Maatwebsite\Excel\Concerns\WithCustomStartCell;
use Maatwebsite\Excel\Concerns\WithEvents;
use Maatwebsite\Excel\Events\AfterSheet;

class CompanyCreditExport implements FromView,WithDrawings,ShouldAutoSize,WithCustomStartCell,WithEvents
   {
  
	  protected $creditnote;

	  
	  function __construct($creditnote)
	  {
        $this->creditnote = $creditnote;
       }
	   
	  public function drawings()
    {
        $drawing = new Drawing();
        $drawing->setName('Logo');
        $drawing->setDescription('This is my logo');
        $drawing->setPath(public_path('elite.jpeg'));
        $drawing->setHeight(87);
        $drawing->setCoordinates('A1');

        return $drawing;
    }
	
	public function startCell(): string
    {
        return 'A6';

    }
	
 public function registerEvents(): array
    {
        return [
            AfterSheet::class=> function(AfterSheet $event) {
                $event-> sheet->mergeCells('A1:E5');
                   
                $event->sheet->getStyle('A6:K6')->applyFromArray ([
				
                    'font' => [
                        'name'      =>  'Calibri',
                        'size'      =>  13,
                        'bold'      =>  true,
                        'color' => ['argb' => '#000000'],
                    ],
					'fill' => [
                        'fillType' => \PhpOffice\PhpSpreadsheet\Style\Fill::FILL_SOLID,
                        'startColor' => [
                            'rgb' => 'dff0d8',
                         ],           
                    ]
				 
				    
				]); 
				
				$event->sheet->getStyle('A10:K10')->applyFromArray ([
				
                    'font' => [
                        'name'      =>  'Calibri',
                        'size'      =>  13,
                        'bold'      =>  true,
                        'color' => ['argb' => '#000000'],
                    ],
					'fill' => [
                        'fillType' => \PhpOffice\PhpSpreadsheet\Style\Fill::FILL_SOLID,
                        'startColor' => [
                            'rgb' => 'dff0d8',
                         ],           
                    ]
				 
				    
				]);
				 
            
	 }
        ];
    }
	
	 public function view(): View
    {
		
       $result = DB::table('tbl_company_credit_note_header as cc')
		         ->leftjoin('tbl_customer','cc.customer','=','tbl_customer.id')
		         ->leftjoin('tbl_warehouse','cc.warehouse','=','tbl_warehouse.id')
		         ->leftjoin('tbl_currency_type','cc.currency','=','tbl_currency_type.id')
		         ->leftjoin('tbl_company_delivery_header','cc.company_credit_delivery_number','=','tbl_company_delivery_header.id')
				 ->select('tbl_customer.customer_code','tbl_customer.customer_name','tbl_company_delivery_header.company_delivery_number','tbl_warehouse.warehouse_code','tbl_warehouse.warehouse_name','tbl_currency_type.currency_notation','cc.company_credit_note_number','cc.delevary_date','cc.total_delivery_value')
		  
                 
				  ->where('cc.id','=',$this->creditnote)
				 ->get();
				 
				 

			 
			$get_data_details =DB::table('tbl_company_credit_note_details')	  
		  ->leftJoin('tbl_material_master','tbl_company_credit_note_details.material_id', '=', 'tbl_material_master.id')
		  ->leftJoin('tbl_unit_of_measurement', 'tbl_company_credit_note_details.uom', '=', 'tbl_unit_of_measurement.id')
		  ->leftJoin('tbl_reason_type', 'tbl_company_credit_note_details.resion', '=', 'tbl_reason_type.id') 
         ->select('tbl_material_master.material_name', 'tbl_material_master.material_code as mat_code','tbl_unit_of_measurement.unit_notation','tbl_reason_type.reasion_type','tbl_company_credit_note_details.quantity','tbl_company_credit_note_details.unite_price','tbl_company_credit_note_details.total')
		 
	    ->where('tbl_company_credit_note_details.header_id','=',$this->creditnote)
	   ->get()
	   ->all();
	  // dd($get_data_details);
	 return view('export.company_credit_export', 
		                  ['header' => $result],
		                  ['details' => $get_data_details]
						  
		            );
  
  }
  }
