<?php
namespace App\Exports;
use App\user;
use Maatwebsite\Excel\Concerns\FromCollection;
use Maatwebsite\Excel\Concerns\WithHeadings;
use Maatwebsite\Excel\Concerns\ShouldAutoSize;
use Illuminate\Support\Facades\DB;
class MaterialPerformanceExport implements FromCollection,WithHeadings,ShouldAutoSize
{
	
	protected $year;
	protected $month;

    function __construct($year,$month) {
        $this->year = $year;
        $this->month = $month;
	}
	public function headings():array{
		return[
		'Material Name',
		'Total Qty',
		'Total Sales',
		];
	}  
    /**
    * @return \Illuminate\Support\Collection
    */
    public function collection() 
	{
	 if($this->month=='all')	
	  {
		  $get_data1 = DB::table('tbl_route_invoice_details')
			->leftJoin('tbl_material_master', 'tbl_route_invoice_details.material_code', '=', 'tbl_material_master.id')
		     ->select(DB::raw('sum(tbl_route_invoice_details.total) as total_invoice'),DB::raw('sum(tbl_route_invoice_details.base_qty) as qty'),'tbl_material_master.material_name as material_name','tbl_material_master.material_code')
			->orderBy(DB::raw('sum(tbl_route_invoice_details.total)'),'desc')
			->groupBy('tbl_route_invoice_details.material_code') 
			->whereYear('tbl_route_invoice_details.created_at', $this->year)
			->get()->all();
 
	  }
	  else
	  {
	     $get_data1 = DB::table('tbl_route_invoice_details')
			->leftJoin('tbl_material_master', 'tbl_route_invoice_details.material_code', '=', 'tbl_material_master.id')
		     ->select(DB::raw('sum(tbl_route_invoice_details.total) as total_invoice'),DB::raw('sum(tbl_route_invoice_details.base_qty) as qty'),'tbl_material_master.material_name as material_name','tbl_material_master.material_code')
			->orderBy(DB::raw('sum(tbl_route_invoice_details.total)'),'desc')
			->groupBy('tbl_route_invoice_details.material_code') 
			->whereYear('tbl_route_invoice_details.created_at', $this->year)
			->whereMonth('tbl_route_invoice_details.created_at', $this->month)
			->get()->all();
			 
		}
		
    return collect($get_data1);
   }
}
