<?php
namespace App\Exports;
use App\user;
use Maatwebsite\Excel\Concerns\FromCollection;
use Maatwebsite\Excel\Concerns\WithHeadings;
use Maatwebsite\Excel\Concerns\WithDrawings;
use Illuminate\Support\Facades\DB;
use PhpOffice\PhpSpreadsheet\Worksheet\Drawing;
use Maatwebsite\Excel\Concerns\WithCustomStartCell;
use Maatwebsite\Excel\Concerns\WithEvents;
use Maatwebsite\Excel\Events\AfterSheet;
use Maatwebsite\Excel\Concerns\ShouldAutoSize;

class MenuSubmenuExport implements FromCollection,WithHeadings,WithDrawings,WithCustomStartCell,WithEvents,ShouldAutoSize

  {
	 protected $menu_id; 
	 protected $submenu_id;
	

    function __construct($menu_id,$submenu_id) {
	    $this->menu_id = $menu_id;
		$this->submenu_id = $submenu_id;
        
	}
	
	public function registerEvents(): array
    {
		 
		//font style	
		$styleArray1 = [
						'font' => [
							'bold' => true,
							]
						];
		
		//column  text alignment
		 $styleArray2 = array(
			'alignment' => array(
				'horizontal' => \PhpOffice\PhpSpreadsheet\Style\Alignment::HORIZONTAL_CENTER,
				 )
		);				
		
		//$styleArray3 used for vertical alignment 
		$styleArray3 = array(
			'alignment' => array(
				'vertical' => \PhpOffice\PhpSpreadsheet\Style\Alignment::VERTICAL_CENTER,
				 )
		);
		

		$styleArray4 = array(
						'fill' => [
        'fillType' => \PhpOffice\PhpSpreadsheet\Style\Fill::FILL_GRADIENT_LINEAR,
        'startColor' => [
        'argb' => 'FFA0A0A0',
        ],
        'endColor' => [
            'argb' => 'FFFFFFFF',
        ]]
					);
		
		$styleArray5 = array(
						'fill' => [
        'fillType' => \PhpOffice\PhpSpreadsheet\Style\Fill::FILL_SOLID,
        
        'startColor' => [
            'argb' => 'E0E0E0',
        ]]);
		
		
		
       return [
            AfterSheet::class => function(AfterSheet $event) use ($styleArray1, $styleArray2, 
            $styleArray3, $styleArray4 , $styleArray5)
			{
                		$cellRange = 'A1:C1'; // All headers
						 $event-> sheet->mergeCells('A1:A3');
                		$event->sheet->getDelegate()->getStyle($cellRange)->getFont()->setSize(13);
				  
							
							//used for making bold
				$event->getSheet()->getDelegate()->getStyle('A4:BN4')->applyFromArray($styleArray1);
				 
				 
						//text center columns...
				$event ->sheet->getStyle('A1:BN1700')->applyFromArray($styleArray2);
			 
			$event ->sheet->getStyle('A4:BN4')->applyFromArray($styleArray3);  //headings vertical alignment 
						 
							

		    },
        ];
    }
	
	
	public function headings():array{
		if($this->menu_id==5 && $this->submenu_id==48)
		{
		return[
		'Client Code',
		'Client',
		'Country Code',
		'Country',
		'Max UOM On Company level',
		'Status'
	   ];
      }
	  else if($this->menu_id==5 && $this->submenu_id==51)
	  {
		return[
		'Company Code',
		'Company',
		'Company Type Code',
		'Company Type',
		'Currency Code',
		'Currency',
		'Country Code',
		'Country',
		'City Code', 
		'City',
		'Address',
		'P.O Box Number',
		'Email Number',
		'Contact No',
		'Status'
	   ];  
	  }
	  
	  
	  else if($this->menu_id==5 && $this->submenu_id==54)  
	  {
		  return[
		
		'Customer Type Code',
		'Customer Type',
		'Customer Category Code',
		'Customer Category',
		'Customer Code',
		'Customer Name',
		'Tax Registration No.',
		'Email',
		'Contact No.',
		'ERP Customer',
		'Region Code',
		'Region',
		'Subregion Code',
		'Subregion',
		'Route Code',
		'Route',
		'Trading Center Code',
		'Trading Center',
		'Credit Limit',
		'Credit Days',
		'Credit Balance',
		'Payment Term Code',
		'Payment Term',
		'Bank Account Name1',
		'Bank Account Number1',
		'Bank Branch1',
		'Bank Account Name2',
		'Bank Account Number2',
		'Bank Branch2',
		'Address',
		'Country Code',
		'Country',
		'City Code',
		'City',
		'Latitude',
		'Longtitude',
		'Threshold Frequency',
		'Status',  
	   ];
	}
	else if($this->menu_id==5 && $this->submenu_id==57)
		{
		 return[
		 
		'Vehicle Code',
		'Vehiecle Number',
		'Brand',
		'Vehicle Type Code',
		'Vehicle Type',
		'Capacity',
		'Vehicle Owner',
		'Vehicle Chechis Number',
		'Tank Capacity',
		'Vehicle Mileage',
		'Warehouse Code',
		'Warehouse Name',
		'Erp Asset Code',
		'Status'
	   ];	
		}
		else if($this->menu_id==5 && $this->submenu_id==60)
		{
		  return[
		  'Sales Area Code',
		'Sales Area',
		'Warehouse Code',
		'Warehouse',
		'Region Code',
		'Region',
		'Subregion Code',
		'Subregion',
		'Status'
	   ];	
		}
		else if($this->menu_id==5 && $this->submenu_id==63) 
		{
		   return[
		   'Route Code',
		'Route',
		'Route Description',
		'Sales Area Code',
		'Sales Area',
		'Distibutor Code',
		'Distibutor',
		'Warehouse Code',
		'Warehouse',
		'Vehicle Code',
		'Vehicle',
		'Status'
	   ];	
		}
		else if($this->menu_id==5 && $this->submenu_id==66)
		{
		  return[
		'Salesman Type Code',
		'Salesman Type Name',
		'Salesman Code',
		'Salesman',
		'Salesman Password',
		'Contact Number',
		'ERP Employee Code',
		'Route Code',
		'Route',
		'Warehouse Code',
		'Warehouse',
		'Customer From',
		'Invoice From',
		'Order From',
		'Delivery From',
		'Collection From',
		'Return Order From',
		'Exchange From',
		'Load From',
		'Block From Date',
		'Block To Date',
		'Status',
	   ];		
		}
		else if($this->menu_id==5 && $this->submenu_id==69)
		{
		   return[
		'Material Type',
		'Material Code',
		'Material Name',
		'Material Category Code',
		'Material Category Name',
		'Brand Code',
		'Brand Name',
		'Base UOM Code',
		'Base UOM Name',
		'Unit Price',
		'Barcode',
		'Net Weight',
		'Packing Size',
		'Shelf Life (Days)',
		'Promotional Material',
		'Erp Material Code',
		'Vat',
		'Excise Ammount',
		'UOM',
		'Packing Size',
		'Unit Price',
		'Status',
	   ];	 
		}
		else if($this->menu_id==5 && $this->submenu_id==72)
		{
		   return[
		'Plan Name',
		'Price Apllied On',
		'Valid From',
		'Valid to',
		'Status'
	   ];	 
		}
		else if($this->menu_id==5 && $this->submenu_id==75)
		{
		  return[
		'Bank Code',
		'Bank',
		'Bank A/C Number',
		'Branch',
		'Country Code',
		'Country',
		'City Code',
		'City',
		'Address',
		'Status'
	   ];	 
		} 
		else if($this->menu_id==5 && $this->submenu_id==78)
		{
		 return[
		'Tax Code',
		'Tax Name',
		'Tax Percentage',
		'Tax Ammount',
		'Status'
	   ];	 	
		}
		else if($this->menu_id==5 && $this->submenu_id==81)   
		{
		  return[
		'Discount Code',
		'Discount Name',
		'Discount Percentage',
		'Discount Ammount',
		'Discount On',
		'Distributor Code',
		'Distributor',
		'Customer Type Code',
		'Customer Type Name',
		'Customer Category Code',
		'Customer Category Name',
		'Status',
	   ];	 		
		}
		else if($this->menu_id==5 && $this->submenu_id==84)
		{
		   return[
		'Supplier Type code',
		'Supplier Type Name',
		'Supplier Code',
		'Supplier Name',
		'Tax Registration No.',
		'Supplier Currency Code',
		'Supplier Currency Name',
		'Payment Term Code',
		'Payment Term Name',
		'Country Code',
		'Country Name',
		'City Code',
		'City Name',
		'Address.',
		'Email ID',
		'Contact No.',
		'Bank Account Number',
		'Bank Branch',
		'Bank Name',
		'Bank Address',
		'Bank Code',
		'Erp Supplier Code',
		'Status',
	   ];	 	
		}
		else if($this->menu_id==5 && $this->submenu_id==87)
		{
		  return[
		'Outlet Code',
		'Outlet Name',
		'Contact Person',
		'Contact Number',
		'Country Code',
		'Country Name',
		'City Code',
		'City Name',
		'Address',
		'Distibutor Code',
		'Distibutor',
		'Warehouse Code',
		'Warehouse Name',
		'Status'
	   ];	 		
		}
		else if($this->menu_id==5 && $this->submenu_id==90)   
		{
		  return[
		'Trading Center Code',
		'Trading Name',
		'Route Code',
		'Route Name',
		'Status'  
	   ];	 		
		}
		 else if($this->menu_id==5 && $this->submenu_id==282)
		{
		 return[
		'Material Type Code',
		'Material Type',
		'Material Code',
		'Status'  
	   ];	  	
		}  
		else if($this->menu_id==13 && $this->submenu_id==106)
		{
		 return[
		'company type Code',
		'company type name',
		'Status'
	   ];	 	
		}
		else if($this->menu_id==13 && $this->submenu_id==279)
		{
		 return[
		'Ragne Code',
		'Range',
		'Status'
	   ];	
		}
		 else if($this->menu_id==13 && $this->submenu_id==109)
		{
		  return[
		'Currency Code',
		'Currency Name',
		'Currency Notation',
		'Status'
	   ];		
		}
		else if($this->menu_id==13 && $this->submenu_id==112)
		{
		  return[
		'Country Code',
		'Country Name' ,
		'Status'
		];		
		} 
		else if($this->menu_id==13 && $this->submenu_id==115)
		{
		  return[
		'City Code',
		'City Name',
		'Country Code',
		'Country',
		'Status'
	    ];		
		}
		else if($this->menu_id==13 && $this->submenu_id==118)
		{
		 return[
		'Region Code',
		'Region Name',
		'Status' 
		];	 	
		}	
		else if($this->menu_id==13 && $this->submenu_id==121)
		{
		  return[
		'Subregion Code',
		'Subegion Name' ,
		'Region Code', 
		'Region', 
		'Status'
		];	  	
		}	
		else if($this->menu_id==13 && $this->submenu_id==124)
		{
		  return[
		'Customer Type Code',
		'Customer Type'  ,
		'Status'
		];	
		}
		else if($this->menu_id==13 && $this->submenu_id==127)
		{
		  return[
		'Customer Category Code',
		'Customer Category Name', 
		'Customer Type Code' ,
		'Customer Type' ,
		'Status'
		];	  	
		}
		else if($this->menu_id==13 && $this->submenu_id==163)
		{
		 return[
		'Payment Code',
		'Payment Term', 
		'Condition Type' ,
		'Status'
		];	 	
		}
		else if($this->menu_id==13 && $this->submenu_id==133)
		{
		   return[
		'Vehicle Type Id',
		'Vehicle Type Name',
		'Status' 
		]; 	
		}
		else if($this->menu_id==13 && $this->submenu_id==130)
		{
		  return[
		'Vehicle Brand Code',
		'Vehicle Brand Name' ,
		'Status'
		]; 		
		}
		else if($this->menu_id==13 && $this->submenu_id==145)
		{
		  return[
		'Category Code',
		'Material Type', 
		'Category' ,
		'Status'
		]; 		 	
		}
		else if($this->menu_id==13 && $this->submenu_id==148)
		{
		 return[
		'Brand Code',
		'Brand Name',
		'Material Type',
		'Status'
		]; 		
		}
		else if($this->menu_id==13 && $this->submenu_id==139)
		{
		  return[
		'UOM ID',
		'UOM Name', 
		'Unit Notation',
		'Is Base UOM',
		'Status'
		]; 		
		}
		else if($this->menu_id==13 && $this->submenu_id==136)
		{
		  return[
		'Salesman Type Code',
		'Salesman Type Name',
		'Status'
		]; 		
		}
		else if($this->menu_id==13 && $this->submenu_id==142)
		{
		  return[
		'UOC Code',
		'UOM Code',
		'UOM Name',
		'Alternate Unit',
		'Conversion',
		'Status'
	   ];	 		
		}
		else if($this->menu_id==13 && $this->submenu_id==151)
		{
		  return[
		'Expence Code',
		'Expence Type',
		'Expence Category Code',
		'Expence Category',
		'Status'
	   ];	 		 	
		}
		else if($this->menu_id==13 && $this->submenu_id==154)
		{
		  
		  return[
		'Discount Code', 
		'Discount Plan Name',
		'Status'
	   ];	 		
		}
		else if($this->menu_id==13 && $this->submenu_id==157)
		{
		  return[
		'Target Code', 
		'Target Name',
		'Status'
	   ];	 		
		}
		else if($this->menu_id==13 && $this->submenu_id==160)
		{
		 return[
		'Location Code', 
		'Location Name',
		'Status'
	   ];	 	
		}
		else if($this->menu_id==13 && $this->submenu_id==169)
		{
		 return[
		'Supplier Type Code', 
		'Supplier Type Name',
		'Status'
	   ];	 	
		}
		else if($this->menu_id==13 && $this->submenu_id==186)
		{
		 return[
		'Name', 
		'Parent'
	   ];	  	
		}
		else if($this->menu_id==13 && $this->submenu_id==203)
		{
		  return[
		'Expence Category Code', 
		'Expence Category',
		'Status'
	   ];	  
		}
		else if($this->menu_id==13 && $this->submenu_id==291)
		{
		 return[
		'Name', 
		'Parente' 
	   ];	  
		}
		else if($this->menu_id==13 && $this->submenu_id==296)
		{
		return[
		'Reason Code', 
		'Reason Name' ,
		'Status'
	   ];	  	
		}
		else if($this->menu_id==2 && $this->submenu_id==3)
		{
		 return[
		'Order Number', 
		'Order Date',
		'Customer',
		'Warehouse',
		'Order Value',
		'Status'
	   ];	  		
		}
		else if($this->menu_id==2 && $this->submenu_id==5)
		{
		 return[
		'Delivery Number', 
		'Customer',
		'Warehouse',
		'Delivery Value',
		'Order Number'
	   ];	  	
		}
		else if($this->menu_id==2 && $this->submenu_id==7)
		{
		   return[
		'Invoice Number', 
		'Invoice Date',
		'Customer',
		'Warehouse',
		'Invoice Value',
		'Delivery Number'
	   ];	  	
		}
		else if($this->menu_id==2 && $this->submenu_id==11)
		{
		  return[
		'CN Number', 
		'CN Date',
		'Customer',
		'Warehouse',
		'CN Value',
		'Delivery Number'
	   ];	  	
		} 
		else if($this->menu_id==2 && $this->submenu_id==13)
		{
		 return[
		'Customer Name', 
		'Warehouse Name',
		'Invoice No',
		'Invoice Ammount',
		'Invoice Paid',
		'Invoice Outstanding',
		'Due Date'
	   ];	 	
		}
		else if($this->menu_id==2 && $this->submenu_id==14)
		{
			return[
		'EXP No', 
		'EXP Date',
		'EXP Date',
		'Warehouse',
		'EXP Ammount'
	   ];	  
		}
		else if($this->menu_id==2 && $this->submenu_id==179)
		{
		 return[
		 
		'Date',
		'Reciept No',
		'Distributor',
		'Request Ammount'
	   ];	  	
		}
		else if($this->menu_id==10 && $this->submenu_id==17)
		{
		 return[
		 
		'From Warehouse',
		'To Warehouse',
		'Transfer Date'
	   ];	  	
		}
		else if($this->menu_id==10 && $this->submenu_id==180)
		{
		 return[
		 
		'Warehouse Code',
		'Warehouse Name',
		'Warehouse Type',
		'Distributor Code',
		'Distributor',
		'Region Code',
		'Region',
		'Subregion Code',
		'Subregion',
		'Address',
		'Status'
	   ];	  	
		}
		else if($this->menu_id==10 && $this->submenu_id==185)
		{
		 return[
		'Warehouse Name',
		'Adjustment date',
		'Adjustment Type'
	   ]; 	
		}
		else if($this->menu_id==3 && $this->submenu_id==19)
		{
		 return[
		'Load No.',
		'Route',
		'Salesman Name',
		'Warehouse Name',
		'Load Create',
		'Load Date',
		'Load Total',
		'Status',
	   ]; 	
		}
		else if($this->menu_id==3 && $this->submenu_id==21)
		{
		 return[
		'Salesman Name',
		'Route',
		'Warehouse Name',
		'Unload Time'
	   ]; 	 	
		}
		else if($this->menu_id==3 && $this->submenu_id==22)    /*Route Invoice*/
		{
		  return[
		'Customer',
		'Warehouse',
		'Route',
		'Salesman',
		'Invoice Number',
		'Invoice Date',
		'Invoice Total',
	   ]; 	 	
		}
		else if($this->menu_id==3 && $this->submenu_id==24)
		{
		   return[
		'Date',
		'Collection Number',
		'Customer',
		'Warehouse',
		'Salesman',
		'Route',
		'Invoice Number',
		'Collection Amount'
	   ]; 	 	
		}
		else if($this->menu_id==3 && $this->submenu_id==26)
		{
		  return[
		
		'Customer',
		'Warehouse',
		'Route',
		'Salesman',
		'Return Number',
		'Return Date',
		'Return Total'
	   ]; 	 	
		}
		else if($this->menu_id==3 && $this->submenu_id==28)
		{
		   return[
		
		'Month',
		'Year',
		'Warehouse',
		'Salesman',
		'Target Based',
		'Salesman Target'
	   ]; 	 		
		}
		else if($this->menu_id==3 && $this->submenu_id==31)
		{
			return[
		
		'Expense No',
		'Expense Date',
		'Expense Type',
		'Warehouse',
		'Salesman',
		'Ammount'
	   ]; 	 		
		  
		}
		else if($this->menu_id==7 && $this->submenu_id==218)
		{
		 return[
		
		'Synchronize(minutes)',
		'Google API key',
		'GCM Notification Enable',
		'Allow Pre Sale Order',
		'Printer Type',
		'Customer Geofence Radius(in meter)',
		'Print Disclaimer'
	   ]; 	 		
		}
		else if($this->menu_id==7 && $this->submenu_id==220)
		{
		 return[
		
		'Email Address',
		'Host Name',
		'Port',
		'Authentication',
		'Password',
		'NTLM',
		'Domain',
		'Username',
		'USE SSL',
		'TLS'
	   ]; 	 
		}
		else if($this->menu_id==15 && $this->submenu_id==265)
		{
		 return[
		
		'Name',
		'Valid From',
		'Valid To',
		'Height(CM)',
		'Width(CM)',
		'Depth(CM)',
		'Capacity(Pcs)',
		'Region Code',
		'Region',
		'Sub Region Code',
		'Sub Region',
		'Customer Code',
		'Customer',
		'Status'
	   ]; 	 
		}
		else if($this->menu_id==15 && $this->submenu_id==267)
		{
		  return[
		
		'Planogram Name',
		'Valid From',
		'Valid To',
		'Region Code',
		'Region',
		'Subregion Code',
		'Subregion',
		'Customer Code',
		'Customer',
		'Shelf Display',
		'Status'
	   ]; 	 
		}
		else if($this->menu_id==15 && $this->submenu_id==271)
		{
		  return[
		
		'Date',
		'Salesman Code',
		'Salesman',
		'Customer Code',
		'Customer',
		'Planogram Name',
		'Shelf Display'
	   ]; 	 	
		}
		else if($this->menu_id==15 && $this->submenu_id==272)
		{
		 return[
		
		'Asset Code',
		'Asset Name',
		'Asset Type',
		'Asset Barcode',
		'Serial Number',
		'Longitude',
		'Latitude',
		'Valid From',
		'Valid To',
		'Region Code',
		'Region',
		'Sub Region Code',
		'Sub Region',
		'Route Code',
		'Route',
		'Customer Category Code',
		'Customer Category',
		'Customer Code',
		'Customer',
		'Status'
	   ]; 	 	
		}
		else if($this->menu_id==15 && $this->submenu_id==276)
		{
		   return[
		
		'Date',
		'Salesman Code',
		'Salesman',
		'Customer Code',
		'Customer',
		'Asset Name'
	   ]; 	 	
		}
		else if($this->menu_id==15 && $this->submenu_id==277)
		{
		 return[
		
		'Material Code',
		'Material',
		'From Date',
		'To Date',
		'Ammount',
		'Status',
	   ]; 	 		
		}
		else if($this->menu_id==15 && $this->submenu_id==278)
		{
		  return[ 
		  'Date',
		'Material Code',
		'Free Material',
		'Invoice',
		'Salesman Code',
		'Salesman',
		'Customer Code',
		'Customer',
		'Phone',
		'Ammount Spend'
	   ]; 	 		
		}
		else if($this->menu_id==15 && $this->submenu_id==342)
		{
		  return[
		
		'Customer Code',
		'Customer Name',
		'Shelf Display',
		'Material Category Code',
		'Material Category',
		'Date',
	   ]; 	 		
		}
		else if($this->menu_id==15 && $this->submenu_id==343)
		{
		   return[
		
		'Date',
		'Customer Code',
		'Customer Name' 
	   ]; 	 		 	
		}
		else if($this->menu_id==15 && $this->submenu_id==35)
		{
		   return[
		
		'Survey Name',
		'From Date',
		'To Date', 
		'Status' 
	   ]; 	 	
		}
		else if($this->menu_id==15 && $this->submenu_id==38)
		{
		    return[
		
		'Survey Name',
		'Customer Name',
		'Phone', 
		'Date' 
	   ]; 	 	 	
		}
		else if($this->menu_id==6 && $this->submenu_id==95)
		{
		   return[
		'User Role Code',
		'User Role',
		'User Code',
		'First Name',
		'Last Name',
		'User Name',
		'User Password',
		'Address',
		'City',
		'Zip', 
		'Email',
		'Contact No',
		'Company Code', 
		'Company Name',
		'Region Code', 
		'Region Name', 
		'Block From', 
		'Block To', 
		'Status' 
	   ]; 	 	 
		}
				else if($this->menu_id==6 && $this->submenu_id==97)
		{
		  return[
		
		'Role Code',
		'Role Name',
		'Status'
	   ]; 	 	
		}
		else if($this->menu_id==13 && $this->submenu_id==348)
		{
		  return[
		
		'Category Code',
		'Category Name',
		'Status'
	   ]; 	 	
		}
		else if($this->menu_id==13 && $this->submenu_id==172)
		{
		   return[
		  'company_code',
		  'customer_code',
		  'warehouse_code',
		  'erp_asset_code',
		  'sales_area_code',
		  'salesman_code',
		  'erp_employee_code',
		  'material_code',
		  'erp_material_code',
		  'bank_code',
		  'user_code',
		  'tax_code',
		  'discount_code', 
		  'supplier_code',
		  'company_type_code',
		  'currency_code',
		  'country_code',
		  'reason_code',
		  'city_code',
		  'region_code',
		  'sub_region_code',
		  'customer_type_code',
		  'customer_category_code',
		  'outlet_code',
		  'vehicle_brand_code',
		  'vehicle_type_code', 
		  'salesman_type_code',
		  'uom_code',
		  'category_code',
		  'brand_code',
		  'role_code',
		  'expense_code',
		  'target_code',
		  'location_code',
		  'payment_code',
		  'supplier_type_code',
		  'expense_category_code',
		  'vehicle_code',
		  'updated_user', 
		  'created_at',
		  'updated_at',
		  'trading_center_code',
		  'invoice_number_code',
		  'unload_code',
		  'load_code',
		  'return_sales_code',
		  'company_order_code',
		  'company_return_order_code',
		  'expense_no',
		  'company_expense_no',
		  'delivery_order_no',
		  'delivery_return_order_number',
		  'company_invoice_no',
		  'company_credit_note_number',
		  'company_colletion_number',
		  'outlet_expense_number',
		  'counter_sales_no',
		  'client_code',
		  'commission_range',
		  'type_code',
		  'category_codes',
		  ]; 	
		}
		
	}
		
	public function drawings()
    {
        $drawing = new Drawing();
        $drawing->setName('Logo');
        $drawing->setDescription('This is my logo');		
        $drawing->setPath(public_path('elite.jpeg'));
        $drawing->setHeight(55);
        
        $drawing->setCoordinates('A1');

        return $drawing;
    }
	 public function startCell(): string
    {
        return 'A4';

    }
	
    public function collection() 
    { 
	   if($this->menu_id==5 && $this->submenu_id==48)
		{
			
		 $records=DB::table('tbl_client')
		 ->leftjoin('tbl_country','tbl_client.country_id','=','tbl_country.id') 
		 ->select('tbl_client.client_code','tbl_client.client_name','tbl_country.country_code','tbl_country.country_name','tbl_client.max_uom','tbl_client.status')
		 /* ->where('tbl_client.status', '=','active') */
		 ->get();   
		//dd($records);
		}	
		else if($this->menu_id==5 && $this->submenu_id==51)
		{
		  $records=DB::table('tbl_company')
		   ->leftjoin('tbl_currency_type','tbl_company.currency_id','=','tbl_currency_type.id')
		   ->leftjoin('tbl_country','tbl_company.country_id','=','tbl_country.id')
		   ->leftjoin('tbl_city','tbl_company.city_id','=','tbl_city.id')
		   ->leftjoin('tbl_company_type','tbl_company.company_type','=','tbl_company_type.id')
		   ->select('tbl_company.company_code','tbl_company.company_name','tbl_company_type.company_type_code','tbl_company_type.company_type_name','tbl_currency_type.currency_code','tbl_currency_type.currency_name','tbl_country.country_code','tbl_country.country_name','tbl_city.city_code','tbl_city.city_name','tbl_company.address','tbl_company.pincode','tbl_company.email_id','tbl_company.contact_no','tbl_company.status')
		   /* ->where('tbl_company.status', '=', 'active') */ 
		  ->get(); 
		}
		
		
		
		else if($this->menu_id==5 && $this->submenu_id==54)   /*MasterConfig - Customer*/  
		{
		  $records=DB::table('tbl_customer')
		  ->leftjoin('tbl_customer_type','tbl_customer.customer_type','=','tbl_customer_type.id')
		  ->leftjoin('tbl_customer_category','tbl_customer.customer_category','=','tbl_customer_category.id')
		  ->leftjoin('tbl_region','tbl_customer.region','=','tbl_region.id')
		  ->leftjoin('tbl_sub_region','tbl_customer.sub_region','=','tbl_sub_region.id')
		  ->leftjoin('tbl_route','tbl_customer.route_id','=','tbl_route.id')
		  ->leftjoin('tbl_trading_center','tbl_customer.trading_center_id','=','tbl_trading_center.id')
		  ->leftjoin('tbl_payment_term','tbl_customer.payment_term','=','tbl_payment_term.id')
		  ->leftjoin('tbl_country','tbl_customer.country_id','=','tbl_country.id')
		  ->leftjoin('tbl_city','tbl_customer.city_id','=','tbl_city.id')
		  
		  ->select('tbl_customer_type.customer_type_code','tbl_customer_type.customer_type_name','tbl_customer_category.customer_category_code','tbl_customer_category.customer_category_name','tbl_customer.customer_code','tbl_customer.customer_name','tbl_customer.tin_no','tbl_customer.email','tbl_customer.contact_no','tbl_customer.erp_customer','tbl_region.region_code','tbl_region.region_name','tbl_sub_region.sub_region_code','tbl_sub_region.sub_region_name','tbl_route.route_code','tbl_route.route_name','tbl_trading_center.trading_center_code','tbl_trading_center.trading_name','tbl_customer.credit_limit','tbl_customer.credit_days','tbl_customer.credit_balance','tbl_payment_term.payment_code','tbl_payment_term.payment_term','tbl_customer.bank_account_name1','tbl_customer.bank_account_number1','tbl_customer.bank_branch1','tbl_customer.bank_account_name2','tbl_customer.bank_account_number2','tbl_customer.bank_branch2','tbl_customer.address','tbl_country.country_code','tbl_country.country_name','tbl_city.city_code','tbl_city.city_name','tbl_customer.latitude','tbl_customer.longitude','tbl_customer.thresold_frequency','tbl_customer.status')
		  /* ->where('tbl_customer.status', '=', 'active')	 */	  
		  ->get(); 	
		}
		
		else if($this->menu_id==5 && $this->submenu_id==57)
		{
		  $records=DB::table('tbl_vehicle')
		  ->leftjoin('tbl_vehicle_type','tbl_vehicle.type','=','tbl_vehicle_type.id')
		  ->leftjoin('tbl_warehouse','tbl_vehicle.warehouse_id','=','tbl_warehouse.id')
		  
		  
		  ->select('tbl_vehicle.vehicle_code','tbl_vehicle.vehicle_number','tbl_vehicle.brand','tbl_vehicle_type.vehicle_type_code','tbl_vehicle_type.vehicle_type_name','tbl_vehicle.capacity','tbl_vehicle.vehicle_owner','tbl_vehicle.vehicle_chechis_number','tbl_vehicle.tank_capacity','tbl_vehicle.vehicle_mileage','tbl_warehouse.warehouse_code','tbl_warehouse.warehouse_name','tbl_vehicle.erp_asset_code','tbl_vehicle.status') 
		  /* ->where('tbl_vehicle.status', '=', 'active') */
		  ->get(); 	
		}
		else if($this->menu_id==5 && $this->submenu_id==60)
		{
		  $records=DB::table('tbl_sales_area')
		  ->leftjoin('tbl_warehouse','tbl_sales_area.warehouse_id','=','tbl_warehouse.id')
		  ->leftjoin('tbl_region','tbl_sales_area.region_id','=','tbl_region.id')
		  ->leftjoin('tbl_sub_region','tbl_sales_area.sub_region_id','=','tbl_sub_region.id')
		  ->select('tbl_sales_area.sales_area_code','tbl_sales_area.sales_area_name','tbl_warehouse.warehouse_code','tbl_warehouse.warehouse_name','tbl_region.region_code','tbl_region.region_name','tbl_sub_region.sub_region_code','tbl_sub_region.sub_region_name','tbl_sales_area.status') 
		  /* ->where('tbl_sales_area.status', '=', 'active') */
		  ->get(); 	
		}
		else if($this->menu_id==5 && $this->submenu_id==63)
		{
		  $records=DB::table('tbl_route')
		  ->leftjoin('tbl_sales_area','tbl_route.sales_area_id','=','tbl_sales_area.id')
		  ->leftjoin('tbl_warehouse','tbl_route.warehouse_id','=','tbl_warehouse.id')
		  ->leftjoin('tbl_vehicle','tbl_route.vehicle_id','=','tbl_vehicle.id')
		  ->leftjoin('tbl_customer','tbl_route.distibutor_id','=','tbl_customer.id')
		  
		  ->select('tbl_route.route_code','tbl_route.route_name','tbl_route.route_description','tbl_sales_area.sales_area_code','tbl_sales_area.sales_area_name','tbl_customer.customer_code','tbl_customer.customer_name','tbl_warehouse.warehouse_code','tbl_warehouse.warehouse_name','tbl_vehicle.vehicle_code','tbl_vehicle.vehicle_number','tbl_route.status') 
		  /* ->where('tbl_route.status', '=', 'active') */ 
		  ->get(); 	
		}
		else if($this->menu_id==5 && $this->submenu_id==66)
		{
		  $records=DB::table('tbl_salesman')
		  ->leftjoin('tbl_route','tbl_salesman.route_id','=','tbl_route.id')
		  ->leftjoin('tbl_warehouse','tbl_salesman.warehouse_id','=','tbl_warehouse.id')
		  ->leftjoin('tbl_salesman_type','tbl_salesman.salesman_type_id','=','tbl_salesman_type.id')
		  
		  ->select('tbl_salesman_type.salesman_type_code','tbl_salesman_type.salesman_type_name','tbl_salesman.salesman_code','tbl_salesman.salesman_name','tbl_salesman.salesman_password','tbl_salesman.contact_number','tbl_salesman.erp_employee_code','tbl_route.route_code','tbl_route.route_name','tbl_warehouse.warehouse_code','tbl_warehouse.warehouse_name','tbl_salesman.customer_from','tbl_salesman.invoice_from','tbl_salesman.order_from','tbl_salesman.delivery_from','tbl_salesman.collection_from','tbl_salesman.return_order_from','tbl_salesman.exchange_from','tbl_salesman.load_from','tbl_salesman.block_from_date','tbl_salesman.block_to_date','tbl_salesman.status') 
		 /*  ->where('tbl_salesman.status', '=', 'active') */
		  ->get(); 	
		}
		else if($this->menu_id==5 && $this->submenu_id==69)
		{
		  $records=DB::table('tbl_material_master')
		  ->leftjoin('tbl_type','tbl_material_master.material_types_id','=','tbl_type.id')
		  ->leftjoin('tbl_unit_of_measurement','tbl_material_master.uom_id','=','tbl_unit_of_measurement.id')
		  ->leftjoin('tbl_brand_type','tbl_material_master.brand','=','tbl_brand_type.id')
		  ->leftjoin('tbl_material_category','tbl_material_master.material_category_id','=','tbl_material_category.id')
		  
		  ->select('tbl_type.type','tbl_material_master.material_code','tbl_material_master.material_name','tbl_material_category.category_code','tbl_material_category.category_name','tbl_brand_type.brand_code','tbl_brand_type.brand_name','tbl_unit_of_measurement.uom_code','tbl_unit_of_measurement.uom_name','tbl_material_master.unit_price','tbl_material_master.bar_code','tbl_material_master.net_weight','tbl_material_master.packing_size','tbl_material_master.shelf_life','tbl_material_master.promotional_material','tbl_material_master.erp_material_code','tbl_material_master.vat','tbl_material_master.excise','tbl_material_master.alt_uom_name','tbl_material_master.alt_packing_size','tbl_material_master.alt_unit_price','tbl_material_master.status') 
		 /*  ->where('tbl_material_master.status', '=', 'active') */ 
		  ->get(); 
		}
		else if($this->menu_id==5 && $this->submenu_id==72)
		{
		  $records=DB::table('tbl_pricing_plan')
		  
		  ->select('tbl_pricing_plan.plan_name','tbl_pricing_plan.price_applied_on','tbl_pricing_plan.valid_from','tbl_pricing_plan.valid_to','tbl_pricing_plan.status') 
		  /* >where('tbl_pricing_plan.status', '=', 'active') */
		  ->get(); 
		}
		else if($this->menu_id==5 && $this->submenu_id==75)
		{
		  $records=DB::table('tbl_bank') 
		  ->leftjoin('tbl_country','tbl_bank.country_id','=','tbl_country.id')
		  ->leftjoin('tbl_city','tbl_bank.city_id','=','tbl_city.id')
		  ->select('tbl_bank.bank_code','tbl_bank.bank_name','tbl_bank.bank_account_number','tbl_bank.branch','tbl_country.country_code','tbl_country.country_name','tbl_city.city_code','tbl_city.city_name','tbl_bank.address','tbl_bank.status')
		  /* ->where('tbl_bank.status', '=', 'active') */
		  ->get();
		}
		else if($this->menu_id==5 && $this->submenu_id==78)
		{
		  $records=DB::table('tbl_tax')
		   ->select('tbl_tax.tax_code','tbl_tax.tax_name','tbl_tax.tax_percentage','tbl_tax.tax_amount','tbl_tax.status')
		  /*  ->where('tbl_tax.status', '=', 'active') */
		  ->get(); 	
		}
		else if($this->menu_id==5 && $this->submenu_id==81)
		{
		  $records=DB::table('tbl_discount')
		  ->leftjoin('tbl_customer','tbl_discount.distributor','tbl_customer.id')
		  ->leftjoin('tbl_customer_category','tbl_discount.customer_category_id','tbl_customer_category.id')
		  ->leftjoin('tbl_customer_type','tbl_discount.customer_type_id','tbl_customer_type.id')
		  
		   ->select('tbl_discount.discount_code','tbl_discount.discount_name','tbl_discount.discount_percentage','tbl_discount.discount_amount','tbl_discount.discount_on','tbl_customer.customer_code','tbl_customer.customer_name','tbl_customer_type.customer_type_code','tbl_customer_type.customer_type_name','tbl_customer_category.customer_category_code','tbl_customer_category.customer_category_name','tbl_discount.status')
		  /*  ->where('tbl_discount.status', '=', 'active') */
		  ->get();
	  
		}
		else if($this->menu_id==5 && $this->submenu_id==84)
		{
		  $records=DB::table('tbl_supplier')
		  ->leftjoin('tbl_supplier_type','tbl_supplier.supplier_type_id','tbl_supplier_type.id')
		  ->leftjoin('tbl_currency_type','tbl_supplier.supplier_currency_id','tbl_currency_type.id')
		  ->leftjoin('tbl_country','tbl_supplier.country_id','tbl_country.id')
		  ->leftjoin('tbl_city','tbl_supplier.city_id','=','tbl_city.id')
		  ->leftjoin('tbl_payment_term','tbl_supplier.payment_term','=','tbl_payment_term.id')
		  
		  ->select('tbl_supplier_type.supplier_type_code','tbl_supplier_type.supplier_type_name','tbl_supplier.supplier_code','tbl_supplier.supplier_name','tbl_supplier.tin_number','tbl_currency_type.currency_code','tbl_currency_type.currency_name','tbl_payment_term.payment_code','tbl_payment_term.payment_term','tbl_country.country_code','tbl_country.country_name','tbl_city.city_code','tbl_city.city_name','tbl_supplier.address','tbl_supplier.email_id','tbl_supplier.contact_number','tbl_supplier.bank_account_number1','tbl_supplier.bank_branch','tbl_supplier.bank_name','tbl_supplier.bank_address','tbl_supplier.bank_code','tbl_supplier.erp_material_code','tbl_supplier.status')
		  /* ->where('tbl_supplier.status', '=', 'active') */    
		  ->get(); 	
		}
		else if($this->menu_id==5 && $this->submenu_id==87)
		{
		  $records=DB::table('tbl_outlet')
		  ->leftjoin('tbl_warehouse','tbl_outlet.warehouse_id','=','tbl_warehouse.id')
		  ->leftjoin('tbl_city','tbl_outlet.city_id','=','tbl_city.id')
		  ->leftjoin('tbl_country','tbl_outlet.country_id','=','tbl_country.id')
		   ->leftjoin('tbl_customer','tbl_outlet.distibutor_id','tbl_customer.id')
		  ->select('tbl_outlet.outlet_code','tbl_outlet.outlet_name','tbl_outlet.contact_persion','tbl_outlet.contact_number','tbl_country.country_code','tbl_country.country_name','tbl_city.city_code','tbl_city.city_name','tbl_outlet.address','tbl_customer.customer_code','tbl_customer.customer_name','tbl_warehouse.warehouse_code','tbl_warehouse.warehouse_name','tbl_outlet.status')
		  /* ->where('tbl_outlet.status', '=', 'active') */
		  ->get(); 	
		}
		else if($this->menu_id==5 && $this->submenu_id==90)
		{
		  $records=DB::table('tbl_trading_center')
		  ->leftjoin('tbl_route','tbl_trading_center.route_id','=','tbl_route.id')

		  ->select('tbl_trading_center.trading_center_code','tbl_trading_center.trading_name','tbl_route.route_code','tbl_route.route_name','tbl_trading_center.status')
		 /*  ->where('tbl_trading_center.status', '=', 'active') */
		  ->get(); 	
		}
		 else if($this->menu_id==5 && $this->submenu_id==282)
		{
		  $records=DB::table('tbl_type')
		  ->select('tbl_type.type_code','tbl_type.type','tbl_type.material_code','tbl_type.status')
		  /* ->where('tbl_type.status', '=', 'active') */ 
		  ->get(); 	
		}
		/* else if($this->menu_id==5 && $this->submenu_id==199)
		{
		  $records=DB::table('tbl_outlet')->get(); 	
		} */
		
		 else if($this->menu_id==13 && $this->submenu_id==106)
		{
		  $records=DB::table('tbl_company_type')
		  ->select('tbl_company_type.company_type_code','tbl_company_type.company_type_name','tbl_company_type.status')
		/*   ->where('tbl_company_type.status', '=', 'active')  */
		  ->get(); 	
		}
		 else if($this->menu_id==13 && $this->submenu_id==279)
		{
		  $records=DB::table('tbl_commission_range')
		  ->select('tbl_commission_range.range_code','tbl_commission_range.range','tbl_commission_range.status')
		  /* ->where('tbl_commission_range.status', '=', 'active')  */ 
		  ->get(); 	
		}
		 else if($this->menu_id==13 && $this->submenu_id==109)
		{
		  $records=DB::table('tbl_currency_type')
		  ->select('tbl_currency_type.currency_code','tbl_currency_type.currency_name','tbl_currency_type.currency_notation','tbl_currency_type.status')
		  /* ->where('tbl_currency_type.status', '=', 'active')  */
		  ->get(); 	
		}
		else if($this->menu_id==13 && $this->submenu_id==112)
		{
		  $records=DB::table('tbl_country')
		  ->select('tbl_country.country_code','tbl_country.country_name','tbl_country.status')
		  /* ->where('tbl_country.status', '=', 'active')  */
		  ->get(); 	
		}
		else if($this->menu_id==13 && $this->submenu_id==115)
		{
		  $records=DB::table('tbl_city')
		  ->leftjoin('tbl_country','tbl_city.Country_id','tbl_country.id')
		  ->select('tbl_city.city_code','tbl_city.city_name','tbl_country.country_code','tbl_country.country_name','tbl_city.status')
		  /* ->where('tbl_city.status', '=', 'active')  */
		  ->get(); 	
		}
		else if($this->menu_id==13 && $this->submenu_id==118)
		{
		  $records=DB::table('tbl_region')
		  ->select('tbl_region.region_code','tbl_region.region_name','tbl_region.status')
		 /*  ->where('tbl_region.status', '=', 'active')  */
		  ->get(); 	
		}
		else if($this->menu_id==13 && $this->submenu_id==121)
		{
		  $records=DB::table('tbl_sub_region')
		  ->leftjoin('tbl_region','tbl_sub_region.region_id','tbl_region.id')
		  ->select('tbl_sub_region.sub_region_code','tbl_sub_region.sub_region_name','tbl_region.region_code','tbl_region.region_name','tbl_sub_region.status')
		  /* ->where('tbl_sub_region.status', '=', 'active') */
		  ->get(); 	 
		}
		else if($this->menu_id==13 && $this->submenu_id==124)
		{
		  $records=DB::table('tbl_customer_type')
		  ->select('tbl_customer_type.customer_type_code','tbl_customer_type.customer_type_name','tbl_customer_type.status')
		  /* ->where('tbl_customer_type.status', '=', 'active')  */
		  ->get(); 	
		}
		else if($this->menu_id==13 && $this->submenu_id==127)
		{
		  $records=DB::table('tbl_customer_category')
		  ->leftjoin('tbl_customer_type','tbl_customer_category.customer_type_id','tbl_customer_type.id')
		  ->select('tbl_customer_category.customer_category_code','tbl_customer_category.customer_category_name','tbl_customer_type.customer_type_code','tbl_customer_type.customer_type_name','tbl_customer_category.status')
		 /*  ->where('tbl_customer_category.status', '=', 'active')  */
		  ->get(); 	
		}
		else if($this->menu_id==13 && $this->submenu_id==163)
		{
		  $records=DB::table('tbl_payment_term')
		  ->select('tbl_payment_term.payment_code','tbl_payment_term.payment_term','tbl_payment_term.condition','tbl_payment_term.status')
		  /* ->where('tbl_payment_term.status', '=', 'active') */ 
		  ->get(); 	
		}
		else if($this->menu_id==13 && $this->submenu_id==133)
		{
		  $records=DB::table('tbl_vehicle_type')
		  ->select('tbl_vehicle_type.vehicle_type_code','tbl_vehicle_type.vehicle_type_name','tbl_vehicle_type.status')
		  /* ->where('tbl_vehicle_type.status', '=', 'active')  */
		  ->get(); 	
		}
		else if($this->menu_id==13 && $this->submenu_id==130)
		{
		  $records=DB::table('tbl_vehicle_brand')
		  ->select('tbl_vehicle_brand.vehicle_brand_code','tbl_vehicle_brand.vehicle_brand_name','tbl_vehicle_brand.status')
		  /* ->where('tbl_vehicle_brand.status', '=', 'active')  */
		  ->get(); 	
		}
		else if($this->menu_id==13 && $this->submenu_id==145)
		{
		  $records=DB::table('tbl_material_category')
		  ->leftjoin('tbl_type','tbl_material_category.material_type_id','tbl_type.id')
		  ->select('tbl_material_category.category_code','tbl_type.type','tbl_material_category.category_name','tbl_material_category.status')
		  /* ->where('tbl_material_category.status', '=', 'active')  */
		  ->get(); 	
		}
		else if($this->menu_id==13 && $this->submenu_id==148)
		{
		  $records=DB::table('tbl_brand_type')
		  ->leftjoin('tbl_type','tbl_brand_type.material_type','tbl_type.id')
		  ->select('tbl_brand_type.brand_code','tbl_brand_type.brand_name','tbl_type.type','tbl_brand_type.status')
		  /* ->where('tbl_brand_type.status', '=', 'active')  */
		  ->get(); 	
		}
		else if($this->menu_id==13 && $this->submenu_id==139)
		{
		  $records=DB::table('tbl_unit_of_measurement')
		  ->select('tbl_unit_of_measurement.uom_code','tbl_unit_of_measurement.uom_name','tbl_unit_of_measurement.unit_notation','tbl_unit_of_measurement.uom_type','tbl_unit_of_measurement.status')
		  /* ->where('tbl_unit_of_measurement.status', '=', 'active') */ 
		  ->get(); 	
		}
		else if($this->menu_id==13 && $this->submenu_id==136)
		{
		  $records=DB::table('tbl_salesman_type')
		  ->select('tbl_salesman_type.salesman_type_code','tbl_salesman_type.salesman_type_name','tbl_salesman_type.status')
		  /* ->where('tbl_salesman_type.status', '=', 'active')  */
		  ->get(); 	
		}
		else if($this->menu_id==13 && $this->submenu_id==142)
		{
		  $records=DB::table('tbl_unit_of_conversion')
		  ->leftjoin('tbl_unit_of_measurement','tbl_unit_of_conversion.uom_id','tbl_unit_of_measurement.id')
		  ->select('tbl_unit_of_conversion.uom_code','tbl_unit_of_measurement.uom_code as uomcode','tbl_unit_of_measurement.uom_name','tbl_unit_of_conversion.alternate_unit','tbl_unit_of_conversion.conversion','tbl_unit_of_conversion.status')
		  /* ->where('tbl_unit_of_conversion.status', '=', 'active')  */
		  ->get(); 	
		}
		else if($this->menu_id==13 && $this->submenu_id==151)
		{
		  $records=DB::table('tbl_expense_type')
		  ->leftjoin('tbl_expense_category','tbl_expense_type.expense_category','tbl_expense_category.id')
		  ->select('tbl_expense_type.expense_code','tbl_expense_type.expense_name','tbl_expense_category.expense_category_code','tbl_expense_category.expense_category','tbl_expense_type.status')
		 /*  ->where('tbl_expense_type.status', '=', 'active')  */
		  ->get(); 	
		}
		else if($this->menu_id==13 && $this->submenu_id==154)
		{
		  $records=DB::table('tbl_discount_type')
		  ->select('tbl_discount_type.discount_code','tbl_discount_type.discount_plan_name','tbl_discount_type.status')
		  /* ->where('tbl_discount_type.status', '=', 'active') */ 
		  ->get(); 	
		}
		else if($this->menu_id==13 && $this->submenu_id==157)
		{
		  $records=DB::table('tbl_sales_target_type')
		  ->select('tbl_sales_target_type.target_code','tbl_sales_target_type.target_name','tbl_sales_target_type.status')
		  /* ->where( 'tbl_sales_target_type.status' , '=', 'active')  */
		  ->get(); 	
		}
		else if($this->menu_id==13 && $this->submenu_id==160)
		{
		  $records=DB::table('tbl_location')
		  ->select('tbl_location.location_code','tbl_location.location_name','tbl_location.status')
		  /* ->where('tbl_location.status', '=', 'active')  */   
		  ->get(); 	
		}
		else if($this->menu_id==13 && $this->submenu_id==169)
		{
		  $records=DB::table('tbl_supplier_type')
		  ->select('tbl_supplier_type.supplier_type_code','tbl_supplier_type.supplier_type_name','tbl_supplier_type.status')
		  /* ->where('tbl_supplier_type.status', '=', 'active')  */
		  ->get(); 	
		}
		else if($this->menu_id==13 && $this->submenu_id==186)
		{
		  $records=DB::table('tbl_sales_hierarchy')
		  ->select('tbl_sales_hierarchy.name','tbl_sales_hierarchy.parent')
		  /* ->where('tbl_sales_hierarchy.status', '=', 'active') */ 
		  ->get(); 	
		}
		else if($this->menu_id==13 && $this->submenu_id==203)
		{
		  $records=DB::table('tbl_expense_category')
		  ->select('tbl_expense_category.expense_category_code','tbl_expense_category.expense_category','tbl_expense_category.status')
		  /* ->where('tbl_expense_category.status', '=', 'active')  */
		  ->get(); 	
		}
		else if($this->menu_id==13 && $this->submenu_id==291)
		{
		  $records=DB::table('tbl_btstructure')
		  ->select('tbl_btstructure.name','tbl_btstructure.parent')
		  /* ->where('tbl_btstructure.status', '=', 'active')  */
		  ->get(); 	
		}
		else if($this->menu_id==13 && $this->submenu_id==296)
		{
		  $records=DB::table('tbl_reason')
		  ->select('tbl_reason.reason_code','tbl_reason.reason_name','tbl_reason.status')
		  
		  ->get(); 	
		}
		else if($this->menu_id==2 && $this->submenu_id==3) 
		{
		  $records=DB::table('tbl_company_order_header')
		  ->leftjoin('tbl_customer','tbl_company_order_header.customer_name','tbl_customer.id')
		  ->leftjoin('tbl_warehouse','tbl_company_order_header.warehouse','tbl_warehouse.id')
		  ->select('tbl_company_order_header.company_order_number','tbl_company_order_header.created_at','tbl_customer.customer_name','tbl_warehouse.warehouse_name','tbl_company_order_header.total_order_value','tbl_company_order_header.is_deliver')
		  /* ->where('tbl_company_order_header.status', '=', 'active')  */
		  ->get(); 	
		}
		else if($this->menu_id==2 && $this->submenu_id==5)
		{
		  $records=DB::table('tbl_company_delivery_header')
		  ->leftjoin('tbl_customer','tbl_company_delivery_header.customer','tbl_customer.id')
		  ->leftjoin('tbl_warehouse','tbl_company_delivery_header.warehouse','tbl_warehouse.id')
		  ->leftjoin('tbl_company_order_header','tbl_company_delivery_header.order_number','tbl_company_order_header.id')
		  ->select('tbl_company_delivery_header.company_delivery_number','tbl_customer.customer_name','tbl_warehouse.warehouse_name','tbl_company_delivery_header.total_delivery_value','tbl_company_order_header.company_order_number')
		  /* ->where('tbl_company_order_header.status', '=', 'active')  */
		  ->get(); 	
		}
		else if($this->menu_id==2 && $this->submenu_id==7)
		{
		  $records=DB::table('tbl_company_invoice_header')
		  ->leftjoin('tbl_customer','tbl_company_invoice_header.customer','tbl_customer.id')
		  ->leftjoin('tbl_warehouse','tbl_company_invoice_header.warehouse','tbl_warehouse.id')
		 /*  ->leftjoin('tbl_currency_type','tbl_company_invoice_header.currency','tbl_currency_type.id') */
		   ->leftjoin('tbl_company_delivery_header','tbl_company_invoice_header.delivery_number','tbl_company_delivery_header.id') 
		  ->select('tbl_company_invoice_header.company_invoice_number','tbl_company_invoice_header.created_at','tbl_customer.customer_name','tbl_warehouse.warehouse_name',/* 'tbl_currency_type.currency_notation', */'tbl_company_invoice_header.total_invoice_value','tbl_company_delivery_header.company_delivery_number')
		  /* ->where('tbl_company_order_header.status', '=', 'active')  */  
		  ->get(); 	
		}
		else if($this->menu_id==2 && $this->submenu_id==11)
		{
		  $records=DB::table('tbl_company_credit_note_header')
		  ->leftjoin('tbl_customer','tbl_company_credit_note_header.customer','tbl_customer.id')
		  ->leftjoin('tbl_warehouse','tbl_company_credit_note_header.warehouse','tbl_warehouse.id')
		  ->leftjoin('tbl_company_delivery_header','tbl_company_credit_note_header.company_credit_delivery_number','tbl_company_delivery_header.id') 
		  
		  ->select('tbl_company_credit_note_header.company_credit_note_number','tbl_company_credit_note_header.created_at','tbl_customer.customer_name','tbl_warehouse.warehouse_name','tbl_company_credit_note_header.total_delivery_value','tbl_company_delivery_header.company_delivery_number')
		  /* ->where('tbl_company_order_header.status', '=', 'active')  */      
		  ->get(); 	
		}
		else if($this->menu_id==2 && $this->submenu_id==13)
		{
		  $records=DB::table('tbl_company_outstanding')
		  ->leftjoin('tbl_customer','tbl_company_outstanding.customer','tbl_customer.id')
		  ->leftjoin('tbl_warehouse','tbl_company_outstanding.warehouse','tbl_warehouse.id')
		  	  
		  ->select('tbl_customer.customer_name','tbl_warehouse.warehouse_name','tbl_company_outstanding.invoice_number','tbl_company_outstanding.invoice_total','tbl_company_outstanding.invoice_paid','tbl_company_outstanding.invoce_outstandig','tbl_company_outstanding.due_date')
		  /* ->where('tbl_company_order_header.status', '=', 'active')  */      
		  ->get(); 	
		}
		else if($this->menu_id==2 && $this->submenu_id==14)
		{
		  $records=DB::table('tbl_company_expenses')
		  ->leftjoin('tbl_expense_type','tbl_company_expenses.expense_type','tbl_expense_type.id')
		  ->leftjoin('tbl_warehouse','tbl_company_expenses.warehouse_id','tbl_warehouse.id')
		  	  
		  ->select('tbl_company_expenses.expense_no','tbl_company_expenses.expense_date','tbl_expense_type.expense_name','tbl_warehouse.warehouse_name','tbl_company_expenses.expense_amount')
		  /* ->where('tbl_company_order_header.status', '=', 'active')  */      
		  ->get(); 	
		}
		else if($this->menu_id==2 && $this->submenu_id==179)
		{
		  $records=DB::table('tbl_advance_payment')
		   ->leftjoin('tbl_customer','tbl_advance_payment.distributor','tbl_customer.id')
		  ->select('tbl_advance_payment.created_at','tbl_advance_payment.receipt_no','tbl_customer.customer_name','tbl_advance_payment.total_amt')
		  /* ->where('tbl_company_order_header.status', '=', 'active')  */      
		  ->get(); 	
		}
		else if($this->menu_id==10 && $this->submenu_id==17)
		{
		  $records=DB::table('tbl_company_stock_transfer_header')
		  
		   ->leftjoin('tbl_warehouse','tbl_company_stock_transfer_header.from_warehouse','tbl_warehouse.id')
		   ->leftjoin('tbl_warehouse as ntbl_warehouse','tbl_company_stock_transfer_header.transfer_warehouse','ntbl_warehouse.id')
		  ->select('tbl_warehouse.warehouse_name','ntbl_warehouse.warehouse_name as nwarehouse_name','tbl_company_stock_transfer_header.created_at')
		/*  ->where('tbl_company_stock_transfer_header.status', '=', 'active')  */     
		  ->get(); 	
		}
		else if($this->menu_id==10 && $this->submenu_id==180)
		{
		  $records=DB::table('tbl_warehouse')
		   ->leftjoin('tbl_customer','tbl_warehouse.distributor','tbl_customer.id')
		   ->leftjoin('tbl_region','tbl_warehouse.region','tbl_region.id')
		   ->leftjoin('tbl_sub_region','tbl_warehouse.sub_region','tbl_sub_region.id')
		  ->select('tbl_warehouse.warehouse_code','tbl_warehouse.warehouse_name','tbl_warehouse.warehouse_type','tbl_customer.customer_code','tbl_customer.customer_name','tbl_region.region_code','tbl_region.region_name','tbl_sub_region.sub_region_code','tbl_sub_region.sub_region_name','tbl_warehouse.address','tbl_warehouse.status')
/* 		->where('tbl_warehouse.status', '=', 'active')    */
		  ->get(); 	
		}
		else if($this->menu_id==10 && $this->submenu_id==185)
		{
		  $records=DB::table('tbl_stock_adjust_header')
		  ->leftjoin('tbl_warehouse','tbl_stock_adjust_header.warehouse','tbl_warehouse.id')
		  ->select('tbl_warehouse.warehouse_name','tbl_stock_adjust_header.invoice_date','tbl_stock_adjust_header.adjustment_type')
		/* ->where('tbl_warehouse.status', '=', 'active')    */
		  ->get(); 	
		}
		else if($this->menu_id==3 && $this->submenu_id==19)
		{
		  $records=DB::table('tbl_route_salesmanload_header')
		  ->leftjoin('tbl_route','tbl_route_salesmanload_header.route_id','tbl_route.id')
		  ->leftjoin('tbl_salesman','tbl_route_salesmanload_header.salesman_id','tbl_salesman.id')
		  ->leftjoin('tbl_warehouse','tbl_route_salesmanload_header.warehouse_id','tbl_warehouse.id')
		  ->select('tbl_route_salesmanload_header.load_number','tbl_route.route_name','tbl_salesman.salesman_name','tbl_warehouse.warehouse_name','tbl_route_salesmanload_header.created_at','tbl_route_salesmanload_header.load_date','tbl_route_salesmanload_header.total_load_value','tbl_route_salesmanload_header.status')
		/* ->where('tbl_warehouse.status', '=', 'active')    */
		  ->get(); 	
		}
		else if($this->menu_id==3 && $this->submenu_id==21)
		{
		  $records=DB::table('tbl_route_unload_header')
		  ->leftjoin('tbl_route','tbl_route_unload_header.route_id','tbl_route.id')
		  ->leftjoin('tbl_salesman','tbl_route_unload_header.salesman_id','tbl_salesman.id')
		  ->leftjoin('tbl_warehouse','tbl_route_unload_header.warehouse_id','tbl_warehouse.id')
		  ->select('tbl_salesman.salesman_name','tbl_route.route_name','tbl_warehouse.warehouse_name','tbl_route_unload_header.unload_time')
		/* ->where('tbl_warehouse.status', '=', 'active')    */
		  ->get(); 	
		}
		else if($this->menu_id==3 && $this->submenu_id==22)
		{
		  $records=DB::table('tbl_route_invoice_header')
		  ->leftjoin('tbl_route','tbl_route_invoice_header.route_id','tbl_route.id')
		  ->leftjoin('tbl_salesman','tbl_route_invoice_header.salesman','tbl_salesman.id')
		  ->leftjoin('tbl_warehouse','tbl_route_invoice_header.warehouse','tbl_warehouse.id')
		  ->leftjoin('tbl_customer','tbl_route_invoice_header.customer_name','tbl_customer.id')
		  ->select('tbl_customer.customer_name','tbl_warehouse.warehouse_name','tbl_route.route_name','tbl_salesman.salesman_name','tbl_route_invoice_header.invoice_number','tbl_route_invoice_header.created_at','tbl_route_invoice_header.total_invoice_value')
		/* ->where('tbl_warehouse.status', '=', 'active')    */
		  ->get(); 	
		}
		else if($this->menu_id==3 && $this->submenu_id==24)
		{
		  $records=DB::table('tbl_route_credit_collection')
		  ->leftjoin('tbl_route','tbl_route_credit_collection.route_id','tbl_route.id')
		  ->leftjoin('tbl_salesman','tbl_route_credit_collection.salesman_id','tbl_salesman.id')
		  ->leftjoin('tbl_warehouse','tbl_route_credit_collection.warehouse_id','tbl_warehouse.id')
		  ->leftjoin('tbl_customer','tbl_route_credit_collection.customer_id','tbl_customer.id')
		  /* ->leftjoin('tbl_route_invoice_header','tbl_route_credit_collection.customer_name','tbl_route_invoice_header.id') */
		  
		  ->select('tbl_route_credit_collection.date','tbl_route_credit_collection.collection_no','tbl_customer.customer_name','tbl_warehouse.warehouse_name','tbl_salesman.salesman_name','tbl_route.route_name','tbl_route_credit_collection.invoice_id','tbl_route_credit_collection.collection_amt')
		/* ->where('tbl_warehouse.status', '=', 'active')    */
		  ->get(); 	
		}
		
		
		
		// Route Outstanding pendig because of column confusion ******
		
		
		/* else if($this->menu_id==3 && $this->submenu_id==25)
		{
		  $records=DB::table('tbl_outstanding_details')
		  ->leftjoin('tbl_route','tbl_outstanding_details.route_id','tbl_route.id')
		  ->leftjoin('tbl_salesman','tbl_outstanding_details.salesman_id','tbl_salesman.id')
		  ->leftjoin('tbl_warehouse','tbl_outstanding_details.warehouse_id','tbl_warehouse.id')
		  ->leftjoin('tbl_customer','tbl_outstanding_details.customer_id','tbl_customer.id')
		  /* ->leftjoin('tbl_route_invoice_header','tbl_route_credit_collection.customer_name','tbl_route_invoice_header.id') */
		  
		 /*  ->select('tbl_route_credit_collection.date','tbl_route_credit_collection.collection_no','tbl_customer.customer_name','tbl_warehouse.warehouse_name','tbl_salesman.salesman_name','tbl_route.route_name','tbl_route_credit_collection.invoice_id','tbl_route_credit_collection.collection_amt')
		/* ->where('tbl_warehouse.status', '=', 'active')    */
		  /* ->get(); 	
		} */
		else if($this->menu_id==3 && $this->submenu_id==26)
		{
		  $records=DB::table('tbl_return_sales_header')
		  ->leftjoin('tbl_route','tbl_return_sales_header.route_id','tbl_route.id')
		  ->leftjoin('tbl_salesman','tbl_return_sales_header.salesman','tbl_salesman.id')
		  ->leftjoin('tbl_warehouse','tbl_return_sales_header.warehouse','tbl_warehouse.id')
		  ->leftjoin('tbl_customer','tbl_return_sales_header.customer_name','tbl_customer.id')
		  
		  ->select('tbl_customer.customer_name','tbl_warehouse.warehouse_name','tbl_route.route_name','tbl_salesman.salesman_name','tbl_return_sales_header.return_number','tbl_return_sales_header.created_at','tbl_return_sales_header.total_invoice_value')
		/* ->where('tbl_warehouse.status', '=', 'active')    */
		  ->get(); 	
		}
		else if($this->menu_id==3 && $this->submenu_id==28)
		{
		  $records=DB::table('tbl_salesman_target')
		  
		   ->leftjoin('tbl_warehouse','tbl_salesman_target.warehouse_id','tbl_warehouse.id')
		  ->leftjoin('tbl_salesman','tbl_salesman_target.salesman_id','tbl_salesman.id')
		  ->select('tbl_salesman_target.month','tbl_salesman_target.year','tbl_warehouse.warehouse_name','tbl_salesman.salesman_name','tbl_salesman_target.target_based_on','tbl_salesman_target.salesman_target')
		/*  ->where('tbl_company_stock_transfer_header.status', '=', 'active')  */     
		  ->get(); 	
		}
		else if($this->menu_id==3 && $this->submenu_id==31)
		{
		  $records=DB::table('tbl_route_expenses')
		  ->leftjoin('tbl_expense_type','tbl_route_expenses.expense_type','tbl_expense_type.id')
		   ->leftjoin('tbl_warehouse','tbl_route_expenses.warehouse_id','tbl_warehouse.id')
		  ->leftjoin('tbl_salesman','tbl_route_expenses.salesman_name','tbl_salesman.id')
		  ->select('tbl_route_expenses.expense_no','tbl_route_expenses.expense_date','tbl_expense_type.expense_name','tbl_warehouse.warehouse_name','tbl_salesman.salesman_name','tbl_route_expenses.expense_amount')
		/*  ->where('tbl_company_stock_transfer_header.status', '=', 'active')  */     
		  ->get(); 	
		}
		else if($this->menu_id==3 && $this->submenu_id==34)
		{
		  $records=DB::table('tbl_route_competitor')
		   ->leftjoin('tbl_route','tbl_route_competitor.route_id','tbl_route.id')
		   ->leftjoin('tbl_warehouse','tbl_route_competitor.warehouse_id','tbl_warehouse.id')
		  ->leftjoin('tbl_salesman','tbl_route_competitor.salesman_id','tbl_salesman.id')
		  ->select('tbl_route.route_name','tbl_warehouse.warehouse_name','tbl_salesman.salesman_name','tbl_route_competitor.company_name','tbl_route_competitor.brand','tbl_route_competitor.company_name','tbl_route_competitor.company_name')
		/*  ->where('tbl_company_stock_transfer_header.status', '=', 'active')  */     
		  ->get(); 	
		}
		
		
		
		else if($this->menu_id==7 && $this->submenu_id==218)
		{
		  $records=DB::table('tbl_device_configuration')
		 ->select('tbl_device_configuration.synchronize','tbl_device_configuration.google_api_key','tbl_device_configuration.gcm_notification','tbl_device_configuration.pre_sale','tbl_device_configuration.printer_type','tbl_device_configuration.geofence_radius','tbl_device_configuration.disclaimer') 		/*  ->where('tbl_company_stock_transfer_header.status', '=', 'active')  */     
		  ->get(); 	
		}
		else if($this->menu_id==7 && $this->submenu_id==220)
		{
		  $records=DB::table('tbl_email_configuration')
		   
		  ->select('tbl_email_configuration.email','tbl_email_configuration.host_name','tbl_email_configuration.port','tbl_email_configuration.authentication','tbl_email_configuration.password','tbl_email_configuration.ntlm','tbl_email_configuration.domain','tbl_email_configuration.username','tbl_email_configuration.use_ssl','tbl_email_configuration.tls')
		/*  ->where('tbl_company_stock_transfer_header.status', '=', 'active')  */     
		  ->get(); 	
		}
		else if($this->menu_id==15 && $this->submenu_id==265)
		{
		  $records=DB::table('tbl_shelf_display')
		   ->leftjoin('tbl_customer','tbl_shelf_display.customer','tbl_customer.id')
		   ->leftjoin('tbl_region','tbl_shelf_display.region','tbl_region.id')
		   ->leftjoin('tbl_sub_region','tbl_shelf_display.sub_region','tbl_sub_region.id')
		  ->select('tbl_shelf_display.name','tbl_shelf_display.valid_from','tbl_shelf_display.valid_to','tbl_shelf_display.height','tbl_shelf_display.width','tbl_shelf_display.depth','tbl_shelf_display.capacity','tbl_region.region_code','tbl_region.region_name','tbl_sub_region.sub_region_code','tbl_sub_region.sub_region_name','tbl_customer.customer_code','tbl_customer.customer_name','tbl_shelf_display.status')
		/*  ->where('tbl_company_stock_transfer_header.status', '=', 'active')  */     
		  ->get(); 	
		}
		else if($this->menu_id==15 && $this->submenu_id==267)
		{
		  $records=DB::table('tbl_planogram')
		   ->leftjoin('tbl_customer','tbl_planogram.customer','tbl_customer.id')
		   ->leftjoin('tbl_region','tbl_planogram.region','tbl_region.id')
		   ->leftjoin('tbl_sub_region','tbl_planogram.sub_region','tbl_sub_region.id')
		   ->leftjoin('tbl_shelf_display','tbl_planogram.shelf_display_name','tbl_shelf_display.id')
		  ->select('tbl_planogram.planogram_name','tbl_planogram.valid_from','tbl_planogram.valid_to','tbl_region.region_code','tbl_region.region_name','tbl_sub_region.sub_region_code','tbl_sub_region.sub_region_name','tbl_customer.customer_code','tbl_customer.customer_name','tbl_shelf_display.name','tbl_shelf_display.status')
		/*  ->where('tbl_company_stock_transfer_header.status', '=', 'active')  */     
		  ->get(); 	
		}
		else if($this->menu_id==15 && $this->submenu_id==271)
		{
		  $records=DB::table('tbl_planogram_post')
		   ->leftjoin('tbl_customer','tbl_planogram_post.customer','tbl_customer.id')
		   ->leftjoin('tbl_salesman','tbl_planogram_post.salesman','tbl_salesman.id')
		   ->leftjoin('tbl_planogram','tbl_planogram_post.planogram_name','tbl_planogram.id')
		   ->leftjoin('tbl_shelf_display','tbl_planogram_post.shelf_display','tbl_shelf_display.id')
		  ->select('tbl_planogram_post.date','tbl_salesman.salesman_code','tbl_salesman.salesman_name','tbl_customer.customer_code','tbl_customer.customer_name','tbl_planogram.planogram_name','tbl_shelf_display.name')
		/*  ->where('tbl_company_stock_transfer_header.status', '=', 'active')  */     
		  ->get(); 	
		}
		else if($this->menu_id==15 && $this->submenu_id==272)
		{
		  $records=DB::table('tbl_asset_tracking')
		    ->leftjoin('tbl_customer','tbl_asset_tracking.customer','tbl_customer.id')
		   ->leftjoin('tbl_region','tbl_asset_tracking.region','tbl_region.id')
		   ->leftjoin('tbl_sub_region','tbl_asset_tracking.sub_region','tbl_sub_region.id')
		   ->leftjoin('tbl_route','tbl_asset_tracking.route','tbl_route.id')
		   ->leftjoin('tbl_customer_category','tbl_asset_tracking.customer_category','tbl_customer_category.id')
		   
		  ->select('tbl_asset_tracking.asset_code','tbl_asset_tracking.asset_name','tbl_asset_tracking.asset_type','tbl_asset_tracking.asset_barcode','tbl_asset_tracking.serial_no','tbl_asset_tracking.longitude','tbl_asset_tracking.latitude','tbl_asset_tracking.valid_from','tbl_asset_tracking.valid_to','tbl_region.region_code','tbl_region.region_name','tbl_sub_region.sub_region_code','tbl_sub_region.sub_region_name','tbl_route.route_code','tbl_route.route_name','tbl_customer_category.customer_category_code','tbl_customer_category.customer_category_name','tbl_customer.customer_code','tbl_customer.customer_name','tbl_asset_tracking.status')
		/*  ->where('tbl_company_stock_transfer_header.status', '=', 'active')  */     
		  ->get(); 	
		}
		else if($this->menu_id==15 && $this->submenu_id==276)    
		{
		  $records=DB::table('tbl_asset_post')
		    ->leftjoin('tbl_customer','tbl_asset_post.customer','tbl_customer.id')
		   ->leftjoin('tbl_salesman','tbl_asset_post.salesman','tbl_salesman.id')
		   ->leftjoin('tbl_asset_tracking','tbl_asset_post.asset_name','tbl_asset_tracking.id')
		  
		  ->select('tbl_asset_post.date','tbl_salesman.salesman_code','tbl_salesman.salesman_name','tbl_customer.customer_code','tbl_customer.customer_name','tbl_asset_tracking.asset_name')
		/*  ->where('tbl_company_stock_transfer_header.status', '=', 'active')  */     
		  ->get(); 	
		}
		else if($this->menu_id==15 && $this->submenu_id==277)
		{
		  $records=DB::table('tbl_promotion')
		    ->leftjoin('tbl_material_master','tbl_promotion.material','tbl_material_master.id')
		  ->select('tbl_material_master.material_code','tbl_material_master.material_name','tbl_promotion.from_date','tbl_promotion.to_date','tbl_promotion.amount','tbl_promotion.status')
		/*  ->where('tbl_company_stock_transfer_header.status', '=', 'active')  */     
		  ->get(); 	
		}
		else if($this->menu_id==15 && $this->submenu_id==278)
		{
		  $records=DB::table('tbl_promotional_post')
		    ->leftjoin('tbl_material_master','tbl_promotional_post.free_material','tbl_material_master.id')
			->leftjoin('tbl_customer','tbl_promotional_post.customer','tbl_customer.id')
		   ->leftjoin('tbl_salesman','tbl_promotional_post.salesman','tbl_salesman.id')
		  ->select('tbl_promotional_post.date','tbl_material_master.material_code','tbl_material_master.material_name','tbl_promotional_post.invoice','tbl_salesman.salesman_code','tbl_salesman.salesman_name','tbl_customer.customer_code','tbl_customer.customer_name','tbl_promotional_post.phone','tbl_promotional_post.amount_spend')
		/*  ->where('tbl_company_stock_transfer_header.status', '=', 'active')  */       
		  ->get(); 	
		}
		else if($this->menu_id==15 && $this->submenu_id==343)
		{
		  $records=DB::table('tbl_assign_inventory_header')
			->leftjoin('tbl_customer','tbl_assign_inventory_header.customer','tbl_customer.id')
			
		  ->select('tbl_assign_inventory_header.created_at','tbl_customer.customer_code','tbl_customer.customer_name')
		/*  ->where('tbl_company_stock_transfer_header.status', '=', 'active')  */      
		  ->get(); 	
		}
		else if($this->menu_id==15 && $this->submenu_id==342)
		{
		  $records=DB::table('tbl_assign_material_header')
			->leftjoin('tbl_customer','tbl_assign_material_header.customer_name','tbl_customer.id')
			->leftjoin('tbl_shelf_display','tbl_assign_material_header.shelf_display','tbl_shelf_display.id')
			->leftjoin('tbl_material_category','tbl_assign_material_header.material_category','tbl_material_category.id')
			
		  ->select('tbl_customer.customer_code','tbl_customer.customer_name','tbl_shelf_display.name','tbl_material_category.category_code','tbl_material_category.category_name','tbl_assign_material_header.created_at')
		/*  ->where('tbl_company_stock_transfer_header.status', '=', 'active')  */      
		  ->get(); 	
		}
		else if($this->menu_id==15 && $this->submenu_id==35)
		{
		   $records=DB::table('tbl_surveys')
			
		  ->select('tbl_surveys.survey_name','tbl_surveys.from_date','tbl_surveys.to_date','tbl_surveys.status')
		   ->get(); 	
		}
		else if($this->menu_id==15 && $this->submenu_id==38)
		{
		   $records=DB::table('tbl_survey_answer_header')
			->leftjoin('tbl_surveys','tbl_survey_answer_header.survey_id','tbl_surveys.id')
			
		  ->select('tbl_surveys.survey_name','tbl_survey_answer_header.customer_name','tbl_survey_answer_header.phone_no','tbl_survey_answer_header.created_at')
		   ->get(); 	
		}
		else if($this->menu_id==6 && $this->submenu_id==95)
		{
		   $records=DB::table('tbl_user')
			->leftjoin('tbl_user_role','tbl_user.user_role','tbl_user_role.id')   
			->leftjoin('tbl_company','tbl_user.company_name','tbl_company.id')
			->leftjoin('tbl_region','tbl_user.region','tbl_region.id')
						
		  ->select('tbl_user_role.role_code','tbl_user_role.role_name','tbl_user.user_code','tbl_user.first_name','tbl_user.last_name','tbl_user.user_name','tbl_user.user_password','tbl_user.address','tbl_user.city','tbl_user.zip','tbl_user.email','tbl_user.contact_no','tbl_company.company_code','tbl_company.company_name','tbl_region.region_code','tbl_region.region_name','tbl_user.block_from','tbl_user.block_to','tbl_user.status')
		   ->get(); 	
		}
		else if($this->menu_id==6 && $this->submenu_id==97)
		{
		   $records=DB::table('tbl_user_role')
			
		  ->select('tbl_user_role.role_code','tbl_user_role.role_name','tbl_user_role.status')
		   ->get(); 	
		}
		
		else if($this->menu_id==13 && $this->submenu_id==348)
		{
		  $records=DB::table('tbl_material_category_new')
			
		  ->select('tbl_material_category_new.category_codes','tbl_material_category_new.category_names','tbl_material_category_new.status')
		   ->get(); 
		}
		
		
		
		
		else if($this->menu_id==13 && $this->submenu_id==172)
		{
		   $records=DB::table('tbl_manage_code')
		  ->select(
		  'tbl_manage_code.company_code',
		  'tbl_manage_code.customer_code',
		  'tbl_manage_code.warehouse_code',
		  'tbl_manage_code.erp_asset_code',
		  'tbl_manage_code.sales_area_code',
		  'tbl_manage_code.salesman_code',
		  'tbl_manage_code.erp_employee_code',
		  'tbl_manage_code.material_code',
		  'tbl_manage_code.erp_material_code',
		  'tbl_manage_code.bank_code',
		  'tbl_manage_code.user_code',
		  'tbl_manage_code.tax_code',
		  'tbl_manage_code.discount_code', 
		  'tbl_manage_code.supplier_code',
		  'tbl_manage_code.company_type_code',
		  'tbl_manage_code.currency_code',
		  'tbl_manage_code.country_code',
		  'tbl_manage_code.reason_code',
		  'tbl_manage_code.city_code',
		  'tbl_manage_code.region_code',
		  'tbl_manage_code.sub_region_code',
		  'tbl_manage_code.customer_type_code',
		  'tbl_manage_code.customer_category_code',
		  'tbl_manage_code.outlet_code',
		  'tbl_manage_code.vehicle_brand_code',
		  'tbl_manage_code.vehicle_type_code', 
		  'tbl_manage_code.salesman_type_code',
		  'tbl_manage_code.uom_code',
		  'tbl_manage_code.category_code',
		  'tbl_manage_code.brand_code',
		  'tbl_manage_code.role_code',
		  'tbl_manage_code.expense_code',
		  'tbl_manage_code.target_code',
		  'tbl_manage_code.location_code',
		  'tbl_manage_code.payment_code',
		  'tbl_manage_code.supplier_type_code',
		  'tbl_manage_code.expense_category_code',
		  'tbl_manage_code.vehicle_code',
		  'tbl_manage_code.updated_user', 
		  'tbl_manage_code.created_at',
		  'tbl_manage_code.updated_at',
		  'tbl_manage_code.trading_center_code',
		  'tbl_manage_code.invoice_number_code',
		  'tbl_manage_code.unload_code',
		  'tbl_manage_code.load_code',
		  'tbl_manage_code.return_sales_code',
		  'tbl_manage_code.company_order_code',
		  'tbl_manage_code.company_return_order_code',
		  'tbl_manage_code.expense_no',
		  'tbl_manage_code.company_expense_no',
		  'tbl_manage_code.delivery_order_no',
		  'tbl_manage_code.delivery_return_order_number',
		  'tbl_manage_code.company_invoice_no',
		  'tbl_manage_code.company_credit_note_number',
		  'tbl_manage_code.company_colletion_number',
		  'tbl_manage_code.outlet_expense_number',
		  'tbl_manage_code.counter_sales_no',
		  'tbl_manage_code.client_code',
		  'tbl_manage_code.commission_range',
		  'tbl_manage_code.type_code',
		  'tbl_manage_code.category_codes',
		  )
		   ->get(); 	
		}
		 
		
		
      return $records; 
	 
    }
	
	
  }
  

