<?php

namespace App\Exports;
use App\user;
use Maatwebsite\Excel\Concerns\FromCollection;
use Maatwebsite\Excel\Concerns\WithHeadings;
use Illuminate\Support\Facades\DB;
use Illuminate\Contracts\View\View;
use Maatwebsite\Excel\Concerns\FromView;
use Maatwebsite\Excel\Concerns\WithDrawings;
use PhpOffice\PhpSpreadsheet\Worksheet\Drawing; 
use Maatwebsite\Excel\Concerns\ShouldAutoSize;
use Maatwebsite\Excel\Concerns\WithCustomStartCell;
use Maatwebsite\Excel\Concerns\WithEvents;
use Maatwebsite\Excel\Events\AfterSheet;
 
class OutletCounterExport implements FromView,WithDrawings,ShouldAutoSize,WithCustomStartCell,WithEvents  
  {
	 
	   protected $id;

        function __construct(int $id){
		
          $this->id = $id;
		
	        }
			
			   
	 public function drawings()
    {
        $drawing = new Drawing();
        $drawing->setName('Logo');
        $drawing->setDescription('This is my logo');
        $drawing->setPath(public_path('elitesotlab.png'));
        $drawing->setHeight(100);
        $drawing->setCoordinates('A1');

        return $drawing;
    }
	
	public function startCell(): string
    {
        return 'A6';

    }
	
	  public function registerEvents(): array
    {
        return [
            AfterSheet::class=> function(AfterSheet $event) {
                $event-> sheet->mergeCells('A1:B5'); 
                   
              $event->sheet->getStyle('A6:F6')->applyFromArray ([
				
                    'font' => [
                        'name'      =>  'Calibri',
                        'size'      =>  13,
                        'bold'      =>  true,
                        'color' => ['argb' => '#000000'],
                    ],
					    'fill' => [
                        'fillType' => \PhpOffice\PhpSpreadsheet\Style\Fill::FILL_SOLID,
                        'startColor' => [
                            'rgb' => 'dff0d8',
                         ],            
                    ]  
				 
				    
				]);   
				
			  $event->sheet->getStyle('A10:H10')->applyFromArray ([
				
                    'font' => [
                        'name'      =>  'Calibri',
                        'size'      =>  13,
                        'bold'      =>  true,
                        'color' => ['argb' => '#000000'],
                    ],
					   'fill' => [
                        'fillType' => \PhpOffice\PhpSpreadsheet\Style\Fill::FILL_SOLID,
                        'startColor' => [
                            'rgb' => 'dff0d8',
                         ],           
                    ]
				   
				    
				]);  
				 
            
	 }
        ];
    }  
	
	      
         public function view(): View
          {
		
		    $get_data =DB::table('tbl_outlet_counter_sales_header')
			->leftJoin('tbl_customer', 'tbl_outlet_counter_sales_header.distibutor_id', '=', 'tbl_customer.id')
			->leftJoin('tbl_warehouse', 'tbl_outlet_counter_sales_header.outlet_id', '=', 'tbl_warehouse.id')
			->leftJoin('tbl_warehouse as warehouse1', 'tbl_outlet_counter_sales_header.warehouse_id', '=', 'warehouse1.id')
			->leftJoin('tbl_currency_type', 'tbl_outlet_counter_sales_header.currency', '=', 'tbl_currency_type.id') 
			 ->select('tbl_outlet_counter_sales_header.*','tbl_currency_type.currency_notation','tbl_customer.customer_code','tbl_customer.customer_name','warehouse1.warehouse_code as wc1','warehouse1.warehouse_name as wn1','tbl_warehouse.warehouse_code','tbl_warehouse.warehouse_name','warehouse1.warehouse_code as w_code','warehouse1.warehouse_name as w_name')->where('tbl_outlet_counter_sales_header.id', '=',$this->id)->get()->first();
			  //dd($get_data);
			$get_data_details =DB::table('tbl_outlet_counter_sales_details') 
			->leftJoin('tbl_material_master', 'tbl_outlet_counter_sales_details.material_id', '=', 'tbl_material_master.id')
			->leftJoin('tbl_unit_of_measurement', 'tbl_outlet_counter_sales_details.uom', '=', 'tbl_unit_of_measurement.id') 
			->select('tbl_outlet_counter_sales_details.*','tbl_material_master.material_code as m_code','tbl_material_master.material_name','tbl_unit_of_measurement.unit_notation')->where('tbl_outlet_counter_sales_details.header_id', '=', $this->id)->get()->all();
		  
        return view('export.counter_sales_export', 
		                  ['header' => $get_data],
		                  ['details' => $get_data_details]
						  
		            );
           } 
	
		  
           
    /**
    * @return \Illuminate\Support\Collection
    */
      
        
}
