<?php

namespace App\Exports;
use App\user;
use Maatwebsite\Excel\Concerns\FromCollection;
use Maatwebsite\Excel\Concerns\WithHeadings;
use Illuminate\Support\Facades\DB;
use Illuminate\Contracts\View\View;
use Maatwebsite\Excel\Concerns\FromView;
use Maatwebsite\Excel\Concerns\WithDrawings;
use PhpOffice\PhpSpreadsheet\Worksheet\Drawing; 
use Maatwebsite\Excel\Concerns\ShouldAutoSize;
use Maatwebsite\Excel\Concerns\WithCustomStartCell;
use Maatwebsite\Excel\Concerns\WithEvents;
use Maatwebsite\Excel\Events\AfterSheet;
 
class ReturnSalesExport implements FromView,WithDrawings,ShouldAutoSize,WithCustomStartCell,WithEvents  
  {
	 
	   protected $id;

        function __construct(int $id){
		
          $this->id = $id;
		
	        }
			
			   
	 public function drawings()
    {
        $drawing = new Drawing();
        $drawing->setName('Logo');
        $drawing->setDescription('This is my logo');
        $drawing->setPath(public_path('elitesotlab.png'));
        $drawing->setHeight(87);
        $drawing->setCoordinates('A1');

        return $drawing;
    }
	
	public function startCell(): string
    {
        return 'A6';

    }
	
	 public function registerEvents(): array
    {
        return [
            AfterSheet::class=> function(AfterSheet $event) {
                $event-> sheet->mergeCells('A1:E5');
                   
                $event->sheet->getStyle('A6:K6')->applyFromArray ([
				
                    'font' => [
                        'name'      =>  'Calibri',
                        'size'      =>  13,
                        'bold'      =>  true,
                        'color' => ['argb' => '#000000'],
                    ],
					'fill' => [
                        'fillType' => \PhpOffice\PhpSpreadsheet\Style\Fill::FILL_SOLID,
                        'startColor' => [
                            'rgb' => 'dff0d8',
                         ],           
                    ]
				 
				    
				]); 
				
				$event->sheet->getStyle('A10:K10')->applyFromArray ([
				
                    'font' => [
                        'name'      =>  'Calibri',
                        'size'      =>  13,
                        'bold'      =>  true,
                        'color' => ['argb' => '#000000'],
                    ],
					'fill' => [
                        'fillType' => \PhpOffice\PhpSpreadsheet\Style\Fill::FILL_SOLID,
                        'startColor' => [
                            'rgb' => 'dff0d8',
                         ],           
                    ]
				 
				    
				]);
				 
            
	 }
        ];
    }
	
	      
         public function view(): View
          {
		
		    $get_data =DB::table('tbl_return_sales_header')
		     ->leftJoin('tbl_trading_center', 'tbl_return_sales_header.trading_center_id', '=', 'tbl_trading_center.id')
		     ->leftJoin('tbl_route', 'tbl_return_sales_header.route_id', '=', 'tbl_route.id')
		     ->leftJoin('tbl_customer', 'tbl_return_sales_header.customer_id', '=', 'tbl_customer.id')
		     ->leftJoin('tbl_warehouse', 'tbl_return_sales_header.warehouse_id', '=', 'tbl_warehouse.id')
		     ->leftJoin('tbl_salesman', 'tbl_return_sales_header.salesman_id', '=', 'tbl_salesman.id')
		     ->leftJoin('tbl_currency_type', 'tbl_return_sales_header.currency', '=', 'tbl_currency_type.id')           
		     ->select('tbl_return_sales_header.*', 'tbl_trading_center.trading_name', 'tbl_trading_center.trading_center_code', 'tbl_route.route_name','tbl_route.route_code','tbl_customer.customer_name','tbl_customer.customer_code','tbl_warehouse.warehouse_name','tbl_warehouse.warehouse_code','tbl_salesman.salesman_name','tbl_salesman.salesman_code','tbl_currency_type.currency_notation')->where('tbl_return_sales_header.id', '=',$this->id)->get()->first();		
		     $get_data_details =DB::table('tbl_return_sales_details')

		     ->leftJoin('tbl_material_master', 'tbl_return_sales_details.material_id', '=', 'tbl_material_master.id')
		     ->leftJoin('tbl_unit_of_measurement', 'tbl_return_sales_details.uom', '=', 'tbl_unit_of_measurement.id')
		     ->leftJoin('tbl_reason_type', 'tbl_return_sales_details.resion', '=', 'tbl_reason_type.id')
  
		     ->select('tbl_return_sales_details.*','tbl_material_master.material_name','tbl_material_master.material_code','tbl_reason_type.reasion_type as reason_name','tbl_unit_of_measurement.unit_notation')->where('tbl_return_sales_details.header_id', '=', $this->id)->get()->all();
		  
        return view('export.return_sales_export', 
		                  ['header' => $get_data],
		                  ['details' => $get_data_details]
						  
		            );
           } 
	
		  
           
    /**
    * @return \Illuminate\Support\Collection
    */
      
        
}
