<?php
namespace App\Exports;
use App\user;
use Maatwebsite\Excel\Concerns\FromCollection;
use Maatwebsite\Excel\Concerns\WithHeadings;
use Illuminate\Support\Facades\DB;
use Maatwebsite\Excel\Concerns\ShouldAutoSize;
class RoutePerformanceExport implements FromCollection,WithHeadings,ShouldAutoSize
  {	
	protected $year;
	protected $month;
	protected $region;
	protected $subregion;
    function __construct($year,$month,$region,$subregion) {
        $this->year = $year;
        $this->month = $month;
        $this->region = $region;
        $this->subregion = $subregion;
	}
	public function headings():array{
		return[
		'Route Name',
		'Warehouse Name',
		'Total Sales',
		'Total Qty',
		];
	}
    /**
    * @return \Illuminate\Support\Collection
    */
    public function collection()
		{
	if($this->region=='')
		{
	      if($this->month=='0')
			{ 
			  $get_data1 = DB::table('tbl_route_invoice_header')
				->leftJoin('tbl_route', 'tbl_route_invoice_header.route_id', '=', 'tbl_route.id')
				->leftJoin('tbl_warehouse', 'tbl_route_invoice_header.warehouse_id', '=', 'tbl_warehouse.id')
				->leftJoin('tbl_route_invoice_details', 'tbl_route_invoice_header.id', '=', 'tbl_route_invoice_details.header_id')
		        ->select(DB::raw('sum(tbl_route_invoice_header.total_invoice_value) as total_invoice'),DB::raw('sum(tbl_route_invoice_details.quantity) as qty'),'tbl_route.route_name as route_name','tbl_warehouse.warehouse_code','tbl_warehouse.warehouse_name','tbl_route_invoice_header.route_id')
				->orderBy(DB::raw('sum(tbl_route_invoice_header.total_invoice_value)'),'desc')
				->groupBy('tbl_route_invoice_header.route_id','tbl_route_invoice_header.warehouse_id') 
				->whereYear('tbl_route_invoice_header.created_at', $this->year)
				->get();
				 
			} 
          else
		    {				
		       $get_data1 = DB::table('tbl_route_invoice_header')
			   ->leftJoin('tbl_route', 'tbl_route_invoice_header.route_id', '=', 'tbl_route.id')
			   ->leftJoin('tbl_warehouse', 'tbl_route_invoice_header.warehouse_id', '=', 'tbl_warehouse.id')
			   ->leftJoin('tbl_route_invoice_details', 'tbl_route_invoice_header.id', '=', 'tbl_route_invoice_details.header_id')
	           ->select(DB::raw('sum(tbl_route_invoice_header.total_invoice_value) as  total_invoice'),DB::raw('sum(tbl_route_invoice_details.quantity) as qty'),'tbl_route.route_name as route_name','tbl_warehouse.warehouse_code','tbl_warehouse.warehouse_name','tbl_route_invoice_header.route_id')
			   ->orderBy(DB::raw('sum(tbl_route_invoice_header.total_invoice_value)'),'desc')
			   ->groupBy('tbl_route_invoice_header.route_id','tbl_route_invoice_header.warehouse_id') 
			   ->whereYear('tbl_route_invoice_header.created_at', $this-> year)
			   ->whereMonth('tbl_route_invoice_header.created_at', $this-> month)
			   ->get();
			  
		    }   
			 
		}
	 else{  
		 if($this->sub_region='s')
		    {
			  if($this->sub_region!=0)
				{
				  $agent_name     = array(); 
				  $agent_id     = array(); 
				  $get_data1 = DB::table('tbl_sub_region')
				  ->select('tbl_sub_region.sub_region_code','tbl_sub_region.sub_region_name','tbl_sub_region.id')
				  ->where('tbl_sub_region.status','=','active')
				  ->where('tbl_sub_region.id','=',$this->sub_region)->get();
				  foreach($get_data1 as $key=> $sub_region)
					{
					  $agent_id[]=$sub_region->id;
					}
					
				}
			  else  
				{
				  $agent_name     = array(); 
				  $agent_id     = array(); 
				  $get_data1 = DB::table('tbl_sub_region')
				  ->select('tbl_sub_region.sub_region_code','tbl_sub_region.sub_region_name','tbl_sub_region.id')
				  ->where('tbl_sub_region.status','=','active')
				  ->get();
				  foreach($get_data1 as $key=> $sub_region)
					{
					 $agent_id[]=$sub_region->id;
					}
				}
			  if($this->month==0)
				{
					$get_data1 = DB::table('tbl_route_invoice_header')
					->leftJoin('tbl_route', 'tbl_route_invoice_header.route_id', '=', 'tbl_route.id')
					->leftJoin('tbl_warehouse', 'tbl_route_invoice_header.warehouse_id', '=', 'tbl_warehouse.id')
					->leftJoin('tbl_route_invoice_details', 'tbl_route_invoice_header.id', '=', 'tbl_route_invoice_details.header_id')
					->select(DB::raw('sum(tbl_route_invoice_header.total_invoice_value) as total_invoice'),DB::raw('sum(tbl_route_invoice_details.quantity) as qty'),'tbl_route.route_name as route_name','tbl_warehouse.warehouse_code','tbl_warehouse.warehouse_name','tbl_route_invoice_header.route_id')
					->orderBy(DB::raw('sum(tbl_route_invoice_header.total_invoice_value)'),'desc')
					->groupBy('tbl_route_invoice_header.route_id','tbl_route_invoice_header.warehouse_id') 
					->whereYear('tbl_route_invoice_header.created_at',$this-> year)
					->whereIn('tbl_route_invoice_header.subregion_id',$agent_id)
					->get();
					 
				}
			 else 
				{
					$get_data1 = DB::table('tbl_route_invoice_header')
					->leftJoin('tbl_route', 'tbl_route_invoice_header.route_id', '=', 'tbl_route.id')
					->leftJoin('tbl_warehouse', 'tbl_route_invoice_header.warehouse_id', '=', 'tbl_warehouse.id')
					->leftJoin('tbl_route_invoice_details', 'tbl_route_invoice_header.id', '=', 'tbl_route_invoice_details.header_id')
			        ->select(DB::raw('sum(tbl_route_invoice_header.total_invoice_value) as total_invoice'),DB::raw('sum(tbl_route_invoice_details.quantity) as qty'),'tbl_route.route_name as route_name','tbl_warehouse.warehouse_code','tbl_warehouse.warehouse_name','tbl_route_invoice_header.route_id')
					->orderBy(DB::raw('sum(tbl_route_invoice_header.total_invoice_value)'),'desc')
					->groupBy('tbl_route_invoice_header.route_id','tbl_route_invoice_header.warehouse_id') 
					->whereYear('tbl_route_invoice_header.created_at', $this->year)
					->whereMonth('tbl_route_invoice_header.created_at', $this->month)
					->whereIn('tbl_route_invoice_header.subregion_id', $agent_id)
					->get();
					 
				}
			     
			}
		else{
			 if($this->region !='s')
			    {
                  if($this->region!=0)
				    {
					  $agent_name     = array(); 
					  $agent_id     = array(); 
					  $get_data1 = DB::table('tbl_region')
					  ->select('tbl_region.region_code','tbl_region.region_name','tbl_region.id')
					  ->where('tbl_region.status','=','active')
					  ->where('tbl_region.id','=',$this->region)->get();
					  foreach($get_data1 as $key=>$region)
						{
						  $agent_id[]=$region->id;
					    }
					}
				  else  
					{
					  $agent_name     = array(); 
					  $agent_id     = array(); 
					  $get_data1 = DB::table('tbl_region')
					  ->select('tbl_region.region_code','tbl_region.region_name','tbl_region.id')
					  ->where('tbl_region.status','=','active')
					  ->get();
					  foreach($get_data1 as $key=> $region)
						{
						 $agent_id[]=$region->id;
						}
				    }
                   if($request->month==0)
				    {					
					   $get_data1 = DB::table('tbl_route_invoice_header')
						->leftJoin('tbl_route', 'tbl_route_invoice_header.route_id', '=', 'tbl_route.id')
						->leftJoin('tbl_warehouse', 'tbl_route_invoice_header.warehouse_id', '=', 'tbl_warehouse.id')
						->leftJoin('tbl_route_invoice_details', 'tbl_route_invoice_header.id', '=', 'tbl_route_invoice_details.header_id')
						->select(DB::raw('sum(tbl_route_invoice_header.total_invoice_value) as total_invoice'),DB::raw('sum(tbl_route_invoice_details.quantity) as qty'),'tbl_route.route_name as route_name','tbl_warehouse.warehouse_code','tbl_warehouse.warehouse_name','tbl_route_invoice_header.route_id')
						->orderBy(DB::raw('sum(tbl_route_invoice_header.total_invoice_value)'),'desc')
						->groupBy('tbl_route_invoice_header.route_id','tbl_route_invoice_header.warehouse_id') 
						->whereYear('tbl_route_invoice_header.created_at', $this->year)
						->whereIn('tbl_route_invoice_header.region_id', $agent_id)
						->get()->all();
						 
					}
				  else
					{
						  
					 $get_data1 = DB::table('tbl_route_invoice_header')
					   ->leftJoin('tbl_route', 'tbl_route_invoice_header.route_id', '=', 'tbl_route.id')
						->leftJoin('tbl_warehouse', 'tbl_route_invoice_header.warehouse_id', '=', 'tbl_warehouse.id')
						->leftJoin('tbl_route_invoice_details', 'tbl_route_invoice_header.id', '=', 'tbl_route_invoice_details.header_id')
				        ->select(DB::raw('sum(tbl_route_invoice_header.total_invoice_value) as total_invoice'),DB::raw('sum(tbl_route_invoice_details.quantity) as qty'),'tbl_route.route_name as route_name','tbl_warehouse.warehouse_code','tbl_warehouse.warehouse_name','tbl_route_invoice_header.route_id')
						->orderBy(DB::raw('sum(tbl_route_invoice_header.total_invoice_value)'),'desc')
						->groupBy('tbl_route_invoice_header.route_id','tbl_route_invoice_header.warehouse_id') 
						->whereYear('tbl_route_invoice_header.created_at',  $this->year)
						->whereMonth('tbl_route_invoice_header.created_at',  $this->month)
						->whereIn('tbl_route_invoice_header.region_id', $agent_id)
						->get()->all();
						 
				    }
					 
			    }
	        }          
			
    return collect($get_data1);
   }
		}
}
