<?php
namespace App\Exports;
use App\user;

use Illuminate\Contracts\View\View;
use Maatwebsite\Excel\Concerns\FromView;
use Illuminate\Support\Facades\DB;
use Maatwebsite\Excel\Concerns\WithDrawings;
use PhpOffice\PhpSpreadsheet\Worksheet\Drawing;
use Maatwebsite\Excel\Concerns\ShouldAutoSize;
use Maatwebsite\Excel\Concerns\WithCustomStartCell;
use Maatwebsite\Excel\Concerns\WithEvents;
use Maatwebsite\Excel\Events\AfterSheet;

class SalesDeliveryExport implements FromView,WithDrawings,ShouldAutoSize,WithCustomStartCell,WithEvents
   {
  
	  protected $delivery;

	  
	  function __construct($delivery)
	  {
        $this->delivery = $delivery;
       }
	   
	  public function drawings()
    {
        $drawing = new Drawing();
        $drawing->setName('Logo');
        $drawing->setDescription('This is my logo');
        $drawing->setPath(public_path('elitesotlab.png'));
        $drawing->setHeight(87);
        $drawing->setCoordinates('A1');

        return $drawing;
    }
	
	public function startCell(): string
    {
        return 'A6';

    }
	
 public function registerEvents(): array
    {
        return [
            AfterSheet::class=> function(AfterSheet $event) {
                $event-> sheet->mergeCells('A1:E5');
                   
                $event->sheet->getStyle('A6:K6')->applyFromArray ([
				
                    'font' => [
                        'name'      =>  'Calibri',
                        'size'      =>  13,
                        'bold'      =>  true,
                        'color' => ['argb' => '#000000'],
                    ],
					'fill' => [
                        'fillType' => \PhpOffice\PhpSpreadsheet\Style\Fill::FILL_SOLID,
                        'startColor' => [
                            'rgb' => 'dff0d8',
                         ],           
                    ]
				 
				    
				]); 
				
				$event->sheet->getStyle('A10:K10')->applyFromArray ([
				
                    'font' => [
                        'name'      =>  'Calibri',
                        'size'      =>  13,
                        'bold'      =>  true,
                        'color' => ['argb' => '#000000'],
                    ],
					'fill' => [
                        'fillType' => \PhpOffice\PhpSpreadsheet\Style\Fill::FILL_SOLID,
                        'startColor' => [
                            'rgb' => 'dff0d8',
                         ],           
                    ]
				 
				    
				]);
				 
            
	 }
        ];
    }
	
	 public function view(): View
    {
		
       $result = DB::table('tbl_company_delivery_header')
		         ->leftjoin('tbl_customer','tbl_company_delivery_header.customer','=','tbl_customer.id')
		         ->leftjoin('tbl_warehouse','tbl_company_delivery_header.warehouse','=','tbl_warehouse.id')
		         ->leftjoin('tbl_company_order_header','tbl_company_delivery_header.order_number','=','tbl_company_order_header.id')
		       
		  
                  ->select( 'tbl_company_delivery_header.company_delivery_number','tbl_customer.customer_name','tbl_customer.customer_code','tbl_warehouse.warehouse_code','tbl_warehouse.warehouse_name','tbl_company_delivery_header.total_delivery_value','tbl_company_order_header.company_order_number','tbl_company_delivery_header.order_type','tbl_company_delivery_header.created_at')
				  ->where('tbl_company_delivery_header.id','=',$this->delivery)
				 ->get();
				 
				 

			 
			$get_data_details =DB::table('tbl_company_delivery_detail')
  
			   ->leftJoin('tbl_material_master', 'tbl_company_delivery_detail.material_id', '=', 'tbl_material_master.id')
			   ->leftJoin('tbl_unit_of_measurement', 'tbl_company_delivery_detail.uom', '=', 'tbl_unit_of_measurement.id')
			  ->leftJoin('tbl_reason','tbl_company_delivery_detail.return_type','=','tbl_reason.id')
			   ->leftJoin('tbl_reason_type','tbl_company_delivery_detail.resion','=','tbl_reason_type.id')
	  
			  ->select('tbl_company_delivery_detail.quantity','tbl_company_delivery_detail.unite_price','tbl_company_delivery_detail.gross_total','tbl_company_delivery_detail.vat','tbl_company_delivery_detail.excise','tbl_company_delivery_detail.discount','tbl_company_delivery_detail.net_amount','tbl_material_master.material_code','tbl_material_master.material_name','tbl_unit_of_measurement.uom_name','tbl_unit_of_measurement.unit_notation','tbl_reason_type.reasion_type','tbl_reason.reason_type'
			  )
			  ->where('tbl_company_delivery_detail.header_id','=',$this->delivery)
			  ->get()->all();
	  // dd($get_data_details);
	 return view('export.sales_delivery_export', 
		                  ['header' => $result],
		                  ['details' => $get_data_details]
						  
		            );
  
  }
  }
