<?php
namespace App\Exports;
use App\user;

use Illuminate\Contracts\View\View;
use Maatwebsite\Excel\Concerns\FromView;
use Illuminate\Support\Facades\DB;
use Maatwebsite\Excel\Concerns\WithDrawings;
use PhpOffice\PhpSpreadsheet\Worksheet\Drawing;
use Maatwebsite\Excel\Concerns\ShouldAutoSize;
use Maatwebsite\Excel\Concerns\WithCustomStartCell;
use Maatwebsite\Excel\Concerns\WithEvents;
use Maatwebsite\Excel\Events\AfterSheet;

class SalesInvoiceExport implements FromView,WithDrawings,ShouldAutoSize,WithCustomStartCell,WithEvents
   {
  
	  protected $salesinvoice;

	  
	  function __construct($salesinvoice)
	  {
        $this->salesinvoice = $salesinvoice;
       }
	   
	  public function drawings()
    {
        $drawing = new Drawing();
        $drawing->setName('Logo');
        $drawing->setDescription('This is my logo');
        $drawing->setPath(public_path('elitesotlab.png'));
        $drawing->setHeight(87);
        $drawing->setCoordinates('A1');

        return $drawing;
    }
	
	public function startCell(): string
    {
        return 'A6';

    }
	
 public function registerEvents(): array
    {
        return [
            AfterSheet::class=> function(AfterSheet $event) {
                $event-> sheet->mergeCells('A1:E5');
                   
                $event->sheet->getStyle('A6:K6')->applyFromArray ([
				
                    'font' => [
                        'name'      =>  'Calibri',
                        'size'      =>  13,
                        'bold'      =>  true,
                        'color' => ['argb' => '#000000'],
                    ],
					'fill' => [
                        'fillType' => \PhpOffice\PhpSpreadsheet\Style\Fill::FILL_SOLID,
                        'startColor' => [
                            'rgb' => 'dff0d8',
                         ],           
                    ]
				 
				    
				]); 
				
				$event->sheet->getStyle('A10:K10')->applyFromArray ([
				
                    'font' => [
                        'name'      =>  'Calibri',
                        'size'      =>  13,
                        'bold'      =>  true,
                        'color' => ['argb' => '#000000'],
                    ],
					'fill' => [
                        'fillType' => \PhpOffice\PhpSpreadsheet\Style\Fill::FILL_SOLID,
                        'startColor' => [
                            'rgb' => 'dff0d8',
                         ],           
                    ]
				 
				    
				]);
				 
            
	 }
        ];
    }
	
	 public function view(): View
    {
		
       $result = DB::table('tbl_company_invoice_header')
		         ->leftjoin('tbl_customer','tbl_company_invoice_header.customer','=','tbl_customer.id')
		         ->leftjoin('tbl_warehouse','tbl_company_invoice_header.warehouse','=','tbl_warehouse.id')
		         ->leftjoin('tbl_currency_type','tbl_company_invoice_header.currency','=','tbl_currency_type.id')
		         ->leftjoin('tbl_company_delivery_header','tbl_company_invoice_header.delivery_number','=','tbl_company_delivery_header.id')
		  
                 ->select('tbl_company_invoice_header.company_invoice_number','tbl_company_invoice_header.created_at','tbl_customer.customer_code','tbl_customer.customer_name','tbl_warehouse.warehouse_code','tbl_warehouse.warehouse_name','tbl_company_invoice_header.total_invoice_value','tbl_company_delivery_header.company_delivery_number')
				  ->where('tbl_company_invoice_header.id','=',$this->salesinvoice)
				 ->get();
				 
				 

			 
			$get_data_details =DB::table('tbl_company_invoice_details')

	   ->leftJoin('tbl_material_master', 'tbl_company_invoice_details.material_id', '=', 'tbl_material_master.id')
	   ->leftJoin('tbl_unit_of_measurement', 'tbl_company_invoice_details.uom', '=', 'tbl_unit_of_measurement.id')
       ->select('tbl_material_master.material_name', 'tbl_material_master.material_code','tbl_unit_of_measurement.unit_notation','tbl_company_invoice_details.quantity','tbl_company_invoice_details.unite_price','tbl_company_invoice_details.discount','tbl_company_invoice_details.vat','tbl_company_invoice_details.excise','tbl_company_invoice_details.net_amount','tbl_company_invoice_details.gross_total')
	   
	    ->where('tbl_company_invoice_details.header_id','=',$this->salesinvoice)
	   ->get()
	   ->all();
	  // dd($get_data_details);
	 return view('export.sales_invoice_export', 
		                  ['header' => $result],
		                  ['details' => $get_data_details]
						  
		            );
  
  }
  }
