<?php
namespace App\Exports;
use App\user;

use Illuminate\Contracts\View\View;
use Maatwebsite\Excel\Concerns\FromView;
use Illuminate\Support\Facades\DB;
use Maatwebsite\Excel\Concerns\WithDrawings;
use PhpOffice\PhpSpreadsheet\Worksheet\Drawing;
use Maatwebsite\Excel\Concerns\ShouldAutoSize;
use Maatwebsite\Excel\Concerns\WithCustomStartCell;
use Maatwebsite\Excel\Concerns\WithEvents;
use Maatwebsite\Excel\Events\AfterSheet;

class SalesOrderExport implements FromView,WithDrawings,ShouldAutoSize,WithCustomStartCell,WithEvents
   {
  
	  protected $saleorder;

	  
	  function __construct($saleorder)
	  {
        $this->saleorder = $saleorder;
       }
	   
	  public function drawings()
    {
        $drawing = new Drawing();
        $drawing->setName('Logo');
        $drawing->setDescription('This is my logo');
        $drawing->setPath(public_path('elitesotlab.png'));
        $drawing->setHeight(87);
        $drawing->setCoordinates('A1');

        return $drawing;
    }
	
	public function startCell(): string
    {
        return 'A6';

    }
	
 public function registerEvents(): array
    {
        return [
            AfterSheet::class=> function(AfterSheet $event) {
                $event-> sheet->mergeCells('A1:E5');
                   
                $event->sheet->getStyle('A6:K6')->applyFromArray ([
				
                    'font' => [
                        'name'      =>  'Calibri',
                        'size'      =>  13,
                        'bold'      =>  true,
                        'color' => ['argb' => '#000000'],
                    ],
					'fill' => [
                        'fillType' => \PhpOffice\PhpSpreadsheet\Style\Fill::FILL_SOLID,
                        'startColor' => [
                            'rgb' => 'dff0d8',
                         ],           
                    ]
				 
				    
				]); 
				
				$event->sheet->getStyle('A10:K10')->applyFromArray ([
				
                    'font' => [
                        'name'      =>  'Calibri',
                        'size'      =>  13,
                        'bold'      =>  true,
                        'color' => ['argb' => '#000000'],
                    ],
					'fill' => [
                        'fillType' => \PhpOffice\PhpSpreadsheet\Style\Fill::FILL_SOLID,
                        'startColor' => [
                            'rgb' => 'dff0d8',
                         ],           
                    ]
				 
				    
				]);
				 
            
	 }
        ];
    }
	
	 public function view(): View
    {
		
       $result = DB::table('tbl_company_order_header')
		         ->leftjoin('tbl_customer','tbl_company_order_header.customer_id','=','tbl_customer.id')
		         ->leftjoin('tbl_warehouse','tbl_company_order_header.warehouse_id','=','tbl_warehouse.id')
		         ->leftjoin('tbl_currency_type','tbl_company_order_header.currency_id','=','tbl_currency_type.id')
		  
                  ->select( 'tbl_company_order_header.company_order_number','tbl_company_order_header.created_at','tbl_customer.customer_name','tbl_customer.customer_code','tbl_warehouse.warehouse_code','tbl_warehouse.warehouse_name','tbl_company_order_header.total_order_value','tbl_company_order_header.order_type_id','tbl_company_order_header.remark')
				  ->where('tbl_company_order_header.id','=',$this->saleorder)
				 ->get()->all();
				 
				 

			 
			$get_data_details =DB::table('tbl_company_order_detail')

	   ->leftJoin('tbl_material_master', 'tbl_company_order_detail.material_id', '=', 'tbl_material_master.id')
	   ->leftJoin('tbl_unit_of_measurement', 'tbl_company_order_detail.uom_id', '=', 'tbl_unit_of_measurement.id')
	   ->leftJoin('tbl_reason_type', 'tbl_company_order_detail.resion_id', '=', 'tbl_reason_type.id')

	   ->select('tbl_material_master.material_name','tbl_material_master.material_code','tbl_unit_of_measurement.unit_notation','tbl_company_order_detail.quantity','tbl_company_order_detail.unite_price','tbl_company_order_detail.gross_total','tbl_company_order_detail.vat','tbl_company_order_detail.net_amount','tbl_company_order_detail.total','tbl_reason_type.reasion_type','tbl_reason_type.return_type','tbl_company_order_detail.excise')
	    ->where('tbl_company_order_detail.header_id','=',$this->saleorder)
	   ->get()
	   ->all();
	  // dd($get_data_details);
	 return view('export.sales_order_export', 
		                  ['header' => $result],
		                  ['details' => $get_data_details]
						  
		            );
  
  }
  }
