<?php

namespace App\Exports;
use App\user;
use Maatwebsite\Excel\Concerns\FromCollection;
use Maatwebsite\Excel\Concerns\WithHeadings;
use Illuminate\Support\Facades\DB;
use Maatwebsite\Excel\Concerns\ShouldAutoSize;

class SalesmanPerformanceExport implements FromCollection,WithHeadings,ShouldAutoSize
  {
	
	protected $year;
    protected $month;
	protected $region;
	protected $subregion;

    function __construct($year,$month,$region,$subregion) {
        $this->year = $year;
        $this->month = $month;
		$this->region = $region;
        $this->subregion = $subregion;
	}
	public function headings():array{
		
		return[
		'Saleman Name',
		'Warehouse Name',
		'Total Sales',
		'Total Qty',
		];
		
	}
    /**
    * @return \Illuminate\Support\Collection
    */
    public function collection()
    {
		if($this->region=='')
		  { 
		  if($this->month=='0')
		    {
			  
			  $get_data1 = DB::table('tbl_route_invoice_header')
				->leftJoin('tbl_salesman', 'tbl_route_invoice_header.salesman_id', '=', 'tbl_salesman.id')
				->leftJoin('tbl_warehouse', 'tbl_route_invoice_header.warehouse_id', '=', 'tbl_warehouse.id')
				->leftJoin('tbl_route_invoice_details', 'tbl_route_invoice_header.id', '=', 'tbl_route_invoice_details.header_id')
		        ->select(DB::raw('SUM(tbl_route_invoice_header.total_invoice_value) as total_invoice'),DB::raw('sum(tbl_route_invoice_details.base_qty) as base_quantity'),'tbl_salesman.salesman_name as sales_name','tbl_salesman.id as salesman_id','tbl_salesman.salesman_code','tbl_warehouse.warehouse_code','tbl_warehouse.warehouse_name')
				
				->groupBy('tbl_route_invoice_header.salesman_id','tbl_route_invoice_header.warehouse_id') 
				->whereYear('tbl_route_invoice_header.created_at', $this->year)
				->get();  
		      //dd($get_data1);
		      	
	        }	
         else
	        {	
               $get_data1 = DB::table('tbl_route_invoice_header')
				    ->leftJoin('tbl_salesman', 'tbl_route_invoice_header.salesman_id', '=', 'tbl_salesman.id')
					->leftJoin('tbl_warehouse', 'tbl_route_invoice_header.warehouse_id', '=', 'tbl_warehouse.id')
					->leftJoin('tbl_route_invoice_details', 'tbl_route_invoice_header.id', '=', 'tbl_route_invoice_details.header_id')
					->select(DB::raw('sum(tbl_route_invoice_header.total_invoice_value) as total_invoice'),DB::raw('sum(tbl_route_invoice_details.base_qty) as base_quantity'),'tbl_salesman.salesman_name as sales_name','tbl_salesman.id as salesman_id','tbl_salesman.salesman_code','tbl_warehouse.warehouse_code','tbl_warehouse.warehouse_name')
					->orderBy(DB::raw('sum(tbl_route_invoice_header.total_invoice_value)'),'desc')
					->groupBy('tbl_route_invoice_header.salesman_id','tbl_route_invoice_header.warehouse_id') 
					->whereYear('tbl_route_invoice_header.created_at', $this->year)
					->whereMonth('tbl_route_invoice_header.created_at', $this->month)
					->get();	  
		     
		  }
	}
else{
	
	 if($this->sub_region='')
	  {
		if($this->sub_region!='0')
		{
		  $agent_name     = array(); 
		  $agent_id     = array(); 
		  $get_data1 = DB::table('tbl_sub_region')
		  ->select('tbl_sub_region.sub_region_code','tbl_sub_region.sub_region_name','tbl_sub_region.id')
		  ->where('tbl_sub_region.status','=','active')
		  ->where('tbl_sub_region.id','=',$this->sub_region)->get();
		  foreach($get_data1 as $key=> $sub_region)
			{
			  $agent_id[]=$sub_region->id;
			}
		 }
	    else  
		{
			$agent_name     = array(); 
			$agent_id     = array(); 
			$get_data1 = DB::table('tbl_sub_region')
			 
			->select('tbl_sub_region.sub_region_code','tbl_sub_region.sub_region_name','tbl_sub_region.id')
			->where('tbl_sub_region.status','=','active')
			->get();
			foreach($get_data1 as $key=> $sub_region)
			  {
				 $agent_id[]=$sub_region->id;
			  }
		}
		
		if($this->month== '0')
			 {
			   $get_data1 = DB::table('tbl_route_invoice_header')
				->leftJoin('tbl_salesman', 'tbl_route_invoice_header.salesman_id', '=', 'tbl_salesman.id')
				->leftJoin('tbl_warehouse', 'tbl_route_invoice_header.warehouse_id', '=', 'tbl_warehouse.id')
				->leftJoin('tbl_route_invoice_details', 'tbl_route_invoice_header.id', '=', 'tbl_route_invoice_details.header_id')
		        ->select(DB::raw('sum(tbl_route_invoice_header.total_invoice_value) as total_invoice'),DB::raw('sum(tbl_route_invoice_details.base_qty) as base_quantity'),'tbl_salesman.salesman_name as sales_name','tbl_salesman.id as salesman_id','tbl_salesman.salesman_code','tbl_warehouse.warehouse_code','tbl_warehouse.warehouse_name')
				->orderBy(DB::raw('sum(tbl_route_invoice_header.total_invoice_value)'),'desc')
				->groupBy('tbl_route_invoice_header.salesman_id','tbl_route_invoice_header.warehouse_id') 
				->whereYear('tbl_route_invoice_header.created_at', $this->year)
				->whereIn('tbl_route_invoice_header.subregion_id',$agent_id)
			    ->get();	  
		       
				 }
		     else{
			       $get_data1 = DB::table('tbl_route_invoice_header')
					->leftJoin('tbl_salesman', 'tbl_route_invoice_header.salesman_id', '=', 'tbl_salesman.id')
					->leftJoin('tbl_warehouse', 'tbl_route_invoice_header.warehouse_id', '=', 'tbl_warehouse.id')
					->leftJoin('tbl_route_invoice_details', 'tbl_route_invoice_header.id', '=', 'tbl_route_invoice_details.header_id')
					->select(DB::raw('sum(tbl_route_invoice_header.total_invoice_value) as total_invoice'),DB::raw('sum(tbl_route_invoice_details.base_qty) as base_quantity'),'tbl_salesman.salesman_name as sales_name','tbl_salesman.id as salesman_id','tbl_salesman.salesman_code','tbl_warehouse.warehouse_code','tbl_warehouse.warehouse_name')
					->orderBy(DB::raw('sum(tbl_route_invoice_header.total_invoice_value)'),'desc')
					->groupBy('tbl_route_invoice_header.salesman_id','tbl_route_invoice_header.warehouse_id') 
					->whereYear('tbl_route_invoice_header.created_at', $this->year)
					->whereMonth('tbl_route_invoice_header.created_at', $this->month)
					->whereIn('tbl_route_invoice_header.subregion_id', $this->agent_id)
					->get();
			 }	  
	    }
     else{
	        if($this->region!='0')
		    {
			  $agent_name     = array(); 
			  $agent_id     = array(); 
			  $get_data1 = DB::table('tbl_region')
			  ->select('tbl_region.region_code','tbl_region.region_name','tbl_region.id')
			  ->where('tbl_region.status','=','active')
			  ->where('tbl_region.id','=',$this->region)->get();
			  foreach($get_data1 as $key=> $region)
				{
				  $agent_id[]=$region->id;
				}
		    }
	      else  
		    {
				$agent_name     = array(); 
				$this->agent_id     = array(); 
				$get_data1 = DB::table('tbl_region')
				 
				->select('tbl_region.region_code','tbl_region.region_name','tbl_region.id')
				->where('tbl_region.status','=','active')
				->get();
				foreach($get_data1 as $key=> $region)
				  {
					 $agent_id[]=$region->id;
				  }
		    }
	       if($this->month=='0')
			{
			   $get_data1 = DB::table('tbl_route_invoice_header')
				->leftJoin('tbl_salesman', 'tbl_route_invoice_header.salesman_id', '=', 'tbl_salesman.id')
				->leftJoin('tbl_warehouse', 'tbl_route_invoice_header.warehouse_id', '=', 'tbl_warehouse.id')
				->leftJoin('tbl_route_invoice_details', 'tbl_route_invoice_header.id', '=', 'tbl_route_invoice_details.header_id')
		        ->select(DB::raw('sum(tbl_route_invoice_header.total_invoice_value) as total_invoice'),DB::raw('sum(tbl_route_invoice_details.base_qty) as base_quantity'),'tbl_salesman.salesman_name as sales_name','tbl_salesman.id as salesman_id','tbl_salesman.salesman_code','tbl_warehouse.warehouse_code','tbl_warehouse.warehouse_name')
				->orderBy(DB::raw('sum(tbl_route_invoice_header.total_invoice_value)'),'desc')
				->groupBy('tbl_route_invoice_header.salesman_id','tbl_route_invoice_header.warehouse_id') 
				->whereYear('tbl_route_invoice_header.created_at', $this->year)
				->whereIn('tbl_route_invoice_header.region_id', $agent_id)
			    ->get();	  
		        
			}
		    else{
			       $get_data1 = DB::table('tbl_route_invoice_header')
					->leftJoin('tbl_salesman', 'tbl_route_invoice_header.salesman_id', '=', 'tbl_salesman.id')
					->leftJoin('tbl_warehouse', 'tbl_route_invoice_header.warehouse_id', '=', 'tbl_warehouse.id')
					->leftJoin('tbl_route_invoice_details', 'tbl_route_invoice_header.id', '=', 'tbl_route_invoice_details.header_id')
					->select(DB::raw('sum(tbl_route_invoice_header.total_invoice_value) as total_invoice'),DB::raw('sum(tbl_route_invoice_details.base_qty) as base_quantity'),'tbl_salesman.salesman_name as sales_name','tbl_salesman.id as salesman_id','tbl_salesman.salesman_code','tbl_warehouse.warehouse_code','tbl_warehouse.warehouse_name')
					->orderBy(DB::raw('sum(tbl_route_invoice_header.total_invoice_value)'),'desc')
					->groupBy('tbl_route_invoice_header.salesman_id','tbl_route_invoice_header.warehouse_id') 
					->whereYear('tbl_route_invoice_header.created_at', $this->year)
					->whereMonth('tbl_route_invoice_header.created_at', $this->month)
					->whereIn('tbl_route_invoice_header.region_id', $agent_id)
					->get();	  
		            
				}
	   }
		  
    }
	 return collect($get_data1);
  
  }
}
