<?php
namespace App\Exports;
use App\Models\SupplierModel;
use Illuminate\Contracts\View\View;
use Maatwebsite\Excel\Concerns\FromView;
use Illuminate\Support\Facades\DB;
use Maatwebsite\Excel\Concerns\WithDrawings;
use PhpOffice\PhpSpreadsheet\Worksheet\Drawing;
use Maatwebsite\Excel\Concerns\ShouldAutoSize;
use Maatwebsite\Excel\Concerns\WithCustomStartCell;
use Maatwebsite\Excel\Concerns\WithEvents;
use Maatwebsite\Excel\Events\AfterSheet;

class SalesmanUnloadExport implements FromView,WithDrawings,ShouldAutoSize,WithCustomStartCell,WithEvents
   {
	   protected $salesman_unload;
	 
    /**
    * @return \Illuminate\Support\Collection
    */
	 function __construct($salesman_unload) {
        $this->salesman_unload = $salesman_unload;
       }
	   
	 public function drawings()
    {
        $drawing = new Drawing();
        $drawing->setName('Logo');
        $drawing->setDescription('This is my logo');
        $drawing->setPath(public_path('elitesotlab.png'));
        $drawing->setHeight(87);
        $drawing->setCoordinates('A1');

        return $drawing;
    }
	
	public function startCell(): string
    {
        return 'A6';

    }
	
	 public function registerEvents(): array
    {
        return [
            AfterSheet::class=> function(AfterSheet $event) {
                $event-> sheet->mergeCells('A1:E5');
                   
                $event->sheet->getStyle('A6:C6')->applyFromArray ([
				
                    'font' => [
                        'name'      =>  'Calibri',
                        'size'      =>  13,
                        'bold'      =>  true,
                        'color' => ['argb' => '#000000'],
                    ],
					'fill' => [
                        'fillType' => \PhpOffice\PhpSpreadsheet\Style\Fill::FILL_SOLID,
                        'startColor' => [
                            'rgb' => 'dff0d8',
                         ],           
                    ]
				 
				    
				]); 
				
				$event->sheet->getStyle('A10:E10')->applyFromArray ([
				
                    'font' => [
                        'name'      =>  'Calibri',
                        'size'      =>  13,
                        'bold'      =>  true,
                        'color' => ['argb' => '#000000'],
                    ],
					'fill' => [
                        'fillType' => \PhpOffice\PhpSpreadsheet\Style\Fill::FILL_SOLID,
                        'startColor' => [
                            'rgb' => 'dff0d8',
                         ],           
                    ]
				 
				    
				]);
				 
            
	 }
        ];
    }
	

	   
    public function view(): View
    {
		
		$unload_code1 = DB::table('tbl_route_unload_header')
		->select('tbl_route_unload_header.*')->get()->sortByDesc('id')->first();
	 
		if($unload_code1=='')
		  {
			$getcode = ManageCodeModel::where('id', 1)->first();
			$last_code = $getcode->unload_code;
		  }
		else
		  {    
			 $getcode = $unload_code1->unload_code; 
			 $last_code = ++$getcode;
		  }
			 //dd($unload_code1);

			 $result = DB::table('tbl_route_unload_details')->select
			       (
					'tbl_route_unload_details.quantity',
					'tbl_material_master.material_code',
					'tbl_material_master.material_name',
					'tbl_salesman.salesman_code',
					'tbl_salesman.salesman_name',
					'tbl_route.route_code',
					'tbl_route.route_name',
					'tbl_route_unload_header.unload_time',
					'tbl_unit_of_measurement.uom_code',
					'tbl_unit_of_measurement.unit_notation',
					'tbl_route_unload_header.unload_code',					
				   )
					->leftJoin('tbl_material_master', 'tbl_material_master.id', '=', 'tbl_route_unload_details.material_id')
					->leftJoin('tbl_route_unload_header', 'tbl_route_unload_header.id', '=', 'tbl_route_unload_details.header_id')	
					->leftJoin('tbl_salesman', 'tbl_salesman.id', '=', 'tbl_route_unload_header.salesman_id')		
					->leftJoin('tbl_route', 'tbl_route.id', '=', 'tbl_route_unload_header.route_id')
					->leftJoin('tbl_unit_of_measurement', 'tbl_unit_of_measurement.id', '=', 'tbl_route_unload_details.uom_id')
					
					 ->where('tbl_route_unload_details.header_id', '=', $this->salesman_unload)
						
					 ->first();
		  
        return view('export.salesman_unload_export', compact('result'));
    } 
	
	
	
    
	
 }
