<?php
namespace App\Exports;
use App\Models\SupplierModel;
use Illuminate\Contracts\View\View;
use Maatwebsite\Excel\Concerns\FromView;
use Illuminate\Support\Facades\DB;
use Maatwebsite\Excel\Concerns\WithDrawings;
use PhpOffice\PhpSpreadsheet\Worksheet\Drawing;
use Maatwebsite\Excel\Concerns\ShouldAutoSize;
use Maatwebsite\Excel\Concerns\WithCustomStartCell;
use Maatwebsite\Excel\Concerns\WithEvents;
use Maatwebsite\Excel\Events\AfterSheet;

class StockAdujestmentExport implements FromView,WithDrawings,ShouldAutoSize,WithCustomStartCell,WithEvents
   {
	   protected $salesman_load;
	 
    /**
    * @return \Illuminate\Support\Collection
    */
	 function __construct($id) {
        $this->id = $id;
       }
	   
	 public function drawings()
    {
        $drawing = new Drawing();
        $drawing->setName('Logo');
        $drawing->setDescription('This is my logo');
        $drawing->setPath(public_path('elitesotlab.png'));
        $drawing->setHeight(87);
        $drawing->setCoordinates('A1');

        return $drawing;
    }
	
	public function startCell(): string
    {
        return 'A6';

    }
	
	 public function registerEvents(): array
    {
        return [
            AfterSheet::class=> function(AfterSheet $event) {
                $event-> sheet->mergeCells('A1:D5');
                   
                $event->sheet->getStyle('A6:D6')->applyFromArray ([
				
                    'font' => [
                        'name'      =>  'Calibri',
                        'size'      =>  13,
                        'bold'      =>  true,
                        'color' => ['argb' => '#000000'],
                    ],
					'fill' => [
                        'fillType' => \PhpOffice\PhpSpreadsheet\Style\Fill::FILL_SOLID,
                        'startColor' => [
                            'rgb' => 'dff0d8',
                         ],           
                    ]
				 
				    
				]); 
				
				$event->sheet->getStyle('A10:F10')->applyFromArray ([
				
                    'font' => [
                        'name'      =>  'Calibri',
                        'size'      =>  13,
                        'bold'      =>  true,
                        'color' => ['argb' => '#000000'],
                    ],
					'fill' => [
                        'fillType' => \PhpOffice\PhpSpreadsheet\Style\Fill::FILL_SOLID,
                        'startColor' => [
                            'rgb' => 'dff0d8',
                         ],           
                    ]
				 
				    
				]);
				 
            
	 }
        ];
    }
 
    public function view(): View
    { 
			$get_data =DB::table('tbl_stock_adjust_header')
		->leftJoin('tbl_warehouse', 'tbl_stock_adjust_header.warehouse', '=', 'tbl_warehouse.id')
		->leftJoin('tbl_reason', 'tbl_stock_adjust_header.adjustment_type', '=', 'tbl_reason.id')
		  
		->select('tbl_stock_adjust_header.*','tbl_warehouse.warehouse_code','tbl_warehouse.warehouse_name','tbl_reason.reason_code','tbl_reason.reason_name')
		->where('tbl_stock_adjust_header.id', '=', $this->id)->get();
		 

		$get_data_details =DB::table('tbl_stock_adjust_details')
        ->leftJoin('tbl_material_master', 'tbl_stock_adjust_details.material_id', '=', 'tbl_material_master.id')
	    ->leftJoin('tbl_unit_of_measurement', 'tbl_stock_adjust_details.uom_id', '=', 'tbl_unit_of_measurement.id')

	    ->select('tbl_stock_adjust_details.*','tbl_material_master.material_name','tbl_material_master.material_code','tbl_unit_of_measurement.unit_notation','tbl_unit_of_measurement.uom_code')
		->where('tbl_stock_adjust_details.header_id', '=', $this->id)->get()->all();	  
		
        return view('export.stock_adjustment_export', 
		                  ['header' => $get_data],
		                  ['details' => $get_data_details]
						  
		            );
    } 
	
 }
