<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;
use App\Models\AssetMasterModel;
use App\Models\ManageCodeModel;
use App\Models\AssetCategoryModel;
use App\Models\SupplierModel;


use Illuminate\Support\Facades\DB;


class AssetMasterController extends Controller
{
    //
    public function list(){
        
        $get_data = DB::table('tbl_asset_master')
        ->leftJoin('tbl_supplier','tbl_asset_master.supplier_id','=','tbl_supplier.id')
        ->select('tbl_asset_master.*','tbl_supplier.supplier_code','tbl_supplier.supplier_name')->orderBy('id', 'DESC')->get();
        // dd($get_data);
        return view('Field_Services.asset_master_list',compact('get_data'));
    }

    public function add(){

        $result =AssetMasterModel::get()->sortByDesc('id')->first();
		if($result=='')
		  {
			$getcode = ManageCodeModel::where('id', 1)->first();
			$last_code = $getcode->asset_code;
		  }
		else
		  {
			 $getcode = $result->asset_code; 
			 $last_code = ++$getcode; 
		  }
          
        $asset_c =  AssetCategoryModel::where('status','=','active')->get();
        
        $supplier = SupplierModel::where('status','=','active')->get();
        

        return view('Field_Services.asset_master',compact('last_code','asset_c','supplier'));
    }

    public function view($id){
        
      $get_data = DB::table('tbl_asset_master as master')
        ->leftJoin('tbl_supplier','master.supplier_id','=','tbl_supplier.id')
        ->leftJoin('tbl_asset_category as asset','master.asset_category_id','=','asset.id')
        ->select('master.*','tbl_supplier.supplier_code','tbl_supplier.supplier_name','asset.asset_category_code','asset.asset_category_name')
        ->where('master.id',$id)->get()->first();
 
      return view('Field_Services.asset_master_view',compact('get_data'));
    }

    public function edit($id){

        $get_data = AssetMasterModel::find($id);

        $asset_c =  AssetCategoryModel::where('status','=','active')->get();
        
        $supplier = SupplierModel::where('status','=','active')->get();

        return view('Field_Services.asset_master',compact('get_data','asset_c','supplier'));
    }

    public function save(Request $request){

	   $data=new AssetMasterModel;           
	   
	   if($request->updated_id)
	   {  

		 $data = AssetMasterModel::find($request->updated_id);         
		 $data->asset_code          =$request->asset_code;
		 $data->asset_category_id   =$request->asset_category;
		 $data->asset_number        =$request->asset_number;
		 $data->serial_number       =$request->serial_number;
		 $data->model_number	      =$request->model_number;  
		 $data->aquisition_date     =$request->aquisition;
		 $data->sap_code            =$request->sap_code;
		 $data->supplier_id         =$request->supplier;
		 $data->manufacturer        =$request->manufacturer;
		 $data->country             =$request->country;
		 $data->customer_id         =$request->customer_id;
		 $data->status              =$request->status;

		 $data->save();

		 return redirect(route('asset_master_list'))->with('successMessage','Asset Master Updated Successfully');
	
	   } else
	       {
			        
            $data->asset_code          =$request->asset_code;
            $data->asset_category_id   =$request->asset_category;
            $data->asset_number        =$request->asset_number;
            $data->serial_number       =$request->serial_number;
            $data->model_number	       =$request->model_number;  
            $data->aquisition_date     =$request->aquisition;
            $data->sap_code            =$request->sap_code;
            $data->supplier_id         =$request->supplier;
            $data->manufacturer        =$request->manufacturer;
            $data->country             =$request->country;
            $data->customer_id         =$request->customer_id;
            $data->status              =$request->status;
   
            $data->save();
			 
		     return redirect(route('asset_master_list'))->with('successMessage','Asset Master Added Successfully');
		   } 

    }


}
