<?php
namespace App\Http\Controllers;
use Illuminate\Http\Request;
use App\Models\BankModel;
use App\Models\CountryTypeModel;
use App\Models\ManageCodeModel;
use App\Models\CityTypeModel;
use Illuminate\Support\Facades\DB;
use Carbon\Carbon;
use Session;

class BankController extends Controller
 {
   public function add()
	{
	   $country =CountryTypeModel::all()->sortByDesc('id')->where('status', '=', 'active');
	   $result =BankModel::get()->sortByDesc('id')->first(); 
	   if($result=='')
	    {
		  $getcode = ManageCodeModel::where('id', 1)->first();
		  $last_code = $getcode->bank_code;			
	    } 
	   else{   
		    $getcode = $result->bank_code; 
		    $last_code = ++$getcode;
	      }
	 
	   return view('Master_Configuration.bank',compact('country','last_code'));
	 }
    
    public function edit($id)
     {
		$get_data=BankModel::find($id);
		$country =CountryTypeModel::all()->sortByDesc('id')->where('status', '=', 'active');
		$last_code = $get_data->bank_code;

		return view('Master_Configuration.bank',compact('get_data','country','last_code'));
     }
	   
    public function view($id)
	 {    
		//$get_data=BankModel::find($id);
		$get_data = DB::table('tbl_bank')
		//dd($get_data);
		 ->leftJoin('tbl_country', 'tbl_bank.country_id', '=', 'tbl_country.id')
		 ->leftJoin('tbl_city', 'tbl_bank.city_id', '=', 'tbl_city.id')
		 ->select('tbl_bank.*','tbl_country.country_code', 'tbl_country.country_name','tbl_city.city_name','tbl_city.city_code') 
		 ->where('tbl_bank.id', '=', $id)
            ->first();

		return view('Master_Configuration.bank_view',compact('get_data'));
	 }
    
    public function list()
	 {
		$get_data = DB::table('tbl_bank')
		->leftJoin('tbl_country', 'tbl_bank.country_id', '=', 'tbl_country.id')
		->leftJoin('tbl_city', 'tbl_bank.city_id', '=', 'tbl_city.id')
		->select('tbl_bank.*','tbl_country.country_code', 'tbl_country.country_name','tbl_city.city_name','tbl_city.city_code')->orderBy('id', 'DESC')->get();

		return view('Master_Configuration.bank_list',compact('get_data'));
     }
    
    public function save(Request $request)
	 {    
		$data=new BankModel;           
	   
		if($request->updated_id)
	      {           
			 $data = BankModel::find($request->updated_id);         
			 $data->bank_code=$request->bank_code;
			 $data->bank_name=$request->bank_name;
			 $data->address=$request->address;
			 $data->country_id=$request->country;
			 $data->city_id=$request->city;  
			 $data->bank_account_number=$request->bank_account_number;
			 $data->branch=$request->branch;
			 $data->company_id= Session::get('company_id');
			 $data->updated_user= Session::get('user_id');
			 $data->status=$request->status;
			 $data->save();

		    return redirect(route('bank_list'))->with('successMessage','Bank Updated Successfully');
	
		  } else{
			
				 $data->bank_code=$request->bank_code;
				 $data->bank_name=$request->bank_name;
				 $data->address=$request->address;
				 $data->country_id=$request->country_id;
				 $data->city_id=$request->city_id;  
				 $data->bank_account_number=$request->bank_account_number;
				 $data->branch=$request->branch;
				 $data->company_id= Session::get('company_id');
				 $data->created_user= Session::get('user_id'); 
				 $data->status=$request->status;
				 $data->save(); 
				 return redirect(route('bank_list'))->with('successMessage','Bank Added Successfully');
				}
				 
	 }
	
    public function get_country($id, $city_id)
	 { 
	     $get_data=CityTypeModel::all()->sortByDesc('id')->where('country_id', '=', $id)->where('status', '=', 'active'); 
		 ?>
		  <option value=""></option>
		 <?php 
		 foreach($get_data as $cityname)
		   { 
		     ?> 
			  <option value="<?php echo $cityname->id ?>" <?php if($cityname->id == $city_id) { echo "selected"; } ?> ><?php echo $cityname->city_code." - ".$cityname->city_name ?></option> 
		     <?php 
		   }
     }
	 
	 public function update_load_status(Request $request)
   { 
      
       $current = Carbon::now()->format('Y-m-d'); 
		if(!strcmp($request->status,"confirm"))
		 {
			 $stock_reserve=DB::table('tbl_stock_reserve')
			         ->where('header_id', $request->load_id)
			         ->get()->all();
				 
		   foreach($stock_reserve as $key => $n)
		    {
			       //storing data in warehouse_stock
					$material_master = DB::table('tbl_route_warehouse_stock')
					->where('warehouse_id', $stock_reserve[$key]->warehouse_id)
					->where('route_warehouse_id', $stock_reserve[$key]->route_warehouse_id)
					->where('item_id','=',$stock_reserve[$key]->item_id)
					->get()->all();
					
					$count = count($material_master);
				
				if($count>0)
				  {
				   // INCREMENTING ROUTE WAREHOUSE STOCK
					$query = DB::table('tbl_route_warehouse_stock')
					->where('warehouse_id', $stock_reserve[$key]->warehouse_id)
					->where('route_warehouse_id', $stock_reserve[$key]->route_warehouse_id)
					->where('item_id','=',$stock_reserve[$key]->item_id);
					
					$query->increment('qty',$stock_reserve[$key]->base_qty);
					
									   
				  }
				else
				{
					$data4=array(
					'warehouse_id'  => $stock_reserve[$key]->warehouse_id,
					'route_warehouse_id' => $stock_reserve[$key]->route_warehouse_id,
					'item_id'  => $stock_reserve[$key]->item_id,
					'uom_id'   => $stock_reserve[$key]->uom,
					'qty'   => $stock_reserve[$key]->base_qty,
					'route_id'  => $stock_reserve[$key]->route_id,
					'created_at'  => $current,
					);	
					
				 DB::table('tbl_route_warehouse_stock')->insert($data4); 
				}
		   }
		    
		   /* CHECKING TRIP CODE */	
         $dateANDtime= date("Y-m-d h:i:s"); 			
		 $result = DB::table('tbl_trip_code')
		            ->select('tbl_trip_code.*')
					->get()->sortByDesc('id')->first();
					
		 if($result=='')
			   {
				  $getcode = ManageCodeModel::where('id', 1)->first();
				  $last_code = $getcode->trip_code;
				 
				  $data3=array( 
				          'trip_code'       =>  $last_code,
						  'salesman_id'     =>  $request->salesman_id,
						  'distributor_id'  =>  $request->distributor_id,
						  'region_id'       =>  $request->region_id,
						  'subregion_id'    =>  $request->subregion_id,
						  'route_id'        =>  $request->route_id,
						  'start_time'      =>  $dateANDtime,
						  'end_time'        =>  null,
						);
				    $header_id =DB::table('tbl_trip_code')->insertGetId($data3);
			        $trip_details =DB::table('tbl_trip_code')->select('id as trip_id','trip_code')->where('id','=',$header_id)->get();
			   }
			 else
			   {
				  if($result->end_time!='')
				   {
					   $getcode = $result->trip_code; 
				       $last_code = ++$getcode; 
					   
					   $data3=array( 
				          'trip_code'       =>  $last_code,
						  'salesman_id'     =>  $request->salesman_id,
						  'distributor_id'  =>  $request->distributor_id,
						  'region_id'       =>  $request->region_id,
						  'subregion_id'    =>  $request->subregion_id,
						  'route_id'        =>  $request->route_id,
						  'start_time'      =>  $dateANDtime,
						  'end_time'        =>  null,
						);
				     $header_id =DB::table('tbl_trip_code')->insertGetId($data3);
			         $trip_details =DB::table('tbl_trip_code')->select('id as trip_id','trip_code')->where('id','=',$header_id)->get();
					 
				   }
				   else{
					     $trip_details =DB::table('tbl_trip_code')->select('id as trip_id','trip_code')->where('id','=',$result->id)->get(); 
				       }
				
				    
			   }
			    /* TRIP FUNCTIONALITY IS ENDED */	
			}
		else
		{
		  $stock_reserve=DB::table('tbl_stock_reserve')
			         ->where('header_id', $request->load_id)
			         ->get()->all();
					 
		   foreach($stock_reserve as $key => $n)
		   {	
			    $query = DB::table('tbl_warehouse_stock')
				->where('warehouse_id', $stock_reserve[$key]->warehouse_id)
				->where('material_id','=',$stock_reserve[$key]->item_id)
				->get()->all();
				
				$count=count($query);
			
			 if($count>0)
			  {
				  // incrementing main warehouse stock
			      $query = DB::table('tbl_warehouse_stock')
				  ->where('warehouse_id', $stock_reserve[$key]->warehouse_id)
				  ->where('material_id','=',$stock_reserve[$key]->item_id); 
				  $query->increment('qty',$stock_reserve[$key]->base_qty);
		      } 
		   } 
		}	 
	   
	       DB::table('tbl_stock_reserve')
			         ->where('header_id', $request->load_id)
			         ->delete();
					 
			$mediaFiles = $request->sign;
			$extension = $mediaFiles->getClientOriginalExtension(); 
			$media_ext = $mediaFiles->getClientOriginalName();
			$media_no_ext = pathinfo($media_ext, PATHINFO_FILENAME);
			$mFiles = 'singnature-' . time() . '.' . $extension;
			$mediaFiles->move(public_path().'/images/salesmanload_sign/', $mFiles); 
				//dd($mediaFiles); 
			 $data= DB::table('tbl_route_salesmanload_header')
			 ->where('id', $request->load_id)
			 ->update([
					 'status' => $request->status,
					 'sign' =>   $mFiles
				 ]);
					  
		   if($data) 
		     { 
		       return array('Result'=>$trip_details, 'API_Status' => 1, 'Message' => "status updated "); 
		     } 
		     else 
		     {
			  return array('Result'=>[], 'API_Status' => 0, 'Message' => "Status Not updated"); 
		     } 
    }
	
	
 }
