<?php
namespace App\Http\Controllers;
use Illuminate\Http\Request;
use App\Models\CityTypeModel;
use App\Models\CountryTypeModel;
use App\Models\ManageCodeModel;
use Session;
use Illuminate\Support\Facades\DB;

class CityController extends Controller
 {
   public function list()
    {
	  $get_data = DB::table('tbl_city')
		  ->leftJoin('tbl_country', 'tbl_city.Country_id', '=', 'tbl_country.id')
		  ->orderBy('id', 'DESC')
		  ->select('tbl_city.*', 'tbl_country.country_name','tbl_country.country_code')
		  ->get();
	  return view('Parameters_Configuration.city_list',compact('get_data'));
    }
	
   public function add()
    { 
	  $result =CityTypeModel::get()->sortByDesc('id')->first();
	  if($result=='')
		{
			$getcode = ManageCodeModel::where('id', 1)->first();
			$last_code = $getcode->city_code;
			
		}
	  else
	    {
			$getcode = $result->city_code; 
			$last_code = ++$getcode;
		} 
	  $country= CountryTypeModel::all()->sortByDesc('id')->where('status', '=', 'active');
	  return view('Parameters_Configuration.city',compact('country','last_code'));

    }
	
   public function edit($id)
    {
		$get_data=CityTypeModel::find($id);
		$country= CountryTypeModel::all()->sortByDesc('id')->where('status', '=', 'active');
		$last_code = $get_data->city_code;
        return view('Parameters_Configuration.city',compact('get_data','country','last_code'));
		
    }
	
   public function save(Request $request)
    {	
	    $data=new CityTypeModel;				
	    if($request->updated_id)
		  {			
			$data = CityTypeModel::find($request->updated_id);
			$data->city_code=$request->city_code;
			$data->city_name=$request->city_name;
			$data->country_id=$request->country;
			$data->updated_user= Session::get('user_id');
			$data->status=$request->status;
			$data->save();

			return redirect(route('city_list'))->with('successMessage','City Updated Successfully');
 
		  } 
		else
		  { 			
			$data->city_code=$request->city_code;
			$data->city_name=$request->city_name;
			$data->country_id=$request->country;
			$data->created_user= Session::get('user_id');
			$data->status=$request->status;
			$data->save();

			return redirect(route('city_list'))->with('successMessage','City Added Successfully');
			 
		  }	
    	 
    }
	 
 }
