<?php

namespace App\Http\Controllers;
use Illuminate\Http\Request;
use App\Models\ClientModel;
use App\Models\CountryTypeModel;
use App\Models\ManageCodeModel;
use App\Exports\ClientExport;
use Session;
use Maatwebsite\Excel\Facades\Excel;

use Illuminate\Support\Facades\DB;

class ClientController extends Controller
 {
   public function list()
	 {
		//$get_data = ClientModel::all()->sortByDesc('id');
		$get_data = DB::table('tbl_client')
		->leftJoin('tbl_country', 'tbl_client.country_id', '=','tbl_country.id') 
		
		->select('tbl_client.*', 'tbl_country.country_name','tbl_country.country_code')
		->orderBy('id', 'DESC')->get();
		return view('Master_Configuration.client_list',compact('get_data'));
	}
	
   public function add()
	{ 	
			 $result = DB::table('tbl_client')
			 ->select('tbl_client.client_code')->get()->sortByDesc('id')->first();			 
			 if($result=='')
			   {
				 $getcode = ManageCodeModel::where('id', 1)->first();
				 $last_code = $getcode->client_code;
			   }
			 else
			   {
				 $getcode = $result->client_code; 
				 $last_code = ++$getcode;
			   }
			 $country =CountryTypeModel::all()->sortByDesc('id')->where('status', '=', 'active');
			 return view('Master_Configuration.client',compact('country','last_code'));
	 }
	
	public function edit($id)
	 {
	    $get_data=ClientModel::find($id);
		$country =CountryTypeModel::all()->sortByDesc('id')->where('status', '=', 'active');
		$last_code = $get_data->client_code;
		return view('Master_Configuration.client',compact('get_data','country','last_code'));
	 }
	
	public function save(Request $request)
	 {
           //dd($request);

			$data=new ClientModel;

			if($request->updated_id) 
		      {			
			    $data = ClientModel::find($request->updated_id);			
			    $data->client_code=$request->client_code;
				$data->client_name=$request->client_name;
				
				$data->country_id=$request->country_id;
				$data->max_uom=$request->max_uom;
				$data->updated_user= Session::get('user_id');
				$data->status=$request->status;
				$data->save();
				return redirect(route('client_list'))->with('successMessage','Client Updated Successfully');
			
			  } 
			else 
			  {
				$data->client_code=$request->client_code;
				$data->client_name=$request->client_name;
				$data->country_id=$request->country_id;
			
				$data->max_uom=$request->max_uom;
				$data->created_user= Session::get('user_id');
				$data->status=$request->status;
				$data->save();
				return redirect(route('client_list'))->with('successMessage','Client Added Successfully');
				
			  }	
    	
      }
	 
 }
  