<?php

namespace App\Http\Controllers;
use Illuminate\Http\Request;
use App\Models\CompanyModel;
use App\Models\ManageCodeModel;
use App\Models\CurrencyTypeModel;
use App\Models\CountryTypeModel;
use App\Models\CompanyTypeModel;
use App\Models\CityTypeModel;
use Illuminate\Support\Facades\DB;
use Illuminate\Support\Facades\Storage;
use Session;

class CompanyController extends Controller
 {	
   public function add()
	{		
		$result =CompanyModel::get()->sortByDesc('id')->first();
		if($result=='')
		  {
			$getcode = ManageCodeModel::where('id', 1)->first();
			$last_code = $getcode->company_code;
		  }
		else
		  {
			 $getcode = $result->company_code; 
			 $last_code = ++$getcode;
		  }
	
		$currency = CurrencyTypeModel::all()->sortByDesc('id')->where('status', '=', 'active');
		$country =CountryTypeModel::all()->sortByDesc('id')->where('status', '=', 'active');
		$company_type =CompanyTypeModel::all()->sortByDesc('id')->where('status', '=', 'active');
		
		return view('Master_Configuration.company',compact('currency','country','company_type','last_code'));
	}

   public function edit($id)
	{
	
	  $get_data = DB::table('tbl_company')
	      ->leftJoin('tbl_city', 'tbl_company.city_id', '=', 'tbl_city.id')
		  ->select('tbl_company.*', 'tbl_city.city_name','tbl_city.id as cityid','tbl_city.city_code')
		  ->where('tbl_company.id', '=', $id)
		  ->first();

	   $currency = CurrencyTypeModel::all()->sortByDesc('id')->where('status', '=', 'active');
	   $country =CountryTypeModel::all()->sortByDesc('id')->where('status', '=', 'active');
	   $company_type =CompanyTypeModel::all()->sortByDesc('id')->where('status', '=', 'active');
	
	   $last_code = $get_data->company_code;
       return view('Master_Configuration.company',compact('get_data','currency','country','company_type','last_code'));
     }
	
	public function view($id)
	 {    
		//$get_data=CompanyModel::find($id);
		$get_data = DB::table('tbl_company')
		->leftJoin('tbl_country', 'tbl_company.country_id', '=', 'tbl_country.id')
		->leftJoin('tbl_currency_type', 'tbl_company.currency_id', '=', 'tbl_currency_type.id')
		->leftJoin('tbl_company_type', 'tbl_company.company_type', '=', 'tbl_company_type.id')
		->leftJoin('tbl_city', 'tbl_company.city_id', '=', 'tbl_city.id')
		
		->select('tbl_company.*', 'tbl_country.country_name','tbl_currency_type.currency_name','tbl_company_type.company_type_name','tbl_company_type.company_type_code','tbl_city.city_name','tbl_city.city_code','tbl_currency_type.currency_code','tbl_country.country_code')
		->where('tbl_company.id', '=', $id)
		
		->first();
		 
	    return view('Master_Configuration.company_view',compact('get_data'));
     }
  
	public function list()
	 {
		//$get_data = CompanyModel::all()->sortByDesc('id');
		$get_data = DB::table('tbl_company')
		->leftJoin('tbl_country', 'tbl_company.country_id', '=', 'tbl_country.id')
		->leftJoin('tbl_currency_type', 'tbl_company.currency_id', '=', 'tbl_currency_type.id')
		
		->select('tbl_company.*','tbl_country.country_code', 'tbl_country.country_name','tbl_currency_type.currency_name','tbl_currency_type.currency_code')
		->orderBy('id', 'DESC')->get();
	
	    return view('Master_Configuration.company_list',compact('get_data'));
     }
  
    public function save(Request $request)
	 {     
	     //dd($request);
		   $logo_image=$request->file('company_logo');
		   if($logo_image)
			 {
			
			  $data=new CompanyModel;
			  $filenameWithExt = $request->file('company_logo')->getClientOriginalName();
			  // Get just filename
			  $filename = pathinfo($filenameWithExt, PATHINFO_FILENAME);            
			  // Get just ext
			  $extension = $request->file('company_logo')->getClientOriginalExtension();
			  //Filename to store
			  $fileNameToStore = $filename.'_'.time().'.'.$extension;                       
			  // Upload Image
			  $path = $request->file('company_logo')->storeAs('public/company', $fileNameToStore);
			 }
		   elseif($request->updated_id !='' && $logo_image == '')
			 {
			   $old_path = CompanyModel::find($request->updated_id);;
			   $path= $old_path->company_logo;
			 }
			 
		   else
			{
			$path = '';
			}	 	
		   
		  if($request->updated_id)
			{            
				$data = CompanyModel::find($request->updated_id);
				$data->company_logo=$path;
				$data->company_code=$request->company_code;
				$data->company_name=$request->company_name;
				$data->company_type=$request->company_type;
				$data->currency_id=$request->currency_id;
				$data->address=$request->address;
				$data->city_id=$request->city_id;
				$data->vat=$request->vat ;
				$data->country_id=$request->country_id;
				$data->email_id=$request->email_id;
				$data->contact_no=$request->contact_no;
				$data->pincode=$request->pincode;
				$data->updated_user= Session::get('user_id');
				$data->status=$request->status;			 
				$data->save();
		
		       return redirect(route('company_list'))->with('successMessage','Company  Updated Successfully');
	
	       }
	     else 
	       {            
				$data->company_logo=$path;
				$data->company_code=$request->company_code;
				$data->company_name=$request->company_name;
				$data->company_type=$request->company_type;
				$data->currency_id=$request->currency_id;
				$data->address=$request->address;
				$data->city_id=$request->city_id;
				$data->country_id=$request->country_id;
				$data->email_id=$request->email_id;
				$data->vat=$request->vat;
				$data->contact_no = $request->contact_no;
				$data->pincode=$request->pincode;
				$data->created_user= Session::get('user_id');
				$data->status=$request->status;			 
				$data->save();
			   return redirect(route('company_list'))->with('successMessage','Company  Added Successfully');
				
	       }   
     }
	   
	public function imagestore(Request $request)
	 {
		 $image= $request->file('company_logo'); 
		 $imageName =time().'.'.$image->extension();
		 $image->move(public_path('images'),$imageName);

		 $data=new CompanyModel();

	 }
	
	public function get_country($id, $city_id)
	 {	
       
		$get_data=CityTypeModel::get()->where('country_id','=',$id)->where('status','=','active')->all();
		 
		?>
		<option  value="">     </option>
		<?php
		foreach($get_data as $cityname)
	      {
			 
			?>
			<option value="<?php echo $cityname->id ?>" <?php if($cityname->id == $city_id) { echo "selected"; } ?> > <?php echo $cityname->city_code." - ".$cityname->city_name ?></option>	
			<?php		
	      }
	    
	 }
    
 }
