<?php

namespace App\Http\Controllers;
use App\Models\OutletModel;
use App\Models\CurrencyTypeModel;
use App\Models\WarehouseModel;
use App\Models\ManageCodeModel;
use App\Models\MaterialMasterModel;
use App\Models\SalesmanInvoiceModel;
use App\Models\CustomerModel;
use App\Models\MaterialCategoryModel;
use App\Models\UnitOfMeasurementModel;
use App\Models\RouteModel;
use App\Models\UserModel;
use App\Models\TradingCenterModel;
use Carbon\Carbon;
use Session;
use Illuminate\Support\Facades\DB;
use Illuminate\Http\Request;
use App\Exports\OutletCounterExport; 
use Maatwebsite\Excel\Facades\Excel;
use PDF;
class CounterSalesController extends Controller
 {
   public function list(Request $request)
	{		
		$current_date=date("Y-m-d");	
		$where="";		
		if(count($request->all()) < 1)
		  {
			$where .= " AND DATE_FORMAT(riheader.created_at, '%Y-%m-%d') between '".$current_date."' and '".$current_date."'"; 
		  }
			
		if($request->fromdate!='')
		
		  {
			$where .= " AND DATE_FORMAT(riheader.created_at, '%Y-%m-%d') between '".$request->fromdate."' and '".$request->todate."'"; 
		  }
			
		if($request->outlet!='')
		
		  {
			$where .= "AND outlet.id = '".$request->outlet."'";
		  }
	 
				$outlet=OutletModel::all()->sortByDesc('id')->where('status', '=', 'active');		 
			$get_data = DB::select("SELECT riheader.*, 
			outlet.warehouse_name,outlet.warehouse_code,currency.currency_notation		
			FROM tbl_outlet_counter_sales_header as riheader
			LEFT JOIN tbl_warehouse as outlet on riheader.outlet_id=outlet.id 
			LEFT JOIN tbl_currency_type as currency on riheader.currency=currency.id 
			WHERE riheader.id IS NOT NULL ".$where." ORDER BY id DESC ");
			//dd($get_data);
			return view('Outlet_Transaction.counter_sales_list',compact('outlet','get_data'));
	}

   public function add()
	{ 
        $distibutor =CustomerModel::all()->sortByDesc('id')->where('status', '=', 'active')->where('customer_type','=',2);  	
		$user_id=Session::get('user_id');	  
		$result = DB::table('tbl_outlet_counter_sales_header')
		->select('tbl_outlet_counter_sales_header.*')->get()->sortByDesc('id')->first();
	 
	   if($result=='')
		 {
			$getcode = ManageCodeModel::where('id', 1)->first();
			$last_code = $getcode->counter_sales_no;
		 }
	   else
	     {
		    $getcode = $result->counter_sales_no; 
		    $last_code = ++$getcode;
	     }
		 

		  $material =MaterialMasterModel::all()->sortByDesc('id')->where('status', '=', 'active');
		  $route =RouteModel::all()->sortByDesc('id')->where('status', '=', 'active');
		  $outlet=OutletModel::all()->sortByDesc('id')->where('status', '=', 'active');		  
		  $login_user = DB::table('tbl_user')
		 ->leftJoin('tbl_company', 'tbl_user.company_id', '=', 'tbl_company.id')
		 ->leftJoin('tbl_currency_type', 'tbl_company.currency_id', '=', 'tbl_currency_type.id')
		 ->select('tbl_user.id', 'tbl_company.currency_id','tbl_currency_type.currency_notation')
		 ->where('tbl_user.id', '=', $user_id)
		 ->get()->first();
		 //dd($login_user);
	 
		 return view('Outlet_Transaction.counter_sales',compact('last_code','route','material','login_user','outlet','distibutor'));
	 }
	
    public function get_material_price_outlet($id,$val)
	 {
	
        $material=MaterialMasterModel::get()->sortByDesc('id')->first()->find($val);	
  
			   $alt_uom = explode(",",$material->alt_uom);
			   
			   $key = array_search($id, $alt_uom);
			   
			   $alt_unit_price = explode(",",$material->alt_unit_price);

				echo $alt_unit_price[$key];
		
	 
			
	 }
	
	public function save(Request $request)
	 {
	    
	     $warehouse=OutletModel::all()->sortByDesc('id')->where('status', '=', 'active')->where('id', '=', $request->outlet);
	     /* dd($warehouse[0]->warehouse_name); */
	   
		  $current = Carbon::now();
		  $user_id=Session::get('user_id');			
		  $login_user = DB::table('tbl_user')
		  ->leftJoin('tbl_company', 'tbl_user.company_id', '=', 'tbl_company.id')
		  ->leftJoin('tbl_currency_type', 'tbl_company.currency_id', '=', 'tbl_currency_type.id')
		  ->select('tbl_user.id', 'tbl_company.currency_id','tbl_currency_type.currency_notation','tbl_currency_type.id as currency_id')
		  ->where('tbl_user.id', '=', $user_id)
		  ->get()->first();
		  
		 $date = str_replace('/', '-', $request->invoice_date);
		 $newDate = date("d-m-Y", strtotime($date));
		 $salesman_id=2;
				 $data3=array(
							  'counter_sales_no'      =>  $request->counter_sales_number,
							  'currency'            =>  $login_user->currency_id,
							  'distibutor_id'            =>  $request->distibutor,
							  'warehouse_id'            =>  $request->warehouse,
							  'outlet_id'            =>  $request->outlet,
							  'remark'              =>  $request->comment,
							  'total_gross'         =>  $request->gross_amount_totali,
							  'net_total_amount'    =>  $request->net_amount_totali,
							  'total_vat'           =>  $request->vat_amount_totali,
							  //'total_unite_price'   =>  $request->price_amount_totali,
							  'total_invoice_value' =>  $request->invoice_amount_totali,
							  'created_at'         => $current,
							 );
				 
			$header_id =DB::table('tbl_outlet_counter_sales_header')->insertGetId($data3);
		 
			if(count($request->material_name)>0)
		      {
			   
			   foreach($request['material_name'] as $key => $n)
			     {
					
				  if($request->quantity[$key ]!='')
			  
				    {
					 $data2=array(
					 'material_id' => $request->material_name[$key ],
					 'header_id'     =>$header_id,
					 'uom'           => $request->uom[$key ],
					 'unite_price'   => $request->price[$key ],
					 'gross_total'   => $request->gross[$key ],
					 'vat'           => $request->vat[$key ],
					 'total'         => $request->total[$key ],
					 'net_amount'    => $request->net_amount[$key ],
					 'quantity'      => $request->quantity[$key ],
					 'base_qty'    => $request->packing_size[$key ],
					 'created_at'    => $current,
					 );
					 DB::table('tbl_outlet_counter_sales_details')->insert($data2);
					 
					 /* stock movement functionality start from here */
							 $stock = DB::table('tbl_outlet_stock_warehouse')
									  ->where('tbl_outlet_stock_warehouse.warehouse_id','=',$request->warehouse)
									  ->where('tbl_outlet_stock_warehouse.outlet_warehouse_id','=',$request->outlet)
									  ->where('tbl_outlet_stock_warehouse.material_id','=',$request->material_name[$key])
									  ->get()->all();
									 $count=count($stock);
									  if($count>0)
									  {
										  // reducing stock from warehouse
										  $query = DB::table('tbl_outlet_stock_warehouse')
									              ->where('tbl_outlet_stock_warehouse.warehouse_id','=',$request->warehouse)
									              ->where('tbl_outlet_stock_warehouse.outlet_warehouse_id','=',$request->outlet)
										          ->where('material_id','=',$request->material_name[$key]);
										          $query->decrement('qty',$request->packing_size[$key]);
									  }	
					 
				        } 
                   }
		 
	           }
		  
		    return redirect(route('counter_sales_list'))->with('successMessage','Counter Sales Uploaded Successfully');
     }
	  
    public function view($id)   
     {   
	
			$user_id=Session::get('user_id');
			 
			$get_data =DB::table('tbl_outlet_counter_sales_header')
			->leftJoin('tbl_customer', 'tbl_outlet_counter_sales_header.distibutor_id', '=', 'tbl_customer.id')
			->leftJoin('tbl_warehouse', 'tbl_outlet_counter_sales_header.outlet_id', '=', 'tbl_warehouse.id')
			->leftJoin('tbl_warehouse as warehouse1', 'tbl_outlet_counter_sales_header.warehouse_id', '=', 'warehouse1.id')
			->leftJoin('tbl_currency_type', 'tbl_outlet_counter_sales_header.currency', '=', 'tbl_currency_type.id') 
			 ->select('tbl_outlet_counter_sales_header.*','tbl_currency_type.currency_notation','tbl_customer.customer_code','tbl_customer.customer_name','tbl_warehouse.warehouse_code','tbl_warehouse.warehouse_name','warehouse1.warehouse_code as w_code','warehouse1.warehouse_name as w_name')->where('tbl_outlet_counter_sales_header.id', '=',$id)->get()->first();
			  
			$get_data_details =DB::table('tbl_outlet_counter_sales_details') 
			->leftJoin('tbl_material_master', 'tbl_outlet_counter_sales_details.material_id', '=', 'tbl_material_master.id')
			->leftJoin('tbl_unit_of_measurement', 'tbl_outlet_counter_sales_details.uom', '=', 'tbl_unit_of_measurement.id') 
			->select('tbl_outlet_counter_sales_details.*','tbl_material_master.material_code as m_code','tbl_material_master.material_name','tbl_unit_of_measurement.unit_notation')->where('tbl_outlet_counter_sales_details.header_id', '=', $id)->get()->all();
		 //dd($get_data_details);    
 
		   $login_user = DB::table('tbl_user')
		  ->leftJoin('tbl_company', 'tbl_user.company_id', '=', 'tbl_company.id')
		  ->leftJoin('tbl_currency_type', 'tbl_company.currency_id', '=', 'tbl_currency_type.id')
		  ->select('tbl_user.id', 'tbl_company.currency_id','tbl_currency_type.currency_notation')
		  ->where('tbl_user.id', '=', $user_id)
		  ->get()->first();	 
		  
		 return view('Outlet_Transaction.counter_sales_view',compact('get_data','get_data_details','login_user'));
	
     }
	
	public function get_material_alt_packing_size($id,$val)
	 {
 
		$material=MaterialMasterModel::get()->sortByDesc('id')->first()->find($val);	

		$alt_uom = explode(",",$material->alt_uom);
	   
		$key = array_search($id, $alt_uom);
	   
		$alt_alt_packing_size = explode(",",$material->alt_packing_size);

		echo $alt_alt_packing_size[$key];

 
		
	 }
	 
	 public function get_material_detailsUom($id,$row)
      {
			$uom12 =UnitOfMeasurementModel::all()->sortByDesc('id')->where('status', '=', 'active');
			$material_master = DB::select('SELECT t2.id, t2.uom_name,t2.unit_notation FROM tbl_material_master as t1 LEFT JOIN     tbl_unit_of_measurement as t2 ON find_in_set(t2.id, 
			t1.alt_uom) WHERE t1.`id`='.$id.'');			
			$get_material_price=MaterialMasterModel::find($id);			
			$alt_unit_price = explode(",",$get_material_price->alt_unit_price);			
		   //dd($material_master);
			$material=MaterialMasterModel::get()->sortByDesc('id')->first()->find($id);
		    foreach($material_master as $key=>$data)
			  {					
				 ?>
				 <option  <?php if($data->id == $material->uom)  echo 'selected'; ?> value ="<?php echo $data->id; ?>" ><?php echo $data->unit_notation; ?></option>
				 <?php
				 
				}
	  }
	public function material_vat($id)
	 {
	 
				$material_vat=MaterialMasterModel::get(['vat'])->sortByDesc('id')->first()->find($id);	
  
				echo $material_vat->vat;
		
 
		
	 }
	public function get_counter_sells_outlet_warehouse_list($distibutor)
	{
		
		
		$outlet_warehouse=WarehouseModel::get()->where('warehouse_type','=',1)->where('status', '=', 'active')->where('distributor','=',$distibutor)->all();
		
		?>
		<option  value=""> </option>
		<?php
		
		foreach($outlet_warehouse as $warehouse_name)
	      {
			?>
			<option value="<?php echo $warehouse_name->id ?>"  ><?php echo $warehouse_name->warehouse_code.' - '.$warehouse_name->warehouse_name ?></option>	
			<?php		
		  }
		  
	}
	
	public function get_outlet_warehouse_of_warehouse($warehouse)
	{
		$outlet_warehouse=WarehouseModel::get()->where('warehouse_type','=',3)->where('status', '=', 'active')->where('outlet_warehouse','=',$warehouse)->all();
		
		?>
		<option  value=""> </option>
		<?php
		
		foreach($outlet_warehouse as $warehouse_name)
	      {
			?>
			<option value="<?php echo $warehouse_name->id ?>"  ><?php echo $warehouse_name->warehouse_code.' - '.$warehouse_name->warehouse_name ?></option>	
			<?php		
		  }
		 
	}
	
	 public function counter_sales_export($id)
	      {   
		      
             return Excel::download(new OutletCounterExport($id), 'counter_export.xlsx');
        
	       }  
	   public function counter_sales_pdf($id)
	      {   
		      
			$get_data =DB::table('tbl_outlet_counter_sales_header')
			->leftJoin('tbl_customer', 'tbl_outlet_counter_sales_header.distibutor_id', '=', 'tbl_customer.id')
			->leftJoin('tbl_warehouse', 'tbl_outlet_counter_sales_header.outlet_id', '=', 'tbl_warehouse.id')
			->leftJoin('tbl_warehouse as warehouse1', 'tbl_outlet_counter_sales_header.warehouse_id', '=', 'warehouse1.id')
			->leftJoin('tbl_currency_type', 'tbl_outlet_counter_sales_header.currency', '=', 'tbl_currency_type.id') 
			 ->select('tbl_outlet_counter_sales_header.*','tbl_currency_type.currency_notation','tbl_customer.address','tbl_customer.tin_no','tbl_customer.contact_no','tbl_customer.email','tbl_customer.customer_code','tbl_customer.customer_name','tbl_warehouse.warehouse_code','tbl_warehouse.warehouse_name','warehouse1.warehouse_code as w_code','warehouse1.warehouse_name as w_name')->where('tbl_outlet_counter_sales_header.id', '=',$id)->get()->first();
			     
			$get_data_details =DB::table('tbl_outlet_counter_sales_details') 
			->leftJoin('tbl_material_master', 'tbl_outlet_counter_sales_details.material_id', '=', 'tbl_material_master.id')
			->leftJoin('tbl_unit_of_measurement', 'tbl_outlet_counter_sales_details.uom', '=', 'tbl_unit_of_measurement.id') 
			->select('tbl_outlet_counter_sales_details.*','tbl_material_master.material_code as m_code','tbl_material_master.material_name','tbl_unit_of_measurement.unit_notation')->where('tbl_outlet_counter_sales_details.header_id', '=', $id)->get()->all();
		  
		      $pdf=PDF::loadView('export.pdf.counter_sales_pdf', compact('get_data','get_data_details'));
             return  $pdf->download('counter_export.pdf');   
        
	       }  
 }
