<?php

namespace App\Http\Controllers;
use Illuminate\Http\Request;
use App\Models\CreditCollectionModel;
use App\Models\MaterialCategoryModel;
use App\Models\CustomerTypeModel;
use App\Models\MaterialMasterModel;
use App\Models\OutstandingDetailsModels;
use App\Models\TradingCenterModel;
use App\Models\RouteModel;
use App\Models\ManageCodeModel;
use App\Models\SalesmanModel;
use App\Models\WarehouseModel;
use App\Models\RouteCollectionModel;
use App\Models\CustomerModel;
use Illuminate\Support\Facades\DB;
use Session;
use PDF;
use Carbon\Carbon;
use Response;
use App\Exports\RouteCollectionExport; 
use Maatwebsite\Excel\Facades\Excel;

class CreditCollectionController extends Controller
 {
   public function list(Request $request)
	{
		 
	  $current_date=date("Y-m-d");	
	  $where="";		
	  if(count($request->all()) < 1)
        {
		  $where .= " AND DATE_FORMAT(riheader.created_at, '%Y-%m-%d') between '".$current_date."' and '".$current_date."'"; 
	    }
	  
	  if($request->fromdate!='')
        {
	      $where .= " AND DATE_FORMAT(riheader.created_at, '%Y-%m-%d') between '".$request->fromdate."' and '".$request->todate."'"; 
        }
		 
	  if($request->warehouse!='')
	    {
		  $where .= "AND warehouse.id = '".$request->warehouse."'";
	    }
		 
	  if($request->route!='')
	    {
		  $where .= "AND route.id = '".$request->route."'";
	    }

	 
		//dd($request);
		 $route =RouteModel::all()->sortByDesc('id')->where('status', '=', 'active');
		 $warehouse=WarehouseModel::all()->sortByDesc('id')->where('warehouse_type','=','1')->where('status', '=', 'active');
		 
		 $customer =CustomerModel::all()->sortByDesc('id')->where('status', '=', 'active');

		$result = DB::select("SELECT riheader.*, route.route_name,route.route_code,
		warehouse.warehouse_code,warehouse.warehouse_name,
	    customer.customer_name,customer.customer_code
		FROM tbl_route_collection_header as riheader
		LEFT JOIN tbl_route as route on riheader.route_id=route.id
	    LEFT JOIN tbl_warehouse as warehouse on riheader.warehouse_id=warehouse.id
		LEFT JOIN tbl_customer as customer on riheader.customer_id=customer.id
		WHERE riheader.id IS NOT NULL ".$where." ORDER BY id DESC");
			return view('Route_Transaction.credit_collection_list',compact('result','route','warehouse','customer'));
     }
	
    public function view($id)
	 {  
	 
	
		$result = DB::table('tbl_route_collection_header')->select
		(
		'tbl_route_collection_header.*',					
		'tbl_route.route_code',
		'tbl_route.route_name',
		'tbl_customer.customer_code',
		'tbl_customer.customer_name',
		'tbl_warehouse.warehouse_code',
		'tbl_warehouse.warehouse_name',
        'tbl_trading_center.trading_name',
        'tbl_trading_center.trading_center_code',
      )
		
		 
		 ->leftJoin('tbl_route', 'tbl_route.id', '=', 'tbl_route_collection_header.route_id')
		 ->leftJoin('tbl_trading_center', 'tbl_trading_center.id', '=', 'tbl_route_collection_header.trading_center_id')
		 ->leftJoin('tbl_customer', 'tbl_customer.id', '=', 'tbl_route_collection_header.customer_id')
		 ->leftJoin('tbl_warehouse', 'tbl_warehouse.id', '=', 'tbl_route_collection_header.warehouse_id')
		 ->leftJoin('tbl_route_collection_details', 'tbl_route_collection_details.header_id', '=', 'tbl_route_collection_header.id')
		 ->where('tbl_route_collection_header.id', '=',$id)->get()->first();
		
		 
		 
		 $get_data=DB::table('tbl_route_collection_details')
		 ->select('tbl_route_collection_details.*')
		->where('tbl_route_collection_details.header_id', '=',$id)->get()->all();
		 
		 
 //dd($result);
		return view('Route_Transaction.credit_collection_view',compact('result','get_data'));
     }
	 
	  public function add()
	 {   

		$user_id=Session::get('user_id');
		$result = DB::table('tbl_route_collection_header')
		 ->select('tbl_route_collection_header.*')->get()->sortByDesc('id')->first();
	 
		if($result=='')
	      {
			$getcode = ManageCodeModel::where('id', 1)->first();
			$last_code = $getcode->route_collection_code;
		  }
	    else
		 {
			 $getcode = $result->collection_number; 
			 $last_code = ++$getcode;
		 }
             
			
			
			   $trading=TradingCenterModel::all()->sortByDesc('id')->where('status', '=', 'active');
			   $customer =CustomerModel::all()->sortByDesc('id')->where('status', '=', 'active');
			
			   $route =RouteModel::all()->sortByDesc('id')->where('status', '=', 'active');
			   
			  
			  
			   $login_user = DB::table('tbl_user')
			         ->leftJoin('tbl_company', 'tbl_user.company_id', '=', 'tbl_company.id')
			         ->leftJoin('tbl_currency_type', 'tbl_company.currency_id', '=', 'tbl_currency_type.id')
			         ->select('tbl_user.id', 'tbl_company.currency_id','tbl_currency_type.currency_notation')
			         ->where('tbl_user.id', '=', $user_id)
			         ->get()->first();
			 
			 
			  return view('Route_Transaction.route_collection',compact('route','trading','login_user','customer','last_code'));
	 }
 public function route_collection_save(Request $request)
     {
	//dd($request);
		 $result = DB::table('tbl_route_collection_header')
		       ->select('tbl_route_collection_header.*')->get()->sortByDesc('id')->first();
		  if($result=='')
		  {
			$getcode = ManageCodeModel::where('id', 1)->first();
			$last_code1 = $getcode->route_collection_code;
		  }
		else
		  {
			 $getcode = $result->collection_number; 
			 $last_code1 = ++$getcode;
		  }
		 
		 $current = Carbon::now(); 
		   $newDate = date("d-m-Y");
		   $warehouse=DB::table('tbl_warehouse')
		   ->select('tbl_warehouse.id')
		   ->get();
		   $invoice=DB::table('tbl_route_invoice_header')
		   ->select('tbl_route_invoice_header.*')
		   ->get();
		   $save_data=array(
									 
									 'route_id'                         =>  $request->route,
									 'customer_id'                      =>  $request->customer_type,
									 'trading_center_id'                =>  $request->trading_type,
									 'warehouse_id'                     =>  $warehouse[0]->id,
									 'collection_type'                  =>  $request->collection_type,
									 'collection_number'                =>  $last_code1, 
									 'cheque_number'                    =>  $request->cheque_number, 
									 'cheque_date'                      =>  $request->cheque_date,
									 'bank_name'                        =>  $request->bank_name,
									 'account_number'                   =>  $request->account_number,
									 'branch_name'                      =>  $request->branch_name,
									 'created_at'                       => $current,
									);
		   
		   
				
		   $header_id =DB::table('tbl_route_collection_header')->insertGetId($save_data);
		 
		//dd($save_data);
		 
		   foreach($request['outstanding'] as $key => $n)
		     {
				
			      if($request->paid_now[$key]!=0)
			       {
					//dd($request->out_id[$key]);
				     $data=OutstandingDetailsModels::find($request->out_id[$key]);
					 
				     $data->increment('amount_paid',$request->paid_now[$key]);
				     $data->decrement('amount_outsatnding',$request->paid_now[$key]);
				     $data->save();
					

				     $s= $data->amount_outsatnding;
					
					                $data2=array
									(
										 'invoice_id'      => $request->invoice_id[$key ],
										 'header_id'       => $header_id,
										 'invoice_no'      => $request->invoice_number[$key ],
										 'outstanding_amt' =>$s,
										 'paid_amt'        => $request->paid_now[$key ],
										 'total_outstanding' => $request->total_invoice_amount[$key ],
										 'created_at'      => $current,
									 );
								   DB::table('tbl_route_collection_details')->insert($data2); 
				           if($s < 1)
				           {
					          OutstandingDetailsModels::find($request->out_id[$key])->delete();
					           
				          }
				    }
					
				}
				 
			 	
		 return redirect(route('credit_collection_list'))->with('successMessage','Collection Save Successfully');
	 }
	 public function get_salesman($id1)
	{
		
	  $get_data=SalesmanModel::all()->sortByDesc('id')->where('route_id', '=', $id1)->where('status', '=', 'active');		
	  ?>
	  <option  value="">     </option>
	  <?php
	  foreach($get_data as $salesman)
		{
			?>
			<option value="<?php echo $salesman->id ?>"  ><?php echo $salesman->salesman_code." - ".$salesman->salesman_name ?></option>					
			<?php		
		}
    }
	
	 public function get_trading($route)
	{
        
		$trading_center=TradingCenterModel::get()->where('status', '=', 'active')->where('route_id', '=', $route)->all();
		

		?>
		<option  value=""> </option>
		<?php
		
		foreach($trading_center as $trading_center_name)
	      {
			?>
			<option value="<?php echo $trading_center_name->id ?>"><?php echo $trading_center_name->trading_center_code." - ".$trading_center_name->trading_name ?></option>	
			<?php		
		  }
		
	}
	
	public function get_customer($trading)
	{

		$customer_type=CustomerModel::get()->where('status', '=', 'active')->where('trading_center_id','=',$trading)->all();
		

		?>
		<option  value=""> </option>
		<?php
		
		foreach($customer_type as $customer_name)
	      {
			?>
			<option value="<?php echo $customer_name->id ?>"> <?php echo $customer_name->customer_code." - ".$customer_name->customer_name ?></option>	
			<?php		
		  }
		
	}
	
	public function get_outstanding($route_id,$trading_id,$cus_id)
	 {	  
        /* echo $route_id.','.$trading_id.','.$cus_id;	 
		exit; */
	
	   $total_outstanding =OutstandingDetailsModels::where('customer_id', $cus_id)->sum('amount_outsatnding');
	   
	    $outstanding1=DB::table('tbl_outstanding_details')
			   ->leftJoin('tbl_route_invoice_header','tbl_outstanding_details.invoice_id','=','tbl_route_invoice_header.id')
			   ->leftjoin('tbl_trading_center','tbl_route_invoice_header.trading_center_id','=','tbl_trading_center.id')
			   ->leftJoin('tbl_customer','tbl_route_invoice_header.customer_name','=','tbl_customer.id')
			   ->select('tbl_outstanding_details.*','tbl_route_invoice_header.invoice_number','tbl_route_invoice_header.invoice_date','tbl_trading_center.trading_name','tbl_trading_center.trading_center_code','tbl_customer.customer_name','tbl_customer.customer_code')
			   ->where('customer_id',$cus_id)
			   ->get();
	  
      
	
	   $customer_type =CustomerModel::all()->sortByDesc('id')->where('customer_type', '=', $cus_id)->where('status', '=', 'active');
	 
	   $user_id=Session::get('user_id');
  
	    $result = DB::table('tbl_route_collection_header')
		 ->select('tbl_route_collection_header.*')->get()->sortByDesc('id')->first();

	   if($result=='')
		 {
			$getcode = ManageCodeModel::where('id', 1)->first();
			$last_code = $getcode->route_colletion_code;
		 }
	   else
		 {
			 $getcode = $result->collection_number; 
			 $last_code = ++$getcode;
		 }
  
		  $material_master = DB::table('tbl_material_master')
			->join('tbl_unit_of_measurement', 'tbl_material_master.uom_id', '=', 'tbl_unit_of_measurement.id')
			
			->select('tbl_material_master.*', 'tbl_unit_of_measurement.uom_name')
		
			->get()->all();
	
		  $material_category =MaterialCategoryModel::all()->sortByDesc('id')->where('status', '=', 'active');
		  
		  $material =MaterialMasterModel::all()->sortByDesc('id')->where('status', '=', 'active');
		 
		  $route =RouteModel::all()->sortByDesc('id')->where('status', '=', 'active');
      $trading=TradingCenterModel::all()->sortByDesc('id')->where('status', '=', 'active')->where('id','=',$route_id);
	 $customer =CustomerModel::all()->sortByDesc('id')->where('status', '=', 'active')->where('customer_type','=',$trading_id);
		  
		  $login_user = DB::table('tbl_user')
			    ->leftJoin('tbl_company', 'tbl_user.company_id', '=', 'tbl_company.id')
			    ->leftJoin('tbl_currency_type', 'tbl_company.currency_id', '=', 'tbl_currency_type.id')
			    ->select('tbl_user.id', 'tbl_company.currency_id','tbl_currency_type.currency_notation')
			    ->where('tbl_user.id', '=', $user_id)
			    ->get()->first();
	   
		 
		
		  return view('Route_Transaction.route_collection',compact('customer_type','material_master',	'material_category','route','material','login_user','total_outstanding','outstanding1','trading','customer','last_code'));
		
	   }
	  
	  public function route_collection_export($id)
	    {
		  
		  return Excel::download(new RouteCollectionExport($id), 'route_collection.xlsx');
	   }
	  
	   public function route_collection_pdf($id)
	    {
		  
		  $result = DB::table('tbl_route_collection_header')->select
		   (
		   'tbl_route_collection_header.*','tbl_route.route_code','tbl_route.route_name','tbl_customer.address','tbl_customer.tin_no','tbl_customer.contact_no','tbl_customer.email','tbl_customer.customer_code','tbl_customer.customer_name','tbl_warehouse.warehouse_code','tbl_warehouse.warehouse_name','tbl_trading_center.trading_name','tbl_trading_center.trading_center_code',
            )
		    ->leftJoin('tbl_route', 'tbl_route.id', '=', 'tbl_route_collection_header.route_id')
		    ->leftJoin('tbl_trading_center', 'tbl_trading_center.id', '=', 'tbl_route_collection_header.trading_center_id')
		    ->leftJoin('tbl_customer', 'tbl_customer.id', '=', 'tbl_route_collection_header.customer_id')
		    ->leftJoin('tbl_warehouse', 'tbl_warehouse.id', '=', 'tbl_route_collection_header.warehouse_id')
		    ->leftJoin('tbl_route_collection_details', 'tbl_route_collection_details.header_id', '=', 'tbl_route_collection_header.id')
		    ->where('tbl_route_collection_header.id', '=',$id)->get()->first();
		 
		 $get_data=DB::table('tbl_route_collection_details')
		   ->select('tbl_route_collection_details.*')
		   ->where('tbl_route_collection_details.header_id', '=',$id)->get()->all();
		   
		   $pdf=PDF::loadView('export.pdf.route_collection_pdf', compact('result','get_data'));
		  return  $pdf->download('route_collection.pdf');
	    }
 }
