<?php

namespace App\Http\Controllers;
use Illuminate\Http\Request;
use App\Models\CustomerModel;
use App\Models\RouteModel;
use App\Models\ManageCodeModel;
use App\Models\CountryTypeModel;
use App\Models\RegionTypeModel;
use App\Models\SubRegionTypeModel;
use App\Models\TradingCenterModel;
use App\Models\CustomerCategoryModel;
use App\Models\CustomerTypeModel;
use App\Models\PaymentTermModel;
use App\Models\WarehouseModel;
use App\Models\CityTypeModel;

use Illuminate\Support\Facades\DB;
use Session;

class CustomerController extends Controller
 {
   public function add()
	{
	 
      $result =CustomerModel::get()->sortByDesc('id')->first();
	  if($result=='')
		{
			$getcode = ManageCodeModel::where('id', 1)->first();
			$last_code = $getcode->customer_code;
		}
	  else
		{
			 $getcode = $result->customer_code; 
			 $last_code = ++$getcode;
		}
	
		
		$country_id =CountryTypeModel::all()->sortByDesc('id')->where('status', '=', 'active');
		$region =RegionTypeModel::all()->sortByDesc('id')->where('status', '=', 'active');
		$subregion =SubRegionTypeModel::all()->sortByDesc('id')->where('status', '=', 'active');
		
		$customer_category =CustomerCategoryModel::all()->sortByDesc('id')->where('status', '=', 'active');
		$customer_type =CustomerTypeModel::all()->sortByDesc('id')->where('status', '=', 'active');
		$payment_term =PaymentTermModel::all()->sortByDesc('id')->where('status', '=', 'active');
		
		$route =RouteModel::all()->sortByDesc('id')->where('status', '=', 'active');
		
		return view('Master_Configuration.customer',compact('country_id','region','subregion','customer_category','customer_type','payment_term','last_code','route'));
	 }
	
	public function edit($id)
	 {
		
		$get_data=CustomerModel::find($id);
		$city_id= CityTypeModel::all()->sortByDesc('id')->where('status', '=', 'active');
		
		$country_id =CountryTypeModel::all()->sortByDesc('id')->where('status', '=', 'active');
		$region =RegionTypeModel::all()->sortByDesc('id')->where('status', '=', 'active');
		$subregion =SubRegionTypeModel::all()->sortByDesc('id')->where('status', '=', 'active');
		$customer_category =CustomerCategoryModel::all()->sortByDesc('id')->where('status', '=', 'active');
		$customer_type =CustomerTypeModel::all()->sortByDesc('id')->where('status', '=', 'active');
		$payment_term =PaymentTermModel::all()->sortByDesc('id')->where('status', '=', 'active');		
		$route =RouteModel::all()->sortByDesc('id')->where('status', '=', 'active');		
		$last_code = $get_data->customer_code;
		// dd($get_data);
	    return view('Master_Configuration.customer',compact('get_data','city_id','country_id','region','subregion','customer_category','customer_type','payment_term','last_code','route'));
	 }
		
	public function view($id)
	 {    
		//$get_data=CustomerModel::find($id);
		$get_data = DB::table('tbl_customer')
		->leftJoin('tbl_country', 'tbl_customer.country_id', '=', 'tbl_country.id')
		->leftJoin('tbl_region', 'tbl_customer.region', '=', 'tbl_region.id')
		->leftJoin('tbl_sub_region', 'tbl_customer.sub_region', '=', 'tbl_sub_region.id')
		->leftJoin('tbl_city', 'tbl_customer.city_id', '=', 'tbl_city.id')
		
		->leftJoin('tbl_payment_term', 'tbl_customer.payment_term', '=', 'tbl_payment_term.id')
		->leftJoin('tbl_customer_category', 'tbl_customer.customer_category', '=', 'tbl_customer_category.id')
		->leftJoin('tbl_customer_type', 'tbl_customer.customer_type', '=', 'tbl_customer_type.id')
		
		->leftJoin('tbl_route', 'tbl_customer.route_id', '=', 'tbl_route.id')
		->leftJoin('tbl_trading_center', 'tbl_customer.trading_center_id', '=', 'tbl_trading_center.id')
		
	    ->select('tbl_customer.*', 'tbl_country.country_code','tbl_country.country_name','tbl_region.region_code','tbl_region.region_name','tbl_sub_region.sub_region_code','tbl_sub_region.sub_region_name','tbl_payment_term.payment_code','tbl_payment_term.payment_term','tbl_customer_category.customer_category_code','tbl_customer_category.customer_category_name','tbl_customer_type.customer_type_name','tbl_customer_type.customer_type_code','tbl_city.city_name','tbl_city.city_code','tbl_route.route_name','tbl_route.route_code','tbl_trading_center.trading_name','tbl_trading_center.trading_center_code')
	    ->where('tbl_customer.id', '=', $id)
		->first();
	    //dd($get_data);

	     return view('Master_Configuration.customer_view',compact('get_data'));
	 }
	
    public function list()
     {
			//$get_data = CustomerModel::all()->sortByDesc('id');
			$get_data = DB::table('tbl_customer')
			->leftJoin('tbl_route', 'tbl_customer.route_id', '=', 'tbl_route.id')
			->leftJoin('tbl_customer_type', 'tbl_customer.customer_type', '=', 'tbl_customer_type.id')
			->leftJoin('tbl_region', 'tbl_customer.region', '=', 'tbl_region.id')
			->leftJoin('tbl_sub_region', 'tbl_customer.sub_region', '=', 'tbl_sub_region.id')
			->leftJoin('tbl_city', 'tbl_customer.city_id', '=', 'tbl_city.id')
			
		   ->select('tbl_customer.*', 'tbl_route.route_code','tbl_route.route_name','tbl_region.region_name','tbl_sub_region.sub_region_name','tbl_customer_type.customer_type_code','tbl_customer_type.customer_type_name','tbl_city.city_name','tbl_city.city_code')
			->orderBy('id', 'DESC')->get();
			//dd($get_data);
			return view('Master_Configuration.customer_list',compact('get_data'));
	 }
	
    public function save(Request $request)
	 {
    
		$data=new CustomerModel;
		
		if($request->updated_id) 
		  {
            
			$data = CustomerModel::find($request->updated_id);
			$data->customer_type=$request->customer_type;
			$data->customer_category=$request->customer_category;
			$data->customer_code=$request->customer_code;
			$data->customer_name=$request->customer_name;
			$data->tin_no=$request->tin_no;
			$data->address=$request->address;
			$data->city_id=$request->city_id;
			$data->country_id=$request->country_id;
			$data->email=$request->email;
			$data->contact_no=$request->contact_no;
			$data->payment_term=$request->payment_term;
			$data->credit_limit=$request->credit_limit;
			$data->credit_days=$request->credit_days;
			$data->region=$request->region;
			$data->sub_region=$request->sub_region;			
			$data->trading_center_id=$request->trading_center;
			$data->route_id=$request->route;
			$data->bank_account_name1=$request->bank_account_name1;
			$data->bank_account_number1=$request->bank_account_number1;
			$data->bank_branch1=$request->bank_branch1;
			$data->bank_account_name2=$request->bank_account_name2;
			$data->bank_account_number2=$request->bank_account_number2;
			$data->bank_branch2=$request->bank_branch2;
			$data->customer_code=$request->customer_code;
			$data->customer_name=$request->customer_name;
			$data->tin_no=$request->tin_no;
			$data->latitude=$request->latitude;
			$data->longitude=$request->longitude;
			$data->thresold_frequency=$request->thresold_frequency;
			$data->erp_customer=$request->erp_customer;
			$data->credit_balance=$request->credit_balance;
			$data->company_id= Session::get('company_id');
			$data->updated_user= Session::get('user_id');
			$data->status=$request->status;
			$data->save();
			// dd($data);
			return redirect(route('customer_list'))->with('successMessage','Customer Updated Successfully');
   
		  } 
		else 
		  {
			$data->customer_type=$request->customer_type;
			$data->customer_category=$request->customer_category;
			$data->customer_code=$request->customer_code;
			$data->customer_name=$request->customer_name;
			$data->tin_no=$request->tin_no;
			$data->address=$request->address;
			$data->trading_center_id=$request->trading_center;
			$data->route_id=$request->route;			
			$data->city_id=$request->city_id;
			$data->email=$request->email;
			$data->contact_no=$request->contact_no;
			$data->payment_term=$request->payment_term;
			$data->credit_limit=$request->credit_limit;
			$data->credit_days=$request->credit_days;
			$data->region=$request->region;
			$data->sub_region=$request->sub_region;
			$data->bank_account_name1=$request->bank_account_name1;
			$data->bank_account_number1=$request->bank_account_number1;
			$data->bank_branch1=$request->bank_branch1;
			$data->bank_account_name2=$request->bank_account_name2;
			$data->bank_account_number2=$request->bank_account_number2;
			$data->bank_branch2=$request->bank_branch2;
			$data->customer_code=$request->customer_code;
			$data->customer_name=$request->customer_name;
			$data->tin_no=$request->tin_no;
			$data->latitude=$request->latitude;           
			$data->longitude=$request->longitude;
			$data->thresold_frequency=$request->thresold_frequency;
			$data->erp_customer=$request->erp_customer;
			$data->company_id= Session::get('company_id');
			$data->country_id=$request->country_id;
			$data->credit_balance=$request->credit_balance;
			$data->created_user= Session::get('user_id');
			$data->status=$request->status;
			$data->save();
			return redirect(route('customer_list'))->with('successMessage','Customer Added Successfully');
		
		  }   
	 }
	
	public function get_country($id, $city_id)
	 {
		 
		$get_data=CityTypeModel::all()->sortByDesc('id')->where('country_id', '=', $id)->where('status', '=', 'active');
		?>
		<option  value="">     </option>
		<?php
		foreach($get_data as $cityname)
		  {
			?>
			<option value="<?php echo $cityname->id ?>" <?php if($cityname->id == $city_id) { echo "selected"; } ?> ><?php echo $cityname->city_code." - ".$cityname->city_name ?></option>	
			<?php		
		  }
		
	 }
	public function get_region($id)
	 {
		 
	   $get_data= DB::table('tbl_route')
		  ->leftJoin('tbl_warehouse', 'tbl_route.warehouse_id', '=', 'tbl_warehouse.id')
		  ->leftJoin('tbl_region', 'tbl_warehouse.region', '=', 'tbl_region.id')
		  ->leftJoin('tbl_sub_region', 'tbl_warehouse.sub_region', '=', 'tbl_sub_region.id')
		  ->select('tbl_warehouse.region as region_id','tbl_warehouse.sub_region as sub_region_id','tbl_region.region_code','tbl_region.region_name','tbl_sub_region.sub_region_code','tbl_sub_region.sub_region_name')
		  ->where('tbl_route.id', '=', $id)
		  ->get()->all();
		//dd($get_data);
		 $count= count($get_data);
		 if($count>0)
		   {	
		     echo $get_data[0]->region_id.'-'.$get_data[0]->sub_region_id.'-'.$get_data[0]->region_code.'-'.$get_data[0]->region_name.'-'.$get_data[0]->sub_region_code.'-'.$get_data[0]->sub_region_name; 
		   }
		else
		  {
			echo $count;
		  }
		
      }
	/*public function get_subregion($id)
	 {
		$material_master1 = DB::table('tbl_warehouse')
			 ->leftJoin('tbl_region', 'tbl_warehouse.region', '=', 'tbl_region.id')
			 ->leftJoin('tbl_sub_region', 'tbl_warehouse.sub_region', '=', 'tbl_sub_region.id')
			 ->leftJoin('tbl_customer', 'tbl_warehouse.distributor', '=', 'tbl_customer.id')
			  ->select('tbl_customer.id as distibutor_id','tbl_customer.customer_code','tbl_customer.customer_name','tbl_region.id as region_id','tbl_region.region_code','tbl_region.region_name','tbl_sub_region.id as sub_region_id','tbl_sub_region.sub_region_code','tbl_sub_region.sub_region_name')
			  ->where('tbl_warehouse.id', '=', $id)
			  ->get()->all();
			  
		$count= count($material_master1);
		if($count>0)
		  {	
		   echo $material_master1[0]->customer_code.'-'.$material_master1[0]->customer_name.'-'.$material_master1[0]->region_code.'-'.$material_master1[0]->region_name.'-'.$material_master1[0]->sub_region_code.'-'.$material_master1[0]->sub_region_name.'-'.$material_master1[0]->region_id.'-'.$material_master1[0]->sub_region_id.'-'.$material_master1[0]->distibutor_id; 
		  }
		else
		  {
			echo $count;
		  }
     }*/
	
	public function get_trading($id1, $trading_id)
	 {
	
		$get_data=TradingCenterModel::all()->sortByDesc('id')->where('route_id', '=', $id1)->where('status', '=', 'active');
		//dd($get_data);
		?>
		<option  value="">     </option>
		<?php
		foreach($get_data as $trading)
		  {
			?>
			<option value="<?php echo $trading->id ?>" <?php if($trading->id == $trading_id) { 
			echo "selected"; } ?> ><?php echo $trading->trading_center_code." - ".$trading->trading_name; ?></option>	
			<?php		
		  }
			//dd($trading->trading_center_code);			
			//return response()->json($get_data);
	
	 }
		
	public function get_customer_category($id, $customer_category_id)
	 {		 
		$get_data=CustomerCategoryModel::all()->sortByDesc('id')->where('customer_type_id', '=', $id)->where('status', '=', 'active');
		
		?>
		<option  value="">     </option>
		<?php
		foreach($get_data as $cityname)
	      {
			?>
			<option value="<?php echo $cityname->id ?>" <?php if($cityname->id == $customer_category_id) { echo "selected"; } ?> ><?php echo $cityname->customer_category_code." - ".$cityname->customer_category_name ?></option>	
			<?php		
		  }
		
	  }
	  
	   
 }
