<?php

namespace App\Http\Controllers;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\DB;

use Session;

class DashboardController extends Controller
 {
   public function index(Request $request)
	{  

		$customer_count              = DB::table('tbl_customer')->count();

		$salesman_count              = DB::table('tbl_route')->count();  

		$route_count                 = DB::table('tbl_salesman')->count(); 

		$route_invoice_count         = DB::table('tbl_route_invoice_header')->count();

		$other_invoice_count         = DB::table('tbl_company_collection_header')->count(); 
		
		// For Pie Chart
		//$dataPoints=DB::select("SELECT customer_category_name as label, COUNT(id) AS y	 FROM tbl_customer_category WHERE status = 'active' GROUP BY label"); 
		
		// For Pie Chart
		$dataPoints =DB::table('tbl_route_invoice_header')
	 
			->leftJoin('tbl_customer', 'tbl_route_invoice_header.customer_name', '=', 'tbl_customer.id')
			->leftJoin('tbl_customer_category', 'tbl_customer.customer_category', '=', 'tbl_customer_category.id')
  
			->select('tbl_customer_category.customer_category_name as label',DB::raw('sum(tbl_route_invoice_header.total_invoice_value) AS y'))
			
			->groupBy('label')
			
			->get()->all();	 
			//dd($dataPoints);
		
		 // Dashboard TOP 10 MATERIAL PERFORMANCE
		 $get_data = DB::table('tbl_route_invoice_details')
				->Join('tbl_material_master', 'tbl_route_invoice_details.material_code', '=', 'tbl_material_master.id')
		
				->select(DB::raw('sum(tbl_route_invoice_details.total) as invoice_total'), 'tbl_material_master.material_name as mat_name')
				->orderBy(DB::raw('sum(tbl_route_invoice_details.total)'),'desc')
				->groupBy('tbl_route_invoice_details.material_code')
				
				->limit(10)
				
				->get()->all();
		
		 // Dashboard TOP 10 SALESMAN PERFORMANCE
		 $get_data1 = DB::table('tbl_route_invoice_header')
				->Join('tbl_salesman', 'tbl_route_invoice_header.salesman_id', '=', 'tbl_salesman.id')
		
				->select(DB::raw('sum(tbl_route_invoice_header.total_invoice_value) as total_invoice'),'tbl_salesman.salesman_name as sales_name')
				->orderBy(DB::raw('sum(tbl_route_invoice_header.total_invoice_value)'),'desc')
				->groupBy('tbl_route_invoice_header.salesman_id') 
				
				->limit(10)
				
				->get()->all();
			

	     // Dashboard TOP 10 ROUTE PERFORMANCE
		 $get_data2 = DB::table('tbl_route_invoice_header')
				->Join('tbl_route', 'tbl_route_invoice_header.route_id', '=', 'tbl_route.id')
		
				->select(DB::raw('sum(tbl_route_invoice_header.total_invoice_value) as total_invoice'),'tbl_route.route_name as route_name')
				->orderBy(DB::raw('sum(tbl_route_invoice_header.total_invoice_value)'),'desc')
				->groupBy('tbl_route_invoice_header.route_id') 
				
				->limit(10)
				
				->get()->all();
				
	     // Dashboard TOP 10 CUSTOMER PERFORMANCE
		 $get_data3 = DB::table('tbl_route_invoice_header')
				->Join('tbl_customer', 'tbl_route_invoice_header.customer_name', '=', 'tbl_customer.id')
		
				->select(DB::raw('sum(tbl_route_invoice_header.total_invoice_value) as total_invoice'),'tbl_customer.customer_name as customer_name')
				->orderBy(DB::raw('sum(tbl_route_invoice_header.total_invoice_value)'),'desc')
				->groupBy('tbl_route_invoice_header.customer_name') 
				
				->limit(10)
				
				->get()->all();
						
				
		 return view('Dashboard.dashboard',compact('customer_count','salesman_count','route_count','route_invoice_count','other_invoice_count','dataPoints','get_data','get_data1','get_data2','get_data3'));
	 }
		
    public function indexB()
	 {
		 return view('Dashboard.dashboard_variation');
	 }
	
	     // Dashboard Bottom 10 CUSTOMER PERFORMANCE
	public function fetch_material()
     {
		 
		  $get_data = DB::table('tbl_route_invoice_details')
			->Join('tbl_material_master', 'tbl_route_invoice_details.material_code', '=', 'tbl_material_master.id')

			->select(DB::raw('sum(tbl_route_invoice_details.total) as invoice_total'), 'tbl_material_master.material_name as mat_name')
			->orderBy(DB::raw('sum(tbl_route_invoice_details.total)'))
			->groupBy('tbl_route_invoice_details.material_code')
			
			->limit(10)
			
			->get()->all();
			//dd($get_data);
		   ?>
		
		   <table class="align-middle mb-0 table table-borderless table-striped table-hover">
								
									<thead>
									  <tr>
										<th class="text-center">#</th>
										<th> Material Name</th>
										<th class="text-center">Total Sales</th>
										 
									  </tr>
									</thead>
									 <tbody>
									 <?php
									 foreach($get_data as $key=> $data)
									   { 
									 ?>
										 <tr>
										   
											   <td class="text-center text-muted"><?php echo $key+1; ?></td> 
												  <td>
													 <div class="widget-content p-0">
														<div class="widget-content-wrapper">
														   <div class="widget-content-left flex2">
															  <div class="widget-heading">
																<?php echo $data->mat_name; ?>
															 </div>
															</div>
														</div>
													  </div>
													</td>
													<td class="text-center">UGX. <?php echo $data->invoice_total; ?></td> 
												
											 </tr>
									<?php
									      }
									 ?>
									 
						       </tbody>
		     </table>
						 <?php

	 }

             // Dashboard Bottom 10 SALESMAN PERFORMANCE
    public function fetch_salesman()
     {
		 
	    $get_data1 = DB::table('tbl_route_invoice_header')
		->Join('tbl_salesman', 'tbl_route_invoice_header.salesman_id', '=', 'tbl_salesman.id')

		->select(DB::raw('sum(tbl_route_invoice_header.total_invoice_value) as total_invoice'),'tbl_salesman.salesman_name as sales_name')
		->orderBy(DB::raw('sum(tbl_route_invoice_header.total_invoice_value)'))
		->groupBy('tbl_route_invoice_header.salesman_id') 
		
		->limit(10)
		
		->get()->all();
		//dd($get_data);
	    ?>
				
		<table class="align-middle mb-0 table table-borderless table-striped table-hover">
									
								<thead>
								  <tr>
									<th class="text-center">#</th>
									<th> Salesman Name</th>
									<th class="text-center">Total Sales</th>
									 
								  </tr>
								</thead>
								<tbody>
								 <?php
								       foreach($get_data1 as $key=> $data)
										 { 
										   ?>
											 <tr>
											   
												   <td class="text-center text-muted"><?php echo $key+1; ?></td> 
													  <td>
														 <div class="widget-content p-0">
															<div class="widget-content-wrapper">
															   <div class="widget-content-left flex2">
																  <div class="widget-heading">
																	<?php echo $data->sales_name; ?>
																 </div>
																</div>
															</div>
														  </div>
														</td>
														<td class="text-center">UGX. <?php echo $data->total_invoice; ?></td> 
													
												 </tr>
										<?php
										    }
										 ?>
										 
							      </tbody>
				</table>
							 <?php
   
	 }

               //Dashboard Bottom 10 ROUTE PERFORMANCE	

    public function fetch_route()
     {
		 
			$get_data2 = DB::table('tbl_route_invoice_header')
				->Join('tbl_route', 'tbl_route_invoice_header.route_id', '=', 'tbl_route.id')
		
				->select(DB::raw('sum(tbl_route_invoice_header.total_invoice_value) as total_invoice'),'tbl_route.route_name as route_name')
				->orderBy(DB::raw('sum(tbl_route_invoice_header.total_invoice_value)'))
				->groupBy('tbl_route_invoice_header.route_id') 
				
				->limit(10)
				
				->get()->all();
				//dd($get_data);
			 ?>
			
			<table class="align-middle mb-0 table table-borderless table-striped table-hover">
									
										<thead>
										  <tr>
											<th class="text-center">#</th>
											<th> Route Name</th>
											<th class="text-center">Total Sales</th>
											 
										  </tr>
										</thead>
										 <tbody>
										 <?php
										 foreach($get_data2 as $key=> $data)
										   { 
										    ?>
											   <tr>
											   
												   <td class="text-center text-muted"><?php echo $key+1; ?></td> 
													  <td>
														 <div class="widget-content p-0">
															<div class="widget-content-wrapper">
															   <div class="widget-content-left flex2">
																  <div class="widget-heading">
																	<?php echo $data->route_name; ?>
																 </div>
																</div>
															</div>
														  </div>
														</td>
														<td class="text-center">UGX. <?php echo $data->total_invoice; ?></td> 
													
												 </tr>
										<?php
										     }
										 ?>
										 
							       </tbody>
				</table>
							 <?php
   
	 }

        //Dashboard Bottom 10 Customer PERFORMANCE

    public function fetch_customer()
     {
		 $get_data3 = DB::table('tbl_route_invoice_header')
					->Join('tbl_customer', 'tbl_route_invoice_header.customer_name', '=', 'tbl_customer.id')
            
					->select(DB::raw('sum(tbl_route_invoice_header.total_invoice_value) as total_invoice'),'tbl_customer.customer_name as customer_name')
					->orderBy(DB::raw('sum(tbl_route_invoice_header.total_invoice_value)'))
					->groupBy('tbl_route_invoice_header.customer_name') 
					
					->limit(10)
					
					->get()->all();
					//dd($get_data);
				 ?>
				
				<table class="align-middle mb-0 table table-borderless table-striped table-hover">
										
									<thead>
									  <tr>
										<th class="text-center">#</th>
										<th> Customer Name</th>
										<th class="text-center">Total Sales</th>
										 
									  </tr>
									</thead>
									 <tbody>
									 <?php
									 foreach($get_data3 as $key=> $data)
									   { 
										 ?>
											 <tr>
											   
												   <td class="text-center text-muted"><?php echo $key+1; ?></td> 
													  <td>
														 <div class="widget-content p-0">
															<div class="widget-content-wrapper">
															   <div class="widget-content-left flex2">
																  <div class="widget-heading">
																	<?php echo $data->customer_name; ?>
																 </div>
																</div>
															</div>
														  </div>
														</td>
														<td class="text-center">UGX. <?php echo $data->total_invoice; ?></td> 
													
												 </tr>
										<?php
										 }
										 ?>
										 
							  </tbody>
							</table>
							 <?php
	   
	  }			 

 }
