<?php

namespace App\Http\Controllers;
use Illuminate\Http\Request;
use App\Models\RouteModel;
use App\Models\RegionTypeModel;
use App\Models\SubRegionTypeModel;
use App\Models\SalesAreaModel;
use App\Models\TradingCenterModel;
use App\Models\MaterialMasterModel;     
use App\Models\ManageCodeModel;
use App\Models\UnitOfMeasurementModel;
use App\Models\VehicleModel;
use App\Models\WarehouseModel;   
use Carbon\Carbon;
use Session;  
use Illuminate\Support\Facades\DB;

class DataSetupController extends Controller
 {
   public function add()
    {   
	   $region =RegionTypeModel::all()->sortByDesc('id')->where('status', '=', 'active');
	
	   $result =RegionTypeModel::get()->sortByDesc('id')->first();
	   if($result=='')
		 {
			$getcode = ManageCodeModel::where('id', 1)->first();
			$regionlast_code = $getcode->region_code;
		 }
	   else
	     {
		    $getcode = $result->region_code; 
		    $regionlast_code = ++$getcode;
	     }
			
    	return view('Route_Configuration.data_setup',compact('region','regionlast_code'));
	 
    }
/* public function edit($id)
	{
	
			$get_data = DB::table('tbl_region')
			->leftJoin('tbl_city', 'tbl_region.city', '=', 'tbl_city.id')
			->select('tbl_region.*', 'tbl_city.city_name','tbl_city.id as cityid','tbl_city.city_code')
			->where('tbl_region.id', '=', $id)
			->first();
		
			$currency = CurrencyTypeModel::all()->sortByDesc('id')->where('status', '=', 'active');
			$country =CountryTypeModel::all()->sortByDesc('id')->where('status', '=', 'active');
			$company_type =CompanyTypeModel::all()->sortByDesc('id')->where('status', '=', 'active');
			
			$last_code = $get_data->company_code;
		return view('Master_Configuration.company',compact('get_data','currency','country','company_type','last_code'));
	 }   
	

    public function edit_region_form($id)
	 { 
	  
		$get_data=RegionTypeModel::find($id);
		 $regionlast_code = $get_data->region_code;		
		return view('Master_Configuration.data_setup',compact('get_data','regionlast_code'));
	 }
      */

    public function get_subregion($id1)
     {
	   $get_data=SubRegionTypeModel::all()->sortByDesc('id')->where('region_id', '=', $id1)->where('status', '=', 'active');		
		
	   foreach($get_data as $sub_region)
		 {
			?>
			<option value="<?php echo $sub_region->id ?>"  ><?php echo $sub_region->sub_region_code." - ".$sub_region->sub_region_name ?></option>					
			<?php		
		 }
     }
		
		
    public function get_sales_area($id1)
	 {
	   $get_data=SalesAreaModel::all()->sortByDesc('id')->where('sub_region_id', '=', $id1)->where('status', '=', 'active');		
		
		foreach($get_data as $sales_area)
		  {
			?>
			<option value="<?php echo $sales_area->id ?>"  ><?php echo $sales_area->sales_area_code." - ".$sales_area->sales_area_name ?></option>					
			<?php		
		  }
     }
		
    public function get_routename($id1)
     {
	   $get_data=RouteModel::all()->sortByDesc('id')->where('sales_area_id', '=', $id1)->where('status', '=', 'active');		
		
		foreach($get_data as $route_name)
		  {
			?>
			<option value="<?php echo $route_name->id ?>"  ><?php echo $route_name->route_code." - ".$route_name->route_name ?></option>					
			<?php		
		  }
     }
		
    public function get_trading_date($id1)
     {
	    $get_data=TradingCenterModel::all()->sortByDesc('id')->where('route_id', '=', $id1)->where('status', '=', 'active');		
		
		foreach($get_data as $trading_name)
		  {
		 	?>
			<option value="<?php echo $trading_name->id ?>"  ><?php echo $trading_name->trading_center_code." - ".$trading_name->trading_name ?></option>					
			<?php		
		  }
      }
		
     public function save_region(Request $request)
	  {		
	
		$data=new RegionTypeModel;			
		if($request->updated_id) 
		  { 			
			$data = RegionTypeModel::find($request->updated_id);		
			$data->region_code=$request->region_code;
			$data->region_name=$request->region_name;
			$data->updated_user= Session::get('user_id');
			$data->company_id= Session::get('company_id');
			$data->status=$request->status;
			$data->save();
		 
		  }
		else
		  {
			$data=new RegionTypeModel; 
			$data->region_code=$request->region_code;
			$data->region_name=$request->region_name;
			$data->created_user= Session::get('user_id');
			$data->company_id= Session::get('company_id');
			$data->status=$request->status;
			$data->save();
		  }
		return redirect(route('data_setup'))->with('successMessage','Region Added Successfully');
		
		  /*
			$get_data=RegionTypeModel::all()->sortByDesc('id')->where('region', '=', $request->region)->where('status', '=', 'active');		
			 $r="";
			foreach($get_data as $region)
			  {
				
					 ?>					   
					<option value="<?php echo $region->id; ?>"><?php echo $region->region_code." - ". $region->region_name; ?> </option>
					<?php
			  }     
					*/
      }
		 
     public function save_subregion(Request $request)
      {
	
		$data=new SubRegionTypeModel;
		if($request->updated_id)
	      {
			$data = SubRegionTypeModel::find($request->updated_id);
			$data->sub_region_code=$request->sub_region_code;
			$data->region_id=$request->region;
			$data->sub_region_name=$request->sub_region_name;
			$data->updated_user= Session::get('user_id');
			$data->status=$request->status;
			$data->save();
		  }
		else
		  {
			$data->sub_region_code=$request->sub_region_code;
			$data->region_id=$request->region;
			$data->sub_region_name=$request->sub_region_name;
			$data->created_user= Session::get('user_id');
			$data->status=$request->status;
			$data->save();
				
          }
		 			
		    $get_data=SubRegionTypeModel::all()->sortByDesc('id')->where('region_id', '=', $request->region)->where('status', '=', 'active');		
		    $r="";
		foreach($get_data as $sub_region)
		  {
			/*$r .= "<option value='". $sub_region->id ."'>".$sub_region->sub_region_code." - ". $sub_region->sub_region_name ."</option>";	
			   */
				 ?>					   
				<option value="<?php echo $sub_region->id; ?>"><?php echo $sub_region->sub_region_code." - ". $sub_region->sub_region_name; ?> </option>
				<?php
		  }    
		    // return $return["json"] = json_encode($r);
		 
		    // return "sdfsdf";
		  		
     }
		
    public function save_sales_area(Request $request)   
     {
		  $data=new SalesAreaModel;
		  if($request->updated_id)
			{
				$data = SalesAreaModel::find($request->updated_id); 
				$data->sales_area_code=$request->sales_area_code;
				$data->sales_area_name=$request->sales_area_name;
				$data->warehouse_id=$request->warehouse;
				$data->region_id=$request->region;
				$data->sub_region_id=$request->sub_region_name;
				$data->company_id= Session::get('company_id');
				$data->updated_user= Session::get('user_id');
				$data->status=$request->status;
				$data->save();
			} 
		  else
		    {

				$data->sales_area_code=$request->sales_area_code;
				$data->sales_area_name=$request->sales_area_name;
				$data->warehouse_id=$request->warehouse;
				$data->region_id=$request->region;
				$data->sub_region_id=$request->sub_region_name;
				$data->company_id= Session::get('company_id');
				$data->created_user= Session::get('user_id');
				$data->status=$request->status;
				$data->save();
			}
			
			 $get_data=SalesAreaModel::all()->sortByDesc('id')->where('sub_region_id', '=', $request->sub_region_name)->where('status', '=', 'active');		
			
		  foreach($get_data as $sales_area)
			{
				?>
				<option value="<?php echo $sales_area->id ?>"  ><?php echo $sales_area->sales_area_code." - ".$sales_area->sales_area_name ?></option>					
				<?php		
			}	
		
				   
	  }
	   
     public function save_route_data(Request $request)   
	  {
			
		  $data=new RouteModel;			 
		  if($request->updated_id)
		    {
				 $data = RouteModel::find($request->updated_id);
				$data->route_code=$request->route_code;
				$data->route_name=$request->route_name;
				$data->route_description=$request->route_description;
				$data->sales_area_id=$request->routesales_area_name;
				$data->warehouse_id=$request->warehouse;
				$data->vehicle_id=$request->vehicle_number;			
				$data->updated_user= Session::get('user_id');
				$data->company_id= Session::get('company_id');
				$data->status=$request->status;
				$data->save();
		    }
		  else{
	            $data->route_code=$request->route_code;
				$data->route_name=$request->route_name;
				$data->route_description=$request->route_description;
				$data->sales_area_id=$request->routesales_area_name;
				$data->warehouse_id=$request->warehouse;
				$data->vehicle_id=$request->vehicle_number;			
				$data->created_user= Session::get('user_id');
				$data->company_id= Session::get('company_id');
				$data->status=$request->status;
				$data->save();
		      }
			    $get_data=RouteModel::all()->sortByDesc('id')->where('sales_area_id', '=', $request->routesales_area_name)->where('status', '=', 'active');		
			
		   foreach($get_data as $route_name)
			 {
				?>
				<option value="<?php echo $route_name->id ?>"  ><?php echo $route_name->route_code." - ".$route_name->route_name ?></option>					
				<?php		
			 }
				
	  }
	   
	 public function save_tradding_data(Request $request)   
	  {
		
		 $data=new TradingCenterModel;	
			if($request->updated_id)
			  {
				$data = TradingCenterModel::find($request->updated_id); 
				$data->trading_center_code=$request->trading_center_code;
				$data->trading_name=$request->trading_name;
				$data->route_id=$request->traddingroute_code;
				$data->updated_user= Session::get('user_id');
				$data->status=$request->status;
				$data->save();
			  } 
			else{
				
					$data->trading_center_code=$request->trading_center_code;
					$data->trading_name=$request->trading_name;
					$data->route_id=$request->traddingroute_code;
					$data->created_user= Session::get('user_id');
					$data->status=$request->status;
					$data->save();
				}
				$get_data=TradingCenterModel::all()->sortByDesc('id')->where('route_id', '=', $request->traddingroute_code)->where('status', '=', 'active');	
              foreach($get_data as $trading_name)
				{
					?>
					<option value="<?php echo $trading_name->id ?>"  ><?php echo $trading_name->trading_center_code." - ".$trading_name->trading_name ?></option>					
					<?php		
				}
					
	  }
	   
	 public function edit_region_form($id)   
      {
		  
		   $get_data= DB::table('tbl_region')
		   ->select('tbl_region.*')
		   ->where('tbl_region.id','=',$id)
		   ->get()->first();
			 
			?>	
			<div class="form-row">
				 <div class="col-md-12">
					  <div class="position-relative form-group"><label for="region_name" class="ml-2 font-weight-bold">Region Name</label><input maxlength="120" name="region_name" id="region_name" placeholder="" type="text" value="<?php echo $get_data->region_name ?>" class="form-control" required>
					  <input name="updated_id" id="updated_id" value="<?php echo $get_data->id; ?>" type="hidden">
					  <input name="status" id="status" value="active" type="hidden">
					  
					  <input name="region_code" id="region_code" value="<?php echo $get_data->region_code; ?>" type="hidden">
				      </div>   
				 </div> 
		    </div>
		     
				<div class="form-row">
				 <div class="col-md-5"></div>
					
						<button id="save_region" data-toggle="modal" data-target="#myModal" class="mt-3 btn btn-primary btn-lg ">Update</button>
				
				</div> 
			  <?php
					 
	  }
	   
	 public function get_subregion_form()   
      {
		 //sub_region
		 $result_sub_region =SubRegionTypeModel::get()->sortByDesc('id')->first();
		 if($result_sub_region=='')
		   {
			$getcode_sub_region = ManageCodeModel::where('id', 1)->first();
			$sub_region_last_code = $getcode_sub_region->sub_region_code;
		   }
		 else
		   {
				 $getcode_sub_region = $result_sub_region->sub_region_code; 
				 $sub_region_last_code = ++$getcode_sub_region;
			}
		         ?>			
				<div class="form-row">
				   <div class="col-md-6">
						<div class="position-relative form-group"><label for="sub_region_code" class="ml-2 font-weight-bold">Sub Region Code</label><input maxlength="20" name="sub_region_code" id="sub_region_code" placeholder="" type="text" class="form-control" value="<?php echo $sub_region_last_code; ?>" readonly="readonly" required>
						 </div>
				    </div>
						 
					<div class="col-md-6">
						<div class="position-relative form-group"><label for="sub_region_name" class="ml-2 font-weight-bold">Sub Region Name</label><input maxlength="120" name="sub_region_name" id="sub_region_name" placeholder="" type="text" class="form-control" value="" required>
						
						<input name="region" id="sregion_id" value="" type="hidden">
						<input name="status" id="status" value="active" type="hidden">
						</div>
					</div> 
				  </div>
				 
				 <div class="form-row">
					<div class="col-md-5"></div>
						
						<button id="save_subregionbtn" data-toggle="modal" data-target="#myModalsubregion"class="mt-3 btn btn-primary btn-lg ">Save</button>
				
					    <div class="col-md-0.5"></div>
						<a href="" class="mt-3 btn btn-danger  btn-lg">Cancel</a>
						
			     </div>
								
	             <?php
		
    }
	   
   public function edit_subregion_form($id)   
    {
			
		$get_data= DB::table('tbl_sub_region')
		->select('tbl_sub_region.*')
		->where('tbl_sub_region.id','=',$id)
		->get()->first();
		
			//sub_region
			?>			
			   <div class="form-row">
				<div class="col-md-12">
						<div class="position-relative form-group"><label for="sub_region_name" class="ml-2 font-weight-bold">Sub Region Name</label><input maxlength="120" name="sub_region_name" id="sub_region_name" placeholder="" type="text" class="form-control" value="<?php echo $get_data->sub_region_name ?>" required> 
						
						<input name="status" id="status" value="active" type="hidden">
						<input name="updated_id" id="updated_id" value="<?php echo $get_data->id; ?>" type="hidden">
							<input name="region" id="updated_id" value="<?php echo $get_data->region_id ?>" type="hidden">
						<input name="sub_region_code" id="sub_region_code" value="<?php echo$get_data->sub_region_code; ?>" type="hidden">
						</div>
					</div> 
				 </div>
						 
				<div class="form-row">
				 <div class="col-md-5"></div>
					
					<button id="save_subregionbtn" data-toggle="modal" data-target="#myModalsubregion"class="mt-3 btn btn-primary btn-lg ">Update</button>
			
				</div> 
		  <?php
				 
	  }
	    
     public function move_subregion_form($id,$region)   
      {
		
		 $get_data= DB::table('tbl_sub_region')
		 ->select('tbl_sub_region.*')
		 ->where('tbl_sub_region.id','=',$id)
		 ->get()->first();
		 DB::table('tbl_sub_region')
		  ->where('id', $id)
		  ->update(['region_id' => 0]);
	
		  $get_data=SubRegionTypeModel::all()->sortByDesc('id')->where('region_id', '=', $region)->where('status', '=', 'active');		
	  
	     foreach($get_data as $sub_region)
		   {
			/*$r .= "<option value='". $sub_region->id ."'>".$sub_region->sub_region_code." - ". $sub_region->sub_region_name ."</option>";	
			   */
				 ?>					   
				<option value="<?php echo $sub_region->id; ?>"><?php echo $sub_region->sub_region_code." - ". $sub_region->sub_region_name; ?> </option>
				<?php
		   } 
			?>			
				 
			<?php
				
     }
	   
    public function get_sales_area_form_body()   
     {
		//sales_area
	    $result_sales_area =SalesAreaModel::get()->sortByDesc('id')->first();
		if($result_sales_area=='')
	      {
		    $getcode_sales_area= ManageCodeModel::where('id', 1)->first();
		    $last_code_sales_area = $getcode_sales_area->sales_area_code;
	      }
	    else
	      {
		    $getcode_sales_area = $result_sales_area->sales_area_code; 
		    $last_code_sales_area = ++$getcode_sales_area;
		  }
		   
		$warehouse =WarehouseModel::all()->sortByDesc('id')->where('status', '=', 'active');	
		     ?>
					  <div class="form-row"> 
								  <div class="col-md-4">
									<div class="position-relative form-group"><label class="font-weight-bold ml-2" for="sales_area_code" class="">Sales Area Code</label><input  maxlength="25" class="mb-2 form-control" name="sales_area_code"   id="sales_area_code" value="<?php echo $last_code_sales_area; ?>"  readonly required >  
									
									</div>
								</div>
								<div class="col-md-4">
									<div class="position-relative form-group"><label class="font-weight-bold ml-2" for="sales_area_name" class="">Sales Area Name</label><input maxlength="125" name="sales_area_name" id="sales_area_name"  type="text" value=""  class="form-control" required >
									<input name="region" id="salesregion" value="" type="hidden">
									<input name="sub_region_name" id="salesub_region" value="" type="hidden">
									<input name="status" id="status" value="active" type="hidden">
									</div>
								</div>
								<div class="col-md-4">
									<div class="position-relative form-group"><label class="font-weight-bold ml-2" for="warehouse" class="">Warehouse/Depo</label><select name="warehouse" id="warehouse"  type="text"   class="form-control" required > 
									 
										<option value=""> </option>
										  <?php 
											foreach($warehouse as $warehousename)
											{   
											  ?>
												<option value ="<?php echo $warehousename->id; ?>"><?php  echo $warehousename->warehouse_code .'-'. $warehousename->warehouse_name; ?></option>
											<?php 
											}
										  ?>
									      </select>
								 	  </div>
								 </div>
						  </div>
							
						  <div class="form-row">
						  <div class="col-md-5"></div>
							   
						  <button data-toggle="modal" data-target="#myModalsales_area" class="mt-3 btn btn-primary btn-lg">Save</button>
						
						  <div class="col-md-0.5"></div>
						  <a href="" class="mt-3 btn btn-danger  btn-lg">Cancel</a>
						  </div>
					   
					<?php
		
				
	  }
	   
	     //edit_sales_area_form_body
	   
     public function edit_sales_area_form_body($id)     
	  {   
		 $get_data= DB::table('tbl_sales_area')
		  ->select('tbl_sales_area.*')
		  ->where('tbl_sales_area.id','=',$id)
		  ->get()->first();
		
		   
		     $warehouse = WarehouseModel::all()->sortByDesc('id')->where('status', '=', 'active');	
			  
		     ?>
		  <div class="form-row"> 
					  
				<div class="col-md-6">
				 <div class="position-relative form-group">
				  <label class="font-weight-bold ml-2" for="sales_area_name" class="">Sales Area Name</label>
				   <input maxlength="125" name="sales_area_name" id="sales_area_name"  type="text" value="<?php echo $get_data->sales_area_name ?>"  class="form-control" required >
				   <input name="updated_id" id="updated_id" value="<?php echo $get_data->id; ?>" type="hidden">
				   <input name="status" id="status" value="active" type="hidden">
				   <input name="sales_area_code" id="sales_area_code" value="<?php echo$get_data->sales_area_code; ?>" type="hidden">
				   <input name="region" id="updated_id" value="<?php echo $get_data->region_id ?>" type="hidden">
				   <input name="sub_region_name" id="updated_id" value="<?php echo $get_data->sub_region_id ?>" type="hidden">
				  </div>
				</div>
				 <div class="col-md-6">
					<div class="position-relative form-group"><label class="font-weight-bold ml-2" for="warehouse" class="">Warehouse/Depo</label><select name="warehouse" id="warehouse"  type="text"   class="form-control" required > 
					 
						<option value=""> </option>
						  <?php 
						  
							foreach($warehouse as $warehousename)
							  {   
								  ?>
									<option value ="<?php echo $warehousename->id; ?>" <?php echo ($warehousename->id ==$get_data->warehouse_id) ? "selected" : ""; ?>><?php  echo $warehousename->warehouse_code .'-'. $warehousename->warehouse_name; ?></option>
								<?php 
							  }
						    ?>
					       </select>
					  </div>
				</div>
			   </div>
			
			   <div class="form-row">
			 <div class="col-md-5"></div>
			   
			  <button data-toggle="modal" data-target="#myModalsales_area" class="mt-3 btn btn-primary btn-lg">Update</button> 
			  </div>
							   
	      <?php 		
      }
   
	      //move_sales_area_form_body   
	   
     public function move_sales_area_form($id,$subregion)     
	  {   
	 
		  DB::table('tbl_sales_area')
              ->where('id', $id)
              ->update(['sub_region_id' => 0]);
			  
			  $get_data=SalesAreaModel::all()->sortByDesc('id')->where('sub_region_id', '=', $subregion)->where('status', '=', 'active');		
			
			foreach($get_data as $sales_area)
			  {
				?>
				<option value="<?php echo $sales_area->id ?>"  ><?php echo $sales_area->sales_area_code." - ".$sales_area->sales_area_name ?></option>					
				<?php		
			  }	
			  
		        ?>
		                
     	    <?php 		
     }
   
	   
	public function get_route_form_body()   
     {
		//route
		$result_route =RouteModel::get()->sortByDesc('id')->first();
		if($result_route=='')
	      {
		    $getcode_route = ManageCodeModel::where('id', 1)->first();
		    $last_code_route = $getcode_route->route_code;
	      }
	    else
		  {
		    $getcode_route = $result_route->route_code	; 
		    $last_code_route = ++$getcode_route;
		  }
		   
		    $warehouse =WarehouseModel::all()->sortByDesc('id')->where('status', '=', 'active');
		    $vehicle =VehicleModel::all()->sortByDesc('id')->where('status', '=', 'active');			
		   ?>
							  <div class="form-row">
									   <div class="col-md-4">
											<div class="position-relative form-group"><label class="font-weight-bold ml-2" for="route_code" class="">Route Code</label><input  maxlength="20" class="mb-2 form-control" name="route_code" id="route_code"  value="<?php echo $last_code_route; ?>" readonly required > 
										
											</div>
										 </div> 
										<div class="col-md-4">
											<div class="position-relative form-group"><label class="font-weight-bold ml-2" for="route_name" class="">Route Name</label><input  maxlength="120" name="route_name" id="route_name" value=""  type="text" class="form-control"  required > 
											<input name="routesales_area_name" id="routesales_area_name" value="" type="hidden"> 
											<input name="status" id="status" value="active" type="hidden"> 
											</div>
										</div>
										<div class="col-md-4">
											<div class="position-relative form-group"><label class="font-weight-bold ml-2" for="route_description" class="">Route Description.</label><input  maxlength="120" name="route_description" id="route_description" type="text" class="form-control" value="" required ></div>
										</div>
									</div>
									
									 <div class="form-row"> 
									  
										 <div class="col-md-4">
											<div class="position-relative form-group"><label class="font-weight-bold ml-2" for="warehouse" class="">Warehouse/Depo</label><select name="warehouse" id="warehouse"  type="text"   class="form-control" required > 
											 
												<option value=""> </option>
												  <?php 
													foreach($warehouse as $warehousename)
													  {   
													    ?>
														 <option value ="<?php echo $warehousename->id; ?>"><?php  echo $warehousename->warehouse_code .'-'. $warehousename->warehouse_name; ?></option>
													     <?php 
													   }
												        ?>
											         </select>
											    </div>
										    </div>
										  <div class="col-md-4">
											<div class="position-relative form-group"><label class="font-weight-bold ml-2" for="vehicle_number" class="">Vehicle Number</label><select name="vehicle_number" id="vehicle_number"  type="text" class="form-control" required >
											  
											 <option value=""> </option>
											 <?php 
											 foreach($vehicle as $vehiclename)
											   {
												  ?>
												 <option value ="<?php echo $vehiclename->id; ?>"><?php  echo $vehiclename->vehicle_code.'-'.$vehiclename->  vehicle_number; ?></option>
												  <?php
											    }
											?>
											
											</select>
											</div>
										</div>
									  </div>
									  
									  
									
									<div class="form-row">
									 <div class="col-md-5"></div>
									  
									   <button data-toggle="modal" data-target="#myModalroute" class="mt-3 btn btn-primary btn-lg">Save</button>
									  
									  <div class="col-md-0.5"></div>
									 <a href="" class="mt-3 btn btn-danger  btn-lg">Cancel</a>
								</div>
							   
				<?php
	
			
	  }
	   
	 public function edit_route_form_body($id)   
	  {
		 $get_data= DB::table('tbl_route')
	        ->select('tbl_route.*')
	        ->where('tbl_route.id','=',$id)
	        ->get()->first();
	        // dd($get_data);
	   
	        $warehouse =WarehouseModel::all()->sortByDesc('id')->where('status', '=', 'active');
            $vehicle =VehicleModel::all()->sortByDesc('id')->where('status', '=', 'active');			
		     ?>
					         <div class="form-row"> 
								<div class="col-md-6">
									<div class="position-relative form-group"><label class="font-weight-bold ml-2" for="route_name" class="">Route Name</label><input  maxlength="120" name="route_name" id="route_name" value="<?php echo $get_data->route_name ?>"  type="text" class="form-control"  required > 
									<input name="routesales_area_name" id="routesales_area_name" value="<?php echo $get_data->sales_area_id ?>" type="hidden">
									<input name="route_code" id="route_code" value="<?php echo$get_data->route_code; ?>" type="hidden">									
									  <input name="updated_id" id="updated_id" value="<?php echo $get_data->id; ?>" type="hidden">
									<input name="status" id="status" value="active" type="hidden"> 
									</div>
								</div>
								<div class="col-md-6">
									<div class="position-relative form-group"><label class="font-weight-bold ml-2" for="route_description" class="">Route Description.</label><input  maxlength="120" name="route_description" id="route_description" type="text" class="form-control" value="<?php echo $get_data->route_description ?>" required ></div>
								</div>
							</div>
							
							 <div class="form-row"> 
							  
								 <div class="col-md-6">
									<div class="position-relative form-group"><label class="font-weight-bold ml-2" for="warehouse" class="">Warehouse/Depo</label><select name="warehouse" id="warehouse"  type="text"   class="form-control" required > 
									 
										<option value=""> </option>
										  <?php 
											foreach($warehouse as $warehousename)
											{   
											  ?>
												<option value ="<?php echo $warehousename->id; ?>"<?php echo ($warehousename->id ==$get_data->warehouse_id) ? "selected" : ""; ?>><?php  echo $warehousename->warehouse_code .'-'. $warehousename->warehouse_name; ?></option>
											<?php 
											}
										  ?>
									  </select>
									</div>
								</div>
								<div class="col-md-6">
									<div class="position-relative form-group"><label class="font-weight-bold ml-2" for="vehicle_number" class="">Vehicle Number</label><select name="vehicle_number" id="vehicle_number"  type="text" class="form-control" required >
									  
									 <option value=""> </option>
									 <?php 
									 foreach($vehicle as $vehiclename)
									   {
										 ?>
									     <option value ="<?php echo $vehiclename->id; ?>"<?php echo ($vehiclename->id ==$get_data->vehicle_id) ? "selected" : ""; ?>><?php echo $vehiclename->vehicle_code.'-'.$vehiclename->vehicle_number; ?></option>			
									     <?php
									 }   
									     ?>
									
									</select>
									</div>
								 </div>
							  </div>
							  
							  
							
						<div class="form-row">
						 <div class="col-md-5"></div>
						  
						   <button data-toggle="modal" data-target="#myModalroute" class="mt-3 btn btn-primary btn-lg">Update</button>
						  
						  
					</div>
				   
	      <?php

	
	  }
	   
          //move_route_form
	 public function move_route_form($id,$sales_area)   
	  {
	   	   
		$get_data= DB::table('tbl_route')
		->select('tbl_route.*')
		->where('tbl_route.id','=',$id)
		->get()->first();
		//dd($get_data);  
		 DB::table('tbl_route')
		  ->where('id', $id)
		  ->update(['sales_area_id' => 0]);
	
		 $get_data=RouteModel::all()->sortByDesc('id')->where('sales_area_id', '=', $sales_area)->where('status', '=', 'active');		
		
		  foreach($get_data as $route_name)
			{
				?>
				<option value="<?php echo $route_name->id ?>"  ><?php echo $route_name->route_code." - ".$route_name->route_name ?></option>					
				<?php		
			}
	  ?>
					 
	<?php

	
	 }
   
	public function get_tradding_form_body()   
	 {
		//trading_name
		 $result_trading =TradingCenterModel::get()->sortByDesc('id')->first();
		 if($result_trading=='')
		   {
			 $getcode_trading = ManageCodeModel::where('id', 1)->first();
			 $last_code_trading = $getcode_trading->trading_center_code;
		   }
		 else
		   {
			 $getcode_trading = $result_trading->trading_center_code; 
			 $last_code_trading = ++$getcode_trading;
		   }
		   
		$warehouse =WarehouseModel::all()->sortByDesc('id')->where('status', '=', 'active');
		$vehicle =VehicleModel::all()->sortByDesc('id')->where('status', '=', 'active');			
		 ?>
				   
							<div class="form-row">
							
								<div class="col-md-6">
									<div class="position-relative form-group"><label class="font-weight-bold ml-2" for="trading_center_code" class="">Trading Center Code</label><input maxlength="20" name="trading_center_code" id="trading_center_code"  type="text" class="form-control" value="<?php echo $last_code_trading; ?>" readonly="readonly" required> 
									</div>
								 </div>
								 
							   <div class="col-md-6">
									<div class="position-relative form-group"><label class="font-weight-bold ml-2" for="trading_name" class="">Trading Name</label><input maxlength="100" name="trading_name" id="trading_name"  type="text" class="form-control" value="" required> 
									<input name="traddingroute_code" id="traddingroute_code" value="" type="hidden">
									<input name="status" id="status" value="active" type="hidden">
									</div>
								</div> 
							   
						   </div>	
						
							
						
							<div class="form-row">
							 <div class="col-md-5"></div>
							
							  <button data-toggle="modal" data-target="#myModalTrading" class="mt-3 btn btn-primary btn-lg">Save</button>
							 
							  <div class="col-md-0.5"></div>
							  <a href="" class="mt-3 btn btn-danger  btn-lg">Cancel</a>
							</div>
		<?php

				
	   }
	   
	  public function edit_tradding_form_body($id)   
       {
		  $get_data= DB::table('tbl_trading_center')
		  ->select('tbl_trading_center.*')
		  ->where('tbl_trading_center.id','=',$id)
		  ->get()->first();
		  // dd($get_data);
		   		
		     ?>
			   
								<div class="form-row"> 
								   <div class="col-md-12">
										<div class="position-relative form-group"><label class="font-weight-bold ml-2" for="trading_name" class="">Trading Name</label><input maxlength="100" name="trading_name" id="trading_name"  type="text" class="form-control" value="<?php echo $get_data->trading_name ?>" required> 
										<input name="traddingroute_code" id="traddingroute_code" value="<?php echo $get_data->route_id ?>" type="hidden">
										<input name="status" id="status" value="active" type="hidden">
										<input name="trading_center_code" id="trading_center_code" value="<?php echo$get_data->trading_center_code; ?>" type="hidden">	
										<input name="updated_id" id="updated_id" value="<?php echo $get_data->id; ?>" type="hidden">
										</div>
									</div> 
								   
							   </div>	
							
								<div class="form-row">
								   <div class="col-md-5"></div>
								 
								   <button data-toggle="modal" data-target="#myModalTrading" class="mt-3 btn btn-primary btn-lg">Update</button>
								 
								</div>
			<?php

		
	   } 
	     //move_trading_form
	  public function move_trading_form($id,$route_name)   
	   {
	 
		 $get_data= DB::table('tbl_trading_center')
		 ->select('tbl_trading_center.*')
		 ->where('tbl_trading_center.id','=',$id)
		 ->get()->first();
		 //dd($get_data);  
		 DB::table('tbl_trading_center')
		  ->where('id', $id)
		  ->update(['route_id' => 0]);
		
		 $get_data=TradingCenterModel::all()->sortByDesc('id')->where('route_id', '=', $route_name)->where('status', '=', 'active');	
          foreach($get_data as $trading_name)
			{
				?>
				<option value="<?php echo $trading_name->id ?>"  ><?php echo $trading_name->trading_center_code." - ".$trading_name->trading_name ?></option>					
				<?php		
			}
		  ?>
					     
		<?php

	
	  }
	   
 }
