<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;
use App\Models\CurrencyTypeModel;
use App\Models\ManageCodeModel;
use App\Models\MaterialMasterModel;
use App\Models\SalesmanInvoiceModel;
use App\Models\CustomerModel;
use App\Models\MaterialCategoryModel;
use App\Models\UnitOfMeasurementModel;
use App\Models\WarehouseModel;
use App\Models\SupplierModel;
use App\Models\RouteModel; 
use App\Models\UserModel;
use App\Models\TradingCenterModel;
use App\Models\CustomerTypeModel;
use App\Models\ReasonTypeModel;
use App\Models\RouteDeliveryModel;
use Carbon\Carbon;
use App\Models\GoodReceiptNoteModel;
use App\Models\PurchaseOutstandingModel;
use Illuminate\Support\Facades\DB;
use App\Exports\PurchaseGoodReceiptNoteExport;
use App\Exports\PurchaseGoodReceiptNoteExportPdf;
use Maatwebsite\Excel\Facades\Excel;
use PDF;
use Session;
class GoodReceiptNoteController extends Controller
{
   public function list(Request $request)
   {
	  $delivery_date=date("Y-m-d");	
	  $where="";		
	  if(count($request->all()) < 1)
		{
		  $where .= " AND DATE_FORMAT(riheader.created_at, '%Y-%m-%d') between '".$delivery_date."' and '".$delivery_date."'"; 
		}
  
	  if($request->supplier!='')
		{
		  $where .= "AND supplier.id = '".$request->supplier."'";
		}
		  
	   $distibutor=SupplierModel::all()->sortByDesc('id')
	   //->where('supplier_id', '!=', 1)
	   ->where('status', '=', 'active');
			
	    //$get_data = CurrencyTypeModel::all()->sortByDesc('id');
	
			$get_data = DB::select("SELECT riheader.*, 
			supplier.supplier_code,supplier.supplier_name,
			currency.currency_notation,header.purchase_order_number
			
			FROM tbl_good_receipt_note_header as riheader		
			LEFT JOIN tbl_supplier as supplier on riheader.supplier_id=supplier.id
			LEFT JOIN tbl_currency_type as currency on riheader.currency_id=currency.id 
			LEFT JOIN tbl_purchase_order_header as header on riheader.purchase_order_id=header.id 
			WHERE riheader.id IS NOT NULL ".$where." ");
         
			return view('Purchase_Transaction.good_receipt_note_list',compact('get_data','distibutor'));
    }
	   
   public function add()
	{  
	
		$user_id=Session::get('user_id');	  
		$result = DB::table('tbl_good_receipt_note_header')
		->select('tbl_good_receipt_note_header.*')->get()->sortByDesc('id')->first();
        
		$supplier=DB::table('tbl_supplier')
		->select('tbl_supplier.supplier_code','tbl_supplier.supplier_name','tbl_supplier.id')
		->where('status','=','active')
		->get();
      
	 
		if($result=='')
		  {
			$getcode = ManageCodeModel::where('id', 1)->first();
			$last_code = $getcode->grn_code;
		  }
		 
		else
		  {
			$getcode = $result->grn_code; 
			$last_code = ++$getcode;
			 
		  }
    
			$material_master = DB::table('tbl_material_master')
			->leftJoin('tbl_unit_of_measurement', 'tbl_material_master.uom_id', '=', 'tbl_unit_of_measurement.id')
			
			->select('tbl_material_master.*', 'tbl_unit_of_measurement.uom_name','tbl_unit_of_measurement.unit_notation')
		
			->get()->all();
			
			
			$material_category =MaterialCategoryModel::all()->sortByDesc('id')->where('status', '=', 'active');
		  			
			$material =MaterialMasterModel::all()->sortByDesc('id')->where('status', '=', 'active');
	
			$login_user = DB::table('tbl_user')
			->leftJoin('tbl_company', 'tbl_user.company_id', '=', 'tbl_company.id')
			->leftJoin('tbl_currency_type', 'tbl_company.currency_id', '=', 'tbl_currency_type.id')
			->select('tbl_user.id', 'tbl_company.currency_id','tbl_currency_type.currency_notation')
			->where('tbl_user.id', '=', $user_id)
			->get()->first();
			
			return view('Purchase_Transaction.good_receipt_note',compact('last_code','material_master','material_category','material','login_user','supplier'));
	 }
	 
	  public function get_order_number($id)
     {
		  
		$get_data1 =DB::table('tbl_purchase_order_header')
		->leftJoin('tbl_supplier', 'tbl_purchase_order_header.supplier_id', '=', 'tbl_supplier.id')
		->select('tbl_purchase_order_header.purchase_order_number','tbl_purchase_order_header.id','tbl_supplier.supplier_name','tbl_supplier.supplier_code')
		->where('tbl_purchase_order_header.supplier_id', '=', $id)
		->where('tbl_purchase_order_header.is_grn', '=', '0') 
		->get()->all();
	   
		 
 
		?>   
		<option  value=""> </option>
		<?php
		foreach($get_data1 as $order_name)
		  {
			?>
			<option  value="<?php echo $order_name->id ?>"  ><?php echo $order_name->purchase_order_number .' ('. $order_name->supplier_code.' - '. $order_name->supplier_name ?> )</option>	
			<?php	
              			
		  }
		 
	 }
	  
	public function get_order_number_details($id,$order)
	 {
		  
		$order_name =DB::table('tbl_purchase_order_header')
		->leftJoin('tbl_supplier', 'tbl_purchase_order_header.supplier_id', '=', 'tbl_supplier.id')
		->select('tbl_purchase_order_header.*','tbl_supplier.supplier_name','tbl_supplier.supplier_code')
		->where('tbl_purchase_order_header.supplier_id','=',$id)
		->where('tbl_purchase_order_header.is_grn','=','0')
		->get()->all();	
        
        		
	   $get_data =DB::table('tbl_temp_grn_header')		
	    ->select('tbl_temp_grn_header.*')
		->where('tbl_temp_grn_header.purchase_order_id', '=',$order)
		->get()->sortByDesc('id')->first();
		
		if($get_data!='')
		{
		 $get_data_details =DB::table('tbl_temp_grn_details')	  
			  ->leftJoin('tbl_material_master', 'tbl_temp_grn_details.material_id', '=', 'tbl_material_master.id')
			  ->leftJoin('tbl_unit_of_measurement', 'tbl_temp_grn_details.uom', '=', 'tbl_unit_of_measurement.id')
			  
			  ->select('tbl_temp_grn_details.*','tbl_material_master.material_name','tbl_unit_of_measurement.uom_name','tbl_unit_of_measurement.unit_notation','tbl_material_master.vat as material_vat')->where('tbl_temp_grn_details.header_id','=', $get_data->id)->get()->all();
		 }
		if($get_data=='')
		{
			$get_data =DB::table('tbl_purchase_order_header')		
			->select('tbl_purchase_order_header.*')
			->where('tbl_purchase_order_header.id', '=',$order)
			->get()->first();
		 
			$get_data_details =DB::table('tbl_purchase_order_details')	  
			  ->leftJoin('tbl_material_master', 'tbl_purchase_order_details.material_id', '=', 'tbl_material_master.id')
			  ->leftJoin('tbl_unit_of_measurement', 'tbl_purchase_order_details.uom', '=', 'tbl_unit_of_measurement.id')
			  
			  ->select('tbl_purchase_order_details.*','tbl_material_master.material_name','tbl_unit_of_measurement.uom_name','tbl_unit_of_measurement.unit_notation','tbl_material_master.vat as material_vat')->where('tbl_purchase_order_details.header_id','=', $order)->get()->all();
		
		}
		
		
		  //$uom12 =UnitOfMeasurementModel::all()->sortByDesc('id')->where('status', '=', 'active');
		  $user_id=Session::get('user_id');
	
		  
			$result = DB::table('tbl_good_receipt_note_header')
		     ->select('tbl_good_receipt_note_header.*')->get()->sortByDesc('id')->first();
			 
	     if($result=='')
		  {
			$getcode = ManageCodeModel::where('id', 1)->first();
			$last_code = $getcode->grn_code;
		  }
		 
		else
		  {
			$getcode = $result->grn_code; 
			$last_code = ++$getcode;
			 
		  }
		  
		  
		  $supplier=DB::table('tbl_supplier')
		->select('tbl_supplier.supplier_code','tbl_supplier.supplier_name','tbl_supplier.id')
		->where('status','=','active')
		->get();
		
          
			
			 $material =MaterialMasterModel::all()->sortByDesc('id')->where('status', '=', 'active');
		
		  
			$login_user = DB::table('tbl_user')
			->leftJoin('tbl_company', 'tbl_user.company_id', '=', 'tbl_company.id')
			->leftJoin('tbl_currency_type', 'tbl_company.currency_id', '=', 'tbl_currency_type.id')
			->select('tbl_user.id', 'tbl_company.currency_id','tbl_currency_type.currency_notation')
			->where('tbl_user.id', '=', $user_id)
			->get()->first();
		
		 
			return view('Purchase_Transaction.good_receipt_note',compact('last_code','material','login_user','get_data','get_data_details','order_name','supplier'));
			
	 }
		
	public function get_material()
	 {

		$material =MaterialMasterModel::all()->sortByDesc('id')->where('status', '=', 'active');	
		?>
		<option  value="">     </option>
		<?php
		foreach($material as $material_name)
		  {
			?>
			<option value="<?php echo $material_name->id ?>"  ><?php echo $material_name->material_code.' - '.$material_name->material_name ?></option>	
			<?php		
		  }		
					//return response()->json($get_data);		
	  }
		   
	 public function get_material_detailsUom1($id,$row)
	  {
		 $uom12 =UnitOfMeasurementModel::all()->sortByDesc('id')->where('status', '=', 'active');
		 $material_master = DB::select('SELECT t2.id, t2.uom_name,t2.unit_notation FROM tbl_material_master as t1 LEFT JOIN     tbl_unit_of_measurement as t2 ON find_in_set(t2.id, 
		 t1.alt_uom) WHERE t1.`id`='.$id.'');				
		 $get_material_price=MaterialMasterModel::find($id);				
		 $alt_unit_price = explode(",",$get_material_price->alt_unit_price);				
		 //dd($alt_unit_price);	
		 $material=MaterialMasterModel::get()->sortByDesc('id')->first()->find($id);
	
		 foreach($material_master as $key=>$data)
		   {				
			 ?>
			 <option  <?php if($data->id == $material->uom)  echo 'selected'; ?> value ="<?php echo $data->id; ?>" ><?php echo $data->unit_notation; ?></option>
				  <?php				 
		   }
	 }
	public function get_material_price($id,$val)
	 {	 
		 $material=MaterialMasterModel::get()->sortByDesc('id')->first()->find($val);	     
		 $alt_uom = explode(",",$material->alt_uom);				   
		 $key = array_search($id, $alt_uom);				   
		 $alt_unit_price = explode(",",$material->alt_unit_price);
		 // print_r($alt_unit_price);
		 echo $alt_unit_price[$key];
	 
	 }

     public function view($id)
      { 
			
			$get_data =DB::table('tbl_good_receipt_note_header')				
			->leftJoin('tbl_supplier', 'tbl_good_receipt_note_header.supplier_id', '=', 'tbl_supplier.id')
			->leftJoin('tbl_currency_type', 'tbl_good_receipt_note_header.currency_id', '=', 'tbl_currency_type.id')
			->select('tbl_good_receipt_note_header.*','tbl_supplier.supplier_name','tbl_supplier.supplier_code',
			 'tbl_currency_type.currency_notation')->where('tbl_good_receipt_note_header.id', '=',$id)->get()->first();
				 
			

			$get_data_details =DB::table('tbl_good_receipt_note_details')
  
			   ->leftJoin('tbl_material_master', 'tbl_good_receipt_note_details.material_id', '=', 'tbl_material_master.id')
			   ->leftJoin('tbl_unit_of_measurement', 'tbl_good_receipt_note_details.uom', '=', 'tbl_unit_of_measurement.id')
			     
			  ->select('tbl_good_receipt_note_details.*','tbl_material_master.material_code','tbl_material_master.material_name','tbl_unit_of_measurement.uom_name','tbl_unit_of_measurement.unit_notation')->where('tbl_good_receipt_note_details.header_id', '=', $id)->get()->all();		  
	
	
			return view('Purchase_Transaction.good_receipt_note_view',compact('get_data','get_data_details'));
	
	  }
		
    public function save(Request $request)
	 {
		
		$get_cust =DB::table('tbl_purchase_order_header')
        ->leftJoin('tbl_purchase_order_header as purchase', 'tbl_purchase_order_header.id', '=', 'purchase.id')		
        ->leftJoin('tbl_supplier', 'tbl_purchase_order_header.supplier_id', '=', 'tbl_supplier.id')		
		->select('purchase.supplier_id','purchase.delivery_date','purchase.currency_id','purchase.purchase_order_number','purchase.supplier_id','tbl_supplier.tin_no as tin_number','purchase.remark') 
		->where('tbl_purchase_order_header.is_grn', '=', '0')
		->where('tbl_purchase_order_header.id', '=', $request->purchase_order_number)
		->get()->first();	
    		
		 $current = Carbon::now();
		 $user_id=Session::get('user_id');
			
		 $login_user = DB::table('tbl_user')
		  ->leftJoin('tbl_company', 'tbl_user.company_id', '=', 'tbl_company.id')
		  ->leftJoin('tbl_currency_type', 'tbl_company.currency_id', '=', 'tbl_currency_type.id')
		  ->select('tbl_user.id', 'tbl_company.currency_id','tbl_currency_type.currency_notation','tbl_currency_type.id as currency_id')
		  ->where('tbl_user.id', '=', $user_id)
		  ->get()->first();
		 
		   
		 //getting credit days of supplier
		  $supplier_creditdays = DB::table('tbl_supplier')
		 ->select('tbl_supplier.credit_days')->where('tbl_supplier.id', '=', $request->supplier_id)->get()->first();
		 //dd($supplier_creditdays );
		 
		 //adding credit days with current date
		  $current_date=date("Y-m-d");  
		  $date=date_create($current_date);
		   date_add($date,date_interval_create_from_date_string(" ".$supplier_creditdays->credit_days." days")); 
		  $due_date= date_format($date,"Y-m-d");
		 	//dd($due_date); 
		
		  
		 
			    
				$data3=array
				(
				 'grn_code'                  => $request->grn_code,
				 'currency_id'               => $login_user->currency_id,
				 'purchase_order_id'         => $request->purchase_order_number,
				 'remark'                    => $get_cust->remark,
				 
				 'delivery_date'             => $get_cust->delivery_date,
				                             
				 'supplier_id'               => $request->supplier_id,
				 'total_gross'               => $request->gross_amount_totali,
				 'net_total_amount'          => $request->net_amount_totali,
				 //'total_excise'            => $request->total_excise,
				 'total_vat'                 => $request->vat_amount_totali,
				 'tin_no'                    => $get_cust->tin_number,
				 'total_discount'            => 0.00,
				 'total_grn_value'           => $request->invoice_amount_totali,
				 'created_at'                => $current,
			 );
			 
			$tempdata=array
				(
				 'grn_code'                  => $request->grn_code,
				 'currency_id'               => $login_user->currency_id,
				 'purchase_order_id'         => $request->purchase_order_number,
				 
				 'delivery_date'             => $get_cust->delivery_date,
				 'remark'                    => $get_cust->remark,
				 'supplier_id'               => $request->supplier_id,
				 'total_gross'               => $request->temp_gross_amount_totali,
				 'net_total_amount'          => $request->temp_net_amount_totali,
				 //'total_excise'            => $request->total_excise,
				 'total_vat'                 => $request->temp_vat_amount_totali,
				 'tin_no'                    => $get_cust->tin_number,
				 'total_discount'            => 0,
				 'total_grn_value'           => $request->temp_invoice_amount_totali,
				 'total_invoice_value'           => $request->temp_invoice_amount_totali,
				 'created_at'                => $current,
			 );
			 
		 $header_id=DB::table('tbl_good_receipt_note_header')->insertGetID($data3);
		$tempheader_id=DB::table('tbl_temp_grn_header')->insertGetID($tempdata);
		
		 /* $data=new PurchaseOutstandingModel;
					$data->grn_number=$request->grn_code;
					$data->supplier_id= $request->supplier_id;
					$data->amount_outstanding=$request->invoice_amount_totali;
					$data->total_grn_amount= $request->invoice_amount_totali;
					$data->grn_id=$header_id;
					$data->due_date=$due_date;
					$data->amount_paid=0;
					$data->save(); */
			 	$pending=0;
                $is_pending=0;				
			     foreach($request['material_name1'] as $key => $n)
				   {
				      $pending=$request->hquantity1[$key ]-$request->quantity1[$key ];
					 
						 $data2=array(
						 'material_id'   => $request->material_name1[$key ],
						 'header_id'     => $header_id,
						 'uom'           => $request->uom1[$key ],
						 'unite_price'    => $request->price1[$key ],
						 'gross_total'   => $request->gross1[$key ],
						 'net_amount'    => $request->net_amount[$key ],
						 'vat'           => $request->vat[$key ],
						 'discount'      => $request->discount[$key ],
						 'order_qty'     => $request->hquantity1[$key ],
						 'pending_qty'   => $pending,
						
						 'total'         => $request->total1[$key ],
						 'quantity'      => $request->quantity1[$key ],
						 'base_qty'      => $request->opacking_size[$key ],
				  	  
						 'created_at'    => $current,
						 );
						 
						 $tempdata2=array(
						 'material_id'   => $request->material_name1[$key ],
						 'header_id'     => $tempheader_id,
						 'uom'           => $request->uom1[$key ],
						 'unite_price'    => $request->price1[$key ],
						 'gross_total'   => $request->temp_gross1[$key ],
						 'net_amount'    => $request->temp_net_amount[$key ],
						 'vat'           => $request->temp_vat[$key ],
						 'discount'      => $request->discount[$key ],
						 'order_qty'     => $request->hquantity1[$key ],
						 'pending_qty'   => $pending,
						 'base_qty'      => $request->opacking_size[$key ],
						 'total'         => $request->temp_total1[$key ],
						 'quantity'      => $pending,
				  	  
						 'created_at'    => $current,
						 );
					 
						DB::table('tbl_good_receipt_note_details')->insert($data2);
						
				      if($request->hquantity1[$key ] > $request->quantity1[$key ])
					   {
                         $is_pending=$is_pending+1;						   
						 DB::table('tbl_temp_grn_details')->insert($tempdata2); 
					   }
						
                  } 
				  
			    /* IF RECIEVE ALL PURCHASE QTY THEN REMOVING LOG AND UPDATE PURCHASE ORDER	 */  
				if($is_pending==0)
				{
					 DB::table('tbl_purchase_order_header')
		             ->where('id', $request->purchase_order_number)
		             ->update(['is_grn' => '1']);
					 
					 
					  $grn=DB::table('tbl_temp_grn_header')
		             ->where('purchase_order_id', $request->purchase_order_number)->
					  get()->all();
					 
					 /* DELTING GRN DETAILS */
					 foreach($grn as $grn)
					 {
					   DB::table('tbl_temp_grn_details')
		               ->where('header_id', $grn->id)
		               ->delete();
						 
					 }
					 /* DELETING GRN HEADER */
					 DB::table('tbl_temp_grn_header')
		             ->where('purchase_order_id', $request->purchase_order_number)
		             ->delete();

                }					
									
			 
			    return redirect(route('good_receipt_note_list'))->with('successMessage',$request->grn_code.' '.'GRN Save Successfully');
      }
	  
	  public function get_material_alt_packing_size($id,$val)
      {
	 
		$material=MaterialMasterModel::get()->sortByDesc('id')->first()->find($val);	

		$alt_uom = explode(",",$material->alt_uom);
	   
		$key = array_search($id, $alt_uom);
	   
		$alt_alt_packing_size = explode(",",$material->alt_packing_size);

		echo $alt_alt_packing_size[$key];
	
	  }
	 public function company_get_material_excise($id)
	  {
	 
		$material_vat=MaterialMasterModel::get(['vat'])->sortByDesc('id')->first()->find($id);	

		echo $material_vat->excise;
			
	  }
		
	 public function company_get_material_vat($id)
	  {
	 
		$material_vat=MaterialMasterModel::get(['vat'])->sortByDesc('id')->first()->find($id);	

		echo $material_vat->vat;

	  }
		
	 public function get_warehousename_filter_delivery($id,$warehouse_url)
      {
				
		$material =WarehouseModel::all()->sortByDesc('id')->where('status', '=', 'active')->where('distributor', '=', $id)->where('warehouse_type', '=',1);
	
		?>
		<option  value="">     </option>
		<?php
		  foreach($material as $material_name)
			{
				?>
				<option <?php if($material_name->id==$warehouse_url) { echo "selected";} ?> value="<?php echo $material_name->id ?>"  ><?php echo $material_name->warehouse_code.' - '.$material_name->warehouse_name ?></option>	
				<?php		
			}
					//return response()->json($get_data);
		  
	   }
		
	public function good_receipt_note_export($id)
	 {
		return Excel::download(new PurchaseGoodReceiptNoteExport($id),'good_receipt_note.xlsx');
		
        //return response()->json($get_data);
	 }
	 
	  public function good_receipt_note_export_pdf($id)
	 {
		 $user_id=Session::get('user_id');
		$get_data =DB::table('tbl_good_receipt_note_header')
		  ->leftJoin('tbl_supplier as supplier', 'tbl_good_receipt_note_header.supplier_id', '=', 'supplier.id')
		  ->leftJoin('tbl_currency_type', 'tbl_good_receipt_note_header.currency_id', '=', 'tbl_currency_type.id')
		 
		  ->select('tbl_good_receipt_note_header.*', 'supplier.supplier_name','supplier.address','supplier.email_id','supplier.tin_no','supplier.contact_number','supplier.supplier_code','tbl_currency_type.currency_notation')->where('tbl_good_receipt_note_header.id', '=',$id)->get()->first();
		   
		$get_data_details =DB::table('tbl_good_receipt_note_details')
		  ->leftJoin('tbl_material_master', 'tbl_good_receipt_note_details.material_id', '=', 'tbl_material_master.id')
		  ->leftJoin('tbl_unit_of_measurement', 'tbl_good_receipt_note_details.uom', '=', 'tbl_unit_of_measurement.id')
          ->select('tbl_good_receipt_note_details.*','tbl_material_master.material_name', 'tbl_material_master.material_code as mat_code','tbl_unit_of_measurement.unit_notation')
		  ->where('tbl_good_receipt_note_details.header_id', '=', $id)->get()->all();
		
		  $pdf=PDF::loadView('export.pdf.purchase_good_receipt_note_pdf',compact('get_data','get_data_details'));
		 
		  return $pdf->download('good_receipt_note.pdf');
		
		
	 }
	 
	 
	 
}
