<?php

namespace App\Http\Controllers;
use Illuminate\Http\Request;
use App\Models\OutletModel;
use App\Models\CountryTypeModel;
use App\Models\ManageCodeModel;
use App\Models\CustomerModel;
use App\Models\CityTypeModel ;
use App\Models\WarehouseModel;
use Illuminate\Support\Facades\DB;
use Session;

class OutletController extends Controller

 {
   public function list()
	{
		//$get_data = OutletModel::all()->sortByDesc('id');
		$get_data = DB::table('tbl_outlet')
		->leftJoin('tbl_warehouse', 'tbl_outlet.warehouse_id', '=', 'tbl_warehouse.id')
		->leftJoin('tbl_country', 'tbl_outlet.country_id', '=', 'tbl_country.id')
		->leftJoin('tbl_city', 'tbl_outlet.city_id', '=', 'tbl_city.id')
		->select('tbl_outlet.*', 'tbl_country.country_code' ,'tbl_country.country_name','tbl_city.city_code','tbl_city.city_name','tbl_warehouse.warehouse_code','tbl_warehouse.warehouse_name')
		->orderBy('id', 'DESC')->get();

		return view('Master_Configuration.outlet_list',compact('get_data'));
	}
	
   public function add()
	{ 
	    $distibutor =CustomerModel::all()->sortByDesc('id')->where('status', '=', 'active')->where('customer_type','=',2);
		$result =OutletModel::get()->sortByDesc('id')->first();
		if($result=='')
		  {
			$getcode = ManageCodeModel::where('id', 1)->first();
			$last_code = $getcode->outlet_code;
		  }
		else
		  {
			$getcode = $result->outlet_code; 
			$last_code = ++$getcode;
		  }
			
			$country =CountryTypeModel::all()->sortByDesc('id')->where('status', '=', 'active');
			return view('Master_Configuration.outlet',compact('country','last_code','distibutor'));
	 }

	public function view($id)
     {    
		$get_data=OutletModel::find($id);
		$get_data = DB::table('tbl_outlet')
		->leftJoin('tbl_country', 'tbl_outlet.country_id', '=', 'tbl_country.id')
		->leftJoin('tbl_customer', 'tbl_outlet.distibutor_id', '=', 'tbl_customer.id')
		->leftJoin('tbl_city', 'tbl_outlet.city_id', '=', 'tbl_city.id')
		->leftJoin('tbl_warehouse', 'tbl_outlet.warehouse_id', '=', 'tbl_warehouse.id')
		->select('tbl_outlet.*', 'tbl_country.country_name', 'tbl_country.country_code','tbl_city.city_name','tbl_customer.customer_code','tbl_customer.customer_name','tbl_city.city_code','tbl_warehouse.warehouse_name','tbl_warehouse.warehouse_code')
		->where('tbl_outlet.id', '=', $id)
		->first();

		return view('Master_Configuration.outlet_view',compact('get_data'));
	 }
	
	public function edit($id)
	 {
		$distibutor =CustomerModel::all()->sortByDesc('id')->where('status', '=', 'active')->where('customer_type','=',2);
		$get_data=OutletModel::find($id);
		$country =CountryTypeModel::all()->sortByDesc('id')->where('status', '=', 'active');
		$last_code = $get_data->outlet_code;
		return view('Master_Configuration.outlet',compact('get_data','country','last_code','distibutor'));
	 }
	
	public function save(Request $request)
	 {

		$data=new OutletModel;
	
		if($request->updated_id)
	      {
			
			$data = OutletModel::find($request->updated_id);
			$data->distibutor_id=$request->distibutor;
			$data->outlet_code=$request->outlet_code;
			$data->outlet_name=$request->outlet_name;
			$data->contact_persion=$request->contact_persion;
			$data->contact_number=$request->contact_number;
			$data->country_id=$request->country;
			$data->city_id=$request->city;
			$data->address=$request->address;
			$data->warehouse_id=$request->warehouse_name;
			$data->company_id= Session::get('company_id');
			$data->updated_user= Session::get('user_id');
			$data->status=$request->status;
			$data->save();
			return redirect(route('outlet_list'))->with('successMessage','Outlet Updated Successfully');

		  } 
		else 
		  {
			
		    
			$data->outlet_code=$request->outlet_code;
			$data->distibutor_id=$request->distibutor;
			$data->warehouse_id=$request->warehouse_name;
			$data->outlet_name=$request->outlet_name;
			$data->contact_persion=$request->contact_persion;
			$data->contact_number=$request->contact_number;
			$data->country_id=$request->country;
			$data->city_id=$request->city;
			$data->address=$request->address;
			 $data->company_id= Session::get('company_id');
			$data->created_user= Session::get('user_id');
			$data->status=$request->status;
			$data->save();
			return redirect(route('outlet_list'))->with('successMessage','Outlet Added Successfully');
		
		   }	
		return redirect(route('outlet_list'))->with('successMessage','Outlet Added Successfully');
	 }
	 
	public function get_country($id, $city_id)
	 {
         
		$get_data=CityTypeModel::all()->sortByDesc('id')->where('country_id', '=', $id)->where('status', '=', 'active');
		//  dd($get_data);
		?>
		<option  value="">     </option>
		<?php
		foreach($get_data as $cityname)
		  {
			?>
			<option value="<?php echo $cityname->id ?>" <?php if($cityname->id == $city_id) { echo "selected"; } ?> ><?php echo $cityname->city_code." - ".$cityname->city_name ?></option>	   
			<?php       
		  }
        
	 }
	 
	 
	  public function get_outlet_warehouse_12($id,$edit_id)
	  {		
				
			$outlet_warehouse=WarehouseModel::get()->where('warehouse_type','=',1)->where('status', '=', 'active')->where('distributor','=',$id)->all();
			
			?>
			<option  value="">     </option>
			<?php
			foreach($outlet_warehouse as $warehousename)
			  {
				?>
				<option value="<?php echo $warehousename->id ?>" <?php if($warehousename->id == $edit_id) { echo "selected"; } ?> ><?php echo $warehousename->warehouse_code." - ".$warehousename->warehouse_name; ?></option>	
				<?php		
			  }
	  }
    
 }
  