<?php

namespace App\Http\Controllers;
use Illuminate\Http\Request;
use App\Models\WarehouseModel;
use App\Models\MaterialMasterModel;
use App\Models\ManageCodeModel;
use App\Models\RegionTypeModel;
use App\Models\SubRegionTypeModel;
use App\Models\CustomerTypeModel;
use App\Models\UnitOfMeasurementModel;
use App\Models\WarehouseStockModel; 
use App\Models\CustomerModel;
use App\Models\ClientModel;
use App\Models\MaterialCategoryModel;
use Illuminate\Support\Facades\DB;
use Carbon\Carbon;

class OutletStockTransferReportController extends Controller
 {
    public function list(Request $request)
     {
		//dd($request);
		$current_date=date("Y-m-d");	
		$where="";		
		if(count($request->all()) < 1)
		  {
			$where .= " AND DATE_FORMAT(riheader.created_at, '%Y-%m-%d') between '".$current_date."' and '".$current_date."'"; 
		  }
		if($request->fromdate!='')
		  {
			$where .= " AND DATE_FORMAT(riheader.created_at, '%Y-%m-%d') between '".$request->fromdate."' and '".$request->todate."'"; 
		  }
		if($request->transfer_warehouse!='')
		  {
		    $where .= "AND riheader.outlet_id = '".$request->transfer_warehouse."'";
		  }
			$get_data = DB::select("SELECT riheader.*, 
			warehouse.warehouse_code,warehouse.warehouse_name,
			warehouse1.outlet_code ,warehouse1.outlet_name
			
			FROM tbl_outlet_stock_transfer_header as riheader
			LEFT JOIN tbl_warehouse as warehouse on riheader.from_warehouse=warehouse.id
			LEFT JOIN tbl_outlet as warehouse1 on riheader.outlet_id=warehouse1.id
			WHERE riheader.id IS NOT NULL ".$where." ORDER BY id DESC ");


			$get_data1 = DB::table('tbl_outlet')
			->select('tbl_outlet.outlet_name','tbl_outlet.id', 'tbl_outlet.outlet_code')
			->get();

		   $material_category =DB::table('tbl_material_category') ->select('tbl_material_category.*')->where('status', '=', 'active')->get()->all();				
		  return view('Outlet_Transaction.stock_transfer_report_list ',compact('get_data','get_data1','material_category'));
	 }

    public function view($view)
	 { 	
		  //$get_data=WarehouseModel::get()->where('status', '=', 'active')->all();
		  
		  $material_category =DB::table('tbl_material_category') ->select('tbl_material_category.*')->where('status', '=', 'active')->get()->all();
		
		  $header_details = DB::select("SELECT riheader.*, 
		  warehouse.warehouse_code,warehouse.warehouse_name,
		  warehouse1.outlet_name ,warehouse1.outlet_code
			
		  FROM tbl_outlet_stock_transfer_header as riheader
		  LEFT JOIN tbl_warehouse as warehouse on riheader.from_warehouse=warehouse.id
		  LEFT JOIN tbl_outlet as warehouse1 on riheader.outlet_id=warehouse1.id
		  WHERE riheader.id =".$view." ");
		
		  // dd($header_details[0]->id);
		  
		  return view('Outlet_Transaction.stock_transfer_report_view',compact('header_details','material_category'));				
	 }

	public function get_transfer_details($cat_id,$warehouse_id)
     { 	
   	 
		// echo $warehouse_id.'  '.$cat_id;
		//exit;
		  $material_master1 = DB::table('tbl_outlet_stock_transfer_details')
		  ->leftJoin('tbl_material_master', 'tbl_outlet_stock_transfer_details.material_id', '=', 'tbl_material_master.id')
		  ->select('tbl_material_master.alt_uom','tbl_material_master.material_name','tbl_material_master.id as material_id')
			 ->where('tbl_outlet_stock_transfer_details.header_id', '=', $warehouse_id)
			 ->where('tbl_outlet_stock_transfer_details.material_category_id', '=', $cat_id)
			 ->groupBy('material_name','material_id')
		  ->get()->all();

		//dd($material_master1);
				
				if(count($material_master1)>0)
				  {
					?>
				       <table class="mb-0 table table-bordered table-responsive border-dark" >
                       <thead class="border-dark">
							<tr>
						
								<th style="width:10%;" class="text-center">Material Name</th>
								<th style="width:100%;" class="text-center">Warehouse Stock</th>
						   </tr>
                       </thead>
                       <tbody>
							<?php
						 foreach($material_master1 as $key1=> $data)
				           {  
					 						      
                                      ?>
                             <tr>									  
							   <td><h5 class="font-weight-bold ml-2"> <?php echo $material_master1[$key1]->material_name; ?>
								</h5>
							     <input type="hidden" name="material_id[]" class="form-control"  value="<?php echo $material_master1[$key1]->material_id; ?>"/>											
							    </td>
						     <td>								 
					         <table style="width:100%;" class="table-light table">  
				             <thead>
								  <?php 

									$material_master = DB::table('tbl_outlet_stock_transfer_details')
									   ->leftJoin('tbl_material_master', 'tbl_outlet_stock_transfer_details.material_id', '=', 'tbl_material_master.id')
									   ->leftJoin('tbl_unit_of_measurement', 'tbl_outlet_stock_transfer_details.uom_id', '=', 'tbl_unit_of_measurement.id')
									   ->select('tbl_outlet_stock_transfer_details.id','tbl_outlet_stock_transfer_details.stock_qty','tbl_material_master.material_name','tbl_material_master.id as material_id','tbl_material_master.alt_uom', 'tbl_unit_of_measurement.uom_name','tbl_outlet_stock_transfer_details.id as uom_id'
										 )
									  ->where('tbl_outlet_stock_transfer_details.header_id', '=', $warehouse_id)
									  ->where('tbl_outlet_stock_transfer_details.material_category_id', '=', $cat_id)
									   ->where('tbl_outlet_stock_transfer_details.material_id', '=', $material_master1[$key1]->material_id)
									  ->get()->all();
									  
									  foreach($material_master as $key=> $data2) 
									    {
										
										  ?>
										  <th class="text-justify text-center font-weight-bold">
										  <label class="font-weight-bold" ><?php echo $data2-> uom_name; ?></data>
										   </label> 
											<br>
											<label class="font-weight-bold" ><?php echo $data2->stock_qty; ?></label>					 													 
										  </th>
										   
										   <?php 
										 
										}
							   
											 ?>
											 
								  </thead>
							 </table>
							 </td>
						     </tr>
						   
                            <?php
							   
	                      }
	                        ?>
                       </tbody>
                     </table>                    
                    <?php  
                }     
			  else  
				{ 
				  ?>
				 <div class="container-fluid "><h1 class="text-center"></h1>
				  <br><h4 class="text-center font-weight-bold"><strong class="text-primary">"Sorry"</strong> Materials are not available in this category</h4></div>

				  <?php
                }
      
	    }
 }
