<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;
use App\Models\RegionTypeModel;
use App\Models\SubRegionTypeModel;
use App\Models\WarehouseModel;
use App\Models\RouteModel;
use App\Models\SalesmanModel;
use App\Models\MaterialMasterModel;
use Illuminate\Support\Facades\DB;
use Maatwebsite\Excel\Facades\Excel;
use App\Exports\PendingOrderReportExport;

class PendingOrderController extends Controller
 {
   public function list()
    {		
		//$get_data = SupplierTypeModel::all()->sortByDesc('id');
		 $region =RegionTypeModel::all()->sortByDesc('id')->where('status', '=', 'active');
		 foreach($region as $key=> $reg){

            $all_region[$key] = $reg->id;  
	   }
     
      $regId=implode(",",$all_region);      
		return view('Report.pending_order_report_list',compact('region','regId'));  
    }
		
   public function get_pendig_order_subregion($region)
	{
		
		$data = explode(',',$region);
		
		$sub_region =SubRegionTypeModel::all()->sortByDesc('id')->whereIn('region_id',$data)->where('status', '=', 'active');
		
		if(count($sub_region)>0){
			foreach($sub_region as $subreg){
				
				$all_subregion[] = $subreg->id;
			}
			$subregId=implode(",",$all_subregion);
		}else{

			$subregId = 0;
		}

   
		?>
		<option  value="">     </option>
		<?php if(count($sub_region) > 0){ ?>
			<option  value="0" data-value="<?php echo $subregId ?>">Select All</option>
		<?php } 
		foreach($sub_region as $sub_region_name)
		  {
			?>
			  <option value="<?php echo $sub_region_name->id ?>"  ><?php echo $sub_region_name->sub_region_code.' - '.$sub_region_name->sub_region_name  ?></option>	
		    <?php  	   	
		  }
	}
	  
			
    public function get_pendig_order_warehouse($id)
     {
			$data = explode(',',$id);
			
			$warehouse =WarehouseModel::all()->sortByDesc('id')->where('warehouse_type','=',1)->whereIn('sub_region',$data)->where('status', '=', 'active');
		   
		    if(count($warehouse)>0){
			foreach($warehouse as $wareh){
				
				$all_warehouse[] = $wareh->id;
			}
			 $warehouseId=implode(",",$all_warehouse);
		    }else{

			 $warehouseId = 0;
		    }

			?>
			 <option  value="">     </option>
			 <?php if(count($warehouse) > 0){ ?>
			 <option  value="0" data-value="<?php echo $warehouseId ?>">Select All</option>
		     <?php }
			  foreach($warehouse as $warehouse_name)
				{
					?>
					  <option value="<?php echo $warehouse_name->id ?>"  ><?php echo $warehouse_name->warehouse_code.' - '.$warehouse_name->warehouse_name  ?></option>	
				   <?php  	   	
				}
	 }
	
	public function get_pending_order_report($region,$subregion,$warehouse,$fromdate,$todate)
	 {
	if($warehouse!='s')
	 {
      $final_data  = array();
	  $data1 = explode(',',$warehouse);
		  $agent_name     = array(); 
		  $agent_id     = array(); 
		  $get_data1 = DB::table('tbl_warehouse')
		  ->select('tbl_warehouse.warehouse_code','tbl_warehouse.warehouse_name','tbl_warehouse.id')
		   ->where('tbl_warehouse.warehouse_type','=',1)
		   ->where('tbl_warehouse.status','=','active')
		   ->whereIn('tbl_warehouse.id',$data1)->get();
		 foreach($get_data1 as $key=> $warehous)
		  {
		   $agent_name[$warehous->id] = $warehous->warehouse_name;
		   $agent_id[]=$warehous->id;
		  }
	    
		$get_data = DB::select("SELECT  riheader.customer_id,riheader.warehouse_id,riheader.company_order_number,riheader.delevary_date,riheader.total_order_value,riheader.order_type_id,riheader.is_deliver,riheader.created_at,customer.customer_code,customer.customer_name,
		warehouse.warehouse_code,warehouse.warehouse_name,
		currency.currency_notation FROM tbl_company_order_header as riheader
		LEFT JOIN tbl_customer as customer on riheader.customer_id=customer.id
		LEFT JOIN tbl_warehouse as warehouse on riheader.warehouse_id=warehouse.id
		LEFT JOIN tbl_currency_type as currency on riheader.currency_id=currency.id 
		WHERE date(riheader.created_at) >= '".$fromdate."' AND  date(riheader.created_at) <= '".$todate."' AND riheader.warehouse_id  in (".implode(',',$agent_id).") AND riheader.order_type_id=1 AND riheader.is_deliver='0'");
		$html="";
	    $count=count($get_data);	
	  if($count<1)
		{
		 $html .="<tr style='background-color: #fff;'><td id='no_data' colspan='5' style='color:red;'>No Data Found </td></tr>";
        }
	 else
		{
		 foreach($get_data as $key=>$data)
		   {
			$html .="<tr>";
			$row1 = date("d M Y g:i a", strtotime($data->created_at));
			$space=" ";
			$html .="<td class='font-weight-bold text-justify text-left'>".$data->customer_code.' - '.ucfirst($data->customer_name)."</td>
				     <td class='font-weight-bold text-justify text-left'>".$data->warehouse_code.' - '.ucfirst($data->warehouse_name)."</td>
					 <td class='font-weight-bold text-justify text-left'>".$data->company_order_number."</td><td class='font-weight-bold text-justify text-left'>".$data->delevary_date."</td>
					 <td class='font-weight-bold text-justify text-left'>".number_format($data->total_order_value,2)."</td></tr>";
           }
		}
     $return['html'] = $html;
     echo json_encode($return);die;
}	

else if($subregion!='s')
  {
	$data1 = explode(',',$subregion);
		 $agent_name     = array(); 
		 $agent_id     = array(); 
		 $get_data1 = DB::table('tbl_sub_region')
			->select('tbl_sub_region.sub_region_code','tbl_sub_region.sub_region_name','tbl_sub_region.id')
			->whereIn('tbl_sub_region.id',$data1)					
			->get();
			foreach($get_data1 as $key=> $sub_region)
			  {
				$agent_name[$sub_region->id] = $sub_region->sub_region_name;
				$agent_id[]=$sub_region->id;
			  } 
		 
         $get_data = DB::select("SELECT   riheader.customer_id,riheader.warehouse_id,riheader.company_order_number,riheader.delevary_date,riheader.total_order_value,riheader.order_type_id,riheader.is_deliver,riheader.subregion_id,riheader.created_at,customer.customer_code,customer.customer_name,
		 subregion.sub_region_code,subregion.sub_region_name,currency.currency_notation
		 FROM tbl_company_order_header as riheader LEFT JOIN tbl_customer as customer on riheader.customer_id=customer.id
		 LEFT JOIN tbl_warehouse as warehouse on riheader.warehouse_id=warehouse.id
		 LEFT JOIN tbl_sub_region as subregion on warehouse.sub_region=subregion.id
		 LEFT JOIN tbl_currency_type as currency on riheader.currency_id=currency.id 
		  WHERE date(riheader.created_at) >= '".$fromdate."' AND  date(riheader.created_at) <= '".$todate."' AND riheader.subregion_id  in (".implode(',',$agent_id).") AND riheader.order_type_id=1 AND riheader.is_deliver='0' ");		
		  
       $html="";
	    $count=count($get_data);	
	  if($count<1)
		{
		 $html .="<tr style='background-color: #fff;'><td id='no_data' colspan='5' style='color:red;'>No Data Found </td></tr>";
        }
	 else
		{
		 foreach($get_data as $key=>$data)
		   {
			$html .="<tr>";
			$row1 = date("d M Y g:i a", strtotime($data->created_at));
			$space=" ";
			$html .="<td class='font-weight-bold text-justify text-left'>".$data->customer_code.' - '.ucfirst($data->customer_name)."</td>
				     <td class='font-weight-bold text-justify text-left'>".$data->sub_region_code.' - '.ucfirst($data->sub_region_name)."</td>
					 <td class='font-weight-bold text-justify text-left'>".$data->company_order_number."</td><td class='font-weight-bold text-justify text-left'>".$data->delevary_date."</td>
					 <td class='font-weight-bold text-justify text-left'>".number_format($data->total_order_value,2)."</td></tr>";
           }
		}
     $return['html'] = $html;
     echo json_encode($return);die;							
							
   }
	
 else if($region!='s')
	{
	$data1 = explode(',',$region);
		  $agent_name     = array(); 
		  $agent_id     = array(); 
		  $get_data1 = DB::table('tbl_region')
			   ->select('tbl_region.region_code','tbl_region.region_name','tbl_region.id')
			   ->whereIn('tbl_region.id',$data1)->get()->all();
			   
		  foreach($get_data1 as $key=> $region)
				{
					$agent_name[$region->id] = $region->region_name;
					$agent_id[]=$region->id;
				}		
	 }
	else  
	 {
	  $agent_name     = array(); 
	  $agent_id     = array(); 
	  $get_data1 = DB::table('tbl_region')
				->select('tbl_region.region_code','tbl_region.region_name','tbl_region.id')
				->where('tbl_region.status','=','active')
		        ->where('tbl_region.id','=',$data1)->get()->all();
				 
				
		foreach($get_data1 as $key=> $region)
				{
				 $agent_name[$region->id] = $region->region_name;
				 $agent_id[]=$region->id;
											 
				}
	 }
	 
            $get_data = DB::select("SELECT   riheader.customer_id,riheader.warehouse_id,riheader.company_order_number,riheader.delevary_date,riheader.total_order_value,riheader.order_type_id,riheader.is_deliver,riheader.subregion_id,riheader.region_id,
			customer.customer_code,customer.customer_name,
			region.region_code,region.region_name,riheader.created_at,
			currency.currency_notation
			FROM tbl_company_order_header as riheader
			LEFT JOIN tbl_customer as customer on riheader.customer_id=customer.id
			LEFT JOIN tbl_warehouse as warehouse on riheader.warehouse_id=warehouse.id
			LEFT JOIN tbl_region as region on warehouse.region=region.id
			LEFT JOIN tbl_currency_type as currency on riheader.currency_id=currency.id 
			WHERE date(riheader.created_at) >= '".$fromdate."' AND  date(riheader.created_at) <= '".$todate."' AND riheader.region_id  in (".implode(',',$agent_id).") AND riheader.order_type_id=1 AND riheader.is_deliver='0' ");
		 
		$html="";
	    $count=count($get_data);	
	  if($count<1)
		{
		 $html .="<tr style='background-color: #fff;'><td id='no_data' colspan='5' style='color:red;'>No Data Found </td></tr>";
        }
	 else
		{
		 foreach($get_data as $key=>$data)
		   {
			$html .="<tr>";
			$row1 = date("d M Y g:i a", strtotime($data->created_at));
			$space=" ";
			$html .="<td class='font-weight-bold text-justify text-left'>".$data->customer_code.' - '.ucfirst($data->customer_name)."</td>
				     <td class='font-weight-bold text-justify text-left'>".$data->region_code.' - '.ucfirst($data->region_name)."</td>
					 <td class='font-weight-bold text-justify text-left'>".$data->company_order_number."</td><td class='font-weight-bold text-justify text-left'>".$data->delevary_date."</td>
					 <td class='font-weight-bold text-justify text-left'>".number_format($data->total_order_value,2)."</td></tr>";
           }
		}
     $return['html'] = $html;
     echo json_encode($return);die;	 
							
	  } 
			
   
	public function get_pending_order_reportxls(Request $request)
	 {
		$region=$request->region1;
		$subregion=$request->subregion1;
		$warehouse=$request->warehouse1;
		$fromdate=$request->fromdate1;
		$todate=$request->todate1;
		return Excel::download(new PendingOrderReportExport($region,$subregion,$warehouse,$fromdate,$todate), 'pending_order_report.xlsx');

	  }
 }
