<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;
use App\Models\PurchaseOrderModel;
use App\Models\SupplierModel;
use App\Models\MaterialMasterModel;
use App\Models\ManageCodeModel;
use App\Models\UnitOfMeasurementModel;
use App\Exports\PurchaseOrderReportExport;
use App\Exports\PurchaseOrderReportExportPdf;
use Maatwebsite\Excel\Facades\Excel;
use PDF;

use Session;
use Carbon\Carbon;
use Illuminate\Support\Facades\DB;


class PurchaseOrderController extends Controller 
{  
    public function list(Request $request)
	 {
		 //dd($request);
		$current_date=date("Y-m-d");	
		$where="";		
		if(count($request->all()) < 1)
		  {
			$where .= " AND DATE_FORMAT(riheader.created_at, '%Y-%m-%d') between '".$current_date."' and '".$current_date."'"; 
		  }	  
		if($request->fromdate!='')
		  {
			$where .= " AND DATE_FORMAT(riheader.created_at, '%Y-%m-%d') between '".$request->fromdate."' and '".$request->todate."'"; 
		  }
			 
		if($request->supplier_name!='')
		  {
			$where .= "AND supplier.id = '".$request->supplier_name."'";
		  }
		 
	   
		    $supplier_name =SupplierModel ::all()->sortByDesc('id')->where('status', '=', 'active');
		
			$get_data = DB::select("SELECT riheader.*,riheader.id as close_id, supplier.supplier_name,supplier.supplier_code,
			currency.currency_notation
			
			FROM tbl_purchase_order_header as riheader
			LEFT JOIN tbl_supplier as supplier on riheader.supplier_id=supplier.id
			LEFT JOIN tbl_currency_type as currency on riheader.currency_id=currency.id
			WHERE riheader.id IS NOT NULL ".$where."ORDER BY ID DESC ");
			
		  //dd($get_data);
		 
		  return view('Purchase_Transaction.purchase_order_list',compact('get_data','supplier_name'));
	  }


   public function add()
	{ 
	     $user_id=Session::get('user_id');	  
		 $result = DB::table('tbl_purchase_order_header')
		 ->select('tbl_purchase_order_header.*')->get()->sortByDesc('id')->first();
			 
		if($result=='')
		  {
			$getcode = ManageCodeModel::where('id', 1)->first();
			$last_code1 = $getcode->purchase_order_code;
		  }
		else
		  {
			 $getcode = $result->purchase_order_number; 
			 $last_code1 = ++$getcode;
		  }
			 $supplier_name =SupplierModel ::all()->sortByDesc('id')->where('status', '=', 'active');
			
			  $material =MaterialMasterModel::all()->sortByDesc('id')->where('status', '=', 'active');
				  
			  $login_user = DB::table('tbl_user')
				->leftJoin('tbl_company', 'tbl_user.company_id', '=', 'tbl_company.id')
				->leftJoin('tbl_currency_type', 'tbl_company.currency_id', '=', 'tbl_currency_type.id')
				->select('tbl_user.id', 'tbl_company.currency_id','tbl_currency_type.currency_notation')
				->where('tbl_user.id', '=', $user_id)
				->get()->first();
				//dd($login_user);
					 
				return view('Purchase_Transaction.purchase_order',compact('last_code1','supplier_name','material','login_user'));
	 }
    public function save(Request $request)
	 {    
	      //dd($request);
	      $current = Carbon::now();
		 
		  $user_id=Session::get('user_id');			
		  $login_user = DB::table('tbl_user')
		  ->leftJoin('tbl_company', 'tbl_user.company_id', '=', 'tbl_company.id')
		  ->leftJoin('tbl_currency_type', 'tbl_company.currency_id', '=', 'tbl_currency_type.id')
		  ->select('tbl_user.id', 'tbl_company.currency_id','tbl_currency_type.currency_notation','tbl_currency_type.id as currency_id')
		  ->where('tbl_user.id', '=', $user_id)
		  ->get()->first();
		  
		  $result = DB::table('tbl_purchase_order_header')
		 ->select('tbl_purchase_order_header.*')->get()->sortByDesc('id')->first();
			 
		if($result=='')
		  {
			$getcode = ManageCodeModel::where('id', 1)->first();
			$last_code1 = $getcode->purchase_order_code;
		  }
		else
		  {
			 $getcode = $result->purchase_order_number; 
			 $last_code1 = ++$getcode;
		  }
		  
		 $date = str_replace('/', '-', $request->delivery_date);
		 $newDate = date("d-m-Y", strtotime($date));
		       
			     $data3=array( 
				 
							  'purchase_order_number'  =>  $last_code1,
							  'currency_id'            =>  $login_user->currency_id,
							  'supplier_id'            =>  $request->supplier_name,
							  'tin_no'                 =>  $request->tin_no,
							  'delivery_date'          =>  $newDate,
							  'remark'                 =>  $request->comment,
							 // 'is_grn'                 =>  0,
							  'total_gross'            =>  $request->gross_amount_totali,
							  'net_total_amount'       =>  $request->net_amount_totali,
							  'total_vat'              =>  $request->vat_amount_totali,
							  'total_discount'         =>  $request->total_discount,
							  'payment_term_id'         =>  $request->payment_term1,
							  'total_invoice_value'    =>  $request->invoice_amount_totali,
							  'created_at'             => $current,
							 );
				 //dd($data3);
			$header_id =DB::table('tbl_purchase_order_header')->insertGetId($data3);
		 
			if(count($request->material_name)>0)
		      {
			   
			   foreach($request['material_name'] as $key => $n)
			     {
					
				  if($request->quantity[$key ]!='')
			  
				    {
					 $data2=array(
					 'material_id'   => $request->material_name[$key ],
					 'header_id'     => $header_id,
					 'uom'           => $request->uom[$key ],
					 'unite_price'   => $request->price[$key ],
					 'gross_total'   => $request->gross[$key ],
					 'vat'           => $request->vat[$key ],
					 'total'         => $request->total[$key ],
					 'net_amount'    => $request->net_amount[$key ],
					 'quantity'      => $request->quantity[$key ],
					 'base_qty'      => $request->packing_size[$key ],
					 'created_at'    => $current,
					     );
					 //dd($data2);
					 DB::table('tbl_purchase_order_details')->insert($data2); 
				        } 
                   } 
	           }
		  
		   return redirect(route('purchase_order_list'))->with('successMessage','Purchase Order Uploaded Successfully');
     }
   public function view($id)
	  {   
	 
		$user_id=Session::get('user_id');
		$get_data =DB::table('tbl_purchase_order_header')
		  ->leftJoin('tbl_supplier as supplier', 'tbl_purchase_order_header.supplier_id', '=', 'supplier.id')
		  ->leftJoin('tbl_currency_type', 'tbl_purchase_order_header.currency_id', '=', 'tbl_currency_type.id')
		  ->leftJoin('tbl_payment_term', 'tbl_purchase_order_header.payment_term_id', '=', 'tbl_payment_term.id')
		  ->select('tbl_purchase_order_header.*', 'supplier.supplier_name','tbl_payment_term.payment_code','tbl_payment_term.payment_term','supplier.supplier_code','tbl_currency_type.currency_notation')->where('tbl_purchase_order_header.id', '=',$id)->get()->first();
		  
		$get_data_details =DB::table('tbl_purchase_order_details')
		  ->leftJoin('tbl_material_master', 'tbl_purchase_order_details.material_id', '=', 'tbl_material_master.id')
		  ->leftJoin('tbl_unit_of_measurement', 'tbl_purchase_order_details.uom', '=', 'tbl_unit_of_measurement.id')
          ->select('tbl_purchase_order_details.*','tbl_material_master.material_name', 'tbl_material_master.material_code as mat_code','tbl_unit_of_measurement.unit_notation')
		  ->where('tbl_purchase_order_details.header_id', '=', $id)->get()->all();
		 
		$fields = array();
		$return_data1 = array();
	 
	    $get_data1=DB::table('tbl_good_receipt_note_header as rd')
	            ->select(
				          'rd.id',
						  'rd.purchase_order_id',
						  'rd.grn_code',
						  'rd.created_at',
						)
						->where('rd.purchase_order_id', '=', $id)
				->get(); 
		
             				  
		 if($get_data1!='')
	       {	 
	        foreach($get_data1 as $key => $details)	
		    {
			$return_data1[$key]['id']                           = $details->id;
			$return_data1[$key]['purchase_order_id']            = $details->purchase_order_id;
			$return_data1[$key]['grn_code']                     = $details->grn_code;
			$return_data1[$key]['created_at']                   = $details->created_at;
			  
			$get_material_data=DB::table('tbl_good_receipt_note_details')
			->leftJoin('tbl_material_master', 'tbl_good_receipt_note_details.material_id', '=', 'tbl_material_master.id')
			->where('header_id','=',$details->id) 
			->get(); 
			
		 if($get_material_data!='') 
		  {
			  
		  	foreach($get_material_data as $key1 => $load_details1)	
		      {
				 
				$fields[$key1] = 
                  array( //this array must be created dynamic 
                      'order_qty'         => $get_material_data[$key1]->order_qty,
                      'quantity'          => $get_material_data[$key1]->quantity,
                      'pending_qty'       => $get_material_data[$key1]->pending_qty,
                      'material_name'     => $get_material_data[$key1]->material_name,
                      );
			     } 
				 $return_data1[$key]['details'] = $fields;
		    $fields=array();
		    }                                                                
		  } 
	    } 
			 
         /* dd($return_data1[0]["details"][0]["material_name"]);   */
		
		$login_user = DB::table('tbl_user')
		   ->leftJoin('tbl_company', 'tbl_user.company_id', '=', 'tbl_company.id')
		   ->leftJoin('tbl_currency_type', 'tbl_company.currency_id', '=', 'tbl_currency_type.id')
		   ->select('tbl_user.id', 'tbl_company.currency_id','tbl_currency_type.currency_notation')
		   ->where('tbl_user.id', '=', $user_id)
		   ->get()->first();			  
		 		
		  return view('Purchase_Transaction.purchase_order_view',compact('get_data','get_data_details','login_user','return_data1'));
		
	 }
	 
	public function get_material_alt_packing_size($id,$val)
	 {
 
		$material=MaterialMasterModel::get()->sortByDesc('id')->first()->find($val);	

		$alt_uom = explode(",",$material->alt_uom);
	   
		$key = array_search($id, $alt_uom);
	   
		$alt_alt_packing_size = explode(",",$material->alt_packing_size);

		echo $alt_alt_packing_size[$key];

 
		
	 }
	public function get_material_price($id,$val)
	 {
	
        $material=MaterialMasterModel::get()->sortByDesc('id')->first()->find($val);	
  
			   $alt_uom = explode(",",$material->alt_uom);
			   
			   $key = array_search($id, $alt_uom);
			   
			   $alt_unit_price = explode(",",$material->alt_unit_price);

				echo $alt_unit_price[$key];
		  
	 }
	 
	 public function get_material_detailsUom($id,$row)
      {
		  //dd($id);
			$uom12 =UnitOfMeasurementModel::all()->sortByDesc('id')->where('status', '=', 'active');
			$material_master = DB::select('SELECT t2.id, t2.uom_name,t2.unit_notation FROM tbl_material_master as t1 LEFT JOIN     tbl_unit_of_measurement as t2 ON find_in_set(t2.id, 
			t1.alt_uom) WHERE t1.`id`='.$id.'');			
			$get_material_price=MaterialMasterModel::find($id);			
			$alt_unit_price = explode(",",$get_material_price->alt_unit_price);			
		   // dd($material_master);
			$material=MaterialMasterModel::get()->sortByDesc('id')->first()->find($id);
		    foreach($material_master as $key=>$data)
			  {					
				 ?>
				 <option  <?php if($data->id == $material->uom)  echo 'selected'; ?> value ="<?php echo $data->id; ?>" ><?php echo $data->unit_notation; ?></option>
				 <?php
				 
				}
	  }
	public function material_vat($id)
	 {
	 
				$material_vat=MaterialMasterModel::get(['vat'])->sortByDesc('id')->first()->find($id);	
  
				echo $material_vat->vat;
		exit;
	 }
	 public function order_get_supplier_tin($id)
	 {
		 $supplier_tin = DB::table('tbl_supplier')
			  ->leftJoin('tbl_payment_term', 'tbl_supplier.payment_term', '=', 'tbl_payment_term.id')
			 ->select('tbl_supplier.tin_number','tbl_supplier.payment_term as payment_term_id', 'tbl_payment_term.payment_term','tbl_payment_term.payment_code')
			 ->where('tbl_supplier.id', '=', $id)->where('tbl_supplier.status', '=', 'active')->first();
			 
		echo $supplier_tin->tin_number.'-'.$supplier_tin->payment_term_id.'-'.$supplier_tin->payment_term.'-'.$supplier_tin->payment_code;
		exit; 
	
        
	    //return response()->json($get_data);
	 } 
	 
	 public function purchase_export($id)
	 {
		 
		
		return Excel::download(new PurchaseOrderReportExport($id),'purchase_order.xlsx');
		
        //return response()->json($get_data);
	 }
	 
	 public function purchase_export_pdf($id)
	 {
		 $user_id=Session::get('user_id');
		$get_data =DB::table('tbl_purchase_order_header')
		  ->leftJoin('tbl_supplier as supplier', 'tbl_purchase_order_header.supplier_id', '=', 'supplier.id')
		  ->leftJoin('tbl_currency_type', 'tbl_purchase_order_header.currency_id', '=', 'tbl_currency_type.id')
		  ->leftJoin('tbl_payment_term', 'tbl_purchase_order_header.payment_term_id', '=', 'tbl_payment_term.id')
		  ->select('tbl_purchase_order_header.*', 'supplier.supplier_name','supplier.address','supplier.email_id','supplier.contact_number','tbl_payment_term.payment_code','tbl_payment_term.payment_term','supplier.supplier_code','tbl_currency_type.currency_notation')->where('tbl_purchase_order_header.id', '=',$id)->get()->first();
		   
		$get_data_details =DB::table('tbl_purchase_order_details')
		  ->leftJoin('tbl_material_master', 'tbl_purchase_order_details.material_id', '=', 'tbl_material_master.id')
		  ->leftJoin('tbl_unit_of_measurement', 'tbl_purchase_order_details.uom', '=', 'tbl_unit_of_measurement.id')
          ->select('tbl_purchase_order_details.*','tbl_material_master.material_name', 'tbl_material_master.material_code as mat_code','tbl_unit_of_measurement.unit_notation')
		  ->where('tbl_purchase_order_details.header_id', '=', $id)->get()->all();
		
		  $pdf=PDF::loadView('export.pdf.purchase_order_pdf',compact('get_data','get_data_details'));
		  
		  return $pdf->download('purchase_order.pdf');
		
		
	 }
	 
	 

	public function close_pop(Request $request)
	 {
		 
		 
		      DB::table('tbl_purchase_order_header')
			       ->where('id', $request->close_id)
				   ->update([
					  'is_grn' => '1',
					  'reason_type' => $request->reason_type 
					  
			         ]);  
				  //dd($request);
		 $temp=DB::table('tbl_temp_grn_header')
			 ->where('purchase_order_id', $request->close_id)->get()->all();
	
		if($temp!=''){
			
		  foreach($temp as $temm)
		   {
			   
			 DB::table('tbl_temp_grn_details')->where('header_id', '=', $temm->id)->delete();  
		   }
		     
		    DB::table('tbl_temp_grn_header')
			  ->where('purchase_order_id', $request->close_id)->delete();
		  }	
		  
		  return redirect(route('purchase_order_list'))->with('successMessage','Your Purchased Order Closed ');
	 }
	
}
