<?php

namespace App\Http\Controllers;
use Illuminate\Http\Request;
use App\Models\WarehouseModel;
use Illuminate\Support\Facades\DB;
use App\Models\CurrencyTypeModel;
use App\Models\ManageCodeModel;
use App\Models\SalesmanModel;
use App\Models\MaterialMasterModel;
use App\Models\SalesmanInvoiceModel;
use App\Models\CustomerModel;
use App\Models\MaterialCategoryModel;
use App\Models\UnitOfMeasurementModel;
use App\Models\RouteModel;
use App\Models\UserModel;
use App\Models\TradingCenterModel;
use Carbon\Carbon;
use App\Models\ReasonTypeModel;
use Session;
use PDF;
use App\Exports\ReturnSalesExport; 
use Maatwebsite\Excel\Facades\Excel;
class ReturnSalesController extends Controller
 {
   public function list(Request $request)
	{ 
	 // dd($request); 
	  $current_date=date("Y-m-d");	
	  $where="";		
	  if(count($request->all()) < 1)
	    {
			$where .= " AND DATE_FORMAT(riheader.created_at, '%Y-%m-%d') between '".$current_date."' and '".$current_date."'"; 
		}
	 
	  if($request->fromdate!='')
		{
		  $where .= " AND DATE_FORMAT(riheader.created_at, '%Y-%m-%d') between '".$request->fromdate."' and '".$request->todate."'"; 
		}
	 
	  if($request->warehouse!='')
		{
		  $where .= "AND warehouse.id = '".$request->warehouse."'";
		}
		 
	  if($request->route!='')
	    {
	      $where .= "AND route.id = '".$request->route."'";
	    }
	
				 $route =RouteModel::all()->sortByDesc('id')->where('status', '=', 'active');
				 $warehouse=WarehouseModel::all()->sortByDesc('id')->where('warehouse_type','=','1')->where('status', '=', 'active');
				//$get_data = CurrencyTypeModel::all()->sortByDesc('id'); 
				$get_data = DB::select("SELECT riheader.*, route.route_name,route.route_code,
				customer.customer_code,customer.customer_name,
				warehouse.warehouse_code,warehouse.warehouse_name,
				salesman.salesman_name,salesman.salesman_code,currency.currency_notation
				
				FROM tbl_return_sales_header as riheader
				LEFT JOIN tbl_route as route on riheader.route_id=route.id
				LEFT JOIN tbl_customer as customer on riheader.customer_id=customer.id
				LEFT JOIN tbl_warehouse as warehouse on riheader.warehouse_id=warehouse.id
				LEFT JOIN tbl_salesman as salesman on riheader.salesman_id=salesman.id 
				LEFT JOIN tbl_currency_type as currency on riheader.currency=currency.id
				WHERE riheader.id IS NOT NULL ".$where." ORDER BY id DESC");
		 
				
				return view('Route_Transaction.return_sales_list',compact('get_data','route','warehouse'));
      }
	
	 public function view($id)
	  {   
	
		 $user_id=Session::get('user_id');
		 $get_data =DB::table('tbl_return_sales_header')
		->leftJoin('tbl_trading_center', 'tbl_return_sales_header.trading_center_id', '=', 'tbl_trading_center.id')
		->leftJoin('tbl_route', 'tbl_return_sales_header.route_id', '=', 'tbl_route.id')
		->leftJoin('tbl_customer', 'tbl_return_sales_header.customer_id', '=', 'tbl_customer.id')
		->leftJoin('tbl_warehouse', 'tbl_return_sales_header.warehouse_id', '=', 'tbl_warehouse.id')
		->leftJoin('tbl_salesman', 'tbl_return_sales_header.salesman_id', '=', 'tbl_salesman.id')
		->leftJoin('tbl_currency_type', 'tbl_return_sales_header.currency', '=', 'tbl_currency_type.id')           
		 ->select('tbl_return_sales_header.*', 'tbl_trading_center.trading_name', 'tbl_trading_center.trading_center_code', 'tbl_route.route_name','tbl_route.route_code','tbl_customer.customer_name','tbl_customer.customer_code','tbl_warehouse.warehouse_name','tbl_warehouse.warehouse_code','tbl_salesman.salesman_name','tbl_salesman.salesman_code','tbl_currency_type.currency_notation')->where('tbl_return_sales_header.id', '=',$id)->get()->first();		
		 $get_data_details =DB::table('tbl_return_sales_details')

		  ->leftJoin('tbl_material_master', 'tbl_return_sales_details.material_id', '=', 'tbl_material_master.id')
		  ->leftJoin('tbl_unit_of_measurement', 'tbl_return_sales_details.uom', '=', 'tbl_unit_of_measurement.id')
		  ->leftJoin('tbl_reason_type', 'tbl_return_sales_details.resion', '=', 'tbl_reason_type.id')
  
		  ->select('tbl_return_sales_details.*','tbl_material_master.material_name','tbl_material_master.material_code','tbl_reason_type.reasion_type as reason_name','tbl_unit_of_measurement.unit_notation')->where('tbl_return_sales_details.header_id', '=', $id)->get()->all();

			$login_user = DB::table('tbl_user')
		  ->leftJoin('tbl_company', 'tbl_user.company_id', '=', 'tbl_company.id')
		  ->leftJoin('tbl_currency_type', 'tbl_company.currency_id', '=', 'tbl_currency_type.id')
		  ->select('tbl_user.id', 'tbl_company.currency_id','tbl_currency_type.currency_notation')
		  ->where('tbl_user.id', '=', $user_id)
		  ->get()->first();			          
			$reason =ReasonTypeModel::all()->sortByDesc('id');		
		return view('Route_Transaction.return_sales_view',compact('get_data','get_data_details','login_user','reason'));
		
      }
	 public function add()
      {   	
			$user_id=Session::get('user_id');
			$result = DB::table('tbl_return_sales_header')
			->select('tbl_return_sales_header.*')->get()->sortByDesc('id')->first();
		 
		if($result=='')
		  {
			$getcode = ManageCodeModel::where('id', 1)->first();
			$last_code = $getcode->return_sales_code;
		  }
		else
	      {
			 $getcode = $result->return_number; 
			 $last_code = ++$getcode;
		  }

				$material_master = DB::table('tbl_material_master')
				->join('tbl_unit_of_measurement', 'tbl_material_master.uom_id', '=', 'tbl_unit_of_measurement.id')
				
				->select('tbl_material_master.*', 'tbl_unit_of_measurement.unit_notation')
			
				->get()->all();
					
				  $material_category =MaterialCategoryModel::all()->sortByDesc('id')->where('status', '=', 'active');
				  
				  /*$user_login =UserModel::all()->sortByDesc('id')->where('id','=',$user_id)->where('status', '=', 'active');
				  
				   echo $user_login->company_id;
				   exit;
				   */
				   
				   
				  $customer_type =CustomerModel ::all()->sortByDesc('id')->where('status', '=', 'active')->where('customer_type', '=', 1);
				  
				  $material =MaterialMasterModel::all()->sortByDesc('id')->where('status', '=', 'active');
				
				  $route =RouteModel::all()->sortByDesc('id')->where('status', '=', 'active');
				  
				  $login_user = DB::table('tbl_user')
					->leftJoin('tbl_company', 'tbl_user.company_id', '=', 'tbl_company.id')
					->leftJoin('tbl_currency_type', 'tbl_company.currency_id', '=', 'tbl_currency_type.id')
					->select('tbl_user.id', 'tbl_company.currency_id','tbl_currency_type.currency_notation')
					->where('tbl_user.id', '=', $user_id)
					->get()->first();
					//dd($login_user);
				 
				return view('Route_Transaction.return_sales',compact('last_code','customer_type','material_master','material_category','route','material','login_user'));
	  }
	
	 public function save(Request $request)
      {
		   $get_region_subregion = DB::table('tbl_customer')
			->select('tbl_customer.id', 'tbl_customer.region','tbl_customer.sub_region')
		   ->where('tbl_customer.id', '=', $request->customer_type)
		   ->get()->first();
		   
		   $current = Carbon::now();
			
			$user_id=Session::get('user_id');

			$salesman = DB::table('tbl_salesman')
			->select('tbl_salesman.id as salesman_id')
			->where('tbl_salesman.route_id', '=', $request->route_id1)
			->get()->first();

		
		   $login_user = DB::table('tbl_user')
		  ->leftJoin('tbl_company', 'tbl_user.company_id', '=', 'tbl_company.id')
		  ->leftJoin('tbl_currency_type', 'tbl_company.currency_id', '=', 'tbl_currency_type.id')
		  ->select('tbl_user.id', 'tbl_company.currency_id','tbl_currency_type.currency_notation','tbl_currency_type.id as currency_id')
		  ->where('tbl_user.id', '=', $user_id)
		  ->get()->first();
	  
		  $date = str_replace('/', '-', $request->invoice_date);
		  $newDate = date("d-m-Y", strtotime($date));
		  $salesman_id=2;
			 $data3=array
			    (
				 'return_number'      =>  $request->return_number,
				 'currency'      =>   $login_user->currency_id,
				 'warehouse_id'           =>  $request->warehaouse_id,
				 'salesman_id'            =>  $request->salesman,
				 'invoice_date'        =>  $newDate,
				 'customer_id'       =>  $request->customer_type,
				 'remark'              =>  $request->comment,
				 'order_type_id'          =>  $request->order_typehidden,
				 'region'              =>  $get_region_subregion->region,
				 'subregion'           =>  $get_region_subregion->sub_region,
				 
				 'route_id'            =>  $request->route_id1,
				 'trading_center_id'   =>  $request->trading_center,
				 'total_gross'         =>  $request->gross_amount_totali,
				  // 'net_total_amount'    =>  $request->net_amount_totali,
				  // 'total_vat'           =>  $request->vat_amount_totali,
				  //'total_unite_price'   =>  $request->price_amount_totali,
				 'total_invoice_value' =>  $request->invoice_amount_totali,
				  'created_at'         => $current,
			    );
				 
				$header_id =DB::table('tbl_return_sales_header')->insertGetId($data3);
  
			  if(count($request->material_name)>0)
				{
			   
				   foreach($request['material_name'] as $key => $n)
				     {
					   if($request->quantity[$key ]!='')
					     {
							 $data2=array
							 (
							 'material_id' => $request->material_name[$key ],
							 'header_id'           =>$header_id,
							 'uom'           => $request->uom[$key ],
							 'unite_price'   => $request->price[$key ],
							 'return_type'   => $request->return_type[$key ],
							 'resion'        => $request->resion[$key ],
							 'gross_total'   => $request->gross[$key ],
							//  'vat'           => $request->vat[$key ],
							 'total'         => $request->total[$key ],
							 'base_qty'    => $request->packing_size[$key ],
							// 'net_amount'    => $request->net_amount[$key ],
							 'quantity'      => $request->quantity[$key ],
							 'created_at'    => $current,
							 );
							 DB::table('tbl_return_sales_details')->insert($data2);
							 
							  /* stock movement functionality start from here */
								  $stock = DB::table('tbl_warehouse_stock')
									  ->where('tbl_warehouse_stock.warehouse_id','=',$request->warehaouse_id)
									  ->where('tbl_warehouse_stock.material_id','=',$request->material_name[$key])
									  ->get()->all();
									 $count=count($stock);
									  if($count>0)
									  {
										  
										  if($request->return_type[$key]=='1')
										{										
										  // reducing stock from warehouse
											$query = DB::table('tbl_warehouse_stock')
										  ->where('warehouse_id',$request->warehaouse_id)
										  ->where('material_id','=',$request->material_name[$key]);
										  
										   $query->increment('qty',$request->packing_size[$key]);
										   
										}
										else
										 {
										   $query = DB::table('tbl_warehouse_stock')
										  ->where('warehouse_id',$request->warehaouse_id)
										  ->where('material_id','=',$request->material_name[$key]);
										   $query->increment('return_stock',$request->packing_size[$key]);
										 }
										  
									 }
						  } 
					  }		 
				  }
		 		return redirect(route('return_sales_list'))->with('successMessage','Item Uploaded Successfully');
      }
	  
	 public function get_trading($id1)
	  {
		
			$get_data=TradingCenterModel::all()->sortByDesc('id')->where('route_id', '=', $id1)->where('status', '=', 'active');		
			?>
			<option  value="">     </option>
			<?php
			foreach($get_data as $trading)
			   {
				?>
				<option value="<?php echo $trading->id ?>"  ><?php echo $trading->trading_center_code." - ".$trading->trading_name ?></option>	
				<?php		
		       }
	  }
	  
	  public function salesman_return($id)
	  {
		
			$get_data=SalesmanModel::all()->sortByDesc('id')->where('id', '=', $id)->where('status', '=', 'active');		
			?>
			<option  value="">     </option>
			<?php
			foreach($get_data as $salesman)
			   {
				?>
				<option value="<?php echo $salesman->id ?>"  ><?php echo $salesman->salesman_code." - ".$salesman->salesman_name ?></option>	
				<?php		
		       }  
	  }
	  
	 public function get_customer($id1)
      {
		
		$get_data=CustomerModel::all()->sortByDesc('id')->where('trading_center_id', '=', $id1)->where('status', '=', 'active');
		
		?>
		<option  value="">     </option>
		<?php
		foreach($get_data as $customer)
		  {
			?>
			<option value="<?php echo $customer->id ?>"  ><?php echo $customer->customer_code." - ".$customer->customer_name ?></option>	
			<?php		
		  }
			
      }
	   
	 public function get_material()
	  {		
		   $material =MaterialMasterModel::all()->sortByDesc('id')->where('status', '=', 'active');	
		   ?>
		   <option  value="">     </option>
		   <?php
		  foreach($material as $material_name)
			{
			  ?>
			  <option value="<?php echo $material_name->id ?>"  ><?php echo $material_name->material_code .' - '. $material_name->material_name ?></option>	
			  <?php		
			}
		
	        //return response()->json($get_data);
		
      }
	  
     public function get_material_price($id,$val)
	  {
	 
		   $material=MaterialMasterModel::get()->sortByDesc('id')->first()->find($val);	     
		   $alt_uom = explode(",",$material->alt_uom);				   
		   $key = array_search($id, $alt_uom);				   
		   $alt_unit_price = explode(",",$material->alt_unit_price);
			echo $alt_unit_price[$key];			
	  }    
	 
	 public function get_material_detailsUom($id,$row)
      {
			$uom12 =UnitOfMeasurementModel::all()->sortByDesc('id')->where('status', '=', 'active');
			$material_master = DB::select('SELECT t2.id, t2.uom_name,t2.unit_notation FROM tbl_material_master as t1 LEFT JOIN     tbl_unit_of_measurement as t2 ON find_in_set(t2.id, 
			t1.alt_uom) WHERE t1.`id`='.$id.'');			
			$get_material_price=MaterialMasterModel::find($id);			
			$alt_unit_price = explode(",",$get_material_price->alt_unit_price);			
		   //dd($material_master);
			$material=MaterialMasterModel::get()->sortByDesc('id')->first()->find($id);
		    foreach($material_master as $key=>$data)
			  {					
				 ?>
				 <option  <?php if($data->id == $material->uom)  echo 'selected'; ?> value ="<?php echo $data->id; ?>" ><?php echo $data->unit_notation; ?></option>
				 <?php
				 
				}
	  }
	   
     public function get_resion($id)
      {		 
		$reason =ReasonTypeModel::all()->sortByDesc('id')->where('return_type', '=', $id);		 
		foreach($reason as $key=>$data)
		  {				
			  ?>
			  <option   value ="<?php echo $data->id; ?>" ><?php echo $data->reasion_type; ?></option>
			  <?php				 
		  }	   
	  }  
		
     public function get_material_return_alt_packing_size($id,$val)
	  {
	 
	    $material=MaterialMasterModel::get()->sortByDesc('id')->first()->find($val);	

		 $alt_uom = explode(",",$material->alt_uom);
	     $key = array_search($id, $alt_uom);
	     $alt_alt_packing_size = explode(",",$material->alt_packing_size);
         echo $alt_alt_packing_size[$key];
			
	   }	
	   
	   public function return_sales_export($id){
		   
		   return Excel::download(new  ReturnSalesExport($id), 'return_sales.xlsx');
	   }
	   
	    public function return_sales_pdf($id)
		{
		   
		   $user_id=Session::get('user_id');
		 $get_data =DB::table('tbl_return_sales_header')
		->leftJoin('tbl_trading_center', 'tbl_return_sales_header.trading_center_id', '=', 'tbl_trading_center.id')
		->leftJoin('tbl_route', 'tbl_return_sales_header.route_id', '=', 'tbl_route.id')
		->leftJoin('tbl_customer', 'tbl_return_sales_header.customer_id', '=', 'tbl_customer.id')
		->leftJoin('tbl_warehouse', 'tbl_return_sales_header.warehouse_id', '=', 'tbl_warehouse.id')
		->leftJoin('tbl_salesman', 'tbl_return_sales_header.salesman_id', '=', 'tbl_salesman.id')
		->leftJoin('tbl_currency_type', 'tbl_return_sales_header.currency', '=', 'tbl_currency_type.id')           
		 ->select('tbl_return_sales_header.*', 'tbl_trading_center.trading_name', 'tbl_trading_center.trading_center_code', 'tbl_route.route_name','tbl_route.route_code','tbl_customer.tin_no','tbl_customer.address','tbl_customer.email','tbl_customer.contact_no','tbl_customer.customer_name','tbl_customer.customer_code','tbl_warehouse.warehouse_name','tbl_warehouse.warehouse_code','tbl_salesman.salesman_name','tbl_salesman.salesman_code','tbl_currency_type.currency_notation')->where('tbl_return_sales_header.id', '=',$id)->get()->first();		
		 $get_data_details =DB::table('tbl_return_sales_details')

		  ->leftJoin('tbl_material_master', 'tbl_return_sales_details.material_id', '=', 'tbl_material_master.id')
		  ->leftJoin('tbl_unit_of_measurement', 'tbl_return_sales_details.uom', '=', 'tbl_unit_of_measurement.id')
		  ->leftJoin('tbl_reason_type', 'tbl_return_sales_details.resion', '=', 'tbl_reason_type.id')
  
		  ->select('tbl_return_sales_details.*','tbl_material_master.material_name','tbl_material_master.material_code','tbl_reason_type.reasion_type as reason_name','tbl_unit_of_measurement.unit_notation')->where('tbl_return_sales_details.header_id', '=', $id)->get()->all();
		   
		   $pdf=PDF::loadView('export.pdf.return_sales_pdf', compact('get_data','get_data_details'));
		   return $pdf->download('return_sales.pdf'); 
	    }
			
      public function get_return_filter($id,$url_return)
       {
		  // dd($url_return);
		 $route =RouteModel::all()->sortByDesc('id')->where('status', '=', 'active')->where('warehouse_id', '=', $id);
		  ?>
			<option  value="">     </option>
			<?php  
			  foreach($route as $routename)   
				{ 
					?>
					<option <?php if($routename->id==$url_return) { echo "selected";} ?> value="<?php echo $routename->id ?>"  ><?php echo $routename->route_code.' - '.$routename->route_name ?></option>	
					<?php		
				 }				 
	    }	   
 }
