<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;
use App\Models\CurrencyTypeModel;
use App\Models\ManageCodeModel;
use App\Models\MaterialMasterModel;
use App\Models\SalesmanInvoiceModel;
use App\Models\CustomerModel;
use App\Models\MaterialCategoryModel;
use App\Models\UnitOfMeasurementModel;
use App\Models\WarehouseModel;
use App\Models\RouteModel; 
use App\Models\UserModel;
use App\Models\TradingCenterModel;
use App\Models\CustomerTypeModel;
use App\Models\ReasonTypeModel;
use App\Models\RouteDeliveryModel;
use Carbon\Carbon;
use Illuminate\Support\Facades\DB;
use Session;
use PDF;
use App\Exports\RouteDeliveryExport; 
use Maatwebsite\Excel\Facades\Excel;
class RouteDeliveryController extends Controller
{
   public function list(Request $request)
   {  
        
	  $current_date=date("Y-m-d");	
	  $where="";		
	  if(count($request->all()) < 1)
		{
		  $where .= " AND DATE_FORMAT(riheader.created_at, '%Y-%m-%d') between '".$current_date."' and '".$current_date."'"; 
		}
  
	  if($request->customer!='')
		{
		  $where .= "AND customer.id = '".$request->customer."'";
		}
		
	   if($request->warehouse!='')
	     {
	       $where .= "AND warehouse.id = '".$request->warehouse."'";
	     }

		 
	   $distibutor=CustomerModel::all()->sortByDesc('id')->where('customer_type', '!=', 1)->where('status', '=', 'active');
			
	    //$get_data = CurrencyTypeModel::all()->sortByDesc('id');
	
			$get_data = DB::select("SELECT riheader.*, 
			customer.customer_code,customer.customer_name,
			riheader.order_number,
			warehouse.warehouse_code,warehouse.warehouse_name,		
			currency.currency_notation		
			FROM tbl_route_delivery_header as riheader		
			LEFT JOIN tbl_customer as customer on riheader.customer_id=customer.id
			LEFT JOIN tbl_warehouse as warehouse on riheader.warehouse_id=warehouse.id
			LEFT JOIN tbl_currency_type as currency on riheader.currency_id=currency.id 
			WHERE riheader.id IS NOT NULL ".$where." ORDER BY id DESC");
            
		    
			return view('Route_Transaction.route_delivery_list',compact('get_data','distibutor'));
    }
	   
   public function add()
	{   
		$user_id=Session::get('user_id');	  
		$result = DB::table('tbl_route_delivery_header')
		 ->select('tbl_route_delivery_header.*')->get()->sortByDesc('id')->first();
         
		if($result=='')
		  {
			$getcode = ManageCodeModel::where('id', 1)->first();
			$last_code = $getcode->route_order_delivery;
		  }
		else
		  {
			$getcode = $result->route_delivery_number; 
			$last_code = ++$getcode;
		  }

			$material_master = DB::table('tbl_material_master')
			->leftJoin('tbl_unit_of_measurement', 'tbl_material_master.uom_id', '=', 'tbl_unit_of_measurement.id')
			->select('tbl_material_master.*', 'tbl_unit_of_measurement.uom_name','tbl_unit_of_measurement.unit_notation')
		    ->get()->all();
			
			
			$material_category =MaterialCategoryModel::all()->sortByDesc('id')->where('status', '=', 'active');
		  			
			$material =MaterialMasterModel::all()->sortByDesc('id')->where('status', '=', 'active')->where('material_types_id', '=',3);
	        
			$login_user = DB::table('tbl_user')
			->leftJoin('tbl_company', 'tbl_user.company_id', '=', 'tbl_company.id')
			->leftJoin('tbl_currency_type', 'tbl_company.currency_id', '=', 'tbl_currency_type.id')
			->select('tbl_user.id', 'tbl_company.currency_id','tbl_currency_type.currency_notation')
			->where('tbl_user.id', '=', $user_id)
			->get()->first();
			
			return view('Route_Transaction.route_delivery',compact('last_code','material_master','material_category','material','login_user'));
 
	 }

    public function get_order_number($id)
     {
		if($id==1)
		  {			
				$get_data1 =DB::table('tbl_route_order_header')
				->leftJoin('tbl_customer', 'tbl_route_order_header.customer_id', '=', 'tbl_customer.id')
				->select('tbl_route_order_header.*','tbl_customer.customer_name','tbl_customer.customer_code')->where('tbl_route_order_header.order_type_id', '=',$id)->where('tbl_route_order_header.is_deliver', '=', '0')->get()->all();
				   //dd($get_data1);
				?>
				<option  value="">     </option>
				<?php
				foreach($get_data1 as $order_name)
				  {
					  
					?>
					<option value="<?php echo $order_name->id ?>"  ><?php echo $order_name->order_number .' ( '. $order_name->customer_code.' - '. $order_name->customer_name ?> )</option>	
					<?php		
				  }
		  }
		  else{
			     $get_data1 =DB::table('tbl_return_sales_header')
				->leftJoin('tbl_customer', 'tbl_return_sales_header.customer_id', '=', 'tbl_customer.id')
				->select('tbl_return_sales_header.*','tbl_customer.customer_name','tbl_customer.customer_code')->where('tbl_return_sales_header.order_type_id', '=',$id)->where('tbl_return_sales_header.is_deliver', '=', '0')->get()->all();
				  
				?>
				<option  value="">     </option>
				<?php
				foreach($get_data1 as $order_name)
				  {
					  
					?>
					<option value="<?php echo $order_name->id ?>"  ><?php echo $order_name->return_number .' ( '. $order_name->customer_code.' - '. $order_name->customer_name ?> )</option>	
					<?php		
				  }
			  
		      }
	 }
	  
	public function get_order_number_details($id,$return)
	 {
		 
          		 
		   $order_name =DB::table('tbl_route_order_header')
		->leftJoin('tbl_customer', 'tbl_route_order_header.customer_id', '=', 'tbl_customer.id')
		->select('tbl_route_order_header.*','tbl_customer.customer_name','tbl_customer.customer_code')->where('tbl_route_order_header.order_type_id', '=',$return)->where('tbl_route_order_header.is_deliver','=','0')->get()->all();
		  
	    $get_data =DB::table('tbl_route_order_header')		
	    ->select('tbl_route_order_header.*')->where('tbl_route_order_header.id', '=',$id)->get()->first();
         //dd($get_data);
		$get_data_details =DB::table('tbl_route_order_details')	  
		  ->leftJoin('tbl_material_master', 'tbl_route_order_details.material_id', '=', 'tbl_material_master.id')
		  ->leftJoin('tbl_unit_of_measurement', 'tbl_route_order_details.uom_id', '=', 'tbl_unit_of_measurement.id')
		  ->select('tbl_route_order_details.*','tbl_material_master.material_name','tbl_material_master.vat as material_vat','tbl_unit_of_measurement.uom_name','tbl_unit_of_measurement.unit_notation')->where('tbl_route_order_details.header_id','=', $id)->get()->all();  
		    // dd($get_data_details); 
		  
		 
		  
		       $order_name1  =DB::table('tbl_return_sales_header')
		     ->leftJoin('tbl_customer', 'tbl_return_sales_header.customer_id', '=', 'tbl_customer.id')
		      ->select('tbl_return_sales_header.*','tbl_customer.customer_name','tbl_customer.customer_code')->where('tbl_return_sales_header.order_type_id', '=',$return)->where('tbl_return_sales_header.is_deliver','=','0')->get()->all();
		     
	        $get_data1  =DB::table('tbl_return_sales_header')		
	         ->select('tbl_return_sales_header.*')->where('tbl_return_sales_header.id', '=',$id)->get()->first();
     
		    $get_data_details1  =DB::table('tbl_return_sales_details')	  
		     ->leftJoin('tbl_material_master', 'tbl_return_sales_details.material_id', '=', 'tbl_material_master.id')
		     ->leftJoin('tbl_unit_of_measurement', 'tbl_return_sales_details.uom', '=', 'tbl_unit_of_measurement.id')
		      ->select('tbl_return_sales_details.*','tbl_material_master.material_name','tbl_material_master.vat as material_vat','tbl_unit_of_measurement.uom_name','tbl_unit_of_measurement.unit_notation')->where('tbl_return_sales_details.header_id','=', $id)->get()->all();
			    //dd($get_data_details);   
		 
		 
		  $reason =ReasonTypeModel::all()->sortByDesc('id');
		  $material_details=MaterialMasterModel::all()->sortByDesc('id')->where('material_types_id', '=',3);
		  //$uom12 =UnitOfMeasurementModel::all()->sortByDesc('id')->where('status', '=', 'active');
		  $user_id=Session::get('user_id');
	
		  $login_user = DB::table('tbl_user')
		  ->leftJoin('tbl_company', 'tbl_user.company_id', '=', 'tbl_company.id')
		  ->leftJoin('tbl_currency_type', 'tbl_company.currency_id', '=', 'tbl_currency_type.id')
		  ->select('tbl_user.id', 'tbl_company.currency_id','tbl_currency_type.currency_notation','tbl_currency_type.id as currency_id')
		  ->where('tbl_user.id', '=', $user_id)
		  ->get()->first();
			  
		  $user_id=Session::get('user_id');
  
			$result = DB::table('tbl_route_delivery_header')
			->select('tbl_route_delivery_header.route_delivery_number')
			->where('tbl_route_delivery_header.order_type', '=', $return)
			->get()->first();
			
	       if($result=='')
			 {
			   if($return=='1')
				 {
				   $getcode = ManageCodeModel::where('id', 1)->first();
				   $last_code = $getcode->route_order_delivery;
				 }
               else{
					  $getcode = ManageCodeModel::where('id', 1)->first();
					  $last_code = $getcode->route_return_delivery;
				   }
		        
			  }
			   
		    else{
		          $getcode = DB::table('tbl_route_delivery_header')
                            ->select('tbl_route_delivery_header.route_delivery_number')
			                ->where('tbl_route_delivery_header.order_type', '=', $return)->get()->last();
							
		          $last_code = ++$getcode->route_delivery_number;
				   
		        }
		
          $material_master = DB::table('tbl_material_master')
			->join('tbl_unit_of_measurement', 'tbl_material_master.uom_id', '=', 'tbl_unit_of_measurement.id')
			
			->select('tbl_material_master.*', 'tbl_unit_of_measurement.uom_name','tbl_unit_of_measurement.unit_notation')
		
			->get()->all();
			
		     $material_category =MaterialCategoryModel::all()->sortByDesc('id')->where('status', '=', 'active');
	  
		     /*$user_login =UserModel::all()->sortByDesc('id')->where('id','=',$user_id)->where('status', '=', 'active');
		  
		     echo $user_login->company_id;
		     exit;
		     */
			
			 $material =MaterialMasterModel::all()->sortByDesc('id')->where('status', '=', 'active')->where('material_types_id', '=',3);
		
		  
			$login_user = DB::table('tbl_user')
			->leftJoin('tbl_company', 'tbl_user.company_id', '=', 'tbl_company.id')
			->leftJoin('tbl_currency_type', 'tbl_company.currency_id', '=', 'tbl_currency_type.id')
			->select('tbl_user.id', 'tbl_company.currency_id','tbl_currency_type.currency_notation')
			->where('tbl_user.id', '=', $user_id)
			->get()->first();
		
			return view('Route_Transaction.route_delivery',compact('last_code','material_master','material_category','material','login_user','get_data','get_data_details','reason','order_name','order_name1','get_data1','get_data_details1'));
			
	 }
		
	public function get_material()
	 {

		$material =MaterialMasterModel::all()->sortByDesc('id')->where('status', '=', 'active');	
		?>
		<option  value="">     </option>
		<?php
		foreach($material as $material_name)
		  {
			?>
			<option value="<?php echo $material_name->id ?>"  ><?php echo $material_name->material_code.' - '.$material_name->material_name ?></option>	
			<?php		
		  }		
					//return response()->json($get_data);		
	  }
		   
	 public function get_material_detailsUom1($id,$row)
	  {
		 $uom12 =UnitOfMeasurementModel::all()->sortByDesc('id')->where('status', '=', 'active');
		 $material_master = DB::select('SELECT t2.id, t2.uom_name,t2.unit_notation FROM tbl_material_master as t1 LEFT JOIN     tbl_unit_of_measurement as t2 ON find_in_set(t2.id, 
		 t1.alt_uom) WHERE t1.`id`='.$id.'');				
		 $get_material_price=MaterialMasterModel::find($id);				
		 $alt_unit_price = explode(",",$get_material_price->alt_unit_price);				
		 //dd($alt_unit_price);	
		 $material=MaterialMasterModel::get()->sortByDesc('id')->first()->find($id);
	
		 foreach($material_master as $key=>$data)
		   {				
			 ?>
			 <option  <?php if($data->id == $material->uom)  echo 'selected'; ?> value ="<?php echo $data->id; ?>" ><?php echo $data->unit_notation; ?></option>
				  <?php				 
		   }
	 }
	public function get_material_price($id,$val)
	 {	 
		 $material=MaterialMasterModel::get()->sortByDesc('id')->first()->find($val);	     
		 $alt_uom = explode(",",$material->alt_uom);				   
		 $key = array_search($id, $alt_uom);				   
		 $alt_unit_price = explode(",",$material->alt_unit_price);
		 // print_r($alt_unit_price);
		 echo $alt_unit_price[$key];
	 
	 }
		
	public function save(Request $request)
	 {
		   $current = Carbon::now();
		    $user_id=Session::get('user_id');
			
		    $login_user = DB::table('tbl_user')
		      ->leftJoin('tbl_company', 'tbl_user.company_id', '=', 'tbl_company.id')
		      ->leftJoin('tbl_currency_type', 'tbl_company.currency_id', '=', 'tbl_currency_type.id')
		      ->select('tbl_user.id', 'tbl_company.currency_id','tbl_currency_type.currency_notation','tbl_currency_type.id as currency_id')
		      ->where('tbl_user.id', '=', $user_id)
		      ->get()->first();
			  
		if($request->order_typehidden=='1')  
			  { 
		       $get_cust =DB::table('tbl_route_order_header')		        
		        ->select('tbl_route_order_header.customer_id','tbl_route_order_header.warehouse_id','tbl_route_order_header.order_date','tbl_route_order_header.route_id','tbl_route_order_header.salesman_id','tbl_route_order_header.trading_center_id','tbl_route_order_header.order_number')->where('tbl_route_order_header.id', '=',$request->order_number)->where('tbl_route_order_header.is_deliver', '=', '0')->get()->first();	
			 
		      DB::table('tbl_route_order_header')
		       ->where('id', $request->order_number)
		       ->update(['is_deliver' => '1']);
			  
				$data3=array
				(
				 'route_delivery_number'      =>  $request->route_delivery_number,
				 'currency_id'                     =>  $login_user->currency_id,
				 'order_number'                 =>  $get_cust->order_number,
				  
				 'order_date'                =>  $get_cust->order_date,
				 'customer_id'                     =>  $get_cust->customer_id,
				 'salesman_id'                     =>  $get_cust->salesman_id,
				 'trading_center_id'                     =>  $get_cust->trading_center_id,
				 'warehouse_id'                    =>  $get_cust->warehouse_id,
				 'route_id'            =>  $get_cust->route_id,
				 'order_type'                   =>  $request->order_typehidden,
				 'total_gross'                  =>  $request->gross_amount_totali,
				  //'net_total_amount'             =>  $request->net_amount_totali,
				// 'total_excise'                 =>  $request->excise_amount_totali,
				  //'total_vat'                    =>  $request->vat_amount_totali,
				 
				 // 'total_discount'              =>  $request->vat_amount_totali,
				  'total_order_value'        =>  $request->invoice_amount_totali,
				  'created_at'                  =>  $current,
				 
			     );
				
			  $header_id =DB::table('tbl_route_delivery_header')->insertGetId($data3);
			   
	         }
			 
		if($request->order_typehidden=='2')  
		    {
			   $get_cust1  =DB::table('tbl_return_sales_header')
                 ->select('tbl_return_sales_header.customer_id','tbl_return_sales_header.warehouse_id','tbl_return_sales_header.invoice_date','tbl_return_sales_header.route_id','tbl_return_sales_header.salesman_id','tbl_return_sales_header.trading_center_id','tbl_return_sales_header.return_number')->where('tbl_return_sales_header.id', '=',$request->return_number)->where('tbl_return_sales_header.is_deliver', '=', '0')->get()->first();	
			 
		      DB::table('tbl_return_sales_header')
		        ->where('id', $request->return_number)
		       ->update(['is_deliver' => '1']);     
			     
				$data4=array
				 (
				 'route_delivery_number'      =>  $request->route_delivery_number,
				 'currency_id'                     =>  $login_user->currency_id,
				 'return_number'                 =>  $get_cust1 ->return_number,
				 // 'invoice_date'                =>  $get_cust1 ->invoice_date,  
				 'customer_id'                     =>  $get_cust1 ->customer_id,
				   'salesman_id'                     =>  $get_cust1 ->salesman_id,
				 'trading_center_id'                     =>  $get_cust1 ->trading_center_id, 
				 'warehouse_id'                    =>  $get_cust1 ->warehouse_id,
				 'route_id'            =>  $get_cust1 ->route_id,
				 'order_type'                   =>  $request->order_typehidden,
				 'total_gross'                  =>  $request->gross_amount_totali,
				   //'net_total_amount'             =>  $request->net_amount_totali,
				// 'total_excise'                 =>  $request->excise_amount_totali,
				   //'total_vat'                    =>  $request->vat_amount_totali,
				 
				  // 'total_discount'              =>  $request->vat_amount_totali,
				  'total_order_value'        =>  $request->invoice_amount_totali,
				  'created_at'                  =>  $current,
				 
			     );
			  
			  $header_id1 =DB::table('tbl_route_delivery_header')->insertGetId($data4);
			  
			} 
			if($request->order_typehidden=='2')  
			  {
				 
			     foreach($request['material_name1'] as $key => $n)
				   {
				     if($request->quantity1[$key ]!='')
					   {
						 $data2=array(
						 'material_id' => $request->material_name1[$key ],
						 'header_id'     =>$header_id1,
						 'uom_id'           => $request->uom1[$key ],
						 'unite_price'   => $request->price1[$key ],
						 'gross_total'   => $request->gross1[$key ],
						 'net_amount'    =>  0,
						 'vat'           =>  0,
						'total'         => $request->total1[$key ],
						 'quantity'      => $request->quantity1[$key ],
				  		 //'return_type'   => $request->return_type[$key ],
						 //'resion'        => $request->resion[$key ],
						 'base_qty'      => $request->opacking_size[$key ],
						 'created_at'    => $current,
						 );
						 DB::table('tbl_route_delivery_details')->insert($data2);
						
						 
						 
						 // stock operation
						 	 $stock = DB::table('tbl_warehouse_stock')
								  ->where('tbl_warehouse_stock.warehouse_id','=',1)
								  ->where('tbl_warehouse_stock.material_id','=',$request->material_name1[$key])
								  ->get()->all();
								 
								  $count=count($stock);
					       if($count>0)
							 {
							   // reducing from 1st warehouse
							   $query = DB::table('tbl_warehouse_stock')
							   //->where('warehouse_id',$get_cust->warehouse_id)  
							   ->where('material_id','=',$request->material_name1[$key]);
							  
							    $query->decrement('qty',$request->opacking_size[$key]);
							   
							    // increamenting from 2nd warehouse
								  /*  if($request->return_type[$key]=='1')
								  {										
									   $query = DB::table('tbl_warehouse_stock')
									  ->where('warehouse_id', 1)
									  ->where('material_id','=',$request->material_name1[$key]);
									   $query->increment('qty',$request->opacking_size[$key]);
									   
								   }
                                 else
								   {
                                       $query = DB::table('tbl_warehouse_stock')
									  ->where('warehouse_id', 1)
									  ->where('material_id','=',$request->material_name1[$key]);
									   $query->increment('return_stock',$request->opacking_size[$key]);
									} 	 */	 						
							   }
				
					     } 
				    }
				
			  }				
			   
			if($request->order_typehidden=='1')
			  {
			     foreach($request['material_name'] as $key => $n)
                   {
			         if($request->quantity[$key ]!='')
					   {
						 $data2=array(
						 'material_id' => $request->material_name[$key ],
						 'header_id'           =>$header_id,
						 'uom_id'           => $request->uom[$key ],
						 'unite_price'   => $request->price[$key ],
						 'gross_total'   => $request->gross[$key ],
						 'vat'           => $request->vat[$key ],
						 'total'         => $request->total[$key ],
						 //'net_amount'    => $request->net_amount[$key ],
						 'quantity'      => $request->quantity[$key ],
						
						 'base_qty'      => $request->packing_size[$key ],
						 'created_at'    => $current,
						 );
						 DB::table('tbl_route_delivery_details')->insert($data2);
						
						 
						  // stock operation
						  $stock = DB::table('tbl_warehouse_stock')
							  ->where('tbl_warehouse_stock.warehouse_id','=',$get_cust->warehouse_id)
							  ->where('tbl_warehouse_stock.material_id','=',$request->material_name[$key])
							  ->get()->all();
							
						   $count=count($stock);
						     if($count>0)
							   {
								  // reducing from 1st warehouse
								  $query = DB::table('tbl_warehouse_stock')
								  ->where('warehouse_id', 1)
								  ->where('material_id','=',$request->material_name[$key]);
								  
								   $query->decrement('qty',$request->packing_size[$key]);
								   
									// increamenting from 2nd warehouse
								   $query = DB::table('tbl_warehouse_stock')
								  ->where('warehouse_id', $get_cust->warehouse_id)
								  ->where('material_id','=',$request->material_name[$key]);
								   $query->increment('qty',$request->packing_size[$key]);
								
							     }
							   else
								 {
									 
								   // reducing from 1st warehouse
								   $query = DB::table('tbl_warehouse_stock')
								   ->where('warehouse_id',1)
								   ->where('material_id','=',$request->material_name[$key]);
								  
								    $query->decrement('qty',$request->packing_size[$key]);
								    //when stock does not exist
								  
									$warehouse_details = DB::table('tbl_warehouse')
										->select('tbl_warehouse.region',  'tbl_warehouse.sub_region')
										->where('tbl_warehouse.id','=',$get_cust->warehouse_id)
										->get()->first();
										
									$material_details= DB::table('tbl_material_master')
											->select('tbl_material_master.uom_id', 'tbl_material_master.material_category_id',  'tbl_material_master.material_types_id')
											->where('tbl_material_master.id','=',$request->material_name[$key ])
										->get()->first();
										
										$data4=array(
										 'region'                => $warehouse_details->region,
										 'subregion'             => $warehouse_details->sub_region,
										 'warehouse_id'          => $get_cust->warehouse_id,
										 'material_category_id'  => $material_details->material_category_id,
										 'material_id'           => $request->material_name[$key],
										 'uom_id'                => $material_details->uom_id,
										 'qty'                   => $request->packing_size[$key],
										 'material_type'         => $material_details->material_types_id,
										 'created_at'            => $current,
										 );									
									 DB::table('tbl_warehouse_stock')->insert($data4);
								   }
					    } 
				   }
			 
			  }
	        
			  
			    return redirect(route('route_delivery_list'))->with('successMessage',$request->route_delivery_number.' '.'Delivery Save Successfully');
      }
	  
	 public function view($id)
      { 
			$user_id=Session::get('user_id');
			$get_data =DB::table('tbl_route_delivery_header')				
			->leftJoin('tbl_customer', 'tbl_route_delivery_header.customer_id', '=', 'tbl_customer.id')
			->leftJoin('tbl_warehouse', 'tbl_route_delivery_header.warehouse_id', '=', 'tbl_warehouse.id')
			//->leftJoin('tbl_customer_type', 'tbl_route_delivery_header.distribution_type', '=', 'tbl_customer_type.id')
			//->join('tbl_warehouse', 'tbl_company_order_header.warehouse', '=', 'tbl_warehouse.id')
			->leftJoin('tbl_currency_type', 'tbl_route_delivery_header.currency_id', '=', 'tbl_currency_type.id')
			->select('tbl_route_delivery_header.*','tbl_customer.customer_name','tbl_customer.customer_code',
			'tbl_warehouse.warehouse_name','tbl_warehouse.warehouse_code', 'tbl_currency_type.currency_notation')->where('tbl_route_delivery_header.id', '=',$id)->get()->first();
				 
			$get_data_details =DB::table('tbl_route_delivery_details')
  
			   ->leftJoin('tbl_material_master', 'tbl_route_delivery_details.material_id', '=', 'tbl_material_master.id')
			   ->leftJoin('tbl_unit_of_measurement', 'tbl_route_delivery_details.uom_id', '=', 'tbl_unit_of_measurement.id')
			     
			  ->select('tbl_route_delivery_details.*','tbl_material_master.material_code','tbl_material_master.material_name','tbl_unit_of_measurement.uom_name','tbl_unit_of_measurement.unit_notation')->where('tbl_route_delivery_details.header_id', '=', $id)->get()->all();
		  
         
			$login_user = DB::table('tbl_user')
			  ->leftJoin('tbl_company', 'tbl_user.company_id', '=', 'tbl_company.id')
			  ->leftJoin('tbl_currency_type', 'tbl_company.currency_id', '=', 'tbl_currency_type.id')
			  ->select('tbl_user.id', 'tbl_company.currency_id','tbl_currency_type.currency_notation')
			  ->where('tbl_user.id', '=', $user_id)
			  ->get()->first();			  
	
		 
			$reason =ReasonTypeModel::all()->sortByDesc('id');
	
			return view('Route_Transaction.route_delivery_view',compact('get_data','get_data_details','login_user','reason'));
	
	  }
		
	 public function get_material_alt_packing_size($id,$val)
      {
	 
		$material=MaterialMasterModel::get()->sortByDesc('id')->first()->find($val);	

		$alt_uom = explode(",",$material->alt_uom);
	   
		$key = array_search($id, $alt_uom);
	   
		$alt_alt_packing_size = explode(",",$material->alt_packing_size);

		echo $alt_alt_packing_size[$key];
	
	  }
	 public function company_get_material_excise($id)
	  {
	 
		$material_vat=MaterialMasterModel::get(['vat'])->sortByDesc('id')->first()->find($id);	

		echo $material_vat->excise;
			
	  }
		
	 public function company_get_material_vat($id)
	  {
	 
		$material_vat=MaterialMasterModel::get(['vat'])->sortByDesc('id')->first()->find($id);	

		echo $material_vat->vat;

	  }
		
	 public function get_warehousename_filter_delivery($id,$warehouse_url)
      {
				
		$material =WarehouseModel::all()->sortByDesc('id')->where('status', '=', 'active')->where('distributor', '=', $id)->where('warehouse_type', '=',1);
	
		?>
		<option  value="">     </option>
		<?php
		  foreach($material as $material_name)
			{
				?>
				<option <?php if($material_name->id==$warehouse_url) { echo "selected";} ?> value="<?php echo $material_name->id ?>"  ><?php echo $material_name->warehouse_code.' - '.$material_name->warehouse_name ?></option>	
				<?php		
			}
					//return response()->json($get_data);
		  
	   }
		
	  public function get_return_code_delevery($id)
	   {
			
		  $result = DB::table('tbl_route_delivery_header')
			->select('tbl_route_delivery_header.route_delivery_number')
			->where('tbl_route_delivery_header.order_type', '=', $id)
			->get()->first();
				
	      if($result=='')
			   
			{
			   if($id=='1')
				 {
				   $getcode = ManageCodeModel::where('id', 1)->first();
				   $last_code = $getcode->route_order_delivery;
				 }
               else{
					  $getcode = ManageCodeModel::where('id', 1)->first();
					  $last_code = $getcode->route_return_delivery;
					}						
			
		     } 
		   else{
		         $getcode = DB::table('tbl_route_delivery_header')
                            ->select('tbl_route_delivery_header.route_delivery_number')
			                ->where('tbl_route_delivery_header.order_type', '=', $id)->get()->last();
							
		          $last_code = ++$getcode->route_delivery_number;
		       }
		
                 echo $last_code;
			
	    }
		
		public function route_delivery_export($id)
		{
			
			return Excel::download(new RouteDeliveryExport($id), 'route_delivery.xlsx');
		}
		
		public function route_delivery_pdf($id)
		{
			$get_data =DB::table('tbl_route_delivery_header')				
			->leftJoin('tbl_customer', 'tbl_route_delivery_header.customer_id', '=', 'tbl_customer.id')
			->leftJoin('tbl_warehouse', 'tbl_route_delivery_header.warehouse_id', '=', 'tbl_warehouse.id')
			//->leftJoin('tbl_customer_type', 'tbl_route_delivery_header.distribution_type', '=', 'tbl_customer_type.id')
			//->join('tbl_warehouse', 'tbl_company_order_header.warehouse', '=', 'tbl_warehouse.id')
			->leftJoin('tbl_currency_type', 'tbl_route_delivery_header.currency_id', '=', 'tbl_currency_type.id')
			->select('tbl_route_delivery_header.*','tbl_customer.customer_name','tbl_customer.customer_code',
			'tbl_customer.address','tbl_customer.tin_no','tbl_customer.contact_no','tbl_customer.email','tbl_warehouse.warehouse_name','tbl_warehouse.warehouse_code', 'tbl_currency_type.currency_notation')->where('tbl_route_delivery_header.id', '=',$id)->get()->first();
				 
			$get_data_details =DB::table('tbl_route_delivery_details')
               ->leftJoin('tbl_material_master', 'tbl_route_delivery_details.material_id', '=', 'tbl_material_master.id')
			   ->leftJoin('tbl_unit_of_measurement', 'tbl_route_delivery_details.uom_id', '=', 'tbl_unit_of_measurement.id')
			   ->select('tbl_route_delivery_details.*','tbl_material_master.material_code','tbl_material_master.material_name','tbl_unit_of_measurement.uom_name','tbl_unit_of_measurement.unit_notation')->where('tbl_route_delivery_details.header_id', '=', $id)-> get()->all();
			  
			  $pdf=PDF::loadView('export.pdf.route_delivery_pdf', compact('get_data','get_data_details'));
			  return $pdf->download('route_delivery.pdf');    
		}
	  	 
}
 