<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;
use App\Models\WarehouseModel;
use Illuminate\Support\Facades\DB;
use App\Models\CurrencyTypeModel;
use App\Models\MaterialMasterModel;
use App\Models\SalesmanInvoiceModel;
use App\Models\CustomerModel;
use App\Models\MaterialCategoryModel;
use App\Models\UnitOfMeasurementModel;
use App\Models\RouteExchangeModel;
use App\Models\RouteModel;
use App\Exports\RouteExchangeExport; 
use Maatwebsite\Excel\Facades\Excel; 
use Session; 
use PDF; 
use Carbon\Carbon;     
  
class RouteExchangeController extends Controller
{
  public function list(Request $request)
	{ 
		 $current_date=date("Y-m-d");	
		  $where="";		
		  if(count($request->all()) < 1)
			{
				$where .= " AND DATE_FORMAT(riheader.created_at, '%Y-%m-%d') between '".$current_date."' and '".$current_date."'"; 
			}
		 
		  if($request->fromdate!='')
			{
			  $where .= " AND DATE_FORMAT(riheader.created_at, '%Y-%m-%d') between '".$request->fromdate."' and '".$request->todate."'"; 
			}
		 
		  if($request->warehouse!='')
			{
			  $where .= "AND warehouse.id = '".$request->warehouse."'";
			}
			 
		  if($request->route!='')
			{
			  $where .= "AND route.id = '".$request->route."'";
			}
		 $route =RouteModel::all()->sortByDesc('id')->where('status', '=', 'active');	
		 $warehouse=WarehouseModel::all()->sortByDesc('id')->where('status', '=', 'active');	
         $get_data = DB::select("SELECT riheader.*,
				customer.customer_name,salesman.salesman_name,warehouse.warehouse_name,route.route_name
				FROM tbl_route_exchange_header as riheader
				LEFT JOIN tbl_customer as customer on riheader.customer_id=customer.id
				LEFT JOIN tbl_route as route on riheader.route_id=route.id
				LEFT JOIN tbl_warehouse as warehouse on riheader.warehouse_id=warehouse.id
				LEFT JOIN tbl_salesman as salesman on riheader.salesman_id=salesman.id 
				WHERE riheader.id IS NOT NULL ".$where."ORDER BY id DESC "); 
				 //dd($get_data);
			return view('Route_Transaction.route_exchange_list',compact('get_data','warehouse'));
	}
   public function view($id)
	{ 
	      
          $get_data = DB::select("SELECT riheader.*,
				customer.customer_name,salesman.salesman_name,warehouse.warehouse_name,route.route_name
				FROM tbl_route_exchange_header as riheader
				LEFT JOIN tbl_customer as customer on riheader.customer_id=customer.id
				LEFT JOIN tbl_route as route on riheader.route_id=route.id
				LEFT JOIN tbl_warehouse as warehouse on riheader.warehouse_id=warehouse.id
				LEFT JOIN tbl_salesman as salesman on riheader.salesman_id=salesman.id 
				WHERE riheader.id=".$id."
				 ");
				 
				$invoice_id=DB::table('tbl_route_invoice_header')
				    ->select('tbl_route_invoice_header.id')
					->where('tbl_route_invoice_header.invoice_number','=',$get_data[0]->invoice_code)
					->get()->first();
				$return_id=DB::table('tbl_return_sales_header')
				    ->select('tbl_return_sales_header.id')
					->where('tbl_return_sales_header.return_number','=',$get_data[0]->return_code)
					->get()->first();	
				
              $get_return_details =DB::select("SELECT riheader.*,
				material.material_name,uom.unit_notation,reason_type.reasion_type
				FROM tbl_route_exchange_return_details as riheader
				LEFT JOIN tbl_material_master as material on riheader.material_id=material.id
				LEFT JOIN tbl_unit_of_measurement as uom on riheader.uom_id=uom.id
				LEFT JOIN tbl_reason_type as reason_type on riheader.return_reason_id=reason_type.id
				WHERE riheader.header_id=".$id."
				 ");
              $get_invoice_details =DB::select("SELECT riheader.*,
				material.material_name,uom.unit_notation
				FROM tbl_route_exchange_invoice_details as riheader
				LEFT JOIN tbl_material_master as material on riheader.material_id=material.id
				LEFT JOIN tbl_unit_of_measurement as uom on riheader.uom_id=uom.id
				WHERE riheader.header_id=".$id."
				");
			return view('Route_Transaction.route_exchange_view',compact('get_data','get_return_details','get_invoice_details','invoice_id','return_id'));    
    }
	public function get_return_filter($id,$url_return)
       {
		 $route =RouteModel::all()->sortByDesc('id')->where('status', '=', 'active')->where('warehouse_id', '=', $id);
		  ?>
			<option  value="">     </option>
			<?php  
			  foreach($route as $routename)   
				{ 
					?>
					<option <?php if($routename->id==$url_return) { echo "selected";} ?> value="<?php echo $routename->id ?>"  ><?php echo $routename->route_name ?></option>	
					<?php		
				 }				 
	    }
		
		public function routeexchangeexcelexport($id)  
	{
		 
      return Excel::download(new RouteExchangeExport($id), 'routeexchange.xlsx'); 
         
	}
		
		public function routeexchangepdfexport($id)  
	{
		 $get_data = DB::select("SELECT riheader.*,
				customer.customer_name,customer.contact_no,customer.address,customer.email,customer.tin_no,salesman.salesman_name,warehouse.warehouse_name,route.route_name
				FROM tbl_route_exchange_header as riheader
				LEFT JOIN tbl_customer as customer on riheader.customer_id=customer.id
				LEFT JOIN tbl_route as route on riheader.route_id=route.id
				LEFT JOIN tbl_warehouse as warehouse on riheader.warehouse_id=warehouse.id
				LEFT JOIN tbl_salesman as salesman on riheader.salesman_id=salesman.id 
				WHERE riheader.id=".$id."
				 ");
		 
		 $get_return_details =DB::select("SELECT riheader.*,
				material.material_name,uom.unit_notation,reason_type.reasion_type
				FROM tbl_route_exchange_return_details as riheader
				LEFT JOIN tbl_material_master as material on riheader.material_id=material.id
				LEFT JOIN tbl_unit_of_measurement as uom on riheader.uom_id=uom.id
				LEFT JOIN tbl_reason_type as reason_type on riheader.return_reason_id=reason_type.id
				WHERE riheader.header_id=".$id."
				 ");
		 
		 $pdf=PDF::loadView('export.pdf.route_exchange_pdf',compact('get_data','get_return_details'));
		 
		 
      return  $pdf->download('routeexchange.pdf'); 
	  
         
	}
		
		
		
		
}
