<?php

namespace App\Http\Controllers;
use Illuminate\Http\Request;
use App\Models\RouteExpensesModel;
use App\Models\ManageCodeModel;
use App\Models\SalesmanModel;
use App\Models\ExpenseTypeModel;
use App\Models\RouteModel;
use App\Models\WarehouseModel;
use Illuminate\Support\Facades\DB;
use Session;
use Carbon\Carbon;

class RouteExpensesController extends Controller
 { 
  public function list(Request $request)
   { 
	 //dd($request);	
	 $expense_date=date("Y-m-d");

	 $where="";		
	 if(count($request->all()) < 1)
	   {
		   $where .= " AND DATE_FORMAT(riheader.created_at, '%Y-%m-%d') between '".$expense_date."' and '".$expense_date."'"; 
	   }
			  
	  if($request->fromdate!='')
	   {
		 $where .= " AND DATE_FORMAT(riheader.created_at, '%Y-%m-%d') between '".$request->fromdate."' and '".$request->todate."'"; 
	   }
				 
	  if($request->warehouse!='')
	   {
		$where .= "AND warehouse.id = '".$request->warehouse."'";
	   }
				 
	  if($request->salesman!='')
	    {
		  $where .= "AND salesman.id = '".$request->salesman."'";
	    }
			
		$route =RouteModel::all()->sortByDesc('id')->where('status', '=', 'active');
		 $warehouse=WarehouseModel::all()->sortByDesc('id')->where('warehouse_type','=','1')->where('status', '=', 'active');
		//$get_data = CurrencyTypeModel::all()->sortByDesc('id');
		
								
			$get_data = DB::select("SELECT riheader.*, route.route_name,route.route_code,
			expense.expense_code,expense.expense_name,
			warehouse.warehouse_code,warehouse.warehouse_name,
			salesman.salesman_name,salesman.salesman_code,currency.currency_notation
			
			FROM tbl_route_expenses as riheader
			LEFT JOIN tbl_route as route on riheader.route_id=route.id
			LEFT JOIN tbl_expense_type as expense on riheader.expense_type=expense.id
			LEFT JOIN tbl_warehouse as warehouse on riheader.warehouse_id=warehouse.id
			LEFT JOIN tbl_salesman as salesman on riheader.salesman_name=salesman.id 
			LEFT JOIN tbl_currency_type as currency on riheader.currency=currency.id 
			WHERE riheader.id IS NOT NULL ".$where."ORDER BY id DESC");

			
			/*$get_data1 = DB::table('tbl_route_expenses')
			->join('tbl_route', 'tbl_route_expenses.route_id', '=', 'tbl_route.id')
			->join('tbl_warehouse', 'tbl_route_expenses.warehouse_id', '=', 'tbl_warehouse.id')
			->join('tbl_salesman', 'tbl_route_expenses.salesman_name', '=', 'tbl_salesman.id')
			->join('tbl_expense_type', 'tbl_route_expenses.expense_type', '=', 'tbl_expense_type.id')
			
			->select('tbl_route_expenses.*', 'tbl_route.route_code','tbl_route.route_name','tbl_warehouse.warehouse_code','tbl_warehouse.warehouse_name','tbl_salesman.salesman_code','tbl_salesman.salesman_name','tbl_expense_type.expense_code','tbl_expense_type.expense_name')
			
		    ->get();*/
						
				  //dd($get_data);
			
			return view('Route_Transaction.route_expenses_list',compact('get_data','warehouse'));

	}
	
   public function add()
    {	
		
		$result =RouteExpensesModel::get()->sortByDesc('id')->first();
		if($result=='')
		  {
			$getcode = ManageCodeModel::where('id', 1)->first();
			$last_code = $getcode->expense_no;
		  }
		else
		  {
			 $getcode = $result->expense_no; 
			 $last_code = ++$getcode;
		   }
		$salesman =SalesmanModel::all()->sortByDesc('id')->where('status', '=', 'active');
		$expense_type =ExpenseTypeModel::all()->sortByDesc('id')->where('status', '=', 'active');;
		
		return view('Route_Transaction.route_expenses',compact('last_code','salesman','expense_type'));
		
	}
	
   public function edit($id)
    {
		
		$salesman =SalesmanModel::all()->sortByDesc('id')->where('status', '=', 'active');
		$expense_type =ExpenseTypeModel::all()->sortByDesc('id')->where('status', '=', 'active');
		 
		$get_data = DB::table('tbl_route_expenses')
		->leftJoin('tbl_route', 'tbl_route_expenses.route_id', '=', 'tbl_route.id')
		->leftJoin('tbl_warehouse', 'tbl_route_expenses.warehouse_id', '=', 'tbl_warehouse.id')
		->leftJoin('tbl_salesman', 'tbl_route_expenses.salesman_name', '=', 'tbl_salesman.id')
		->leftJoin('tbl_expense_type', 'tbl_route_expenses.expense_type', '=', 'tbl_expense_type.id')
		
		->select('tbl_route_expenses.*', 'tbl_route.route_code','tbl_route.route_name','tbl_warehouse.warehouse_code','tbl_warehouse.warehouse_name','tbl_salesman.salesman_code','tbl_salesman.salesman_name','tbl_expense_type.expense_code','tbl_expense_type.expense_name','tbl_route_expenses.salesman_name')
		
		->where('tbl_route_expenses.id', '=', $id)
		
		->first();
		
	    $last_code = $get_data->expense_no;
	
	    //dd($get_data);
	   return view('Route_Transaction.route_expenses',compact('get_data','salesman','expense_type','last_code'));
    }
	
   public function save(Request $request)
    {
	  $data=new RouteExpensesModel;		 
	  $get_data = DB::select("SELECT s.salesman_name,s.route_id,route.warehouse_id FROM tbl_salesman as s 
	  LEFT JOIN tbl_route as route on s.route_id=route.id
	  LEFT JOIN tbl_warehouse as warehouse on route.warehouse_id=warehouse.id
	 
	  where s.id='".$request->salesman_id."'");
	
	  $user_id=Session::get('user_id');        
	
		$login_user = DB::table('tbl_user')
		->leftJoin('tbl_company', 'tbl_user.company_id', '=', 'tbl_company.id')
		->leftJoin('tbl_currency_type', 'tbl_company.currency_id', '=', 'tbl_currency_type.id')
		->select('tbl_user.id', 'tbl_company.currency_id','tbl_currency_type.currency_notation')
		->where('tbl_user.id', '=', $user_id)
		->get()->first();		 

		//dd($login_user);
	     if($request->updated_id) 
		   {
            
				$data = RouteExpensesModel::find($request->updated_id);			
				$data->expense_no=$request->expense_no;
				$data->salesman_name=$request->salesman_id;
				$data->expense_type=$request->expense_type;
				$data->expense_date=$request->expense_date;
				$data->expense_amount=$request->expense_amt;
				$data->route_id=$get_data[0]->route_id;
				$data->warehouse_id=$get_data[0]->warehouse_id;
				$data->comment=$request->comment;            
				//$data->updated_user= Session::get('user_id');
				//$data->status=$request->status;
				$data->save();
				return redirect(route('route_expenses_list'))->with('successMessage','Route Updated Successfully');
        
			 } 
		   else
 			 {
            
				$data->currency = $login_user->currency_id;
				$data->expense_no=$request->expense_no;
				$data->salesman_name=$request->salesman_id;
				$data->expense_type=$request->expense_type;
				$data->expense_date=$request->expense_date;
				$data->expense_amount=$request->expense_amt;
				 $data->route_id=$get_data[0]->route_id;
				$data->warehouse_id=$get_data[0]->warehouse_id;
				$data->comment=$request->comment;
				

				//$data->updated_user= Session::get('user_id');
				//$data->status=$request->status;
				
				$data->save();
				return redirect(route('route_expenses_list'))->with('successMessage','Expenses Added Successfully');
				
			 }   
	}
	
   public function get_salesman_name_filter($id)
	{ 
		$get_data = DB::table('tbl_route_expenses') 
		 ->leftJoin('tbl_salesman', 'tbl_route_expenses.salesman_name', '=', 'tbl_salesman.id')
		 ->leftJoin('tbl_warehouse', 'tbl_route_expenses.warehouse_id', '=', 'tbl_warehouse.id')
		 
		 ->select('tbl_route_expenses.*', 'tbl_salesman.salesman_code','tbl_salesman.salesman_name')
		
		 ->where('tbl_route_expenses.warehouse_id', '=', $id)
		
		 ->get()->all();
		 //dd($get_data);

		 ?>
		 <option  value="">     </option>
				<?php
			foreach($get_data as $salesmanname1)
			  {
				?>
				<option value="<?php echo $salesmanname1->salesman_name ?>"  ><?php echo $salesmanname1->salesman_code ?> - <?php echo $salesmanname1->salesman_name ?> </option>	
				<?php		
			  }
		
			//return response()->json($get_data);
		
    }
   public function get_salesman_filter($id,$url_salesman)
    {
		 $salesman =SalesmanModel::all()->sortByDesc('id')->where('status', '=', 'active')->where('warehouse_id', '=', $id);
		  ?>
			<option  value="">     </option>
			<?php  
		 foreach($salesman as $salesmanname)   
		   { 
				?>
				<option <?php if($salesmanname->id==$url_salesman) { echo "selected";} ?> value="<?php echo $salesmanname->id ?>"  ><?php echo $salesmanname->salesman_code.' - '.$salesmanname->salesman_name ?></option>	
				<?php		
			}
		 
	 }
 }
