<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;

use App\Models\RegionTypeModel;
use App\Models\SubRegionTypeModel;
use App\Models\WarehouseModel;
use App\Models\RouteModel;
use App\Models\SalesmanModel;
use Illuminate\Support\Facades\DB;
use Maatwebsite\Excel\Facades\Excel;
use App\Exports\MaterialPerformanceExport;
use App\Models\MaterialMasterModel;

use Session;
class RouteMaterialPerformanceController extends Controller
{
    public function get_material_performance()
	{		
		return view('Report.route_material_performance_list');  
	}
	
	public function material_performance(Request $request)
	 {	
     if($request->month=='all')	
	  {
		  $get_data1 = DB::table('tbl_route_invoice_details')
			->leftJoin('tbl_material_master', 'tbl_route_invoice_details.material_code', '=', 'tbl_material_master.id')
		     ->select(DB::raw('sum(tbl_route_invoice_details.total) as total_invoice'),DB::raw('sum(tbl_route_invoice_details.base_qty) as qty'),'tbl_material_master.material_name as material_name','tbl_material_master.material_code')
			->orderBy(DB::raw('sum(tbl_route_invoice_details.total)'),'desc')
			->groupBy('tbl_route_invoice_details.material_code') 
			->whereYear('tbl_route_invoice_details.created_at', $request->year)
			->get()->all();
			
			//for chart
			 $get_data_chart = DB::table('tbl_route_invoice_details')
			->leftJoin('tbl_material_master', 'tbl_route_invoice_details.material_code', '=', 'tbl_material_master.id')
			->select('tbl_material_master.material_name as label',DB::raw('sum(tbl_route_invoice_details.total) as y'))
			->groupBy('label') 
			->limit(10)
			->whereYear('tbl_route_invoice_details.created_at', $request->year)
			->get()->all();
	  }
	  else
	  {
	     $get_data1 = DB::table('tbl_route_invoice_details')
			->leftJoin('tbl_material_master', 'tbl_route_invoice_details.material_code', '=', 'tbl_material_master.id')
		     ->select(DB::raw('sum(tbl_route_invoice_details.total) as total_invoice'),DB::raw('sum(tbl_route_invoice_details.base_qty) as qty'),'tbl_material_master.material_name as material_name','tbl_material_master.material_code')
			->orderBy(DB::raw('sum(tbl_route_invoice_details.total)'),'desc')
			->groupBy('tbl_route_invoice_details.material_code') 
			->whereYear('tbl_route_invoice_details.created_at', $request->year)
			->whereMonth('tbl_route_invoice_details.created_at', $request->month)
			->get()->all();
			
			//for chart
			 $get_data_chart = DB::table('tbl_route_invoice_details')
			->leftJoin('tbl_material_master', 'tbl_route_invoice_details.material_code', '=', 'tbl_material_master.id')
			->select('tbl_material_master.material_name as label',DB::raw('sum(tbl_route_invoice_details.total) as y'))
			->groupBy('label') 
			->limit(10)
			->whereYear('tbl_route_invoice_details.created_at',$request->year)
			->whereMonth('tbl_route_invoice_details.created_at', $request->month)
			->get()->all();
		}
		Session::put('year', $request->year);
		Session::put('month', $request->month);
		Session::put('get_data1', $get_data1);
		Session::put('get_data_chart', $get_data_chart);
	}
	public function material_performance_report_export($year,$month)
	 { 	 
	     
	   return Excel::download(new MaterialPerformanceExport($year,$month), 'material_performance_report.xlsx');		 
	 }
		
    public function material_performance_report_exportpdf($year,$month)
	 { 	
	   
	   return Excel::download(new MaterialPerformanceExport($year,$month), 'material_performance_report.pdf');		 
	 }
}
