<?php

namespace App\Http\Controllers;
use Illuminate\Http\Request;
use App\Models\SalesAreaModel;
use App\Models\CompanyModel;
use App\Models\ManageCodeModel;
use App\Models\RegionTypeModel;
use App\Models\SubRegionTypeModel;
use App\Models\WarehouseModel;
use Illuminate\Support\Facades\DB;
use Session;

class SalesAreaController extends Controller
 {
   public function list()
	{
		//$get_data = SalesAreaModel::all()->sortByDesc('id');
		$get_data = DB::table('tbl_sales_area')
		->leftJoin('tbl_region', 'tbl_sales_area.region_id', '=', 'tbl_region.id')
		->leftJoin('tbl_sub_region', 'tbl_sales_area.sub_region_id', '=', 'tbl_sub_region.id')
		->leftJoin('tbl_warehouse', 'tbl_sales_area.warehouse_id', '=', 'tbl_warehouse.id')
		->select('tbl_sales_area.*','tbl_region.region_code', 'tbl_region.region_name','tbl_sub_region.sub_region_name','tbl_sub_region.sub_region_code','tbl_warehouse.warehouse_name','tbl_warehouse.warehouse_code')
		->orderBy('id', 'DESC')->get();
		
		return view('Master_Configuration.sales_area_list',compact('get_data'));
	 }
    public function add()
	 {	
		$result =SalesAreaModel::get()->sortByDesc('id')->first();
		 if($result=='')
		   {
			 $getcode = ManageCodeModel::where('id', 1)->first();
			 $last_code = $getcode->sales_area_code;
	       }
		 else
		   {
			   $getcode = $result->sales_area_code; 
			   $last_code = ++$getcode;
		   }
	
				$region =RegionTypeModel::all()->sortByDesc('id')->where('status', '=', 'active');
				$subregion =SubRegionTypeModel::all()->sortByDesc('id')->where('status', '=', 'active');
				$warehouse =WarehouseModel::all()->sortByDesc('id')->where('status', '=', 'active')->where('warehouse_type', '=', 1);
				
			
				
			return view('Master_Configuration.sales_area',compact('region','subregion','last_code','warehouse'));
	 }
	
	public function edit($id)
	 {
		$get_data=SalesAreaModel::find($id);
		$get_data1=DB::table('tbl_warehouse')
		    ->leftJoin('tbl_sub_region', 'tbl_warehouse.sub_region', '=', 'tbl_sub_region.id')
		    ->leftJoin('tbl_region', 'tbl_warehouse.region', '=', 'tbl_region.id')
			->select('tbl_warehouse.sub_region','tbl_warehouse.region','tbl_sub_region.sub_region_code','tbl_sub_region.sub_region_name','tbl_region.region_code','tbl_region.region_name')
			->where('tbl_warehouse.status', '=', 'active')
			->where('tbl_warehouse.warehouse_type', '=', 1)
			->where('tbl_warehouse.id', '=', $get_data->warehouse_id)
			->get()->first();
			
		$warehouse =WarehouseModel::all()->sortByDesc('id')->where('status', '=', 'active')->where('warehouse_type', '=', 1);
		
		$last_code = $get_data->sales_area_code;
		
		return view('Master_Configuration.sales_area',compact('get_data','warehouse','last_code','get_data1'));
     }
    public function view($id)
     {    
		//$get_data=CompanyModel::find($id);
		$get_data = DB::table('tbl_sales_area')
		->leftJoin('tbl_region', 'tbl_sales_area.region_id', '=', 'tbl_region.id')
		->leftJoin('tbl_sub_region', 'tbl_sales_area.sub_region_id', '=', 'tbl_sub_region.id')
		->leftJoin('tbl_warehouse', 'tbl_sales_area.warehouse_id', '=', 'tbl_warehouse.id')
		->select('tbl_sales_area.*', 'tbl_region.region_code','tbl_region.region_name','tbl_sub_region.sub_region_code','tbl_sub_region.sub_region_name','tbl_warehouse.warehouse_code','tbl_warehouse.warehouse_name')
		->where('tbl_sales_area.id', '=', $id)
		->get()->first();
		// dd($get_data);
	
	    return view('Master_Configuration.sales_area_view',compact('get_data'));
     }
	
	public function save(Request $request)   
	 {   
//dd($request);
		 $data=new SalesAreaModel;
		
		 if($request->updated_id) 
		   {
			 $data = SalesAreaModel::find($request->updated_id);			
			 $data->sales_area_code=$request->sales_area_code;
			 $data->sales_area_name=$request->sales_area_name;
			 $data->warehouse_id=$request->warehouse;
			 $data->region_id=$request->region;
			 $data->sub_region_id=$request->sub_region;
			 
			 $data->company_id= Session::get('company_id');
			 $data->updated_user= Session::get('user_id');
			 $data->status=$request->status;
			//dd($data->region_id);
			 $data->save();
		
			 return redirect(route('sales_area_list'))->with('successMessage','Sales Area Updated Successfully');
		   } 
		 else 
		   {
				
			 $data->sales_area_code=$request->sales_area_code;
			 $data->sales_area_name=$request->sales_area_name;
			 $data->warehouse_id=$request->warehouse;
			 $data->region_id=$request->region;
			 $data->sub_region_id=$request->sub_region;
			 $data->company_id= Session::get('company_id');
			 $data->created_user= Session::get('user_id');
			 $data->status=$request->status;
			 $data->save();
		
		     return redirect(route('sales_area_list'))->with('successMessage','Sales Area Added Successfully');	
		
		  }	
	  }
	
	 public function get_region($id)
	  {
		$get_data=DB::table('tbl_warehouse')
		    ->leftJoin('tbl_region', 'tbl_warehouse.region', '=', 'tbl_region.id')
			->select('tbl_warehouse.region','tbl_region.region_code','tbl_region.region_name')
			->where('tbl_warehouse.status', '=', 'active')
			->where('tbl_warehouse.warehouse_type', '=', 1)
			->where('tbl_warehouse.id', '=', $id)
			->get()->first();
			
		  echo $get_data->region.'-'.$get_data->region_code.'-'.$get_data->region_name;
		}
	
	 public function get_sub_region($id)
	  {
		$get_data=DB::table('tbl_warehouse')
		    ->leftJoin('tbl_sub_region', 'tbl_warehouse.sub_region', '=', 'tbl_sub_region.id')
			->select('tbl_warehouse.sub_region','tbl_sub_region.sub_region_code','tbl_sub_region.sub_region_name')
			->where('tbl_warehouse.status', '=', 'active')
			->where('tbl_warehouse.warehouse_type', '=', 1)
			->where('tbl_warehouse.id', '=', $id)
			->get()->first();
		 
		 echo $get_data->sub_region.'-'.$get_data->sub_region_code.'-'.$get_data->sub_region_name;
		   
	  }
	
	
	
 }
