<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;
use App\Models\RegionTypeModel;
use App\Models\SubRegionTypeModel;
use App\Models\WarehouseModel;
use App\Models\RouteModel;
use App\Models\SalesmanModel;
use App\Models\MaterialMasterModel;
use Illuminate\Support\Facades\DB;
use Maatwebsite\Excel\Facades\Excel;
use App\Exports\SalesReportExport;
use PDF;

class SalesReportController extends Controller
 {
   public function list()
	{		
		$region =RegionTypeModel::all()->sortByDesc('id')->where('status', '=', 'active');
          foreach($region as $key=> $reg){

            $all_region[$key] = $reg->id; 
		 
	     }
     
         $regId=implode(",",$all_region);
		 $material =MaterialMasterModel::all()->sortByDesc('id')->where('status', '=', 'active');
	   
		return view('Report.sales_report_list',compact('region','material','regId'));  
	}
		
   public function get_sales_subregion($region)
	{
	  $data = explode(',',$region);
		

		$sub_region =SubRegionTypeModel::all()->sortByDesc('id')->whereIn('region_id',$data)->where('status', '=', 'active');
		 
		if(count($sub_region)>0){
			foreach($sub_region as $subreg){
				
				$all_subregion[] = $subreg->id;
			}
			$subregId=implode(",",$all_subregion);
		}else{

			$subregId = 0;
		}

		
		?>
		<option  value="">     </option>
		<?php if(count($sub_region) > 0){ ?>
			<option  value="0" data-value="<?php echo $subregId ?>">Select All</option>
		<?php } 
		foreach($sub_region as $sub_region_name)
		  {
			?>
			  <option value="<?php echo $sub_region_name->id ?>"  ><?php echo $sub_region_name->sub_region_code.' - '.$sub_region_name->sub_region_name  ?></option>	
		    <?php  	   	
		  }
	 }
			
	public function get_sales_warehouse($sub_region)
	 {
		$data = explode(',',$sub_region);
		$warehouse =WarehouseModel::all()->sortByDesc('id')->whereIn('sub_region',$data)->where('status', '=', 'active');
		
		if(count($warehouse)>0){
			foreach($warehouse as $subreg){
				
				$all_warehaouse[] = $subreg->id;
			}
			$allwarehaouse=implode(",",$all_warehaouse);
		}else{

			$allwarehaouse = 0;
		}

		
		?>
		<option  value="">     </option>
		<?php if(count($warehouse) > 0){ ?>
			<option  value="0" data-value="<?php echo $allwarehaouse ?>">Select All</option>
		<?php } 
		foreach($warehouse as $warehouse_name)
		  {
			?>
			  <option value="<?php echo $warehouse_name->id ?>"  ><?php echo $warehouse_name->warehouse_code.' - '.$warehouse_name->warehouse_name  ?></option>	
		   <?php  	 	   	
		  }
	  }
	 public function get_route_sales($warehouse)
	 {
		$data = explode(',',$warehouse);
		
		$route =RouteModel::all()->sortByDesc('id')->whereIn('warehouse_id',$data)->where('status', '=', 'active');
		
		if(count($route)>0){
			foreach($route as $routedata){
				
				$all_route[] = $routedata->id;
			}
			$allroute=implode(",",$all_route);
		}else{

			$allroute = 0;
		}

		
		?>
		<option  value="">     </option>
		<?php if(count($route) > 0){ ?>
			<option  value="0" data-value="<?php echo $allroute ?>">Select All</option>
		<?php } 
		foreach($route as $route_name)
		  {
			?>
			  <option value="<?php echo $route_name->id ?>"  ><?php echo $route_name->route_code.' - '.$route_name->route_name  ?></option>	
		   <?php 	 	   	
		  }
	
	 }
		
public function get_sales_report($report_with,$region,$subregion,$warehouse,$route,$fromdate,$todate)
 {
	
    if($route!='s')
	  {
	   if($report_with==1)
	    {
	     $final_data  = array();
	  
		  
			  $data1 = explode(',',$route);
			  $agent_name     = array(); 
			  $agent_id     = array(); 
			  $get_data1 = DB::table('tbl_route')
			  ->select('tbl_route.route_code','tbl_route.route_name','tbl_route.id')
			  ->where('tbl_route.status','=','active')
			  ->whereIn('tbl_route.id',$data1)->get();
	        foreach($get_data1 as $key=> $route)
		    {
			  $agent_name[$route->id] = $route->route_name;
			  $agent_id[]=$route->id;
		     }
				 		 
				$get_sales_material_wise = DB::select("SELECT  item.material_name,item.material_code as mat_code,item.id,route1.id as route_id ,
				SUM(d.base_qty) as base_quantity
				FROM `tbl_route_invoice_details` as d
				left join tbl_route_invoice_header
				as h on d.header_id=h.id 
				LEFT JOIN tbl_material_master as item on d.material_code=item.id
				LEFT JOIN tbl_route as route1 on h.route_id=route1.id
				WHERE date(h.created_at) >= '".$fromdate."' AND  date(h.created_at) <= '".$todate."' AND route1.id in (".implode(',',$agent_id).") group by item.id,route_id");
				
				//dd($get_sales_material_wise );
				
				 
				$count=count($get_sales_material_wise);	
								
	     foreach($get_sales_material_wise as $row) 
	     {
			$final_data['item'][$row->id]  = $row->mat_code.' - '.$row->material_name;
			$final_data['item_id1'][$row->id]  = $row->id;
			if(isset($final_data['base'][$row->route_id][$row->id]))
			  {
				$final_data['base'][$row->route_id][$row->id]   += $row->base_quantity;
			  }
		     else
		      {
		       $final_data['base'][$row->route_id][$row->id]   = $row->base_quantity;	
		      }
	       }
    
			$html = "<table style='width: 100%;' id='example' class='table table-hover table-striped table-bordered'>
			<thead class='bg-secondary text-white'> 	
			<tr style='height: 56px;color: white; background-color: #3f6ad8;'>
			<th style='width:60px !important;' class='text-justify font-weight-bold  text-center'>Material</th>";
			 $i=2;
			 
	    foreach($agent_name as $warehouse)
		{$i++;
		  $html .= "<th style='width:40px !important; background-color: #3f6ad8;'  class='text-justify font-weight-bold  text-center'> ".$warehouse."</th>";
		}
	    $html .= "<th style='width:60px !important;' class='text-justify font-weight-bold  text-center'>Total Sales</th>
         </tr>";
		$count=count($get_sales_material_wise);	
		 if($count<1)
			{
			$html .= "<tr style='background-color: #fff;'><td id='no_data' colspan='".$i."' style='color:red;'>No Data Found </td></tr>";
            }
		else
		 {
			$html .= "</thead>
			<tbody>";
			$total_base_sales  = array();
		   foreach($final_data['item'] as $item_id => $item_name) 
		   { 
				$html .= "<tr><td class='font-weight-bold  text-left'>".$item_name."</td>";
				$base_item_sales  = 0;
				foreach($agent_id as $name) 
				  {
				   if(!isset($total_base_sales[$name])) {
					$total_base_sales[$name] = 0;
				    }
				  $base_item_count = isset($final_data['base'][$name][$item_id]) ? $final_data['base'][$name][$item_id] : 0;
				  $total_base_sales[$name]    += $base_item_count;
				  $base_item_sales +=$base_item_count;
				  $model  = $base_item_count > 0  ? "modal" : "";
				  $data_target  = $base_item_count > 0  ? "#myModal_sales" : "";
				  $class= $base_item_count > 0  ? "material_wise_route_sales_modal" : "";
				  
                 $html .="<td data-toggle=".$model." data-target=".$data_target." class='font-weight-bold  text-right ".$class."' data-agent-id=".$name." data-material-id=".$item_id.">".$base_item_count."</td>";
                 }
			 $html .="<th class='font-weight-bold  text-right'>".$base_item_sales."</th></tr>";
			
	        }
			
		    $html .="<tfoot><tr style='height: 56px;background: #f5f2ec;'>
		  	<th style='width:25%;' class='font-weight-bold  text-left'>Total Sales </th>";
			$total_item_base_sales  = 0;
			foreach($agent_id as $name) 
		     {
			   $item_total_base_sales  = isset($total_base_sales[$name]) ? $total_base_sales[$name] : 0;
			   $total_item_base_sales  += $item_total_base_sales;
			   $model  = $item_total_base_sales > 0  ? "modal" : "";
			   $data_target= $item_total_base_sales > 0  ? "#myModal_sales" : "";
			    $class= $item_total_base_sales > 0  ? "route_quantity_modal" : "";
			    $html .="<th data-toggle=".$model." data-target=".$data_target." class='font-weight-bold  text-right ".$class."' data-agent-id=".$name.">".$item_total_base_sales."</th>";
			 }
		
		    $html .="<th class='font-weight-bold  text-right'>".$total_item_base_sales."</th>
              </tr> </tfoot> </tbody>";
		
	      }
	
     $html .=" </table>";
     $return['html'] = $html;
     echo json_encode($return);die;  
 } /* route with quantity closed */  
 
else{
	 $final_data  = array();
	  $data1 = explode(',',$route);
		  $agent_name     = array(); 
		  $agent_id     = array(); 
		  $get_data1 = DB::table('tbl_route')
		  ->select('tbl_route.route_code','tbl_route.route_name','tbl_route.id')		   
		   ->where('tbl_route.status','=','active')
		   ->whereIn('tbl_route.id',$data1)->get();
		 foreach($get_data1 as $key=> $route)
		  {
		   $agent_name[$route->id] = $route->route_name;
		   $agent_id[]=$route->id;
		  }
	     
		$get_sales_material_wise = DB::select("SELECT sum(d.total) as total,item.material_code as mat_code ,item.material_name,item.id,route1.id as route_id FROM `tbl_route_invoice_details` as d
		left join tbl_route_invoice_header as h on d.header_id=h.id 
		LEFT JOIN tbl_material_master as item on d.material_code=item.id
		LEFT JOIN tbl_route as route1 on h.route_id=route1.id
	    WHERE date(h.created_at) >= '".$fromdate."' AND  date(h.created_at) <= '".$todate."' AND route1.id in (".implode(',',$agent_id).") group by item.id,route_id");
		$count=count($get_sales_material_wise);
		
	    foreach($get_sales_material_wise as $row) 
		 {
		  $final_data['item'][$row->id]  = $row->mat_code.' - '.$row->material_name;
		  $final_data['sales'][$row->route_id][$row->id]  = $row->total;
		 }		
	  $html ="<table style='width: 100%;' id='example' class='table table-hover table-striped table-bordered'>
	  <thead class='bg-secondary text-white'> 	
	  <tr style='height: 56px; background-color: #3f6ad8;color: white;'>
	  <th style='width:60px;' class='text-justify font-weight-bold  text-center'>Material</th>";
	   $i=2;
	 foreach($agent_name as $route)
	  {
	   $i++;
	   $html .="<th style='height: 40px;' class='text-justify font-weight-bold  text-center'>".$route."</th>";
	  }
	  $html .="<th style='width:60;' class='text-justify font-weight-bold  text-center'>Total Sales</th>
	  </tr>";
	  $count=count($get_sales_material_wise);	
	  if($count<1)
		{
		 $html .="<tr style='background-color: #fff;'><td id='no_data' colspan=".$i." style='color:red;'>No Data Found </td></tr>";
        }
	 else
		{
		$html .="</thead><tbody>";
		$total_alter_sales = array();
		$total_base_sales  = array();
		foreach($final_data['item'] as $item_id => $item_name) 
		  {
		   $html .="<tr>
		   <td class='font-weight-bold  text-left'>".$item_name."</td>";
			$alter_item_sales = 0;
			$base_item_sales  = 0;
			foreach($agent_id as $name) 
			 {
			 if (!isset($total_alter_sales[$name])) {
				$total_alter_sales[$name] = 0;}
				$alter_item_count = isset($final_data['sales'][$name][$item_id]) ? $final_data['sales'][$name][$item_id] : 0;
				$alter_item_sales  +=$alter_item_count;
				$total_alter_sales[$name]+= $alter_item_count;
				$model  = $alter_item_count > 0  ? "modal" : "";
				$data_target  = $alter_item_count > 0  ? "#myModal_sales" : "";
				$class= $alter_item_count > 0  ? "material_wise_route_sales_modal" : "";
				  
                 $html .="<td data-toggle=".$model." data-target=".$data_target." class='font-weight-bold  text-right ".$class."' data-agent-id=".$name." data-material-id=".$item_id.">".number_format($alter_item_count,2)."</td>";
			}
			$html .="<th class='font-weight-bold  text-right'>".number_format($alter_item_sales,2)."</th></tr>";
		}
      $html .="<tfoot><tr style='height: 56px;background: #f5f2ec;'>
			 <th class='font-weight-bold  text-left'>Total Sales </th>";
			 $total_item_alter_sales = 0;
			 $total_item_base_sales  = 0;
			 foreach($agent_id as $name)
			  {
			  $item_total_alter_sales = isset($total_alter_sales[$name]) ? $total_alter_sales[$name] : 0;
			  $total_item_alter_sales += $item_total_alter_sales;
			  $model  = $item_total_alter_sales > 0  ? "modal" : "";
			  $data_target= $item_total_alter_sales > 0  ? "#myModal_sales" : "";
			  $class= $item_total_alter_sales > 0  ? "route_amount_modal" : "";
			  $html .="<th data-toggle=".$model." data-target=".$data_target." class='font-weight-bold  text-right ".$class."' data-agent-id=".$name.">".number_format($item_total_alter_sales,2)."</th>";
	        }
			$html .="<th class='font-weight-bold  text-right'>".number_format($total_item_alter_sales,2)."</th></tr>
			</tfoot> </tbody>";
			
	  }
   $html .="</table>";
   $return['html'] = $html;
   echo json_encode($return);die;
  }/* ROUTE with amount */
}/* ROUTE finished*/	
	
    else if($warehouse!='s')
	 {
	 if($report_with==1)
	  {
	  $final_data  = array();
		$data1 = explode(',',$warehouse);
		  $agent_name     = array(); 
		  $agent_id     = array(); 
	      $get_data1 = DB::table('tbl_warehouse')
		  ->select('tbl_warehouse.warehouse_code','tbl_warehouse.warehouse_name','tbl_warehouse.id')
		  ->where('tbl_warehouse.warehouse_type','=',1)
		  ->where('tbl_warehouse.status','=','active')
	    ->whereIn('tbl_warehouse.id',$data1)					
				->get();
	    foreach($get_data1 as $key=> $warehouse)
		{
		  $agent_name[$warehouse->id] = $warehouse->warehouse_name;
		  $agent_id[]=$warehouse->id;
		}
			  
	$get_sales_material_wise = DB::select("SELECT  item.material_name,item.material_code as mat_code,item.id,warehouse1.id as warehouse_id ,
	SUM(d.base_qty) as base_quantity
	FROM `tbl_route_invoice_details` as d
	left join tbl_route_invoice_header
	as h on d.header_id=h.id 
	LEFT JOIN tbl_material_master as item on d.material_code=item.id
	LEFT JOIN tbl_warehouse as warehouse1 on h.warehouse_id=warehouse1.id
	WHERE date(h.created_at) >= '".$fromdate."' AND  date(h.created_at) <= '".$todate."' AND warehouse1.id in (".implode(',',$agent_id).") group by item.id,warehouse_id");
     
	$count=count($get_sales_material_wise);	
								
	foreach($get_sales_material_wise as $row) 
	 {
		$final_data['item'][$row->id]  =$row->mat_code.' - '.$row->material_name;
	    $final_data['item_id1'][$row->id]  = $row->id;
		if(isset($final_data['base'][$row->warehouse_id][$row->id]))
		  {
			$final_data['base'][$row->warehouse_id][$row->id]   += $row->base_quantity;
		  }
		else
		  {
		  $final_data['base'][$row->warehouse_id][$row->id]   = $row->base_quantity;	
		  }
	 }
    
	$html = "<table style='width: 100%;' id='example' class='table table-hover table-striped table-bordered'>
	<thead class='bg-secondary text-white'> 	
	<tr style='height: 56px;color: white; background-color: #3f6ad8;'>
	<th style='width:20%;' class='text-justify font-weight-bold  text-center'>Material</th>";
	 $i=2;
	 foreach($agent_name as $warehouse)
		{$i++;
		$html .= "<th style='width:10%; background-color: #3f6ad8;'  class='text-justify font-weight-bold  text-center'> ".$warehouse."</th>";
		}
	  $html .= "<th style='width:20%;' class='text-justify font-weight-bold  text-center'>Total Sales</th>
       </tr>";
		$count=count($get_sales_material_wise);	
		 if($count<1)
			{
			$html .= "<tr style='background-color: #fff;'><td id='no_data' colspan='".$i."' style='color:red;'>No Data Found </td></tr>";
            }
			else
		    {
			$html .= "</thead>
			<tbody>";
			$total_base_sales  = array();
		   foreach($final_data['item'] as $item_id => $item_name) 
		   { 
				$html .= "<tr><td class='font-weight-bold  text-left'>".$item_name."</td>";
				$base_item_sales  = 0;
				foreach($agent_id as $name) 
				  {
				   if(!isset($total_base_sales[$name])) {
					$total_base_sales[$name] = 0;
				    }
				  $base_item_count = isset($final_data['base'][$name][$item_id]) ? $final_data['base'][$name][$item_id] : 0;
				  $total_base_sales[$name]    += $base_item_count;
				  $base_item_sales +=$base_item_count;
				  $model  = $base_item_count > 0  ? "modal" : "";
				  $data_target  = $base_item_count > 0  ? "#myModal_sales" : "";
				  $class= $base_item_count > 0  ? "material_wise_warehouse_sales_modal" : "";
				  
                 $html .="<td data-toggle=".$model." data-target=".$data_target." class='font-weight-bold  text-right ".$class."' data-agent-id=".$name." data-material-id=".$item_id.">".$base_item_count."</td>";
                 }
			 $html .="<th class='font-weight-bold  text-right'>".$base_item_sales."</th></tr>";
			
	        }
		$html .="<tfoot><tr style='height: 56px;background: #f5f2ec;'>
			<th style='width:25%;' class='font-weight-bold  text-left'>Total Sales </th>";
			$total_item_base_sales  = 0;
			foreach($agent_id as $name) 
		    {
			 $item_total_base_sales  = isset($total_base_sales[$name]) ? $total_base_sales[$name] : 0;
			 $total_item_base_sales  += $item_total_base_sales;
			 $model  = $item_total_base_sales > 0  ? "modal" : "";
			 $data_target= $item_total_base_sales > 0  ? "#myModal_sales" : "";
			 $class= $item_total_base_sales > 0  ? "warehouse_quantity_modal" : "";
			 $html .="<th data-toggle=".$model." data-target=".$data_target." class='font-weight-bold  text-right ".$class."' data-agent-id=".$name.">".$item_total_base_sales."</th>";
			 }
		
		$html .="<th class='font-weight-bold  text-right'>".$total_item_base_sales."</th>
        </tr> 
		</tfoot> 
		</tbody>";
		
	}
	
     $html .=" </table>";
     $return['html'] = $html;
     echo json_encode($return);die;  
 } /* warehouse with quantity closed */     
else{
	 $final_data  = array();
	 $data1 = explode(',',$warehouse);
		  $agent_name     = array(); 
		  $agent_id     = array(); 
		  $get_data1 = DB::table('tbl_warehouse')
		  ->select('tbl_warehouse.warehouse_code','tbl_warehouse.warehouse_name','tbl_warehouse.id')
		   ->where('tbl_warehouse.warehouse_type','=',1)
		   ->where('tbl_warehouse.status','=','active')
		  ->whereIn('tbl_warehouse.id',$data1)					
				->get();
		 foreach($get_data1 as $key=> $warehouse)
		  {
		   $agent_name[$warehouse->id] = $warehouse->warehouse_name;
		   $agent_id[]=$warehouse->id;
		  }
	     
		$get_sales_material_wise = DB::select("SELECT sum(d.total) as total,item.material_code as mat_code ,item.material_name,item.id,warehouse1.id as warehouse_id FROM `tbl_route_invoice_details` as d
		left join tbl_route_invoice_header as h on d.header_id=h.id 
		LEFT JOIN tbl_material_master as item on d.material_code=item.id
		LEFT JOIN tbl_warehouse as warehouse1 on h.warehouse_id=warehouse1.id
	    WHERE date(h.created_at) >= '".$fromdate."' AND  date(h.created_at) <= '".$todate."' AND warehouse1.id in (".implode(',',$agent_id).") group by item.id,warehouse_id");
		$count=count($get_sales_material_wise);
	    foreach($get_sales_material_wise as $row) 
		 {
		  $final_data['item'][$row->id]  = $row->mat_code.' - '.$row->material_name;
		  $final_data['sales'][$row->warehouse_id][$row->id]  = $row->total;
		 }		
	  $html ="<table style='width: 100%;' id='example' class='table table-hover table-striped table-bordered'>
	  <thead class='bg-secondary text-white'> 	
	  <tr style='height: 56px;background-color: #3f6ad8;color: white;'>
	  <th style='width:25%;' class='text-justify font-weight-bold  text-center'>Material</th>";
	   $i=2;
	 foreach($agent_name as $warehouse)
	  {
	   $i++;
	   $html .="<th style='width:10%;' class='text-justify font-weight-bold  text-center'>".$warehouse."</th>";
	  }
	  $html .="<th style='width:20%;' class='text-justify font-weight-bold  text-center'>Total Sales</th>
	  </tr>";
	  $count=count($get_sales_material_wise);	
	  if($count<1)
		{
		 $html .="<tr style='background-color: #fff;'><td id='no_data' colspan=".$i." style='color:red;'>No Data Found </td></tr>";
        }
	 else
		{
		$html .="</thead><tbody>";
		$total_alter_sales = array();
		$total_base_sales  = array();
		foreach($final_data['item'] as $item_id => $item_name) 
		  {
		   $html .="<tr>
		   <td class='font-weight-bold  text-left'>".$item_name."</td>";
			$alter_item_sales = 0;
			$base_item_sales  = 0;
			foreach($agent_id as $name) 
			 {
			 if (!isset($total_alter_sales[$name])) {
				$total_alter_sales[$name] = 0;}
				$alter_item_count = isset($final_data['sales'][$name][$item_id]) ? $final_data['sales'][$name][$item_id] : 0;
				$alter_item_sales  +=$alter_item_count;
				$total_alter_sales[$name]+= $alter_item_count;
				$model  = $alter_item_count > 0  ? "modal" : "";
				$data_target  = $alter_item_count > 0  ? "#myModal_sales" : "";
				$class= $alter_item_count > 0  ? "material_wise_warehouse_sales_modal" : "";
				  
                 $html .="<td data-toggle=".$model." data-target=".$data_target." class='font-weight-bold  text-right ".$class."' data-agent-id=".$name." data-material-id=".$item_id.">".number_format($alter_item_count,2)."</td>";
			}
			$html .="<th class='font-weight-bold  text-right'>".number_format($alter_item_sales,2)."</th></tr>";
		}
      $html .="<tfoot><tr style='height: 56px;background: #f5f2ec;'>
			 <th style='width:40px:' class='font-weight-bold  text-left'>Total Sales </th>";
			 $total_item_alter_sales = 0;
			 $total_item_base_sales  = 0;
			 foreach($agent_id as $name)
			  {
			  $item_total_alter_sales = isset($total_alter_sales[$name]) ? $total_alter_sales[$name] : 0;
			  $total_item_alter_sales += $item_total_alter_sales;
			  $model  = $item_total_alter_sales > 0  ? "modal" : "";
			  $data_target= $item_total_alter_sales > 0  ? "#myModal_sales" : "";
			  $class= $item_total_alter_sales > 0  ? "warehouse_modal" : "";
			  $html .="<th data-toggle=".$model." data-target=".$data_target." class='font-weight-bold  text-right ".$class."' data-agent-id=".$name.">".number_format($item_total_alter_sales,2)."</th>";
	        }
			$html .="<th class='font-weight-bold  text-right'>".number_format($total_item_alter_sales,2)."</th></tr>
			</tfoot> </tbody>";
	  }
   $html .="</table>";
   $return['html'] = $html;
   echo json_encode($return);die;
  }/* warehouse with amount */
}/* warehouse finished*/
else if($subregion!='s')
	 {
		if($report_with==1)
	      {
			$final_data  = array();
			 $data1 = explode(',',$subregion);
				$agent_name     = array(); 
				$agent_id     = array(); 
				$get_data1 = DB::table('tbl_sub_region')
				 
				->select('tbl_sub_region.sub_region_code','tbl_sub_region.sub_region_name','tbl_sub_region.id')
				 ->whereIn('tbl_sub_region.id',$data1)					
				->get();
				foreach($get_data1 as $key=> $sub_region)
				  {
					 $agent_name[$sub_region->id] = $sub_region->sub_region_name;
					 $agent_id[]=$sub_region->id;
				  }
			 	 
				 $get_sales_material_wise = DB::select("SELECT  item.material_name,item.material_code as mat_code ,item.id,sub_region_name.id as sub_region_id,
				 SUM(d.base_qty) as base_quantity
				 FROM `tbl_route_invoice_details` as d
				 left join tbl_route_invoice_header as h on d.header_id=h.id 
			    LEFT JOIN tbl_material_master as item on d.material_code=item.id
				LEFT JOIN tbl_warehouse as warehouse1 on h.warehouse_id=warehouse1.id
				LEFT JOIN tbl_sub_region as sub_region_name on warehouse1.sub_region=sub_region_name.id
				WHERE date(h.created_at) >= '".$fromdate."' AND  date(h.created_at) <= '".$todate."' AND sub_region_name.id in (".implode(',',$agent_id).") group by item.id,sub_region_id");
				$count=count($get_sales_material_wise);	
				
				foreach($get_sales_material_wise as $row) 
				 {
				  $final_data['item'][$row->id]  = $row->mat_code.' - '.$row->material_name;
					if(isset($final_data['base'][$row->sub_region_id][$row->id]))
					 {
					  $final_data['base'][$row->sub_region_id][$row->id]   += $row->base_quantity;
					 }
					else
					{
					 $final_data['base'][$row->sub_region_id][$row->id]   = $row->base_quantity;	
					}
			     }
              $html ="<table style='width: 100%;' id='example' class='table table-hover table-striped table-bordered'>
			  <thead class='bg-secondary text-white'> 	
			  <tr style='height: 56px;background-color: #3f6ad8;color: white;'>
			  <th style='width: 60px !importantpx;' class='text-justify font-weight-bold  text-center'>Material</th>";
			  $i=2;
		      foreach($agent_name as $warehouse)
				{
				  $i++;
				  $html .="<th style='width:40px !important;' class='text-justifyfont-weight-bold  text-center'>".$warehouse."</th>";
				}
				$html .="<th style='width: 60px !important;' class='text-justify font-weight-bold  text-center'>Total Sales</th>
						</tr>";
				$count=count($get_sales_material_wise);	
				if($count<1)
				 {
				  $html .="<tr style='background-color: #fff;'><td id='no_data' colspan='".$i."' style='color:red;'>No Data Found </td></tr>";
                 }
				else
				{
				  $html .="</thead><tbody>";
			      $total_alter_sales = array();
				  $total_base_sales  = array();
					foreach($final_data['item'] as $item_id => $item_name)
					{
					 $html .="<tr><td class='font-weight-bold  text-left'>".$item_name."</td>";
					 $alter_item_sales = 0;
					 $base_item_sales  = 0;
					  foreach($agent_id as $name) 
					   {
						 if (!isset($total_base_sales[$name])) {
							$total_base_sales[$name] = 0;}
							
							$base_item_count                = isset($final_data['base'][$name][$item_id]) ? $final_data['base'][$name][$item_id] : 0;
							$total_base_sales[$name]  += $base_item_count;
							$base_item_sales   +=$base_item_count;
							$model  = $base_item_count > 0  ? "modal" : "";
				            $data_target  = $base_item_count > 0  ? "#myModal_sales" : "";
				            $class= $base_item_count > 0  ? "material_wise_subregion_sales_modal" : "";
				  
                             $html .="<td data-toggle=".$model." data-target=".$data_target." class='font-weight-bold  text-right ".$class."' data-agent-id=".$name." data-material-id=".$item_id.">".$base_item_count."</td>";
					  }
					$html .="<th class='font-weight-bold  text-right'>".$base_item_sales."</th></tr>";
				 }
				$html .="<tfoot><tr style='height: 56px;background: #f5f2ec;'><th style='width:25%;' class='font-weight-bold  text-left'>Total Sales </th>";
				  $total_item_alter_sales = 0;
				  $total_item_base_sales  = 0;
				   foreach($agent_id as $name) 
				   {
					$item_total_base_sales  = isset($total_base_sales[$name]) ? $total_base_sales[$name] : 0;
					$total_item_base_sales  += $item_total_base_sales;
					$model  = $item_total_base_sales > 0  ? "modal" : "";
			        $data_target= $item_total_base_sales > 0  ? "#myModal_sales" : "";
			        $class= $item_total_base_sales > 0  ? "sub_region_quantity_modal" : "";
			        $html .="<th data-toggle=".$model." data-target=".$data_target." class='font-weight-bold  text-right ".$class."' data-agent-id=".$name.">".$item_total_base_sales."</th>";
				  }
				$html .="<th class='font-weight-bold  text-right'>".$total_item_base_sales."</th></tr> 
						</tfoot></tbody>";
				}
				$html .="<tfoot></tfoot></table>";
				$return['html'] = $html;
                echo json_encode($return);die;	
           }/* End report with quantity subregion */
	   else{
		    
			$final_data = array();
			 $data1 = explode(',',$subregion);
			  $agent_name     = array(); 
			  $agent_id     = array(); 
			  $get_data1 = DB::table('tbl_sub_region')
			  ->select('tbl_sub_region.sub_region_code','tbl_sub_region.sub_region_name','tbl_sub_region.id')
			  ->whereIn('tbl_sub_region.id',$data1)					
				->get();
			  foreach($get_data1 as $key=> $sub_region)
				{
				 $agent_name[$sub_region->id] = $sub_region->sub_region_name;
				 $agent_id[]=$sub_region->id;
				}
			 
				$get_sales_material_wise = DB::select("SELECT sum(d.total) as total, item.material_name,item.id,item.material_code as mat_code,sub_region_name.id as sub_region_id FROM `tbl_route_invoice_details` as d
				left join tbl_route_invoice_header as h on d.header_id=h.id 
				LEFT JOIN tbl_material_master as item on d.material_code=item.id
				LEFT JOIN tbl_warehouse as warehouse1 on h.warehouse_id=warehouse1.id
				LEFT JOIN tbl_sub_region as sub_region_name on warehouse1.sub_region=sub_region_name.id
				WHERE date(h.created_at) >= '".$fromdate."' AND  date(h.created_at) <= '".$todate."' AND sub_region_name.id in (".implode(',',$agent_id).") group by item.id,sub_region_id");
				$count=count($get_sales_material_wise);
				 foreach($get_sales_material_wise as $row) 
						{
						 $final_data['item'][$row->id]  =$row->mat_code.' - '.$row->material_name;
						  $final_data['sales'][$row->sub_region_id][$row->id]  = $row->total;
						}		
				$html ="<table style='width: 100%;' id='example' class='table table-hover table-striped table-bordered'><thead class='bg-secondary text-white'> 	
				<tr style='height: 56px;background-color: #3f6ad8; color: white;'>
				<th style='width: 25%;' class='text-justify font-weight-bold  text-center'>Material</th>";
				 $i=2;
				foreach($agent_name as $subregion)
					{$i++;
					  $html .="<th style='width: 15%;' class='text-justify font-weight-bold  text-center'>".$subregion."</th>";
					}
					$html .="<th style='width: 25%;' class='text-justify font-weight-bold  text-center'>Total Sales</th></tr>";
					
                    $count=count($get_sales_material_wise);	
					if($count<1)
					{
					 $html .="<tr style='background-color: #fff;'><td id='no_data' colspan='".$i."' style='color:red;'>No Data Found </td></tr>";
                    }
					else
					{
					  $html .="</thead><tbody>";
					  $total_alter_sales = array();
					  $total_base_sales  = array();
					 foreach($final_data['item'] as $item_id => $item_name) {
						$html .="<tr><td class='font-weight-bold  text-left'>".$item_name."</td>";
					    $alter_item_sales = 0;
						$base_item_sales  = 0;
						foreach($agent_id as $name) {
						  if (!isset($total_alter_sales[$name])) {
                                $total_alter_sales[$name] = 0;}
								$alter_item_count = isset($final_data['sales'][$name][$item_id]) ? $final_data['sales'][$name][$item_id] : 0;
								$alter_item_sales +=$alter_item_count;
								$total_alter_sales[$name]+= $alter_item_count;
								$model  = $alter_item_count > 0  ? "modal" : "";
				                $data_target  = $alter_item_count > 0  ? "#myModal_sales" : "";
				                $class= $alter_item_count > 0  ? "material_wise_subregion_sales_modal" : "";
				            $html .="<td data-toggle=".$model." data-target=".$data_target." class='font-weight-bold  text-right ".$class."' data-agent-id=".$name." data-material-id=".$item_id.">".number_format($alter_item_count,2)."</td>";
                            }
						$html .="<th class='font-weight-bold  text-right'>".number_format($alter_item_sales,2)."</th></tr>";
					}
					 $html .="<tfoot><tr style='height: 56px;background: #f5f2ec;'><th class='font-weight-bold  text-left'>Total Sales </th>";
					$total_item_alter_sales = 0;
					$total_item_base_sales  = 0;
					foreach($agent_id as $name)
						{
						 $item_total_alter_sales = isset($total_alter_sales[$name]) ? $total_alter_sales[$name] : 0;
						 $total_item_alter_sales += $item_total_alter_sales;
						 $model  = $item_total_alter_sales > 0  ? "modal" : "";
			             $data_target= $item_total_alter_sales > 0  ? "#myModal_sales" : "";
			             $class= $item_total_alter_sales > 0  ? "sub_region_modal" : "";
			             $html .="<th data-toggle=".$model." data-target=".$data_target." class='font-weight-bold  text-right ".$class."' data-agent-id=".$name.">".number_format($item_total_alter_sales,2)."</th>";
						}
						$html .="<th class='font-weight-bold  text-right'>".number_format($total_item_alter_sales,2)."</th></tr>
								</tfoot></tbody>";
					 }
					$html .="<tfoot></tfoot></table>";
					$return['html'] = $html;
                echo json_encode($return);die;
					
		 }/* END SUBREGION AMOUNT REPORT */
		}/* END SUBREGION SALES REPORT */
   else if($region!='s')
		 {
		  if($report_with==1)
		   {
			$final_data  = array();
			$final_data         = array();
			  $data1 = explode(',',$region);
			 $agent_name     = array(); 
			 $agent_id     = array(); 
			 $get_data1 = DB::table('tbl_region')
			  ->select('tbl_region.region_code','tbl_region.region_name','tbl_region.id')
			  ->whereIn('tbl_region.id',$data1)->get()->all();
			 foreach($get_data1 as $key=> $region)
			  {
				 $agent_name[$region->id] = $region->region_name;
				 $agent_id[]=$region->id;
		      }
			 
			 $get_sales_material_wise = DB::select("SELECT
				  SUM(d.base_qty) as base_quantity,
				  item.material_name,item.material_code as mat_code,item.id,region_name.id as region_id FROM `tbl_route_invoice_details` as d
				  left join tbl_route_invoice_header as h on d.header_id=h.id 
				  LEFT JOIN tbl_material_master as item on d.material_code=item.id
				  LEFT JOIN tbl_warehouse as warehouse1 on h.warehouse_id=warehouse1.id
				  LEFT JOIN tbl_region as region_name on warehouse1.region=region_name.id
				  WHERE date(h.created_at) >= '".$fromdate."' AND  date(h.created_at) <= '".$todate."' AND region_name.id in (".implode(',',$agent_id).") group by item.id,region_id");
				  
				 
				  $count=count($get_sales_material_wise);	
			 foreach($get_sales_material_wise as $row) 
				{
				  $final_data['item'][$row->id]  = $row->mat_code.' - '.$row->material_name;
				  if(isset($final_data['base'][$row->region_id][$row->id]))
					{
					  $final_data['base'][$row->region_id][$row->id]   += $row->base_quantity;
					}
				  else
					{
					  $final_data['base'][$row->region_id][$row->id]   = $row->base_quantity;	
					}
			   }
             $html ="<table style='width: 100%;' id='example' class='table table-hover table-striped table-bordered'>
			 <thead class='bg-secondary text-white'><tr style='height: 56px;
			  background-color: #3f6ad8;color: white;'>
			  <th style='width: 25%;' class='text-justify font-weight-bold  text-center'>Material</th>";
			  $i=2;
			foreach($agent_name as $warehouse)
		      {$i++;
			   $html .="<th style='width: 15%;' class='text-justify font-weight-bold  text-center'>".$warehouse."</th>";
			  }
			$html .="<th style='width: 25%;' class='text-justify font-weight-bold  text-center'>Total Material Sales</th></tr>";
			$count=count($get_sales_material_wise);	
			if($count<1)
				{
				$html .="<tr style='background-color: #fff;'><td id='no_data' colspan='".$i."' style='color:red;'>No Data Found </td></tr>";				  
			    }
			else
			   {
				$html .="</thead><tbody>";
				$total_base_sales  = array();
				foreach($final_data['item'] as $item_id => $item_name) {
					$html .="<tr><td class='font-weight-bold  text-left'>".$item_name."</td>";
					
					$base_item_sales  = 0;
					 foreach($agent_id as $name) {
					   if (!isset($total_base_sales[$name])) {
						$total_base_sales[$name] = 0;}
						$base_item_count= isset($final_data['base'][$name][$item_id]) ? $final_data['base'][$name][$item_id] : 0;
						$total_base_sales[$name]    += $base_item_count;
						$base_item_sales +=$base_item_count;
						$model  = $base_item_count > 0  ? "modal" : "";
				        $data_target  = $base_item_count > 0  ? "#myModal_sales" : "";
				        $class= $base_item_count > 0  ? "material_wise_region_sales_modal" : "";
				        $html .="<td data-toggle=".$model." data-target=".$data_target." class='font-weight-bold  text-right ".$class."' data-agent-id=".$name." data-material-id=".$item_id.">".$base_item_count."</td>";
                      }
					   $html .="<th class='font-weight-bold  text-right'>".$base_item_sales."</th></tr>";
					}
				 $html .="<tfoot><tr style='height: 56px;background: #f5f2ec;'>
						<th class='font-weight-bold  text-left'>Total Sales </th>";
						$total_item_base_sales  = 0;
						foreach($agent_id as $name) {
						 $item_total_base_sales  = isset($total_base_sales[$name]) ? $total_base_sales[$name] : 0;
						 $total_item_base_sales  += $item_total_base_sales;
						 $model  = $item_total_base_sales > 0  ? "modal" : "";
			             $data_target= $item_total_base_sales > 0  ? "#myModal_sales" : "";
			             $class= $item_total_base_sales > 0  ? "region_quantity_modal" : "";
			             $html .="<th data-toggle=".$model." data-target=".$data_target." class='font-weight-bold  text-right ".$class."' data-agent-id=".$name.">".$item_total_base_sales."</th>";
						}
					$html .="<th class='font-weight-bold  text-right'>".$total_item_base_sales."</th>
                             </tr></tfoot> </tbody>";
			}
				$html .="<tfoot></tfoot></table>";
				$return['html'] = $html;
                echo json_encode($return);die;
		} /* END REGION QAUNTITY REPORT */
		
   else{
		$final_data         = array();
		 $data1 = explode(',',$region);
		 $agent_name     = array(); 
		 $agent_id     = array(); 
		 $get_data1 = DB::table('tbl_region')
		->select('tbl_region.region_code','tbl_region.region_name','tbl_region.id')
		 ->whereIn('tbl_region.id',$data1)->get()->all(); 
		 foreach($get_data1 as $key=> $region)
		  {
		   $agent_name[$region->id] = $region->region_name;
		   $agent_id[]=$region->id;
		  }
		 
		 $get_sales_material_wise = DB::select("SELECT sum(d.total) as total, item.material_name,item.id,item.material_code as mat_code,region_name.id as region_id FROM `tbl_route_invoice_details` as d
		 left join tbl_route_invoice_header as h on d.header_id=h.id 
		 LEFT JOIN tbl_material_master as item on d.material_code=item.id
		 LEFT JOIN tbl_warehouse as warehouse1 on h.warehouse_id=warehouse1.id
		 LEFT JOIN tbl_region as region_name on warehouse1.region=region_name.id
		 WHERE date(h.created_at) >= '".$fromdate."' AND  date(h.created_at) <= '".$todate."' AND region_id in (".implode(',',$agent_id).") group by item.id,region_id");
		//dd($get_sales_material_wise);
		$count=count($get_sales_material_wise);	
		  foreach($get_sales_material_wise as $row) 
		   {
			$final_data['item'][$row->id]  = $row->mat_code.' - '.$row->material_name;
			$final_data['sales'][$row->region_id][$row->id]  = $row->total;
		   }
	   
			$html ="<table  id='example' class='table table-hover table-striped table-bordered'>
					<thead class='bg-secondary text-white'> 	
					<tr style='height: 56px;background-color: #3f6ad8;color: white;'>
					<th style='width: 25%;' class='text-justify font-weight-bold  text-center'>Material</th>";
				    $i=2;
			foreach($agent_name as $region)
				{
				  $i++;
				 $html .="<th style='width: 10%;' class='text-justify font-weight-bold  text-center'>".$region."</th>";
				}
				$html .="<th  style='width: 25%;' class='text-justify font-weight-bold  text-center'>Total Sales</th></tr>";
				 $count=count($get_sales_material_wise);	
				
				if($count<1)
					{
					 $html .="<tr style='background-color: #fff;'><td id='no_data' colspan='".$i."' style='color:red;'>No Data Found </td></tr>";
                    				  
					}
					else
					{
					 $html .="</thead><tbody>";
					  $total_alter_sales = array();
					  $total_base_sales  = array();
					  foreach($final_data['item'] as $item_id => $item_name) {
					  $html .="<tr><td class='font-weight-bold  text-left'>".$item_name."</td>";
					  $alter_item_sales = 0;
					  $base_item_sales  = 0;
					 
					 foreach($agent_id as $name) {
						 if (!isset($total_alter_sales[$name])) {
                              $total_alter_sales[$name] = 0;}
						   $alter_item_count = isset($final_data['sales'][$name][$item_id]) ? $final_data['sales'][$name][$item_id] : 0;
						   $alter_item_sales +=$alter_item_count;
						   $total_alter_sales[$name]+= $alter_item_count;
						   $model  = $alter_item_count > 0  ? "modal" : "";
				           $data_target  = $alter_item_count > 0  ? "#myModal_sales" : "";
				           $class= $alter_item_count > 0  ? "material_wise_region_sales_modal" : "";
				        $html .="<td data-toggle=".$model." data-target=".$data_target." class='font-weight-bold  text-right ".$class."' data-agent-id=".$name." data-material-id=".$item_id.">".number_format($alter_item_count,2)."</td>";
					}
					
                     $html .="<th class='font-weight-bold  text-right'>".number_format($alter_item_sales,2)."</th></tr>";
				}
				$html .="<tfoot><tr style=height: 56px;background: #f5f2ec;'>
				<th class='font-weight-bold  text-left'>Total Sales </th>";
				  $total_item_alter_sales = 0;
				  $total_item_base_sales  = 0;
				  
				   foreach($agent_id as $name)
					{
						$item_total_alter_sales = isset($total_alter_sales[$name]) ? $total_alter_sales[$name] : 0;
						$total_item_alter_sales += $item_total_alter_sales;
						$model  = $item_total_alter_sales > 0  ? "modal" : "";
			            $data_target= $item_total_alter_sales > 0  ? "#myModal_sales" : "";
			            $class= $item_total_alter_sales > 0  ? "region_modal" : "";
			            $html .="<th data-toggle=".$model." data-target=".$data_target." class='font-weight-bold  text-right ".$class."' data-agent-id=".$name.">".number_format($item_total_alter_sales,2)."</th>";
						}
					$html .="<th class='font-weight-bold  text-right'>".number_format($total_item_alter_sales,2)."</th>
                             </tr></tfoot> </tbody>";
							 
					}    
					
					$html .="</table>";
					$return['html'] = $html;
                    echo json_encode($return);die;
				}/* END REGION AMOUNT REPORT */
			} /* END REGION SALES REPORT */ 
		 
	 
}			
	//modal for region	
 public function get_return_sales_report_pop($fromdate, $todate, $region)
	 {
	  $agent_name     = array(); 
	  $agent_id     = array();
      $final_data = array();			 
	    $get_data1 = DB::table('tbl_region')
		->select('tbl_region.region_code','tbl_region.region_name','tbl_region.id')
		->where('tbl_region.id','=',$region)					
		->get()->all();
		$titlename =$get_data1[0]->region_code.' - '.$get_data1[0]->region_name;
			
		$get_sales_material_wise = DB::select("SELECT sum(d.total) as total, item.material_name,item.material_code as mat_code,item.id,region_name.id as region_id,DATE(h.created_at) as created_date FROM `tbl_route_invoice_details` as d
		left join tbl_route_invoice_header as h on d.header_id=h.id 
		LEFT JOIN tbl_material_master as item on d.material_code=item.id
		LEFT JOIN tbl_warehouse as warehouse1 on h.warehouse_id=warehouse1.id
		LEFT JOIN tbl_region as region_name on warehouse1.region=region_name.id
		WHERE date(h.created_at) >= '".$fromdate."' AND  date(h.created_at) <= '".$todate."' AND region_name.id=".$region." 
		group by item.id,region_id,DATE(h.created_at)
        ORDER BY DATE(h.created_at) DESC");
		foreach($get_sales_material_wise as $row) 
		  {
			$final_data['item'][$row->id]  = $row->mat_code.' - '.$row->material_name;
			$final_data['sales'][$row->created_date][$row->id]  = $row->total;
		  } 
		   $first_date     = date($fromdate);
		   $last_date      = date($todate);
		  $date1=date_create($fromdate);
           $date2=date_create($todate);

          $diff=date_diff($date1,$date2);
		  $colspan        =  $diff->format("%a");
		  $colspan = $colspan+3;
		 
		 $html ="<table style='width: 100%;' id='example' class='table table-hover table-striped table-bordered'>
		  <thead class='bg-secondary text-white'> 
           <tr><th style='height: 56px;background-color: #3f6ad8;color: white;' colspan=".$colspan." class='text-left'>".$titlename."</th>
		   </tr><tr style='height: 56px;background-color: #3f6ad8;color: white;'><th style='width: 20%;' class='text-justify font-weight-bold  text-center'>Material</th>";
			while($first_date <= $last_date) 
			{
			    $html .="<th class='font-weight-bold  text-center'>".date('d M y', strtotime($first_date))."</th>";
				$first_date = date('Y-m-d', strtotime($first_date . ' +1 day'));   
            }
		   $html .="<th style='width: 20%;' class='text-justify font-weight-bold  text-center'>Total Sales</th>
					</tr></thead><tbody>";
			$total_base_sales  = array();
			foreach($final_data['item'] as $item_id => $item_name)  
 				{
				  $total_item_alter   = 0;
				  $html .="<tr><td class='font-weight-bold  text-left'>".$item_name."</td>";
				  $first_date = date($fromdate);
				  $alter_item_sales = 0;
				  $base_item_sales  = 0;
				  
				  while($first_date <= $last_date)
					{
					  if (!isset($total_alter_sales[$first_date])) 
						{
                          $total_alter_sales[$first_date] = 0;
                        } 
						$alter_date_sale = isset($final_data['sales'][$first_date][$item_id]) ? $final_data['sales'][$first_date][$item_id] : 0;
						$total_item_alter   += $alter_date_sale; 
						$total_alter_sales[$first_date] += $alter_date_sale;
						
                      $html .="<td class='font-weight-bold  text-right'>".$alter_date_sale."</td>";
					  $first_date = date('Y-m-d', strtotime($first_date . ' +1 day'));
					}
					$html .="<th class='font-weight-bold  text-right'>".$total_item_alter."</th>
						</tr>";
				}
				$html .="<tbody><tfoot><tr><th class='font-weight-bold  text-left'>Total Sales</th>";
						$first_date     = date($fromdate);
						$total_sales_alter    = 0;
						$total_sales_base     = 0;
						while($first_date <= $last_date) 
						{
						   $total_sales_alter += $total_alter_sales[$first_date];
								$html .="<th class='font-weight-bold  text-right'>".number_format($total_alter_sales[$first_date],2)."</th>";
						        $first_date = date('Y-m-d', strtotime($first_date . ' +1 day'));
							}
                        $html .="<th class='font-weight-bold  text-right'>".number_format($total_sales_alter,2)."</th>
                    </tr><tfoot></table>";	
		 $return['html'] = $html;
         echo json_encode($return);die;

	}			
	
   //modal for subregion
   public function get_subregionreturn_sales_report_pop($fromdate, $todate, $subregion)
	{
		
	   $agent_name     = array(); 
		$agent_id     = array();
		$final_data = array();			 
		$get_data1 = DB::table('tbl_sub_region')
		->select('tbl_sub_region.sub_region_code','tbl_sub_region.sub_region_name','tbl_sub_region.id')
		->where('tbl_sub_region.id','=',$subregion)					
		->get()->all();
		$titlename =$get_data1[0]->sub_region_code.' - '.$get_data1[0]->sub_region_name;
		$get_sales_material_wise = DB::select("SELECT sum(d.total) as total, item.material_name,item.material_code as mat_code,item.id,subregion_name.id as region_id,DATE(h.created_at) as created_date FROM `tbl_route_invoice_details` as d
		 left join tbl_route_invoice_header as h on d.header_id=h.id 
		 LEFT JOIN tbl_warehouse as warehouse1 on h.warehouse_id=warehouse1.id
		 LEFT JOIN tbl_material_master as item on d.material_code=item.id
		 LEFT JOIN tbl_sub_region as subregion_name on warehouse1.sub_region=subregion_name.id
		WHERE date(h.created_at) >= '".$fromdate."' AND  date(h.created_at) <= '".$todate."' AND subregion_name.id=".$subregion." 
		group by item.id,region_id,DATE(h.created_at)
		ORDER BY DATE(h.created_at) DESC");
			
		foreach($get_sales_material_wise as $row) 
		  {
			$final_data['item'][$row->id]  = $row->mat_code.' - '.$row->material_name;
			$final_data['sales'][$row->created_date][$row->id]  = $row->total;
	      } 
		 $first_date     = date($fromdate);
		 $last_date      = date($todate);
		$date1=date_create($fromdate);
           $date2=date_create($todate);

          $diff=date_diff($date1,$date2);
		  $colspan        =  $diff->format("%a");
		  $colspan = $colspan+3;
		$html ="<table style='width: 100%;' id='example' class='table table-hover table-striped table-bordered'>
		<thead class='bg-secondary text-white'><tr><th style='height: 56px; background-color: #3f6ad8; color: white;' colspan=". $colspan." class='text-left'>".$titlename."</th></tr>
		<tr style='height: 56px; background-color: #3f6ad8; color: white;'>
		<th style='width: 20%;' class='text-justify font-weight-bold  text-center'>Material</th>";
		while($first_date <= $last_date)
		{
        $html .="<th class='font-weight-bold  text-center'>".date('d M y', strtotime($first_date))."</th>";
		$first_date = date('Y-m-d', strtotime($first_date . ' +1 day'));   
        }
		$html .="<th style='width: 20%;' class='text-justify font-weight-bold  text-center'>Total Sales</th></tr></thead>
				 <tbody>";
			$total_alter_sales = array();
			$total_base_sales  = array();
			foreach($final_data['item'] as $item_id => $item_name) 
			{
			$total_item_alter   = 0;
							
			$html .="<tr><td class='font-weight-bold  text-left'>".$item_name."</td>";
			 $first_date = date($fromdate);
			 $alter_item_sales = 0;
			 $base_item_sales  = 0;
			 
			  while($first_date <= $last_date) 
				{
				  if (!isset($total_alter_sales[$first_date])) 
					{
                      $total_alter_sales[$first_date] = 0;
                    }
				  $alter_date_sale = isset($final_data['sales'][$first_date][$item_id]) ? $final_data['sales'][$first_date][$item_id] : 0;
				  $total_item_alter   += $alter_date_sale; 
				  $total_alter_sales[$first_date] += $alter_date_sale;
                 $html .="<td class='font-weight-bold  text-right'>".number_format($alter_date_sale,2)."</td>";
				 $first_date = date('Y-m-d', strtotime($first_date . ' +1 day'));
									     
              }
			  $html .="<th class='font-weight-bold  text-right'>".number_format($total_item_alter,2)."</th>
						</tr>";
		   }
		$html .=" <tbody><tfoot><tr>
                 <th class='font-weight-bold  text-left'>Total Sales</th>";
				$first_date     = date($fromdate);
				$total_sales_alter    = 0;
				$total_sales_base     = 0;
				while($first_date <= $last_date) 
				{
					$total_sales_alter += $total_alter_sales[$first_date];
					 $html .="<th class='font-weight-bold  text-right'>".number_format($total_alter_sales[$first_date],2)."</th>
						       ";
					$first_date = date('Y-m-d', strtotime($first_date . ' +1 day'));
				}
                          
                     $html .="<th class='font-weight-bold  text-right'>". number_format($total_sales_alter,2)."</th></tr><tfoot>
			        </table>";	
         $return['html'] = $html;
         echo json_encode($return);die;					
	}	
		
       //modal for warehouse
   public function get_warehousereturn_sales_report_pop($fromdate, $todate, $warehous)
	{	
	 $agent_name     = array(); 
	 $agent_id     = array();
	 $final_data = array();			 
	$get_data1 = DB::table('tbl_warehouse')
    ->select('tbl_warehouse.warehouse_code','tbl_warehouse.warehouse_name','tbl_warehouse.id')
    ->where('tbl_warehouse.warehouse_type','=',1)	
	->where('tbl_warehouse.id','=',$warehous)					
	 ->get()->all();
	$titlename =$get_data1[0]->warehouse_code.' - '.$get_data1[0]->warehouse_name;
	$get_sales_material_wise = DB::select("SELECT sum(d.total) as total, item.material_name,item.id,item.material_code as mat_code,warehouse_name.id as region_id,DATE(h.created_at) as created_date FROM `tbl_route_invoice_details` as d
	left join tbl_route_invoice_header as h on d.header_id=h.id 
	LEFT JOIN tbl_material_master as item on d.material_code=item.id
    LEFT JOIN tbl_warehouse as warehouse_name on h.warehouse_id=warehouse_name.id
    WHERE date(h.created_at) >= '".$fromdate."' AND  date(h.created_at) <= '".$todate."' AND warehouse_name.id=".$warehous." 
	group by item.id,region_id,DATE(h.created_at)
	ORDER BY DATE(h.created_at) DESC");
								
	foreach($get_sales_material_wise as $row) 
	  {
		$final_data['item'][$row->id]  = $row->mat_code.' - '.$row->material_name;
		$final_data['sales'][$row->created_date][$row->id]  = $row->total;
	  } 
		
	  $first_date     = date($fromdate);
	  $last_date      = date($todate);
	$date1=date_create($fromdate);
           $date2=date_create($todate);

          $diff=date_diff($date1,$date2);
		  $colspan        =  $diff->format("%a");
		  $colspan = $colspan+3;
		 
		$html ="<table style='width: 100%;' id='example' class='table table-hover table-striped table-bordered'>
		<thead class='bg-secondary text-white'><tr><th style='height: 56px; background-color: #3f6ad8; color: white;' colspan=". $colspan." class='text-left'>".$titlename."</th></tr>
		<tr style='height: 56px; background-color: #3f6ad8; color: white;'>
		<th style='width: 20%;' class='text-justify font-weight-bold  text-center'>Material</th>";
		
		while($first_date <= $last_date)
		{
         $html .=" <th class='font-weight-bold  text-center'>".date('d M y', strtotime($first_date))."</th>";
		 $first_date = date('Y-m-d', strtotime($first_date . ' +1 day'));   
         }
		$html .="<th style='width: 20%;' class='text-justify font-weight-bold  text-center'>Total Sales</th>
			</tr></thead> <tbody>";
			$total_alter_sales = array();
			$total_base_sales  = array();
			foreach($final_data['item'] as $item_id => $item_name) 
			{
			     $total_item_alter   = 0;
						
				 $html .="<tr><td class='font-weight-bold  text-left'>".$item_name."</td>";
					
				$first_date = date($fromdate);
				$alter_item_sales = 0;
				$base_item_sales  = 0;
		      while($first_date <= $last_date) 
				 {
				  if (!isset($total_alter_sales[$first_date])) 
					{
                     $total_alter_sales[$first_date] = 0; }
					 $alter_date_sale = isset($final_data['sales'][$first_date][$item_id]) ? $final_data['sales'][$first_date][$item_id] : 0;
					 $total_item_alter   += $alter_date_sale; 
					 $total_alter_sales[$first_date] += $alter_date_sale;
      
				    $html .=" <td class='font-weight-bold  text-right'>" .number_format($alter_date_sale,2)."</td>";
					$first_date = date('Y-m-d', strtotime($first_date . ' +1 day'));
			     }
									
				$html .="<th class='font-weight-bold  text-right'>".number_format($total_item_alter,2)."</th></tr>";
										
			}
			$html .="<tbody><tfoot><tr><th class='font-weight-bold  text-left'>Total Sales</th>";
						
				$first_date     = date($fromdate);
				$total_sales_alter    = 0;
				$total_sales_base     = 0;
			 while($first_date <= $last_date) 
				{
				  $total_sales_alter += $total_alter_sales[$first_date];
						
					$html .="<th class='font-weight-bold  text-right'>".number_format($total_alter_sales[$first_date],2)."</th>";
					$first_date = date('Y-m-d', strtotime($first_date . ' +1 day'));
				}
             $html .="<th class='font-weight-bold  text-right'>".number_format($total_sales_alter,2)."</th>
                    </tr><tfoot></table>";
          $return['html'] = $html;
         echo json_encode($return);die;						
		
	 }
	/* END warehouse AMOUNT MODEL POPUP */

	   //modal for route
   public function get_routereturn_sales_report_pop($fromdate, $todate, $route)
	{
	
	 $agent_name     = array(); 
	 $agent_id     = array();
	 $final_data = array();	
	 
	$get_data1 = DB::table('tbl_route')
    ->select('tbl_route.route_code','tbl_route.route_name','tbl_route.id')	
	->where('tbl_route.id','=',$route)					
	->get()->all();
	$titlename =$get_data1[0]->route_code.' - '.$get_data1[0]->route_name;
	$get_sales_material_wise = DB::select("SELECT sum(d.total) as total, item.material_name,item.id,item.material_code as mat_code,route_name.id as region_id,DATE(h.created_at) as created_date FROM `tbl_route_invoice_details` as d
	left join tbl_route_invoice_header as h on d.header_id=h.id 
	LEFT JOIN tbl_material_master as item on d.material_code=item.id
    LEFT JOIN tbl_route as route_name on h.route_id=route_name.id
    WHERE date(h.created_at) >= '".$fromdate."' AND  date(h.created_at) <= '".$todate."' AND route_name.id=".$route." 
	group by item.id,region_id,DATE(h.created_at)
	ORDER BY DATE(h.created_at) DESC");
								
	foreach($get_sales_material_wise as $row) 
	  {
		$final_data['item'][$row->id]  = $row->mat_code.' - '.$row->material_name;
		$final_data['sales'][$row->created_date][$row->id]  = $row->total;
	  } 
		
	  $first_date     = date($fromdate);
	  $last_date      = date($todate);
	 $date1=date_create($fromdate);
           $date2=date_create($todate);

          $diff=date_diff($date1,$date2);
		  $colspan        =  $diff->format("%a");
		  $colspan = $colspan+3;
		 
		$html ="<table style='width: 100%;' id='example' class='table table-hover table-striped table-bordered'>
		<thead class='bg-secondary text-white'><tr><th style='height: 56px; background-color: #3f6ad8; color: white;' colspan=". $colspan." class='text-left'>". $titlename."</th></tr>
		<tr style='height: 56px; background-color: #3f6ad8; color: white;'>
		<th style='width: 20%;' class='text-justify font-weight-bold  text-center'>Material</th>";
		
		while($first_date <= $last_date)
		{
         $html .="<th class='font-weight-bold  text-center'>".date('d M y', strtotime($first_date))."</th>";
		 $first_date = date('Y-m-d', strtotime($first_date . ' +1 day'));   
         }
		$html .="<th style='width: 20%;' class='text-justify font-weight-bold  text-center'>Total Sales</th>
			</tr></thead> <tbody>";
			$total_alter_sales = array();
			$total_base_sales  = array();
			foreach($final_data['item'] as $item_id => $item_name) 
			{
			     $total_item_alter   = 0;
						
				 $html .="<tr><td class='font-weight-bold  text-left'>".$item_name."</td>";
					
				$first_date = date($fromdate);
				$alter_item_sales = 0;
				$base_item_sales  = 0;
		      while($first_date <= $last_date) 
				 {
				  if (!isset($total_alter_sales[$first_date])) 
					{
                     $total_alter_sales[$first_date] = 0; }
					 $alter_date_sale = isset($final_data['sales'][$first_date][$item_id]) ? $final_data['sales'][$first_date][$item_id] : 0;
					 $total_item_alter   += $alter_date_sale; 
					 $total_alter_sales[$first_date] += $alter_date_sale;
      
				    $html .="<td class='font-weight-bold  text-right'>".number_format($alter_date_sale,2)."</td>";
					$first_date = date('Y-m-d', strtotime($first_date . ' +1 day'));
			     }
									
				$html .="<th class='font-weight-bold  text-right'>".number_format($total_item_alter,2)."</th></tr>";
										
			}
			$html .="<tbody><tfoot><tr><th class='font-weight-bold  text-left'>Total Sales</th>";
						
				$first_date     = date($fromdate);
				$total_sales_alter    = 0;
				$total_sales_base     = 0;
			 while($first_date <= $last_date) 
				{
				  $total_sales_alter += $total_alter_sales[$first_date];
						
					$html .="<th class='font-weight-bold  text-right'>".number_format($total_alter_sales[$first_date],2)."</th>";
					$first_date = date('Y-m-d', strtotime($first_date . ' +1 day'));
				}
             $html .="<th class='font-weight-bold  text-right'>".number_format($total_sales_alter,2)."</th>
                    </tr><tfoot></table>";
          $return['html'] = $html;
         echo json_encode($return);die;						
		
	 }
	/* END ROUTE AMOUNT MODEL POPUP */
	
    public function get_regionreturn_quntity_sales_report_pop($fromdate, $todate, $region)
	 {
 
       $baseuom_id     = array(); 
	   $altuom_id     = array(); 
	   $get_data1 = DB::table('tbl_unit_of_measurement')
	   ->select('tbl_unit_of_measurement.id',)
	   ->where('tbl_unit_of_measurement.uom_type','=',1)->get();
		foreach($get_data1 as $key=> $warehous)
		  {
			$baseuom_id[]=$warehous->id;
		  }
		$get_data1 = DB::table('tbl_unit_of_measurement')
	   ->select('tbl_unit_of_measurement.id',)
	  ->where('tbl_unit_of_measurement.uom_type','=',2)->get();
	   foreach($get_data1 as $key=> $warehous)
		{
		  $altuom_id[]=$warehous->id;
		}    
            
	     $agent_name     = array(); 
		 $agent_id     = array();
         $final_data = array();			 
	     $get_data1 = DB::table('tbl_region')
		->select('tbl_region.region_code','tbl_region.region_name','tbl_region.id')
		->where('tbl_region.id','=',$region)					
		->get()->all();
				
		$titlename =$get_data1[0]->region_code.' - '.$get_data1[0]->region_name;
			
		$get_sales_material_wise = DB::select("SELECT sum(d.total) as total, item.material_name,item.material_code as mat_code,item.id,region_name.id as region_id,DATE(h.created_at) as created_date,
        SUM(d.base_qty) as base_quantity
	    FROM `tbl_route_invoice_details` as d
	    left join tbl_route_invoice_header as h on d.header_id=h.id 
		LEFT JOIN tbl_material_master as item on d.material_code=item.id
		LEFT JOIN tbl_warehouse as warehouse1 on h.warehouse_id=warehouse1.id
	    LEFT JOIN tbl_region as region_name on warehouse1.region=region_name.id
		WHERE date(h.created_at) >= '".$fromdate."' AND  date(h.created_at) <= '".$todate."' AND region_name.id=".$region." 
	    group by item.id,region_id,DATE(h.created_at)
        ORDER BY DATE(h.created_at) DESC");
		foreach($get_sales_material_wise as $row) 
			{
			  $final_data['item'][$row->id]  = $row->mat_code.' - '.$row->material_name;
			   if(isset($final_data['base'][$row->region_id][$row->id]))
				{
				  $final_data['base'][$row->created_date][$row->id]   += $row->base_quantity;
				}
			  else
				{
				$final_data['base'][$row->created_date][$row->id]   = $row->base_quantity;	
				}
			  } 
			 
		$first_date     = date($fromdate);
		$last_date      = date($todate);
		$date1=date_create($fromdate);
           $date2=date_create($todate);

          $diff=date_diff($date1,$date2);
		  $colspan        =  $diff->format("%a");
		  $colspan = $colspan+3;
		  
		  $html ="<table style='width: 100%;' id='example' class='table table-hover table-striped table-bordered'>
		<thead class='bg-secondary text-white'><tr><th style='height: 56px; background-color: #3f6ad8; color: white;' colspan=". $colspan." class='text-left'>".$titlename."</th></tr>
		<tr style='height: 56px; background-color: #3f6ad8; color: white;'>
		<th style='width: 20%;' class='text-justify text-center'>Material</th>";
		while($first_date <= $last_date) 
		  {
			 $html .="<th class='text-justify text-center'>".date('d M y', strtotime($first_date))."</th>";
					$first_date = date('Y-m-d', strtotime($first_date . ' +1 day'));   
          }
				
		$html .="<th style='width: 20%;' class='text-justify text-center'>Total Material Sales</th>
			</tr></thead> <tbody>";
		    $total_alter_sales = array();
			$total_base_sales  = array();
			foreach($final_data['item'] as $item_id => $item_name) 
			  {
				$total_item_alter   = 0;
				$html .="<tr><td class='font-weight-bold  text-left'>".$item_name."</td>";
			    $first_date = date($fromdate);
				$base_item_sales  = 0;
			  while($first_date <= $last_date)
				 {
					if (!isset($total_base_sales[$first_date])) {
					   $total_base_sales[$first_date] = 0;
					  }
				   $base_item_count = isset($final_data['base'][$first_date][$item_id]) ? $final_data['base'][$first_date][$item_id] : 0;
				   $total_base_sales[$first_date]    += $base_item_count;
				   $base_item_sales +=$base_item_count;
                
				$html .=" <td class='font-weight-bold  text-right'>" .$base_item_count."</td>";
				
						$first_date = date('Y-m-d', strtotime($first_date . ' +1 day'));
			     }
				$html .="<th class='font-weight-bold  text-right'>".$base_item_sales."</th></tr>";
			}
					
		$html .="<tbody><tfoot><tr><th class='font-weight-bold text-left'>Total Sales</th>";
					$first_date     = date($fromdate);
					$total_item_base_sales     = 0;
					while($first_date <= $last_date) 
						{
						$item_total_base_sales  = isset($total_base_sales[$first_date]) ? $total_base_sales[$first_date] : 0;
						$total_item_base_sales  += $item_total_base_sales;
						$html .="<th class='font-weight-bold  text-right'>". $item_total_base_sales."</th>";
							$first_date = date('Y-m-d', strtotime($first_date . ' +1 day'));
						}
                      	
                        $html .="<th class='font-weight-bold  text-right'>". $total_item_base_sales."</th>
                     </tr><tfoot></table>";					  
		 $return['html'] = $html;
         echo json_encode($return);die;	
		
	 }	

    public function get_subregionreturn_quantity_sales_report_pop($fromdate, $todate, $subregion)
	 {
		
	   $agent_name     = array(); 
	   $agent_id     = array();
       $final_data = array();			 
	   $get_data1 = DB::table('tbl_sub_region')
	  ->select('tbl_sub_region.sub_region_code','tbl_sub_region.sub_region_name','tbl_sub_region.id')
	  ->where('tbl_sub_region.id','=',$subregion)					
	  ->get()->all();
			 
	   $titlename =$get_data1[0]->sub_region_code.' - '.$get_data1[0]->sub_region_name;
			
			 $get_sales_material_wise = DB::select("SELECT 
			 SUM(d.base_qty) as base_quantity,
			 item.material_name,item.id,item.material_code as mat_code,subregion_name.id as region_id,DATE(h.created_at) as created_date 
			 FROM `tbl_route_invoice_details` as d
			 left join tbl_route_invoice_header as h on d.header_id=h.id 
			 LEFT JOIN tbl_material_master as item on d.material_code=item.id
			 LEFT JOIN tbl_warehouse as warehouse1 on h.warehouse_id=warehouse1.id
			 LEFT JOIN tbl_sub_region as subregion_name on warehouse1.sub_region=subregion_name.id
             WHERE date(h.created_at) >= '".$fromdate."' AND  date(h.created_at) <= '".$todate."' AND subregion_name.id=".$subregion." 
			 group by item.id,region_id,DATE(h.created_at)
             ORDER BY DATE(h.created_at) DESC");
			foreach($get_sales_material_wise as $row) 
			  {
				 $final_data['item'][$row->id]  = $row->mat_code.' - '.$row->material_name;
				 if(isset($final_data['base'][$row->region_id][$row->id]))
					{
					$final_data['base'][$row->created_date][$row->id]   += $row->base_quantity;
					}
					else
					{
					 $final_data['base'][$row->created_date][$row->id]   = $row->base_quantity;	
				    }
			   } 
			$first_date     = date($fromdate);
			 $last_date      = date($todate);
			$date1=date_create($fromdate);
           $date2=date_create($todate);

          $diff=date_diff($date1,$date2);
		  $colspan        =  $diff->format("%a");
		  $colspan = $colspan+3;
		     
		   $html ="<table style='width: 100%;' id='example' class='table table-hover table-striped table-bordered'>
		   <thead class='bg-secondary text-white'><tr><th style='height: 56px; background-color: #3f6ad8; color: white;' colspan=". $colspan." class='text-left'>".$titlename."</th></tr>
		   <tr style='height: 56px; background-color: #3f6ad8; color: white;'>
		   <th style='width: 20%;' class='text-justify text-center'>Material</th>";
			
			while($first_date <= $last_date) 
				{
                   $html .="<th class='text-justify text-center'>". date('d M y', strtotime($first_date))."</th>";
					$first_date = date('Y-m-d', strtotime($first_date . ' +1 day'));   
                }
			$html .="<th style='width: 20%;' class='text-justify text-center'>Total Material Sales</th></tr>
					 </thead><tbody>";
					$total_base_sales  = array();
					foreach($final_data['item'] as $item_id => $item_name) 
					  {
						$total_item_alter   = 0;
						$html .="<tr><td class='font-weight-bold  text-left'>".$item_name."</td>";
								
							$first_date = date($fromdate);
							$alter_item_sales = 0;
							$base_item_sales  = 0;
							while($first_date <= $last_date)
							 {
							   if (!isset($total_base_sales[$first_date])) {
								$total_base_sales[$first_date] = 0;
							 }
							 $base_item_count = isset($final_data['base'][$first_date][$item_id]) ? $final_data['base'][$first_date][$item_id] : 0;
							$total_base_sales[$first_date]    += $base_item_count;
							$base_item_sales +=$base_item_count;
	                     $html .="<td class='font-weight-bold  text-right'>".$base_item_count."</td>";
					                    
							$first_date = date('Y-m-d', strtotime($first_date . ' +1 day'));
									     
                          }
										
					$html .="<th class='font-weight-bold  text-right'>". $base_item_sales."</th></tr>";
								   
				   }
				$html .="<tbody><tfoot><tr><th class='font-weight-bold text-left'>Total Sales</th>";
				   $first_date     = date($fromdate);
					$total_item_base_sales     = 0;
					while($first_date <= $last_date) 
						{
						$item_total_base_sales  = isset($total_base_sales[$first_date]) ? $total_base_sales[$first_date] : 0;
						$total_item_base_sales  += $item_total_base_sales;
							
						$html .="<th class='font-weight-bold  text-right'>".$item_total_base_sales."</th>";
						$first_date = date('Y-m-d', strtotime($first_date . ' +1 day'));
						}
                       
                       $html .="<th class='font-weight-bold  text-right'>". $total_item_base_sales."</th>
                    </tr><tfoot></table>";		
		   $return['html'] = $html;
           echo json_encode($return);die;	

	 }		
	
	
	public function get_routereturn_quantity_sales_report_pop($fromdate, $todate, $route)
	 {
		$agent_name     = array(); 
		$agent_id     = array();
        $final_data = array();			 
	    $get_data1 = DB::table('tbl_route')
	    ->select('tbl_route.route_code','tbl_route.route_name','tbl_route.id')					
	   ->where('tbl_route.id','=',$route)					
	   ->get()->all();
				
		$titlename =$get_data1[0]->route_code.' - '.$get_data1[0]->route_name;
			
			 $get_sales_material_wise = DB::select("SELECT 
			 SUM(d.base_qty) as base_quantity,
			 item.material_name,item.id,item.material_code as mat_code,route_name.id as region_id,DATE(h.created_at) as created_date FROM `tbl_route_invoice_details` as d
			 left join tbl_route_invoice_header as h on d.header_id=h.id 
			 LEFT JOIN tbl_material_master as item on d.material_code=item.id
			 LEFT JOIN tbl_route as route_name on h.route_id=route_name.id
			 WHERE date(h.created_at) >= '".$fromdate."' AND  date(h.created_at) <= '".$todate."' AND route_name.id=".$route." 
			 group by item.id,region_id,DATE(h.created_at)
			 ORDER BY DATE(h.created_at) DESC");
							
			 foreach($get_sales_material_wise as $row) 
			   {
				$final_data['item'][$row->id]  = $row->mat_code.' - '.$row->material_name;
				  if(isset($final_data['alter'][$row->region_id][$row->id]))
					{
					   $final_data['base'][$row->created_date][$row->id]   += $row->base_quantity;
					}
				  else
					{
					 $final_data['base'][$row->created_date][$row->id]   = $row->base_quantity;	
				    }
			   } 
			
			 $first_date     = date($fromdate);
			 $last_date      = date($todate);
			$date1=date_create($fromdate);
            $date2=date_create($todate);

            $diff=date_diff($date1,$date2);
		    $colspan        =  $diff->format("%a");
		    $colspan = $colspan+3;
		    
		
			 $html ="<table style='width: 100%;' id='example' class='table table-hover table-striped table-bordered'>
		     <thead class='bg-secondary text-white'><tr><th style='height: 56px; background-color: #3f6ad8; color: white;' colspan=". $colspan." class='text-left'>".$titlename."</th></tr>
		    <tr style='height: 56px; background-color: #3f6ad8; color: white;'>
		    <th style='width: 20%;' class='text-justify text-center'>Material</th>";
			while($first_date <= $last_date)
				{
                 $html .="<th class='text-justify text-center'>".date('d M y', strtotime($first_date))."</th>";
				 $first_date = date('Y-m-d', strtotime($first_date . ' +1 day'));   
                }
				$html .="<th style='width: 20%;' class='text-justify text-center'>Total Material Sales</th>
						</tr>
					</thead>
				    <tbody>";
				 $total_alter_sales = array();
				 $total_base_sales  = array();
				 foreach($final_data['item'] as $item_id => $item_name) 
					 {
					  $total_item_alter   = 0;
					  $html .="<tr><td class='font-weight-bold  text-left'>".$item_name."</td>";
					  $first_date = date($fromdate);
					  $alter_item_sales = 0;
					  $base_item_sales  = 0;
					  while($first_date <= $last_date)
						 {
						   if (!isset($total_base_sales[$first_date])) {
							$total_base_sales[$first_date] = 0;}
							$base_item_count = isset($final_data['base'][$first_date][$item_id]) ? $final_data['base'][$first_date][$item_id] : 0;
							$total_base_sales[$first_date]    += $base_item_count;
							$base_item_sales +=$base_item_count;
                            $html .="<td class='font-weight-bold  text-right'>".$base_item_count."</td>";
							  $first_date = date('Y-m-d', strtotime($first_date . ' +1 day'));
						 }
					$html .="<th class='font-weight-bold  text-right'>".$base_item_sales."</th></tr>";
								 
				  }
					$html .="<tbody><tfoot><tr><th class='font-weight-bold text-left'>Total Sales</th>";
						
						$first_date     = date($fromdate);
						$total_item_alter_sales    = 0;
						$total_item_base_sales     = 0;
					    while($first_date <= $last_date) 
							{
							$item_total_alter_sales = isset($total_alter_sales[$first_date]) ? $total_alter_sales[$first_date] : 0;
							$item_total_base_sales  = isset($total_base_sales[$first_date]) ? $total_base_sales[$first_date] : 0;
							$total_item_base_sales  += $item_total_base_sales;
							
							$html .="<th class='font-weight-bold  text-right'>". $item_total_base_sales."</th>";
							$first_date = date('Y-m-d', strtotime($first_date . ' +1 day'));
							}
                        $html .="<th class='font-weight-bold  text-right'>".$total_item_base_sales."</th></tr>";
					
					 $html .="<tfoot></table>";		
		      $return['html'] = $html;
              echo json_encode($return);die;	

	  }
	  
	public function get_warehousereturn_quantity_sales_report_pop($fromdate, $todate, $warehous)
	 {
		$agent_name     = array(); 
		$agent_id     = array();
        $final_data = array();			 
	    $get_data1 = DB::table('tbl_warehouse')
	    ->select('tbl_warehouse.warehouse_code','tbl_warehouse.warehouse_name','tbl_warehouse.id')
	    ->where('tbl_warehouse.warehouse_type','=',1)					
	   ->where('tbl_warehouse.id','=',$warehous)					
	   ->get()->all();
				
		$titlename =$get_data1[0]->warehouse_code.' - '.$get_data1[0]->warehouse_name;
			
			 $get_sales_material_wise = DB::select("SELECT 
			 SUM(d.base_qty) as base_quantity,
			 item.material_name,item.id,item.material_code as mat_code,warehouse_name.id as region_id,DATE(h.created_at) as created_date FROM `tbl_route_invoice_details` as d
			 left join tbl_route_invoice_header as h on d.header_id=h.id 
			 LEFT JOIN tbl_material_master as item on d.material_code=item.id
			 LEFT JOIN tbl_warehouse as warehouse_name on h.warehouse_id=warehouse_name.id
			 WHERE date(h.created_at) >= '".$fromdate."' AND  date(h.created_at) <= '".$todate."' AND warehouse_name.id=".$warehous." 
			 group by item.id,region_id,DATE(h.created_at)
			 ORDER BY DATE(h.created_at) DESC");
							
			 foreach($get_sales_material_wise as $row) 
			   {
				$final_data['item'][$row->id]  = $row->mat_code.' - '.$row->material_name;
				  if(isset($final_data['alter'][$row->region_id][$row->id]))
					{
					   $final_data['base'][$row->created_date][$row->id]   += $row->base_quantity;
					}
				  else
					{
					 $final_data['base'][$row->created_date][$row->id]   = $row->base_quantity;	
				    }
			   } 
			
			 $first_date     = date($fromdate);
			 $last_date      = date($todate);
			 $date1=date_create($fromdate);
             $date2=date_create($todate);

             $diff=date_diff($date1,$date2);
		     $colspan        =  $diff->format("%a");
		     $colspan = $colspan+3;
		    
		
			 $html ="<table style='width: 100%;' id='example' class='table table-hover table-striped table-bordered'>
		     <thead class='bg-secondary text-white'><tr><th style='height: 56px; background-color: #3f6ad8; color: white;' colspan=". $colspan." class='text-left'>".$titlename."</th></tr>
		    <tr style='height: 56px; background-color: #3f6ad8; color: white;'>
		    <th style='width: 20%;' class='text-justify text-center'>Material</th>";
			while($first_date <= $last_date)
				{
                 $html .="<th class='text-justify text-center'>".date('d M y', strtotime($first_date))."</th>";
				 $first_date = date('Y-m-d', strtotime($first_date . ' +1 day'));   
                }
				$html .="<th style='width: 20%;' class='text-justify text-center'>Total Material Sales</th>
						</tr>
					</thead>
				    <tbody>";
				 $total_alter_sales = array();
				 $total_base_sales  = array();
				 foreach($final_data['item'] as $item_id => $item_name) 
					 {
					  $total_item_alter   = 0;
					  $html .="<tr><td class='font-weight-bold  text-left'>".$item_name."</td>";
					  $first_date = date($fromdate);
					  $alter_item_sales = 0;
					  $base_item_sales  = 0;
					  while($first_date <= $last_date)
						 {
						   if (!isset($total_base_sales[$first_date])) {
							$total_base_sales[$first_date] = 0;}
							$base_item_count = isset($final_data['base'][$first_date][$item_id]) ? $final_data['base'][$first_date][$item_id] : 0;
							$total_base_sales[$first_date]    += $base_item_count;
							$base_item_sales +=$base_item_count;
                            $html .="<td class='font-weight-bold  text-right'>".$base_item_count."</td>";
							  $first_date = date('Y-m-d', strtotime($first_date . ' +1 day'));
						 }
					$html .="<th class='font-weight-bold  text-right'>".$base_item_sales."</th></tr>";
								 
				  }
					$html .="<tbody><tfoot><tr><th class='font-weight-bold text-left'>Total Sales</th>";
						
						$first_date     = date($fromdate);
						$total_item_alter_sales    = 0;
						$total_item_base_sales     = 0;
					    while($first_date <= $last_date) 
							{
							$item_total_alter_sales = isset($total_alter_sales[$first_date]) ? $total_alter_sales[$first_date] : 0;
							$item_total_base_sales  = isset($total_base_sales[$first_date]) ? $total_base_sales[$first_date] : 0;
							$total_item_base_sales  += $item_total_base_sales;
							
							$html .="<th class='font-weight-bold  text-right'>". $item_total_base_sales."</th>";
							$first_date = date('Y-m-d', strtotime($first_date . ' +1 day'));
							}
                        $html .="<th class='font-weight-bold  text-right'>".$total_item_base_sales."</th></tr>";
					
					 $html .="<tfoot></table>";		
		      $return['html'] = $html;
              echo json_encode($return);die;	

	  } 
	  
	  public function get_route_materialwise_quntity_sales_report_pop($fromdate, $todate, $warehous,$material,$report_selction,$slug)
	 {
	   $agent_name     = array(); 
	   $agent_id     = array();
       $final_data = array();
	   if($report_selction=='1')
	     { 
	      if($slug=='route')
		    { 
			 $get_data1 = DB::table('tbl_route')
	         ->select('tbl_route.route_code','tbl_route.route_name','tbl_route.id')					
	         ->where('tbl_route.id','=',$warehous)					
	         ->get()->all();
				
		     $titlename =$get_data1[0]->route_code.' - '.$get_data1[0]->route_name;
			
			 $get_sales_material_wise = DB::select("SELECT 
			 SUM(d.base_qty) as base_quantity,
			 item.material_name,item.id,item.material_code as mat_code,route_name.id as route_id,DATE(h.created_at) as created_date FROM `tbl_route_invoice_details` as d
			 left join tbl_route_invoice_header as h on d.header_id=h.id 
			 LEFT JOIN tbl_material_master as item on d.material_code=item.id
			 LEFT JOIN tbl_route as route_name on h.route_id=route_name.id
			 WHERE date(h.created_at) >= '".$fromdate."' AND  date(h.created_at) <= '".$todate."' AND route_name.id=".$warehous." AND item.id=".$material."
			 group by item.id,route_id,DATE(h.created_at)
			 ORDER BY DATE(h.created_at) DESC");
			 
		  }
	      else if($slug=='warehouse')
		  { 
			 $get_data1 = DB::table('tbl_warehouse')
			 ->select('tbl_warehouse.warehouse_code','tbl_warehouse.warehouse_name','tbl_warehouse.id')
			 ->where('tbl_warehouse.warehouse_type','=',1)					
			 ->where('tbl_warehouse.id','=',$warehous)					
			 ->get()->all();
				
			 $titlename =$get_data1[0]->warehouse_code.' - '.$get_data1[0]->warehouse_name;
			
			 $get_sales_material_wise = DB::select("SELECT 
			 SUM(d.base_qty) as base_quantity,
			 item.material_name,item.id,item.material_code as mat_code,warehouse_name.id as warehouse_id,DATE(h.created_at) as created_date FROM `tbl_route_invoice_details` as d
			 left join tbl_route_invoice_header as h on d.header_id=h.id 
			 LEFT JOIN tbl_material_master as item on d.material_code=item.id
			 LEFT JOIN tbl_warehouse as warehouse_name on h.warehouse_id=warehouse_name.id
			  WHERE date(h.created_at) >= '".$fromdate."' AND  date(h.created_at) <= '".$todate."' AND warehouse_name.id=".$warehous." AND item.id=".$material."
			 group by item.id,warehouse_id,DATE(h.created_at)
			 ORDER BY DATE(h.created_at) DESC");
		  }
         else if($slug=='sub_region')
	     {
			 $get_data1 = DB::table('tbl_sub_region')
			 ->select('tbl_sub_region.sub_region_code','tbl_sub_region.sub_region_name','tbl_sub_region.id')
			->where('tbl_sub_region.id','=',$warehous)					
			 ->get()->all();
				
			 $titlename =$get_data1[0]->sub_region_code.' - '.$get_data1[0]->sub_region_name;
			
			 $get_sales_material_wise = DB::select("SELECT 
			 SUM(d.base_qty) as base_quantity,
			 item.material_name,item.id,item.material_code as mat_code,sub_region_name.id as subregion_id,DATE(h.created_at) as created_date FROM `tbl_route_invoice_details` as d
			 left join tbl_route_invoice_header as h on d.header_id=h.id 
			 LEFT JOIN tbl_material_master as item on d.material_code=item.id
			 LEFT JOIN tbl_warehouse as warehouse_name on h.warehouse_id=warehouse_name.id
			 LEFT JOIN tbl_sub_region as sub_region_name on warehouse_name.sub_region=sub_region_name.id
			  WHERE date(h.created_at) >= '".$fromdate."' AND  date(h.created_at) <= '".$todate."' AND sub_region_name.id=".$warehous." AND item.id=".$material."
			 group by item.id,subregion_id,DATE(h.created_at)
			 ORDER BY DATE(h.created_at) DESC");
		 }
         else
		 {
			 $get_data1 = DB::table('tbl_region')
			 ->select('tbl_region.region_code','tbl_region.region_name','tbl_region.id')
			->where('tbl_region.id','=',$warehous)					
			 ->get()->all();
				
			 $titlename =$get_data1[0]->region_code .' - '.$get_data1[0]->region_name;
			
			 $get_sales_material_wise = DB::select("SELECT 
			 SUM(d.base_qty) as base_quantity,
			 item.material_name,item.id,item.material_code as mat_code,region_name.id as region_id,DATE(h.created_at) as created_date FROM `tbl_route_invoice_details` as d
			 left join tbl_route_invoice_header as h on d.header_id=h.id 
			 LEFT JOIN tbl_material_master as item on d.material_code=item.id
			 LEFT JOIN tbl_warehouse as warehouse_name on h.warehouse_id=warehouse_name.id
			 LEFT JOIN tbl_region as region_name on warehouse_name.region=region_name.id
			  WHERE date(h.created_at) >= '".$fromdate."' AND  date(h.created_at) <= '".$todate."' AND region_name.id=".$warehous." AND item.id=".$material."
			 group by item.id,region_id,DATE(h.created_at)
			 ORDER BY DATE(h.created_at) DESC");
			 
		 }
	   
			foreach($get_sales_material_wise as $row) {
                $temp_date = date('Y-m-d', strtotime($row->created_date));
                $item_name = $row->mat_code .' - '.$row->material_name;
                $final_data_base[$temp_date]  = $row->base_quantity;
				
            } 
			
		$html = "<table style='width: 100%;' id='example' class='table table-hover       table-striped table-bordered'>
		
		  <thead class='text-white'> 
            <tr style='background-color: #3f6ad8;'>
             <th colspan='2' class='text-center'> ".ucfirst($item_name)." </th>
           </tr>
           <tr style='background-color: #3f6ad8;'>
            <th> Date </th>
            <th>Total Item Sales</th>
           </tr>
           </thead>
           <tbody>";
            $current_date   = date('Y-m-d');
            $first_date     = date($fromdate);
            $last_date      = date($todate);
			$base_item_sales  = 0;
			while($first_date <= $last_date) {
                $date_sale_base  = isset($final_data_base[$first_date]) ? $final_data_base[$first_date] : 0;
				$base_item_sales +=$date_sale_base;
				if($date_sale_base!=0)
				  {
                $html .= "
                           <tr>
                                <td>".date('d M y', strtotime($first_date))."</td>
                                <td>".$date_sale_base."</td>
                            <tr>
                        ";
				  }	
				  

                $first_date = date('Y-m-d', strtotime($first_date . ' +1 day'));        
            }
			$html .= "
                           <tr>
                               <th class='text-center'>Total</th>
                               <th colspan='2'>".$base_item_sales."</th>
                            <tr>";
		 }
		 else
		 {
			 if($slug=='route')
		  { 
			 $get_data1 = DB::table('tbl_route')
	    ->select('tbl_route.route_code','tbl_route.route_name','tbl_route.id')					
	   ->where('tbl_route.id','=',$warehous)					
	   ->get()->all();
				
		$titlename =$get_data1[0]->route_code.' - '.$get_data1[0]->route_name;
			
			 $get_sales_material_wise = DB::select("SELECT 
			 SUM(d.total) as total,
			 item.material_name,item.id,item.material_code as mat_code,route_name.id as region_id,DATE(h.created_at) as created_date FROM `tbl_route_invoice_details` as d
			 left join tbl_route_invoice_header as h on d.header_id=h.id 
			 LEFT JOIN tbl_material_master as item on d.material_code=item.id
			 LEFT JOIN tbl_route as route_name on h.route_id=route_name.id
			 WHERE date(h.created_at) >= '".$fromdate."' AND  date(h.created_at) <= '".$todate."' AND route_name.id=".$warehous." AND item.id=".$material."
			 group by item.id,region_id,DATE(h.created_at)
			 ORDER BY DATE(h.created_at) DESC");
		  }
			else if($slug=='warehouse')
		  { 
			 $get_data1 = DB::table('tbl_warehouse')
			 ->select('tbl_warehouse.warehouse_code','tbl_warehouse.warehouse_name','tbl_warehouse.id')
			 ->where('tbl_warehouse.warehouse_type','=',1)					
			 ->where('tbl_warehouse.id','=',$warehous)					
			 ->get()->all();
				
			 $titlename =$get_data1[0]->warehouse_code.' - '.$get_data1[0]->warehouse_name;
			 $get_sales_material_wise = DB::select("SELECT 
			 SUM(d.total) as total,
			 item.material_name,item.id,item.material_code as mat_code,warehouse_name.id as warehouse_id,DATE(h.created_at) as created_date FROM `tbl_route_invoice_details` as d
			 left join tbl_route_invoice_header as h on d.header_id=h.id 
			 LEFT JOIN tbl_material_master as item on d.material_code=item.id
			 LEFT JOIN tbl_warehouse as warehouse_name on h.warehouse_id=warehouse_name.id
			  WHERE date(h.created_at) >= '".$fromdate."' AND  date(h.created_at) <= '".$todate."' AND warehouse_name.id=".$warehous." AND item.id=".$material."
			 group by item.id,warehouse_id,DATE(h.created_at)
			 ORDER BY DATE(h.created_at) DESC");
		  }
         else if($slug=='sub_region')
	     {
			 $get_data1 = DB::table('tbl_sub_region')
			 ->select('tbl_sub_region.sub_region_code','tbl_sub_region.sub_region_name','tbl_sub_region.id')
			->where('tbl_sub_region.id','=',$warehous)					
			 ->get()->all();
				
			 $titlename =$get_data1[0]->sub_region_code.' - '.$get_data1[0]->sub_region_name;
			
			 $get_sales_material_wise = DB::select("SELECT 
			 SUM(d.total) as total,
			 item.material_name,item.id,item.material_code as mat_code,sub_region_name.id as subregion_id,DATE(h.created_at) as created_date FROM `tbl_route_invoice_details` as d
			 left join tbl_route_invoice_header as h on d.header_id=h.id 
			 LEFT JOIN tbl_material_master as item on d.material_code=item.id
			 LEFT JOIN tbl_warehouse as warehouse_name on h.warehouse_id=warehouse_name.id
			 LEFT JOIN tbl_sub_region as sub_region_name on warehouse_name.sub_region=sub_region_name.id
			  WHERE date(h.created_at) >= '".$fromdate."' AND  date(h.created_at) <= '".$todate."' AND sub_region_name.id=".$warehous." AND item.id=".$material."
			 group by item.id,subregion_id,DATE(h.created_at)
			 ORDER BY DATE(h.created_at) DESC");
		 }
         else
		 {
			 $get_data1 = DB::table('tbl_region')
			 ->select('tbl_region.region_code','tbl_region.region_name','tbl_region.id')
			->where('tbl_region.id','=',$warehous)					
			 ->get()->all();
				
			 $titlename =$get_data1[0]->region_code.' - '.$get_data1[0]->region_name;
			
			 $get_sales_material_wise = DB::select("SELECT 
			 SUM(d.total) as total,
			 item.material_name,item.id,item.material_code as mat_code,region_name.id as region_id,DATE(h.created_at) as created_date FROM `tbl_route_invoice_details` as d
			 left join tbl_route_invoice_header as h on d.header_id=h.id 
			 LEFT JOIN tbl_material_master as item on d.material_code=item.id
			 LEFT JOIN tbl_warehouse as warehouse_name on h.warehouse_id=warehouse_name.id
			 LEFT JOIN tbl_region as region_name on warehouse_name.region=region_name.id
			  WHERE date(h.created_at) >= '".$fromdate."' AND  date(h.created_at) <= '".$todate."' AND region_name.id=".$warehous." AND item.id=".$material."
			 group by item.id,region_id,DATE(h.created_at)
			 ORDER BY DATE(h.created_at) DESC");
			 
		 }
	   
			foreach($get_sales_material_wise as $row) {
                $temp_date = date('Y-m-d', strtotime($row->created_date));
                $item_name = $row->mat_code.' - '.$row->material_name;
                $final_data_base[$temp_date]  = $row->total;
            } 
		$html = "<table style='width: 100%;' id='example' class='table table-hover       table-striped table-bordered'>
		  <thead class='bg-secondary text-white'> 
            <tr style='background-color: #3f6ad8;'>
             <th colspan='2' class='text-center'> ".ucfirst($item_name)." </th>
           </tr>
		   
           <tr style='background-color: #3f6ad8;'>
            <th> Date </th>
            <th>Total Item Sales</th>
           </tr>
           </thead>
           <tbody>";
            $current_date   = date('Y-m-d');
            $first_date     = date($fromdate);
            $last_date      = date($todate);
			$base_item_sales  = 0;
			while($first_date <= $last_date) {
                $date_sale_base  = isset($final_data_base[$first_date]) ? $final_data_base[$first_date] : 0;
				$base_item_sales +=$date_sale_base;
				if($date_sale_base!=0)
				  {
                   $html .= "
                           <tr>
                                <td>".date('d M y', strtotime($first_date))."</td>
                                <td>".number_format($date_sale_base,2)."</td>
                            <tr>
                        ";
				  }
                $first_date = date('Y-m-d', strtotime($first_date . ' +1 day'));        
            } 
			$html .= "
                           <tr>
                               <th class='text-center'>Total</th>
                               <th colspan='2'>".number_format($base_item_sales,2)."</th>
                            <tr>";
			 
		 }

            $html .= "
                    </tbody>
                </table>";
		    $return['html'] = $html;
           echo json_encode($return);die;
	  }
	  
	  
	  
	  
	  /*   public function sales_report_exportpdf1(Request $request)
	 {
		  
		 $region=$request->region;
		$subregion=$request->subregion;
		$warehouse=$request->warehouse;
		$route=$request->route;
		 
		$fromdate=$request->fromdate;
		$todate=$request->todate;  
		 return Excel::download(new SalesReportExport(''), 'sales_report.xlsx');

      } */  
 }
