<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;
use App\Models\SalesmanModel;
use App\Models\SalesmanTypeModel;
use App\Models\ManageCodeModel;
use App\Models\RouteModel;
use App\Models\WarehouseModel;
use Illuminate\Support\Facades\DB;
use Session;

class SalesmanController extends Controller
 {
   public function list()
	{
		$get_data = DB::table('tbl_salesman')
			->leftJoin('tbl_salesman_type', 'tbl_salesman.salesman_type_id', '=', 'tbl_salesman_type.id')
			->leftJoin('tbl_route', 'tbl_salesman.route_id', '=', 'tbl_route.id')
			->leftJoin('tbl_warehouse', 'tbl_salesman.warehouse_id', '=', 'tbl_warehouse.id')
			->select('tbl_salesman.*', 'tbl_route.route_code','tbl_route.route_name','tbl_salesman_type.salesman_type_name','tbl_salesman_type.salesman_type_code','tbl_warehouse.warehouse_code','tbl_warehouse.warehouse_name')
			->orderBy('id', 'DESC')->get()->all();
			 
		return view('Master_Configuration.salesman_list',compact('get_data'));
	}	
   public function add()
	{ 
		
		$result =SalesmanModel::get()->sortByDesc('id')->first();
		if($result=='')
		  {
			$getcode = ManageCodeModel::where('id', 1)->first();
			$last_code = $getcode->salesman_code;					
		  }
		else
		  {
			$getcode = $result->salesman_code; 
			$last_code = ++$getcode;
		  }
			$salesman_type =SalesmanTypeModel::all()->sortByDesc('id')->where('status', '=', 'active');
			$route =RouteModel::all()->sortByDesc('id')->where('status', '=', 'active');
			return view('Master_Configuration.salesman',compact('salesman_type','last_code','route'));
	 }	
	public function edit($id)
	 {
		$get_data=SalesmanModel::find($id);
		$salesman_type =SalesmanTypeModel::all()->sortByDesc('id')->where('status', '=', 'active');
		$route =RouteModel::all()->sortByDesc('id')->where('status', '=', 'active');
		$last_code = $get_data->salesman_code;
		
		return view('Master_Configuration.salesman',compact('get_data','salesman_type','last_code','route'));
	 }

	public function save(Request $request)
	 { 
	   $data=new SalesmanModel;
	   $salesman_image=$request->file('salesman_picture');
		   
	   if($salesman_image)
		  {  
	      
		     $filenameWithExt = $request->file('salesman_picture')->getClientOriginalName();
			 // Get just filename
			 $filename = pathinfo($filenameWithExt, PATHINFO_FILENAME);            
		     // Get just ext
			 $extension = $request->file('salesman_picture')->getClientOriginalExtension();
			 //Filename to store
			 $fileNameToStore = $filename.'_'.time().'.'.$extension;                       
		     // Upload Image
			 $path = $request->file('salesman_picture')->storeAs('public/salesman', $fileNameToStore);
		  }
			 elseif($request->updated_id !='' && $salesman_image == '')
				{
				   $old_path = SalesmanModel::find($request->updated_id);
				   $path= $old_path->salesman_picture;
			 
				}   
			 else 
				{
					$path = '';
				}		   
						
			 if($request->updated_id) 
			   {			
					$data = SalesmanModel::find($request->updated_id);			
					$data->salesman_type_id=$request->salesman_type_id;
					$data->salesman_code=$request->salesman_code;
					$data->route_id=$request->routename;
					$data->warehouse_id=$request->warehouse_id;
					$data->salesman_name=$request->salesman_name;
					$data->salesman_password=$request->salesman_password;
					$data->contact_number=$request->contact_number;
					$data->block_from_date=$request->block_from_date;
					$data->block_to_date=$request->block_to_date;
					$data->salesman_picture=$path;	
					$data->erp_employee_code=$request->erp_employee_code;
					$data->customer_from=$request->customer_from;
					$data->customer_to=$request->customer_to;
					$data->invoice_from=$request->invoice_from;
					$data->invoice_to=$request->invoice_to;
					$data->order_from=$request->order_from;
					$data->order_to=$request->order_to;
					$data->delivery_from=$request->delivery_from;
					$data->delivery_to=$request->delivery_to;
					$data->collection_from=$request->collection_from;
					$data->collection_to=$request->collection_to;
					$data->return_order_from=$request->return_order_from;
					$data->return_order_to=$request->return_order_to;
					$data->exchange_from=$request->exchange_from;
					$data->exchange_to=$request->exchange_to;
					
					$data->load_from=$request->load_from;
					$data->load_to=$request->load_to;
					
					$data->block_salesman=$request->block_salesman;			
					$data->company_id= Session::get('company_id');
					$data->updated_user= Session::get('user_id');
					$data->status=$request->status;
					$data->save();
					return redirect(route('salesman_list'))->with('successMessage','Salesman Updated Successfully');
			
				} 
			  else 
				{  
					$data->salesman_type_id=$request->salesman_type_id;
					$data->salesman_code=$request->salesman_code;
					$data->route_id=$request->routename;
					$data->warehouse_id=$request->warehouse_id; 
					$data->salesman_name=$request->salesman_name;
					$data->salesman_password=$request->salesman_password;
					$data->contact_number=$request->contact_number;
					$data->block_from_date=$request->block_from_date;
					$data->block_to_date=$request->block_to_date;
					$data->salesman_picture=$path;
					$data->erp_employee_code=$request->erp_employee_code;
					$data->customer_from=$request->customer_from;
					$data->customer_to=$request->customer_to;
					$data->invoice_from=$request->invoice_from;
					$data->invoice_to=$request->invoice_to;
					$data->order_from=$request->order_from;
					$data->order_to=$request->order_to;
					$data->delivery_from=$request->delivery_from;
					$data->delivery_to=$request->delivery_to;
					$data->collection_from=$request->collection_from;
					$data->collection_to=$request->collection_to;
					$data->return_order_from=$request->return_order_from;
					$data->return_order_to=$request->return_order_to;
					$data->exchange_from=$request->exchange_from;
					$data->exchange_to=$request->exchange_to;
					
					$data->load_from=$request->load_from;
					$data->load_to=$request->load_to;
					
					$data->block_salesman=$request->block_salesman;
					$data->created_user= Session::get('user_id');
					$data->company_id= Session::get('company_id');
					$data->status=$request->status;
					$data->save();
					return redirect(route('salesman_list'))->with('successMessage','Salesman Added Successfully');
					//exit;
			    }	
    	
	  }
	 
	 public function view($id)
      {    
		//$get_data=SalesmanModel::find($id);
		$get_data = DB::table('tbl_salesman')
		->leftJoin('tbl_salesman_type', 'tbl_salesman.salesman_type_id', '=', 'tbl_salesman_type.id')
		->leftJoin('tbl_warehouse', 'tbl_salesman.warehouse_id', '=', 'tbl_warehouse.id')
		->leftJoin('tbl_route', 'tbl_salesman.route_id', '=', 'tbl_route.id')
		->select('tbl_salesman.*', 'tbl_salesman_type.salesman_type_name','tbl_salesman_type.salesman_type_code','tbl_route.route_code','tbl_route.route_name','tbl_warehouse.warehouse_code','tbl_warehouse.warehouse_name')
		->where('tbl_salesman.id', '=',$id)
		->first();
	     //dd($get_data);
		 return view('Master_Configuration.salesman_view',compact('get_data'));
	  }
		
	 public function get_warehouse($id)
	  {
		$get_data=DB::table('tbl_route')
		    ->leftJoin('tbl_warehouse', 'tbl_route.warehouse_id', '=', 'tbl_warehouse.id')
			->select('tbl_route.warehouse_id','tbl_warehouse.warehouse_name','tbl_warehouse.warehouse_code')
			->where('tbl_warehouse.status', '=', 'active')
			->where('tbl_warehouse.warehouse_type', '=',1)
			->where('tbl_route.id', '=', $id)
			->get()->first();
		 echo $get_data->warehouse_id.'-'.$get_data->warehouse_name.'-'.$get_data->warehouse_code;
	  }

 }
