<?php

namespace App\Http\Controllers;
use App\Models\RouteModel;
use App\Models\SalesmanModel;
use App\Models\SalesmanLoadModel;
use App\Models\MaterialMasterModel;
use App\Models\ManageCodeModel;
use App\Models\UnitOfMeasurementModel;
use App\Models\WarehouseModel;
use App\Exports\SalesManLoadListExport; 
use PDF; 
use Maatwebsite\Excel\Facades\Excel;
use Carbon\Carbon;
use Session;
use Illuminate\Support\Facades\DB;
use Illuminate\Http\Request;

class SalesmanLoadController extends Controller
 {
   public function list(Request $request)
    {

	   //dd($request);		
	   $current_date=date("Y-m-d");
	
	   $where="";		
	   if(count($request->all()) < 1)
		 {
			
			$where .= " AND DATE_FORMAT(riheader.created_at, '%Y-%m-%d') between '".$current_date."' and '".$current_date."'"; 
		 }
	  
	   if($request->fromdate!='')
		 {
			$where .= " AND DATE_FORMAT(riheader.created_at, '%Y-%m-%d') between '".$request->fromdate."' and '".$request->todate."'"; 
		 }
 
	   if($request->warehouse!='')
		 {
			$where .= "AND warehouse.id = '".$request->warehouse."'";
		 }
 
	   if($request->route!='')
		 {
			$where .= "AND route.id = '".$request->route."'";
		 }
		 
	   if($request->salesman!='')
		 {
			$where .= "AND salesman.id = '".$request->salesman."'";
		 }
		//dd($request);
		$route =RouteModel::all()->sortByDesc('id')->where('status', '=', 'active');
		$warehouse=WarehouseModel::all()->sortByDesc('id')->where('warehouse_type','=','1')->where('status', '=', 'active');
		$salesman =SalesmanModel::all()->sortByDesc('id')->where('status', '=', 'active');
		$get_data = DB::select("SELECT riheader.*, route.route_name,route.route_code,

		warehouse.warehouse_code,warehouse.warehouse_name,
		salesman.salesman_name,salesman.salesman_code,currency.currency_notation  
		
		FROM tbl_route_salesmanload_header as riheader
		LEFT JOIN tbl_route as route on riheader.route_id=route.id
		LEFT JOIN tbl_warehouse as warehouse on riheader.warehouse_id=warehouse.id
		LEFT JOIN tbl_salesman as salesman on riheader.salesman_id=salesman.id 
		LEFT JOIN tbl_currency_type as currency on riheader.currency=currency.id 
		WHERE riheader.id IS NOT NULL ".$where."ORDER BY id DESC ");
			
		//dd($get_data);
	
		return view('Route_Transaction.salesman_load_list',compact('get_data','route','warehouse','salesman'));
    }
	
   public function view($id)
	{ 
		$get_data =DB::table('tbl_route_salesmanload_header')
		->leftJoin('tbl_route', 'tbl_route_salesmanload_header.route_id', '=', 'tbl_route.id')
		->leftJoin('tbl_salesman', 'tbl_route_salesmanload_header.salesman_id', '=', 'tbl_salesman.id')
		->leftJoin('tbl_currency_type', 'tbl_route_salesmanload_header.currency', '=', 'tbl_currency_type.id')
	  
		->select('tbl_route_salesmanload_header.*','tbl_route.route_code','tbl_route.route_name','tbl_salesman.salesman_name','tbl_salesman.salesman_code','tbl_currency_type.currency_notation')->where('tbl_route_salesmanload_header.id', '=', $id)->get()->first();

		$get_data_details =DB::table('tbl_route_salesmanload_details')
 
		->leftJoin('tbl_material_master', 'tbl_route_salesmanload_details.material_id', '=', 'tbl_material_master.id')
		->leftJoin('tbl_unit_of_measurement', 'tbl_route_salesmanload_details.uom_id', '=', 'tbl_unit_of_measurement.id')

		->select('tbl_route_salesmanload_details.*','tbl_material_master.material_name','tbl_material_master.material_code','tbl_unit_of_measurement.unit_notation')->where('tbl_route_salesmanload_details.header_id', '=', $id)->get()->all();	  
		
		return view('Route_Transaction.salesman_load_view',compact('get_data','get_data_details'));
	
		//dd($get_data);
	
    }
   public function add()
	{	
		
	   $user_id=Session::get('user_id');
 
	   $result = DB::table('tbl_route_salesmanload_header')
	   ->select('tbl_route_salesmanload_header.*')->get()->sortByDesc('id')->first();
			 
	   if($result=='')
		 {
			$getcode = ManageCodeModel::where('id', 1)->first();
			$last_code = $getcode->load_code;
		 }
	   else
		 {
			$getcode = $result->load_number; 
			$last_code = ++$getcode;
		 }
		
		 $route =RouteModel::all()->sortByDesc('id')->where('status', '=', 'active');
		 $salesman =SalesmanModel::all()->sortByDesc('id')->where('status', '=', 'active');
		 $material =MaterialMasterModel::all()->sortByDesc('id')->where('status', '=', 'active')->where('material_types_id', '=',3);
		 //dd($route);
		 $login_user = DB::table('tbl_user')
		 ->leftJoin('tbl_company', 'tbl_user.company_id', '=', 'tbl_company.id')
		 ->leftJoin('tbl_currency_type', 'tbl_company.currency_id', '=', 'tbl_currency_type.id')
		 ->select('tbl_user.id', 'tbl_company.currency_id','tbl_currency_type.currency_notation')
		 ->where('tbl_user.id', '=', $user_id)
		 ->get()->first();
		 
		
		 return view('Route_Transaction.salesman_load',compact('route','salesman','material','last_code','login_user'));
    }
	
   public function salesman_load_modified(Request $request)
    {
	   $current = Carbon::now();
	   DB::table('tbl_route_salesmanload_header')
	    ->where('id', $request->load_id1)
	    ->update([
				  'status' => 'approved',
				  'total_load_value' => $request->invoice_amount_totali
			     ]);
				
	   $load_header=DB::table('tbl_route_salesmanload_details')->where('header_id', '=', $request->load_id1);
	   if($load_header!='')   
	     {
		   DB::table('tbl_route_salesmanload_details')->where('header_id', '=', $request->load_id1)->delete();
		 
		   if(count($request->material_name)>0)
			 {
		       foreach($request['material_name'] as $key => $n)
			     {
				   if($request->quantity[$key ]!='')
				     {
					   $data2=array
					   (				 
					    'header_id'     => $request->load_id1,
					    'material_id'   => $request->material_name[$key ],
					    'uom_id'        => $request->uom[$key ],
					    'quantity'      => $request->quantity[$key ],
					    'price'         => $request->price[$key ],
					    'total'         => $request->total[$key ],
					    'created_at'    => $current,
					   );
					  DB::table('tbl_route_salesmanload_details')->insert($data2);
				    } 
			   }
	 
			}
		  
		  return redirect(route('salesman_load_list'))->with('successMessage','Salesman Load Modified Successfully');	
		}  
    }
   public function save(Request $request)
	{
		
	  $user_id=Session::get('user_id');
	   $get_route_transfer_details=DB::table('tbl_warehouse')
			->select('tbl_warehouse.route')
			->where('warehouse_type','=',2)
			->where('id','=',$request->route_warehouse)
			->get();

	  $login_user = DB::table('tbl_user')
	   ->leftJoin('tbl_company', 'tbl_user.company_id', '=', 'tbl_company.id')
	   ->leftJoin('tbl_currency_type', 'tbl_company.currency_id', '=', 'tbl_currency_type.id')
	   ->select('tbl_user.id', 'tbl_company.currency_id','tbl_currency_type.currency_notation','tbl_currency_type.id as currency_id')
	   ->where('tbl_user.id', '=', $user_id)
	   ->get()->first();


	  $current = Carbon::now();
	  $data=$request->all(); 
	  
	  $data3=array
	        (				 
			 'currency'        =>  $login_user->currency_id,
			 'route_id'         =>  $request->route,
			 'total_load_value' =>  $request->invoice_amount_totali,
			 'salesman_id'      =>  $request->salesman,
			 'load_date'        =>  $request->load_date,
			 'load_number'      =>  $request->invoice_number,
			 'route_id'			=>  $request->route_id1,
			 'warehouse_id'		=>	$request->warehaouse_id,
			 'status'		    =>	'approved',
			 'created_at'       =>  $current,
		    );
		 
	   $header_id =DB::table('tbl_route_salesmanload_header')->insertGetId($data3);		        
	  if(count($request->material_name)>0)
		{
			
		  foreach($request['material_name'] as $key => $n)
		    {
				$material=DB::table('tbl_material_master')
                 ->select('uom_id')->where('id','=',$request->material_name[$key ])->first();
              
			   
		     if($request->quantity[$key ]!='')
			   {
				$material_details= DB::table('tbl_material_master')
								->select('tbl_material_master.uom_id', 'tbl_material_master.material_category_id',  'tbl_material_master.material_types_id')
								->where('tbl_material_master.id','=',$request->material_name[$key ])
								->get()->first();
								
				 $data2=array
				 (				 
				  'header_id'     => $header_id,
				  'material_id'   => $request->material_name[$key ],
				  'uom_id'           => $request->uom[$key ],
				  'quantity'      => $request->quantity[$key ],
				  'price'         => $request->price[$key ],
				  'base_qty'      => $request->packing_size[$key ],
				  'total'         => $request->total[$key ],
				  'created_at'    => $current,
				 );
				 DB::table('tbl_route_salesmanload_details')->insert($data2);
				 
				 /* stock movement functionality start from here */
					    $stock = DB::table('tbl_warehouse_stock')
							  ->where('tbl_warehouse_stock.warehouse_id','=',$request->warehaouse_id)
							  ->where('tbl_warehouse_stock.material_id','=',$request->material_name[$key])
							  ->get()->all();
							  $count=count($stock);
							  if($count>0)
								{
								  // reducing stock from warehouse
								  $query = DB::table('tbl_warehouse_stock')
								  ->where('warehouse_id',$request->warehaouse_id)
								  ->where('material_id','=',$request->material_name[$key]);
								  
								   $query->decrement('qty',$request->packing_size[$key]);
								}	   				
				 $data4=array(
				               'header_id'          => $header_id,
				               'warehouse_id'       => $request->warehaouse_id,
							   'route_warehouse_id' => $request->route_warehouse,
							   'item_id'            => $request->material_name[$key],
							   'uom'                => $material_details->uom_id,
							   'qty'                => $request->quantity[$key ],
							   'base_qty'           => $request->packing_size[$key ],
							   'route_id'           => $get_route_transfer_details[0]->route,
							   'created_at'  => $current,
							  );	

    				DB::table('tbl_stock_reserve')->insert($data4);
			   } 
		    }
 
		 }
  
	   return redirect(route('salesman_load_list'))->with('successMessage','Salesman Load Uploaded Successfully');	
    }
	
   public function get_salesman($id1)
	{
		
	  $get_data=SalesmanModel::all()->sortByDesc('id')->where('route_id', '=', $id1)->where('status', '=', 'active');		
	  ?>
	  <option  value="">     </option>
	  <?php
	  foreach($get_data as $salesman)
		{
			?>
			<option value="<?php echo $salesman->id ?>"  ><?php echo $salesman->salesman_code." - ".$salesman->salesman_name ?></option>					
			<?php		
		}
    }
	
	 public function get_route_warehouse($warehouse)
	{
	
		$outlet_warehouse=WarehouseModel::get()->where('warehouse_type','=',2)->where('status', '=', 'active')->where('route_warehouse','=',$warehouse)->all();
		

		?>
		<option  value=""> </option>
		<?php
		
		foreach($outlet_warehouse as $warehouse_name)
	      {
			?>
			<option value="<?php echo $warehouse_name->id ?>"> <?php echo $warehouse_name->warehouse_code.' - '.$warehouse_name->warehouse_name ?></option>	
			<?php		
		  }
		
	}
	
   public function get_material_price1($id,$val)
	{
	  $material=MaterialMasterModel::get()->sortByDesc('id')->first()->find($val);	
	  $alt_uom = explode(",",$material->alt_uom);				   
	  $key = array_search($id, $alt_uom);				   
	  $alt_unit_price = explode(",",$material->alt_unit_price);
	  echo $alt_unit_price[$key];
		
	}
	 
   public function get_material_detailsUom1($id,$row)
    {
	  $uom12 =UnitOfMeasurementModel::all()->sortByDesc('id')->where('status', '=', 'active');
	  $material_master = DB::select('SELECT t2.id, t2.uom_name,t2.unit_notation  FROM tbl_material_master as t1 LEFT JOIN     tbl_unit_of_measurement as t2 ON find_in_set(t2.id, 
	  t1.alt_uom) WHERE t1.`id`='.$id.'');				
	  $get_material_price=MaterialMasterModel::find($id);				
	  $alt_unit_price = explode(",",$get_material_price->alt_unit_price);
	  //dd($material_master);
	  $material=MaterialMasterModel::get()->sortByDesc('id')->first()->find($id);

	  foreach($material_master as $key=>$data)
		{
	
		 ?>
		 <option  <?php if($data->id == $material->uom)  echo 'selected'; ?> value ="<?php echo $data->id; ?>" ><?php echo $data->unit_notation; ?></option>
			  <?php
	 
		}
    }

   public function get_material1()
    {		
	  $material =MaterialMasterModel::all()->sortByDesc('id')->where('status', '=', 'active')->where('material_types_id', '=',3);
      	  
	  ?>
	  <option  value="">     </option>
	  <?php
	  foreach($material as $material_name)
	    {
		  ?>
		  <option value="<?php echo $material_name->id ?>"  ><?php echo $material_name-> material_code.' - '.$material_name->material_name ?></option>	
		  <?php		
	    }		
	}
	
   public function get_approved($id)
	{	
           	
	  DB::table('tbl_route_salesmanload_header')
	   ->where('id', $id)
	   ->update(['status' => 'approved']);
	   return redirect(route('salesman_load_list'))->with('successMessage','Status Approved Successfully');	

	}
	
   public function get_cancel_load(Request $request)
	{
    	
	  DB::table('tbl_route_salesmanload_header')
	   ->where('id', $request->load_id)
	   ->update([
				'status' => 'cancel',
				'reson'  => $request->region_name
		       ]);
		return redirect(route('salesman_load_list'))->with('successMessage','Status Cancel Successfully');
		
    }
   public function get_material_alt_packing_size($id,$val)
	{
	 
	  $material=MaterialMasterModel::get()->sortByDesc('id')->first()->find($val);	

	  $alt_uom = explode(",",$material->alt_uom);
   
	  $key = array_search($id, $alt_uom);
   
	  $alt_alt_packing_size = explode(",",$material->alt_packing_size);

	  echo $alt_alt_packing_size[$key];

    }
   public function get_route_filter($id,$url_route)
    {
	  $route =RouteModel::all()->sortByDesc('id')->where('status', '=', 'active')->where('warehouse_id', '=', $id);

	  ?>
	  <option  value="">     </option>
	  <?php
	  foreach($route as $routename)   
		{ 
			?>
			<option <?php if($routename->id==$url_route) { echo "selected";} ?> value="<?php echo $routename->id ?>"  ><?php echo $routename->route_code.' - '.$routename->route_name ?></option>	
			<?php		
		}
				 
    }
	
	public function salesmanloadexcelexport($id)  
	{
		 
      return Excel::download(new SalesManLoadListExport($id), 'salesmanloadexcelexport.xlsx'); 
         
	}
	
	
	public function salesmanloadpdfexport($id)  
	{
		 
       $get_data =DB::table('tbl_route_salesmanload_header')
		->leftJoin('tbl_route', 'tbl_route_salesmanload_header.route_id', '=', 'tbl_route.id')
		->leftJoin('tbl_salesman', 'tbl_route_salesmanload_header.salesman_id', '=', 'tbl_salesman.id')
		->leftJoin('tbl_currency_type', 'tbl_route_salesmanload_header.currency', '=', 'tbl_currency_type.id')
		->leftJoin('tbl_warehouse', 'tbl_route_salesmanload_header.warehouse_id', '=', 'tbl_warehouse.id')
	  
		->select('tbl_route_salesmanload_header.*','tbl_route.route_code','tbl_route.route_name','tbl_salesman.salesman_name','tbl_salesman.salesman_code','tbl_salesman.contact_number','tbl_currency_type.currency_notation','tbl_warehouse.warehouse_code','tbl_warehouse.warehouse_name')->where('tbl_route_salesmanload_header.id', '=', $id)->get()->first();

		$get_data_details =DB::table('tbl_route_salesmanload_details')
 
		->leftJoin('tbl_material_master', 'tbl_route_salesmanload_details.material_id', '=', 'tbl_material_master.id')
		->leftJoin('tbl_unit_of_measurement', 'tbl_route_salesmanload_details.uom_id', '=', 'tbl_unit_of_measurement.id')

		->select('tbl_route_salesmanload_details.*','tbl_material_master.material_name','tbl_material_master.material_code','tbl_unit_of_measurement.unit_notation')->where('tbl_route_salesmanload_details.header_id', '=', $id)->get()->all();	
		 
		 $pdf=PDF::loadView('export.pdf.stock_request_pdf',compact('get_data','get_data_details'));
		 
		 
      return  $pdf->download('salesmanloadexcelexport.pdf'); 
	  
         
	}
	
	
	
	
	
	
	
	
	
	
 }
