<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;

use App\Models\RegionTypeModel;
use App\Models\SubRegionTypeModel;
use App\Models\WarehouseModel;
use App\Models\RouteModel;
use App\Models\SalesmanModel;
use Illuminate\Support\Facades\DB;
use Maatwebsite\Excel\Facades\Excel;
use App\Exports\SalesmanPerformanceExport;
use App\Models\MaterialMasterModel;
use Session;

class SalesmanPerformanceController extends Controller
 {
   public function get_salesman_performance()
	{		
		
	  $region =RegionTypeModel::all()->sortByDesc('id')->where('status', '=', 'active');
       
       foreach($region as $key=> $reg){

            $all_region[$key] = $reg->id; 
		 
	   }
     
      $regId=implode(",",$all_region);
	  return view('Report.salesman_performance_list',compact('region','regId'));  
	}
   public function get_subregion_data($id)
	{
		$data = explode(',',$id);
	    $sub_region =SubRegionTypeModel::all()->sortByDesc('id')->whereIn('region_id',$data)->where('status', '=', 'active');
		if(count($sub_region)>0){
			foreach($sub_region as $subreg){
				
				$all_subregion[] = $subreg->id;
			}
			$subregId=implode(",",$all_subregion);
		}else{

			$subregId = 0;
		}	
	   
   
		?>
		
		<option  value=""></option>
		<?php if(count($sub_region) > 0){ ?>
		<option  value="0" data-value="<?php echo $subregId ?>">Select All</option>
		<?php }
		foreach($sub_region as $sub_region_name)
		  { 
			?>
			  <option value="<?php echo $sub_region_name->id ?>"  ><?php echo $sub_region_name->sub_region_code.' - '.$sub_region_name->sub_region_name  ?></option>	
		   <?php  	   	
		  }
	 
	}
  public function salesman_performance(Request $request)
	{	
	       //dd($request);
      $region =RegionTypeModel::all()->sortByDesc('id')->where('status', '=', 'active');
        
		if($request->region=='')
		  { 
		  if($request->month=='0')
		    {
			  
			  $get_data1 = DB::table('tbl_route_invoice_header')
				->leftJoin('tbl_salesman', 'tbl_route_invoice_header.salesman_id', '=', 'tbl_salesman.id')
				->leftJoin('tbl_warehouse', 'tbl_route_invoice_header.warehouse_id', '=', 'tbl_warehouse.id')
				->leftJoin('tbl_route_invoice_details', 'tbl_route_invoice_header.id', '=', 'tbl_route_invoice_details.header_id')
		        ->select(DB::raw('SUM(tbl_route_invoice_header.total_invoice_value) as total_invoice'),DB::raw('sum(tbl_route_invoice_details.base_qty) as base_quantity'),'tbl_salesman.salesman_name as sales_name','tbl_salesman.id as salesman_id','tbl_salesman.salesman_code','tbl_warehouse.warehouse_code','tbl_warehouse.warehouse_name')
				
				->groupBy('tbl_route_invoice_header.salesman_id','tbl_route_invoice_header.warehouse_id') 
				->whereYear('tbl_route_invoice_header.created_at', $request->year)
				->get();  
		      //dd($get_data1);
		       
		      $get_data_chart = DB::table('tbl_route_invoice_header')
					 ->leftJoin('tbl_salesman', 'tbl_route_invoice_header.salesman_id', '=', 'tbl_salesman.id')
					 ->select('tbl_salesman.salesman_name as label',DB::raw('sum(tbl_route_invoice_header.total_invoice_value) as y'))
					->groupBy('label') 
				    ->limit(10)
					->whereYear('tbl_route_invoice_header.created_at', $request->year)
					->get()->all();	
					
				   Session::put('year', $request->year);
				   Session::put('month', $request->month);
				   Session::put('get_data1', $get_data1);
				   Session::put('get_data_chart', $get_data_chart);
			 
		    	
	        }	
         else
	        {	
               $get_data1 = DB::table('tbl_route_invoice_header')
				    ->leftJoin('tbl_salesman', 'tbl_route_invoice_header.salesman_id', '=', 'tbl_salesman.id')
					->leftJoin('tbl_warehouse', 'tbl_route_invoice_header.warehouse_id', '=', 'tbl_warehouse.id')
					->leftJoin('tbl_route_invoice_details', 'tbl_route_invoice_header.id', '=', 'tbl_route_invoice_details.header_id')
					->select(DB::raw('sum(tbl_route_invoice_header.total_invoice_value) as total_invoice'),DB::raw('sum(tbl_route_invoice_details.base_qty) as base_quantity'),'tbl_salesman.salesman_name as sales_name','tbl_salesman.id as salesman_id','tbl_salesman.salesman_code','tbl_warehouse.warehouse_code','tbl_warehouse.warehouse_name')
					->orderBy(DB::raw('sum(tbl_route_invoice_header.total_invoice_value)'),'desc')
					->groupBy('tbl_route_invoice_header.salesman_id','tbl_route_invoice_header.warehouse_id') 
					->whereYear('tbl_route_invoice_header.created_at', $request->year)
					->whereMonth('tbl_route_invoice_header.created_at', $request->month)
					->get();	  
		     
		    $get_data_chart = DB::table('tbl_route_invoice_header')
					->leftJoin('tbl_salesman', 'tbl_route_invoice_header.salesman_id', '=', 'tbl_salesman.id')
					->select('tbl_salesman.salesman_name as label',DB::raw('sum(tbl_route_invoice_header.total_invoice_value) as y'))
					 ->groupBy('label') 
					  ->limit(10)
					  ->whereYear('tbl_route_invoice_header.created_at', $request->year)
					  ->whereMonth('tbl_route_invoice_header.created_at', $request->month)
					  ->get()->all();
					  
					 //dd($request->sub_region); 
				   Session::put('year', $request->year);
				   Session::put('month', $request->month);
				   Session::put('region_id', $request->region);
				   Session::put('subregion_id', $request->sub_region);
				   Session::put('get_data1', $get_data1);
				   Session::put('get_data_chart', $get_data_chart);
		  }
	}
else{
	
	 if($request->sub_region!='')
	  {
		if($request->sub_region!='0')
		{
		  $agent_name     = array(); 
		  $agent_id     = array(); 
		  $get_data1 = DB::table('tbl_sub_region')
		  ->select('tbl_sub_region.sub_region_code','tbl_sub_region.sub_region_name','tbl_sub_region.id')
		  ->where('tbl_sub_region.status','=','active')
		  ->where('tbl_sub_region.id','=',$request->sub_region)->get();
		  foreach($get_data1 as $key=> $sub_region)
			{
			  $agent_id[]=$sub_region->id;
			}
		 }
	    else  
		{
			$agent_name     = array(); 
			$agent_id     = array(); 
			$get_data1 = DB::table('tbl_sub_region')
			 
			->select('tbl_sub_region.sub_region_code','tbl_sub_region.sub_region_name','tbl_sub_region.id')
			->where('tbl_sub_region.status','=','active')
			->get();
			foreach($get_data1 as $key=> $sub_region)
			  {
				 $agent_id[]=$sub_region->id;
			  }
		}
		
		if($request->month== '0')
			 {
			   $get_data1 = DB::table('tbl_route_invoice_header')
				->leftJoin('tbl_salesman', 'tbl_route_invoice_header.salesman_id', '=', 'tbl_salesman.id')
				->leftJoin('tbl_warehouse', 'tbl_route_invoice_header.warehouse_id', '=', 'tbl_warehouse.id')
				->leftJoin('tbl_route_invoice_details', 'tbl_route_invoice_header.id', '=', 'tbl_route_invoice_details.header_id')
		        ->select(DB::raw('sum(tbl_route_invoice_header.total_invoice_value) as total_invoice'),DB::raw('sum(tbl_route_invoice_details.base_qty) as base_quantity'),'tbl_salesman.salesman_name as sales_name','tbl_salesman.id as salesman_id','tbl_salesman.salesman_code','tbl_warehouse.warehouse_code','tbl_warehouse.warehouse_name')
				->orderBy(DB::raw('sum(tbl_route_invoice_header.total_invoice_value)'),'desc')
				->groupBy('tbl_route_invoice_header.salesman_id','tbl_route_invoice_header.warehouse_id') 
				->whereYear('tbl_route_invoice_header.created_at', $request->year)
				->whereIn('tbl_route_invoice_header.subregion_id', $agent_id)
			    ->get();	  
		        
				   
		          //for chart
				  $get_data_chart = DB::table('tbl_route_invoice_header')
				  ->leftJoin('tbl_salesman', 'tbl_route_invoice_header.salesman_id', '=', 'tbl_salesman.id')
				  ->select('tbl_salesman.salesman_name as label',DB::raw('sum(tbl_route_invoice_header.total_invoice_value) as y'))
				  ->groupBy('label') 
				  ->limit(10)
				  ->whereYear('tbl_route_invoice_header.created_at', $request->year)
				  ->whereIn('tbl_route_invoice_header.subregion_id', $agent_id)
				  ->get()->all();
				 }
		     else{
			       $get_data1 = DB::table('tbl_route_invoice_header')
					->leftJoin('tbl_salesman', 'tbl_route_invoice_header.salesman_id', '=', 'tbl_salesman.id')
					->leftJoin('tbl_warehouse', 'tbl_route_invoice_header.warehouse_id', '=', 'tbl_warehouse.id')
					->leftJoin('tbl_route_invoice_details', 'tbl_route_invoice_header.id', '=', 'tbl_route_invoice_details.header_id')
					->select(DB::raw('sum(tbl_route_invoice_header.total_invoice_value) as total_invoice'),DB::raw('sum(tbl_route_invoice_details.base_qty) as base_quantity'),'tbl_salesman.salesman_name as sales_name','tbl_salesman.id as salesman_id','tbl_salesman.salesman_code','tbl_warehouse.warehouse_code','tbl_warehouse.warehouse_name')
					->orderBy(DB::raw('sum(tbl_route_invoice_header.total_invoice_value)'),'desc')
					->groupBy('tbl_route_invoice_header.salesman_id','tbl_route_invoice_header.warehouse_id') 
					->whereYear('tbl_route_invoice_header.created_at', $request->year)
					->whereMonth('tbl_route_invoice_header.created_at', $request->month)
					->whereIn('tbl_route_invoice_header.subregion_id', $agent_id)
					->get();
					
		           
				   
					 //for chart
					  $get_data_chart = DB::table('tbl_route_invoice_header')
					
					  ->leftJoin('tbl_salesman', 'tbl_route_invoice_header.salesman_id', '=', 'tbl_salesman.id')
					
					  ->select('tbl_salesman.salesman_name as label',DB::raw('sum(tbl_route_invoice_header.total_invoice_value) as y'))
					
					  ->groupBy('label') 
					  ->limit(10)
					  ->whereYear('tbl_route_invoice_header.created_at', $request->year)
					  ->whereMonth('tbl_route_invoice_header.created_at', $request->month)
					  ->whereIn('tbl_route_invoice_header.subregion_id', $agent_id)
					  ->get()->all();				
			         }
			       Session::put('year', $request->year);
				   Session::put('month', $request->month);
				   Session::put('region_id', $request->region);
				   Session::put('subregion_id', $request->sub_region);
				   Session::put('get_data1', $get_data1);
				   Session::put('get_data_chart', $get_data_chart);
			  
			  
	  }
  else{
	   if($request->region!='0')
		{
		  $agent_name     = array(); 
		  $agent_id     = array(); 
		  $get_data1 = DB::table('tbl_region')
		  ->select('tbl_region.region_code','tbl_region.region_name','tbl_region.id')
		  ->where('tbl_region.status','=','active')
		  ->where('tbl_region.id','=',$request->region)->get();
		  foreach($get_data1 as $key=> $region)
			{
			  $agent_id[]=$region->id;
			}
		 }
	    else  
		 {
			$agent_name     = array(); 
			$agent_id     = array(); 
			$get_data1 = DB::table('tbl_region')
			 
			->select('tbl_region.region_code','tbl_region.region_name','tbl_region.id')
			->where('tbl_region.status','=','active')
			->get();
			foreach($get_data1 as $key=> $region)
			  {
				 $agent_id[]=$region->id;
			  }
		  }
	  if($request->month=='0')
			 {
			   $get_data1 = DB::table('tbl_route_invoice_header')
				->leftJoin('tbl_salesman', 'tbl_route_invoice_header.salesman_id', '=', 'tbl_salesman.id')
				->leftJoin('tbl_warehouse', 'tbl_route_invoice_header.warehouse_id', '=', 'tbl_warehouse.id')
				->leftJoin('tbl_route_invoice_details', 'tbl_route_invoice_header.id', '=', 'tbl_route_invoice_details.header_id')
		        ->select(DB::raw('sum(tbl_route_invoice_header.total_invoice_value) as total_invoice'),DB::raw('sum(tbl_route_invoice_details.base_qty) as base_quantity'),'tbl_salesman.salesman_name as sales_name','tbl_salesman.id as salesman_id','tbl_salesman.salesman_code','tbl_warehouse.warehouse_code','tbl_warehouse.warehouse_name')
				->orderBy(DB::raw('sum(tbl_route_invoice_header.total_invoice_value)'),'desc')
				->groupBy('tbl_route_invoice_header.salesman_id','tbl_route_invoice_header.warehouse_id') 
				->whereYear('tbl_route_invoice_header.created_at', $request->year)
				->whereIn('tbl_route_invoice_header.region_id', $agent_id)
			    ->get();	  
		        
				 //for chart
				 $get_data_chart = DB::table('tbl_route_invoice_header')
				 ->leftJoin('tbl_salesman', 'tbl_route_invoice_header.salesman_id', '=', 'tbl_salesman.id')
				 ->select('tbl_salesman.salesman_name as label',DB::raw('sum(tbl_route_invoice_header.total_invoice_value) as y'))
				 ->groupBy('label') 
				 ->limit(10)
				 ->whereYear('tbl_route_invoice_header.created_at', $request->year)
				 ->whereIn('tbl_route_invoice_header.region_id', $agent_id)
				 ->get()->all();
				  
				   Session::put('year', $request->year);
				   Session::put('month', $request->month);
				   Session::put('region_id', $request->region);
				   Session::put('get_data1', $get_data1);
				   Session::put('get_data_chart', $get_data_chart);
				 }
		     else{
			       $get_data1 = DB::table('tbl_route_invoice_header')
					->leftJoin('tbl_salesman', 'tbl_route_invoice_header.salesman_id', '=', 'tbl_salesman.id')
					->leftJoin('tbl_warehouse', 'tbl_route_invoice_header.warehouse_id', '=', 'tbl_warehouse.id')
					->leftJoin('tbl_route_invoice_details', 'tbl_route_invoice_header.id', '=', 'tbl_route_invoice_details.header_id')
					->select(DB::raw('sum(tbl_route_invoice_header.total_invoice_value) as total_invoice'),DB::raw('sum(tbl_route_invoice_details.base_qty) as base_quantity'),'tbl_salesman.salesman_name as sales_name','tbl_salesman.id as salesman_id','tbl_salesman.salesman_code','tbl_warehouse.warehouse_code','tbl_warehouse.warehouse_name')
					->orderBy(DB::raw('sum(tbl_route_invoice_header.total_invoice_value)'),'desc')
					->groupBy('tbl_route_invoice_header.salesman_id','tbl_route_invoice_header.warehouse_id') 
					->whereYear('tbl_route_invoice_header.created_at', $request->year)
					->whereMonth('tbl_route_invoice_header.created_at', $request->month)
					->whereIn('tbl_route_invoice_header.region_id', $agent_id)
					->get();	  
		            
				   
					 //for chart
					  $get_data_chart = DB::table('tbl_route_invoice_header')
					 ->leftJoin('tbl_salesman', 'tbl_route_invoice_header.salesman_id', '=', 'tbl_salesman.id')
					 ->select('tbl_salesman.salesman_name as label',DB::raw('sum(tbl_route_invoice_header.total_invoice_value) as y'))
					 ->groupBy('label') 
					 ->limit(10)
					 ->whereYear('tbl_route_invoice_header.created_at', $request->year)
					 ->whereMonth('tbl_route_invoice_header.created_at', $request->month)
					 ->whereIn('tbl_route_invoice_header.region_id', $agent_id)
					 ->get()->all();	
					  
					   Session::put('year', $request->year);
					   Session::put('month', $request->month);
					   Session::put('region_id', $request->region);
					   Session::put('get_data1', $get_data1);
					   Session::put('get_data_chart', $get_data_chart);
			        }
	   }
		  
    }	  
  }
 public function saleman_performance_report_export($year,$month,$region,$subregion)
	{ 
	 
        return Excel::download(new SalesmanPerformanceExport($year,$month,$region,$subregion), 'saleman_performance_report.xlsx');		 
	}
	
   public function saleman_performance_report_exportpdf($year,$month,$region,$subregion)
	{ 	
       return Excel::download(new SalesmanPerformanceExport($year,$month,$region,$subregion), 'saleman_performance_report.pdf');		 
	}
 
  public function get_salesman_month_sales($salesman_id,$year,$month,$region1,$sub_region)
	{ 
		 //echo $salesman_id.','.$year.','.$month.','.$region1.','.$sub_region;
         //exit;
		
		$days = cal_days_in_month(0,$month,$year);
		//if($month=='all')
         // $month=0;			
		$month_name='';
		if($month==0){$month_name='All';}
		if($month==1){$month_name='January';}
		if($month==2){$month_name='February';}
		if($month==3){$month_name='March';}
		if($month==4){$month_name='April';}
		if($month==5){$month_name='May';}
		if($month==6){$month_name='June';}
		if($month==7){$month_name='July';}
		if($month==8){$month_name='August';}
		if($month==9){$month_name='September';}
		if($month==10){$month_name='Octobber';}
		if($month==11){$month_name='November';}
		if($month==12){$month_name='December';}
         	//dd($month);
        if($region1=='0')
           	$region1='s';
        if($sub_region=='0')
            $sub_region='s';	 
	     //when region sub region are null
		 if($region1=='s' && $sub_region=='s' )
		  {
			
		    ?>
		     <table style="width: 100%;" id="example" class="table table-hover table-striped table-bordered">
			      <thead> 	
				  	 <tr>
						 <th class="text-justify text-center">Date</th>
						  
						 <th class="text-justify text-center">Total Sales In Month</th>
						 
						 <th class="text-justify text-center">Total Qty In Month</th>
						  
					 </tr>
				  </thead>
				  <tbody>
				  <?php
				  $j=0;
				  for($i=1;  $i<=$days; $i++)
				     {

					    $get_data1 = DB::select("SELECT sum(h.total_invoice_value) as total_invoice, 
						sum(d.base_qty) as base_quantity FROM `tbl_route_invoice_header` as h 
						left join tbl_route_invoice_details as d on h.id = d.header_id 
							
							WHERE EXTRACT(DAY FROM h.created_at)=".$i."
							AND h.salesman_id=".$salesman_id."
							group by h.created_at");
			
						     //print_r($get_data1);	
						     $counte=count($get_data1);
                            if($counte>0)
							{								
							 ?>
							 <tr> 
								   <td class="font-weight-bold text-justify text-left"><?php  echo $i.' '.$month_name.'  '.$year; ?></td>
								   
								   <td class="font-weight-bold text-justify text-left"> <?php   echo $get_data1[0]->total_invoice;
																			  ?> </td>
									 <td class="font-weight-bold text-justify text-left"> <?php  echo $get_data1[0]->base_quantity;
																			   ?></td>
									
									 
							  </tr>
				              <?php
							}
						     $j++;
					  }
				    ?>
				  </tbody>
			</table>
                   <?php		
		   }
         else
           {
			 if($region1!='s' && $sub_region!='s')
		         {
				   ?>
					
				   <table style="width: 100%;" id="example" class="table table-hover table-striped table-bordered">
				   	   <thead> 	
						 <tr>
							 <th class="text-justify text-center">Date</th>
							 <th class="text-justify text-center">Total Sales In Month</th>
							 <th class="text-justify text-center">Total Qty In Month</th>
							  
						 </tr>
					   </thead>
					   <tbody>
				       <?php
					   $j=0;
					   for($i=1;  $i<=$days; $i++)
				          {
                           $get_data1 = DB::select("SELECT sum(h.total_invoice_value) as total_invoice, 
							sum(d.base_qty) as base_quantity FROM `tbl_route_invoice_header` as h 
							left join tbl_route_invoice_details as d on h.id = d.header_id 
								
								WHERE EXTRACT(DAY FROM h.created_at)=".$i."
								AND h.salesman_id=".$salesman_id."
								AND h.region_id=".$region1."
								AND h.subregion_id=".$sub_region."
									
								group by h.created_at");
								//print_r($get_data1);	
								 $counte=count($get_data1);
								 if($counte>0){
								  ?>
									<tr>
								      <td class="font-weight-bold text-justify text-left"><?php  echo $i.' '. $month_name.'  '.$year; ?></td>
								     <td class="font-weight-bold text-justify text-left"><?php  echo $get_data1[0]->total_invoice;   ?></td>
									 
									  <td class="font-weight-bold text-justify text-left"><?php  echo $get_data1[0]->base_quantity;
									 
									  ?></td>
							      </tr>
				                  <?php
						          }
						       $j++;
				            }
				           ?>
				         </tbody>
				   </table>
                         <?php		
				   
				}
			  else
				{
		         ?>
				   <table style="width: 100%;" id="example" class="table table-hover table-striped table-bordered">
					 <thead> 	
						<tr>
							 <th class="text-justify text-center">Date</th>
							  
							 <th class="text-justify text-center">Total Sales In Month</th>
							 
							 <th class="text-justify text-center">Total Qty In Month</th>
							  
						 </tr>
					  </thead>
					  <tbody>
					<?php
					$j=0;
					for($i=1;  $i<=$days; $i++)
				       {

						   $get_data1 = DB::select("SELECT sum(h.total_invoice_value) as total_invoice, 
							sum(d.base_qty) as base_quantity FROM `tbl_route_invoice_header` as h 
							left join tbl_route_invoice_details as d on h.id = d.header_id 
							
							WHERE EXTRACT(DAY FROM h.created_at)=".$i."
							AND h.salesman_id=".$salesman_id."
							AND h.region_id=".$region1."
							group by h.created_at");
                            //print_r($get_data1);	
                            $counte=count($get_data1);					 
                            ?>
						  	<tr>
							    <td class="font-weight-bold text-justify text-left"><?php  echo $i.' '.$month_name.'  '.$year; ?></td>
							   
							    <td class="font-weight-bold text-justify text-left"><?php  if($counte>0){echo $get_data1[0]->total_invoice;}
								else{ echo '0';}										   ?></td>
								 
								<td class="font-weight-bold text-justify text-left"><?php  if($counte>0){echo $get_data1[0]->base_quantity;}
								else{ echo '0/0';}										   ?></td>
							</tr>
				          <?php
						  $j++;
					   }
				      ?>
				     </tbody>
				   </table>
                   <?php		

				}
             
					 
		    }

       }
   public function get_salesman_name_month_sale($id)
	{
		$get_data1 = DB::table('tbl_salesman')
				
		->select('tbl_salesman.salesman_name','tbl_salesman.salesman_code')
		->where('tbl_salesman.id','=',$id)->get()->first();
		echo $get_data1->salesman_name.' - '.$get_data1->salesman_code;
    }
		
		
} 
