<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;
use App\Models\WarehouseModel;
use App\Models\MaterialCategoryModel;
use App\Models\SalesmanTargetModel;
use App\Models\RouteModel;
use App\Models\SalesmanModel;
use App\Models\CommissionRangeModel;
use App\Models\SalesmanTargetDetailsModel;

use App\Models\CustomerModel;
use Illuminate\Support\Facades\DB;
use Session;

class SalesmanTargetController extends Controller
 {
   public function add()
	{   
		 $material_category =MaterialCategoryModel::all()->sortByDesc('id')->where('status', '=', 'active');
		 $warehouse=WarehouseModel::all()->sortByDesc('id')->where('warehouse_type','=','1')->where('status', '=', 'active');
		 $commission=CommissionRangeModel::all()->sortByDesc('id')->where('status', '=', 'active');
		 
		 return view('Route_Transaction.salesman_target',compact('warehouse','material_category','commission'));
	}
   public function get_routename_filter($id)
	{
		 $salesman = DB::select("SELECT s.*
		 FROM tbl_salesman as s
		 LEFT JOIN tbl_route as route on s.route_id=route.id
		 LEFT JOIN tbl_warehouse as w on route.warehouse_id=w.id
		 WHERE w.id=$id");
		 ?>
		 <option  value="">     </option>
		 <?php
		 foreach($salesman as $salesmanname)
	     {
			?>
			<option value="<?php echo $salesmanname->id ?>"  ><?php echo $salesmanname->salesman_code?> - <?php echo $salesmanname->salesman_name ?></option>	
			<?php		
		 }
		
    }

   public function view($id)
    {  
		$material_category =MaterialCategoryModel::all()->sortByDesc('id')->where('status', '=', 'active');
		$result = DB::table('tbl_salesman_target')->select
				(
					'tbl_salesman_target.*',
					'tbl_material_category.category_name',
					'tbl_material_category.category_code',
					'tbl_total_count_amt.sales_amt',
					'tbl_total_count_qty.sales_qty',					
					'tbl_salesman.salesman_code',
					'tbl_salesman.salesman_name',
					'tbl_warehouse.warehouse_code',
					'tbl_warehouse.warehouse_name',
				)
		
		
		->leftJoin('tbl_salesman', 'tbl_salesman.id', '=', 'tbl_salesman_target.salesman_id')		
		->leftJoin('tbl_warehouse', 'tbl_warehouse.id', '=', 'tbl_salesman_target.warehouse_id')
		
		->leftJoin('tbl_material_category', 'tbl_material_category.id', '=', 'tbl_salesman_target.material_category_id')
		
		->leftJoin('tbl_total_count_amt', 'tbl_total_count_amt.id', '=', 'tbl_salesman_target.salesman_id')
		->leftJoin('tbl_total_count_qty', 'tbl_total_count_qty.id', '=', 'tbl_salesman_target.salesman_id')
		
		->where('tbl_salesman_target.id', '=', $id)
		
		->first();
		  //$data=$result->month;
		  
         
						
			            
	

	    return view('Route_Transaction.salesman_target_view',compact('result','material_category',));

    }
   public function save(Request $request)
	{  
		
		  $set_category    = array();
		  $material_category_id    = array();
		  // dd($request);

	      if($request->updated_id)
	        {
			 foreach($request['material_category_id'] as $key => $n)
			   { 
				 $set_category[$key] = $request->set_category[$key ];
				 $material_category_id[$key] = $request->material_category_id[$key ];
			   }	
		
			 $data2=array
			 (
				 'salesman_id'=>$request->salesman_id,
				 'warehouse_id'=>$request->warehouse_id,   
				 'target_based_on' =>$request->target_based_on,
				 'month' =>$request->month,
				 'year' =>$request->year,
				 'salesman_target' =>$request->salesman_target,
				 'total_sales' =>$request->total_sales,
				 'updated_user' => Session::get('user_id'),
				 'created_user' => Session::get('user_id'),
				 //'total_sales' =>$request->total_sales,
				 'set_category'       =>implode(",",$set_category),
				 'material_category_id'   =>implode(",",$material_category_id),
			 );
			 DB::table('tbl_salesman_target')->where('tbl_salesman_target.id','=',$request->updated_id)->update($data2);
              
			  foreach($request['comming_range'] as $key => $n)
					{
					 if($request->range[$key ]!='')
					    {
						   $data3=array
							(	 
							 'header_id'     =>$request->updated_id,
							 'comming_range' => $request->comming_range[$key ],
							 'range'           => $request->range[$key ], 
							);
                           DB::table('tbl_salesman_target_details')->insert($data3);							
						}
					}
			 return redirect(route('salesman_target_list'))->with('successMessage','Salesman Target Updated Successfully');

			}
          else 
			{
    	     foreach($request['material_category_id'] as $key => $n)
			   { 
				 $set_category[$key] = $request->set_category[$key ];
				 $material_category_id[$key] = $request->material_category_id[$key ];
			   }	
				 $data2=array
						(
						 'salesman_id'=>$request->salesman_id,
						 'warehouse_id'=>$request->warehouse_id,   
						 'target_based_on' =>$request->target_based_on,
						 'month' =>$request->month,
						 'year' =>$request->year,
						 'salesman_target' =>$request->salesman_target,
						 'total_sales' =>$request->total_sales,
						 'created_user' => Session::get('user_id'),
						 'updated_user' => Session::get('user_id'),
						 //'total_sales' =>$request->total_sales,
						 'set_category'       =>implode(",",$set_category),
						 'material_category_id'   =>implode(",",$material_category_id),
						);
					 
			 $header_id=DB::table('tbl_salesman_target')->insertGetId($data2);

             foreach($request['comming_range'] as $key => $n)
					{
					 if($request->range[$key ]!='')
					    {
						   $data3=array
							(	 
							 'header_id'     =>$header_id,
							 'comming_range' => $request->comming_range[$key ],
							 'range'           => $request->range[$key ], 
							);
                           DB::table('tbl_salesman_target_details')->insert($data3);							
						}
					}
				
			 return redirect(route('salesman_target_list'))->with('successMessage','Salesman Target Added Successfully');

		   }
	}
   public function list()
	{ 

		$result = DB::select("SELECT riheader.*, 
		warehouse.warehouse_code,warehouse.warehouse_name,
		salesman.salesman_name,salesman.salesman_code		
		FROM tbl_salesman_target as riheader
		LEFT JOIN tbl_salesman as salesman on riheader.salesman_id=salesman.id 
		LEFT JOIN tbl_warehouse as warehouse on riheader.warehouse_id=warehouse.id
         ORDER BY id DESC");		
		return view('Route_Transaction.salesman_target_list',compact('result'));
	
	}
   public function edit($id)
	{   
	    $commission=CommissionRangeModel::all()->sortByDesc('id')->where('status', '=', 'active');
		$salesman =SalesmanModel::all()->sortByDesc('id')->where('status', '=', 'active');
		$result = DB::table('tbl_salesman_target')->select
			(				
				'tbl_salesman_target.*',
				'tbl_salesman.salesman_name',
				'tbl_salesman.salesman_code',				
				'tbl_warehouse.warehouse_name',
				'tbl_warehouse.warehouse_code', 
			)
		
		->leftJoin('tbl_salesman', 'tbl_salesman.id', '=', 'tbl_salesman_target.salesman_id')		
		->leftJoin('tbl_warehouse', 'tbl_warehouse.id', '=', 'tbl_salesman_target.warehouse_id')
		 ->where('tbl_salesman_target.id', '=', $id)
		->get()->first();

		 $material_category =MaterialCategoryModel::all()->sortByDesc('id')->where('status', '=', 'active');
		 $warehouse=WarehouseModel::all()->sortByDesc('id')->where('status', '=', 'active');
		//dd($result);

		//dd($material_master);
	    return view('Route_Transaction.salesman_target',compact('result','material_category','salesman','warehouse','commission'));
    }
	   
   public function get_commission()
    {
		$commission=CommissionRangeModel::all()->sortByDesc('id')->where('status', '=', 'active');

		?>
		<option  value="">     </option>
		<?php
        foreach($commission as $warehouse)
		  {
			?>
			<option value="<?php echo $warehouse->id ?>"  ><?php echo $warehouse->range_code ?></option>	
			<?php		
		  }
		
	    //return response()->json($get_data);

    }
		 
 }
