<?php

namespace App\Http\Controllers;
use App\Models\SalesmanUnloadModel;
use App\Models\ManageCodeModel;
use Illuminate\Http\Request;
use App\Models\RouteModel;
use App\Models\SalesmanModel;
use App\Models\WarehouseModel;
use Session;
use Carbon\Carbon;
use Response;
use Illuminate\Support\Facades\DB;
use Maatwebsite\Excel\Facades\Excel;
use App\Exports\SalesmanUnloadExport;
use PDF;



class SalesmanUnloadController extends Controller
 {
   public function list(Request $request)
	{ 
	
		$current_date=date("Y-m-d");

		$where="";		
		if(count($request->all()) < 1)
		  {
			$where .= " AND DATE_FORMAT(riheader.created_at, '%Y-%m-%d') between '".$current_date."' and '".$current_date."'"; 
		  }	  
		if($request->fromdate!='')
		  {
			$where .= " AND DATE_FORMAT(riheader.created_at, '%Y-%m-%d') between '".$request->fromdate."' and '".$request->todate."'"; 
		  }
		 
		if($request->warehouse!='')
		  {
			$where .= "AND warehouse.id = '".$request->warehouse."'";
		  }
		 
		if($request->route!='')
		  {
			$where .= "AND route.id = '".$request->route."'";
		  }
	 
		if($request->salesman!='')
		  {
			$where .= "AND salesman.id = '".$request->salesman."'";
		  }
			//dd($request);
			 $route =RouteModel::all()->sortByDesc('id')->where('status', '=', 'active');
			 $warehouse=WarehouseModel::all()->sortByDesc('id')->where('warehouse_type','=','1')->where('status', '=', 'active');
			 $salesman =SalesmanModel::all()->sortByDesc('id')->where('status', '=', 'active');
	
		
		
			$result = DB::select("SELECT riheader.*, route.route_name,route.route_code,
			warehouse.warehouse_code,warehouse.warehouse_name,
			salesman.salesman_name,salesman.salesman_code  
			
			FROM tbl_route_unload_header as riheader
			
			LEFT JOIN tbl_route as route on riheader.route_id=route.id
			LEFT JOIN tbl_salesman as salesman on riheader.salesman_id=salesman.id 
			LEFT JOIN tbl_warehouse as warehouse on riheader.warehouse_id=warehouse.id
			
			WHERE riheader.id IS NOT NULL ".$where." ORDER BY id DESC");
				
			//dd($get_data)
			
		
			return view('Route_Transaction.salesman_unload_list',compact('result','route','salesman','warehouse'));
	}
	 
   public function view($id)
	{  
		$unload_code1 = DB::table('tbl_route_unload_header')
		->select('tbl_route_unload_header.*')->get()->sortByDesc('id')->first();
	 
		if($unload_code1=='')
		  {
			$getcode = ManageCodeModel::where('id', 1)->first();
			$last_code = $getcode->unload_code;
		  }
		else
		  {    
			 $getcode = $unload_code1->unload_code; 
			 $last_code = ++$getcode;
		  }
			 //dd($unload_code1);

			 $result = DB::table('tbl_route_unload_details')->select
			       (
					'tbl_route_unload_details.quantity',
					'tbl_material_master.material_code',
					'tbl_material_master.material_name',
					'tbl_salesman.salesman_code',
					'tbl_salesman.salesman_name',
					 
					'tbl_route.route_code',
					'tbl_route.route_name',
					'tbl_route_unload_header.unload_time',
					'tbl_unit_of_measurement.uom_code',
					'tbl_unit_of_measurement.unit_notation',
					'tbl_route_unload_header.unload_code',					
				   )
					->leftJoin('tbl_material_master', 'tbl_material_master.id', '=', 'tbl_route_unload_details.material_id')
					->leftJoin('tbl_route_unload_header', 'tbl_route_unload_header.id', '=', 'tbl_route_unload_details.header_id')	
					->leftJoin('tbl_salesman', 'tbl_salesman.id', '=', 'tbl_route_unload_header.salesman_id')		
					->leftJoin('tbl_route', 'tbl_route.id', '=', 'tbl_route_unload_header.route_id')
					->leftJoin('tbl_unit_of_measurement', 'tbl_unit_of_measurement.id', '=', 'tbl_route_unload_details.uom_id')
					
					 ->where('tbl_route_unload_details.header_id', '=', $id)
						
					 ->first();

					 
				 return view('Route_Transaction.salesman_unload_view',compact('result','last_code'));
	 }
	 
	public function get_route_filter($id,$url_route)
     {
		 $route =RouteModel::all()->sortByDesc('id')->where('status', '=', 'active')->where('warehouse_name', '=', $id);
		 
		    ?>
			<option  value="">     </option>
			<?php
		    foreach($route as $routename)   
			  { 
				?>
				<option <?php if($routename->id==$url_route) { echo "selected";} ?> value="<?php echo $routename->id ?>"  ><?php echo $routename->route_code.' - '.$routename->route_name ?></option>	
				<?php		
			  }
				 
	  }

	  public function export($id){

		return Excel::download(new SalesmanUnloadExport($id),'salesman_unload.xlsx');
	  }
	  
	  public function exportpdf($id){
		  
		  
		  $get_data= DB::table('tbl_route_unload_header')
		  ->leftJoin('tbl_route','tbl_route_unload_header.route_id','=','tbl_route.id')
		  ->leftJoin('tbl_salesman','tbl_route_unload_header.salesman_id','=','tbl_salesman.id')
		  ->leftJoin('tbl_warehouse','tbl_route_unload_header.warehouse_id','=','tbl_warehouse.id')
		  ->select('tbl_route_unload_header.*','tbl_warehouse.warehouse_code','tbl_warehouse.warehouse_name','tbl_salesman.salesman_code','tbl_salesman.salesman_name','tbl_salesman.contact_number','tbl_route.route_code','tbl_route.route_name')
		  ->where('tbl_route_unload_header.id', '=', $id)
		  ->get();
		  
		   $get_data_details =DB::table('tbl_route_unload_details')
		   ->leftJoin('tbl_material_master','tbl_route_unload_details.material_id','=','tbl_material_master.id')
		   ->leftJoin('tbl_unit_of_measurement','tbl_route_unload_details.uom_id','=','tbl_unit_of_measurement.id')
		   ->select('tbl_route_unload_details.*','tbl_material_master.material_name','tbl_unit_of_measurement.unit_notation')
		   ->where('tbl_route_unload_details.header_id', '=', $id)
		   ->get();  
					 
					 $pdf=PDF::loadView('export.pdf.stock_unload_pdf',compact('get_data','get_data_details'));
		   
		             return  $pdf->download('stock_unload.pdf');
	  } 
 }
