<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;
use App\Models\ShelfDisplayModel;
use App\Models\RegionTypeModel;
use App\Models\SubRegionTypeModel;
use App\Models\CustomerModel;
use Illuminate\Support\Facades\DB;
use Session;

class ShelfDisplayController extends Controller
 {
   public function add()
    {
	   $get_data=ShelfDisplayModel::all()->sortByDesc('id')->where('status', '=', 'active');
	   $region =RegionTypeModel::all()->sortByDesc('id')->where('status', '=', 'active');
	   $sub_region =SubRegionTypeModel::all()->sortByDesc('id')->where('status', '=', 'active');
	   
	   return view('Merchandising.shelf_display',compact('region','get_data','sub_region'));
	} 
	
   public function get_subregion($id, $subregion_id)
	{ 
	   $get_data=SubRegionTypeModel::all()->sortByDesc('id')->where('region_id', '=', $id)->where('status', '=', 'active'); 
		?>
		 <option value=""></option>
	     <?php foreach($get_data as $subregion_name) { ?>
			
		 <option value="<?php echo $subregion_name->id ?>" <?php if($subregion_name->id == $subregion_id) { echo "selected"; } ?> ><?php echo $subregion_name->sub_region_code." - ".$subregion_name->sub_region_name ?></option>	
		
	    <?php }
    }
	
	public function get_customer1($id, $customer_id)
	{ 
		
	   $get_data=CustomerModel::all()->sortByDesc('id')->where('customer_type', '=', '3')->where('sub_region', '=', $id);
	  /*  $get_data=DB::table('tbl_customer')
		->select('tbl_customer.*')
		->whereRaw("find_in_set('".$id."',tbl_customer.customer_name)")
		->where('status', '=', 'active')
		->get();
		//dd($get_data);
		
	   $sub = explode(",",$customer_id); */
		
	   if($customer_id!=0){
		   
			$sub = explode(",",$customer_id);	

			foreach($get_data as $data){ 
			
			?><option <?php if(in_array($data->id, $sub)) { echo "selected"; } ?> value="<?php echo $data->id ?>" > <?php echo $data->customer_code." - ".$data->customer_name ?></option>	
		
			<?php 
			}
		}else{

			foreach($get_data as $data){ 
				
			?> 
			<option value="<?php echo $data->id ?>" > <?php echo $data->customer_code." - ".$data->customer_name ?></option>	
	
			<?php 
			}
		}	
    }
	
   public function save(Request $request)
	{   
	//dd($request);
	   $customer    = array();
	   $data=new ShelfDisplayModel;           
	   
	   if($request->updated_id)
	   {  

		foreach($request['customer'] as $key => $n)
		  { 
			 $customer[$key] = $request->customer[$key ];
					
		  }
		 $data = ShelfDisplayModel::find($request->updated_id);         
		 $data->name=$request->name;
		 $data->valid_from=$request->valid_from;
		 $data->valid_to=$request->valid_to;
		 $data->height=$request->height;
		 $data->width	=$request->width	;  
		 $data->depth=$request->depth;
		 $data->capacity=$request->capacity;
		 $data->region=$request->region;
		 $data->sub_region=$request->sub_region;
		 $data->customer=implode(",",$customer);
		 $data->status=$request->status;
		 $data->save();

		 return redirect(route('shelf_display_list'))->with('successMessage','Shelf Display Updated Successfully');
	
	   } else
	       {
			
			 foreach($request['customer'] as $key => $n)
			   { 
				 $customer[$key] = $request->customer[$key ];
					
			   }
			 
			 $data->name=$request->name;
			 $data->valid_from=$request->valid_from;
			 $data->valid_to=$request->valid_to;
			 $data->height=$request->height;
			 $data->width	=$request->width	;  
			 $data->depth=$request->depth;
			 $data->capacity=$request->capacity;
			 $data->region=$request->region;
			 $data->sub_region=$request->sub_region;
			 $data->customer=implode(",",$customer);
			 $data->status=$request->status;
			 $data->save();
			 
		     return redirect(route('shelf_display_list'))->with('successMessage','Shelf Display Added Successfully');
		   } 
	}
	
   public function list()
	{
		$get_data = DB::table('tbl_shelf_display')
		->leftJoin('tbl_region', 'tbl_shelf_display.region', '=', 'tbl_region.id')
		->leftJoin('tbl_sub_region', 'tbl_shelf_display.sub_region', '=', 'tbl_sub_region.id')
		->select('tbl_shelf_display.*', 'tbl_region.region_name','tbl_sub_region.sub_region_name')->orderBy('id', 'DESC')->get();
		//dd($get_data);   

		return view('Merchandising.shelf_display_list',compact('get_data'));
    }
	 
   public function edit($id)
    {
		$get_data=ShelfDisplayModel::find($id);
		$region =RegionTypeModel::all()->sortByDesc('id')->where('status', '=', 'active');
		$sub_region =DB::table('tbl_shelf_display')->leftJoin('tbl_sub_region', 'tbl_shelf_display.sub_region', '=', 'tbl_sub_region.id')
		->select('tbl_sub_region.id','tbl_sub_region.sub_region_name','tbl_sub_region.sub_region_code')->where('tbl_shelf_display.id', '=', $id)->first();
       
	 	$customers=CustomerModel::all()->sortByDesc('id')->where('status', '=', 'active')->where('customer_type', '=', '3');
		$shelf_customers = DB::select('SELECT customer.id,customer.customer_name,customer.customer_code  FROM tbl_shelf_display as s_display 
 		LEFT JOIN  tbl_customer as customer ON find_in_set(customer.id, s_display.customer) WHERE s_display.id='.$id.'');
		
		return view('Merchandising.shelf_display',compact('get_data','region','sub_region','shelf_customers','customers'));
    }
	
   public function view($id)
	{    
		//$get_data=BankModel::find($id);
		$get_data = DB::table('tbl_shelf_display')
		//dd($get_data);
		->leftJoin('tbl_region', 'tbl_shelf_display.region', '=', 'tbl_region.id')
		->leftJoin('tbl_sub_region', 'tbl_shelf_display.sub_region', '=', 'tbl_sub_region.id')
		->leftJoin('tbl_customer', 'tbl_shelf_display.customer', '=', 'tbl_customer.id')
		->select('tbl_shelf_display.*', 'tbl_region.region_name','tbl_region.region_code','tbl_sub_region.sub_region_name','tbl_sub_region.sub_region_code','tbl_customer.customer_code','tbl_customer.customer_name')
		->where('tbl_shelf_display.id', '=', $id)
        ->first();
		
		$data = DB::select('SELECT t2.customer_name FROM tbl_shelf_display as t1 
		LEFT JOIN  tbl_customer as t2 ON find_in_set(t2.id, t1.customer) WHERE t1.id='.$id.'');
		
		$i = 0;
        $code = array();
        foreach($data as $key[$i] => $datas){
            
            $code[$i] = $datas->customer_name;
           
            $i++;
        }

		$customer= implode(",",$code);

		return view('Merchandising.shelf_display_view',compact('get_data','customer'));
	}
 }
