<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;
use App\Models\WarehouseModel;
use App\Models\CurrencyTypeModel;
use App\Models\ManageCodeModel;
use App\Models\MaterialMasterModel;
use App\Models\SalesmanInvoiceModel;
use App\Models\CustomerModel;
use App\Models\MaterialCategoryModel;
use App\Models\UnitOfMeasurementModel;
use App\Models\RouteModel;
use App\Models\UserModel;
use App\Models\StockAdjustModel;
use App\Models\ReasonModel;
use Carbon\Carbon;
use Session;
use Illuminate\Support\Facades\DB;
 
use Maatwebsite\Excel\Facades\Excel;
use App\Exports\StockAdujestmentExport;
use PDF;

class StockAdjustController extends Controller
 {
	
   public function list(Request $request)
	{
	  $current_date=date("Y-m-d");	
	  $where="";		
	  if(count($request->all()) < 1)
		{
			$where .= " AND DATE_FORMAT(riheader.created_at, '%Y-%m-%d') between '".$current_date."' and '".$current_date."'"; 
		}	  
	  if($request->fromdate!='')
		{
			$where .= " AND DATE_FORMAT(riheader.created_at, '%Y-%m-%d') between '".$request->fromdate."' and '".$request->todate."'"; 
		}
	 
	  if($request->warehouse!='')
		{
			$where .= "AND warehouse.id = '".$request->warehouse."'";
		}
		 
	  if($request->route!='')
		{
			$where .= "AND route.id = '".$request->route."'";
		}
		
	    $warehouse=WarehouseModel::all()->sortByDesc('id')->where('status', '=', 'active')->whereIn('warehouse_type', [0,1]);
			
		$get_data = DB::select("SELECT riheader.*, 
		warehouse.warehouse_code,warehouse.warehouse_name,
		reason.reason_code,reason.reason_name,adjustment_type
		
		FROM tbl_stock_adjust_header as riheader
		LEFT JOIN tbl_warehouse as warehouse on riheader.warehouse=warehouse.id
		LEFT JOIN tbl_reason as reason on riheader.adjustment_type=reason.id
		WHERE riheader.id IS NOT NULL ".$where."ORDER BY id DESC ");
		
		/*$get_data_details =DB::table('tbl_stock_adjust_details')

			  ->leftJoin('tbl_stock_adjust_header', 'tbl_stock_adjust_details.header_id', '=', 'tbl_stock_adjust_header.id')
			  ->select('tbl_stock_adjust_details.balance_qty')
			  ->get()->all();*/
				
		//dd($get_data);
		 
		return view('Stock_Management.stock_adjust_list',compact('warehouse','get_data'));
	}
		
   public function add()
	{   	
		$user_id=Session::get('user_id');	  
		$result = DB::table('tbl_route_invoice_header')
		 ->select('tbl_route_invoice_header.*')->get()->sortByDesc('id')->first();
	 
	    if($result=='')
		  {
			$getcode = ManageCodeModel::where('id', 1)->first();
			$last_code = $getcode->invoice_number_code;
		  }
		else
		  {
			 $getcode = $result->invoice_number; 
			 $last_code = ++$getcode;
		  }

		  $material_master = DB::table('tbl_material_master')
		  ->leftJoin('tbl_unit_of_measurement', 'tbl_material_master.uom_id', '=', 'tbl_unit_of_measurement.id')
		
		  ->select('tbl_material_master.*', 'tbl_unit_of_measurement.uom_name')
	
		  ->get()->all();
		
		  $material_category =MaterialCategoryModel::all()->sortByDesc('id')->where('status', '=', 'active');		  
		  $customer_type =CustomerModel::all()->sortByDesc('id')->where('status', '=', 'active');		  
		  $warehouse =WarehouseModel::all()->sortByDesc('id')->whereIn('warehouse_type', [0,1])->where('status', '=', 'active');
		  $material =MaterialMasterModel::all()->sortByDesc('id')->where('status', '=', 'active');	
		  $reason1 =ReasonModel::all()->sortByDesc('id')->where('status', '=', 'active');	

          $login_user = DB::table('tbl_user')
		  ->leftJoin('tbl_company', 'tbl_user.company_id', '=', 'tbl_company.id')
		  ->leftJoin('tbl_currency_type', 'tbl_company.currency_id', '=', 'tbl_currency_type.id')
		  ->select('tbl_user.id', 'tbl_company.currency_id','tbl_currency_type.currency_notation')
		  ->where('tbl_user.id', '=', $user_id)
		  ->get()->first();
		  //dd($login_user);
		 
    	  return view('Stock_Management.stock_adjust',compact('last_code','customer_type','material_master','material_category','warehouse','login_user','material','reason1'));
	 }

	public function get_material_of_warehouse($id)

	 {
		  $material=DB::table('tbl_warehouse_stock')
			 ->leftJoin('tbl_material_master', 'tbl_warehouse_stock.material_id', '=', 'tbl_material_master.id')
			 ->select('tbl_material_master.material_code','tbl_material_master.material_name','tbl_material_master.id')
			 ->where('warehouse_id',$id)
			 ->get()->all();

		   foreach ($material as $value)
		   {
         	?>
			  <option value="<?php echo $value->id; ?>"><?php echo $value->material_code; ?>-<?php echo $value->material_name; ?></option>
			
		    <?php

		   }
	 }
		
	public function get_material_price($id,$val,$uom,$reason)
	 {
	    if($reason == 1)
		  {
			$alt_unit_price = DB::select('SELECT qty as stock FROM `tbl_warehouse_stock` as ws WHERE ws.warehouse_id='.$id.' AND  `material_id` ='.$val.'');
			
			$s=0;
			$count=count($alt_unit_price);
					if($count > 0)
					echo $alt_unit_price[0]->stock;
					else
					echo $s;
		  }
		else{
			  $alt_unit_price = DB::select('SELECT return_stock as stock FROM `tbl_warehouse_stock` as ws WHERE ws.warehouse_id='.$id.' AND  `material_id` ='.$val.'');
			
			  $s=0;
			  $count=count($alt_unit_price);
					if($count > 0)
					echo $alt_unit_price[0]->stock;
					else
					echo $s;
		    }
			
	 }
		
	public function get_material_detailsUom($id,$row)
	 {
			
		$material_master = DB::table('tbl_material_master')
			->leftJoin('tbl_unit_of_measurement', 'tbl_material_master.uom_id', '=', 'tbl_unit_of_measurement.id')
			
			->select('tbl_material_master.*', 'tbl_unit_of_measurement.unit_notation','tbl_unit_of_measurement.uom_code')
			->where('tbl_material_master.id','=',$id)
			->get()->all();
			
		$alt_uom = explode(",",$material_master[0]->alt_uom);
	   
		$key = array_search($material_master[0]->uom_id, $alt_uom);
	   
		$alt_alt_packing_size = explode(",",$material_master[0]->alt_packing_size);

		
		echo $material_master[0]->unit_notation.'-'.$material_master[0]->uom_id.'-'. $alt_alt_packing_size[$key];
				    
	 }
	
    public function get_material()
	 {
		
		$material =MaterialMasterModel::all()->sortByDesc('id')->where('status', '=', 'active');
	
		?>
		<option  value="">     </option>
		<?php
		foreach($material as $material_name)
		  {
			?>
			<option value="<?php echo $material_name->id ?>"  ><?php echo $material_name->material_code.' - '.$material_name->material_name ?></option>	
			<?php		
		  }
		 
	 }

	public function save(Request $request)
	 {
				
			  
		$current = Carbon::now();
		$date = str_replace('/', '-', $request->adjust_date);
		$newDate = date("d-m-Y", strtotime($date));
		
		
		
		$data3=array
			(
			 'warehouse'           =>  $request->warehouse_name,
			 'invoice_date'        =>  $newDate,
			 'adjustment_type'     =>  $request->reason_type,
			 'reason_name'         =>  $request->reason_is,
			 'remark'              =>  $request->remark,
			 'created_at'          =>  $current,
			 );
		$header_id =DB::table('tbl_stock_adjust_header')->insertGetId($data3); 
				 
	    if(count($request->material_name)>0)
		 
		 {
			foreach($request['material_name'] as $key => $n)
			  {
				if($request->quantity[$key ]!='')
				  {
					$data2=array(
					  'material_id'   => $request->material_name[$key ],
					  'header_id'       => $header_id,
					  'uom_id'             => $request->uomh[$key ],
					  'adjustment_type' => $request->adjs_type[$key ],
					  'available_qty'   => $request->price[$key ],
					  'adjust_qty'      => $request->quantity[$key ],
					  'balance_qty'     => $request->discount[$key ],
					  'created_at'      => $current,
					   );
				       DB::table('tbl_stock_adjust_details')->insert($data2); 
				 
				       //storing data in warehouse_stock
					   $material_master = DB::table('tbl_warehouse_stock')
					   ->where('tbl_warehouse_stock.warehouse_id','=',$request->warehouse_name)
					   ->where('tbl_warehouse_stock.material_id','=',$request->material_name[$key])
					   ->get()->all();
					   $count=count($material_master);
					   if($count>0)
				         {
						  if($request->reason_type==1)
						    {	 
							   //updating data in warehouse_stock
								DB::table('tbl_warehouse_stock')
								  ->where('warehouse_id', $request->warehouse_name)
								  ->where('material_id', $request->material_name[$key ])
								  ->update([
										  'qty' => $request->discount[$key]*$request->  packing_size[$key]
										   ]);
							}else{
								   DB::table('tbl_warehouse_stock')
								    ->where('warehouse_id', $request->warehouse_name)
								    ->where('material_id', $request->material_name[$key ])
								    ->update([
										  'return_stock' => $request->discount[$key]*$request->  packing_size[$key]
										   ]);
						         }
						  }
					    else
					      {
						    //when stock does not exist
						  
							$warehouse_details = DB::table('tbl_warehouse')
								->select('tbl_warehouse.region',  'tbl_warehouse.sub_region')
								->where('tbl_warehouse.id','=',$request->warehouse_name)
								->get()->first();
							    $material_details= DB::table('tbl_material_master')
											->select('tbl_material_master.uom_id',  'tbl_material_master.material_category_id',  'tbl_material_master.material_types_id')
											->where('tbl_material_master.id','=',$request->material_name[$key ])
										    ->get()->first();
							if($request->reason_type==1)
							  {		
							   $data4=array(
										  'region'                => $warehouse_details->region,
										  'subregion'             => $warehouse_details->sub_region,
										  'warehouse_id'          => $request->warehouse_name,
										  'material_category_id'  => $material_details->material_category_id,
										  'material_id'           => $request->material_name[$key],
										  'uom_id'                => $material_details->uom_id,
										  'qty'                   => $request->discount[$key]*$request->  packing_size[$key],
										  'material_type'         => $material_details->material_types_id,
										  'created_at'            => $current,
										  );
							  }else{
								     $data4=array(
										  'region'                => $warehouse_details->region,
										  'subregion'             => $warehouse_details->sub_region,
										  'warehouse_id'          => $request->warehouse_name,
										  'material_category_id'  => $material_details->material_category_id,
										  'material_id'           => $request->material_name[$key],
										  'uom_id'                => $material_details->uom_id,
										  'return_stock'                   => $request->discount[$key]*$request->  packing_size[$key],
										  'material_type'         => $material_details->material_types_id,
										  'created_at'            => $current,
										  );
							       }
							  DB::table('tbl_warehouse_stock')->insert($data4);
						   }			 
				   } 
			  }
		  
	     }
					return redirect(route('stock_adjust_list'))->with('successMessage','Stock Uploaded Successfully');
	}

   public function view($id)
	{   
	
				
		$get_data =DB::table('tbl_stock_adjust_header')
		
		->leftJoin('tbl_warehouse', 'tbl_stock_adjust_header.warehouse', '=', 'tbl_warehouse.id')
		->leftJoin('tbl_reason', 'tbl_stock_adjust_header.adjustment_type', '=', 'tbl_reason.id')
		->select('tbl_stock_adjust_header.*','tbl_warehouse.warehouse_name','tbl_warehouse.warehouse_code','tbl_reason.reason_name','tbl_reason.reason_code')->where('tbl_stock_adjust_header.id', '=',$id)->get()->first();
		 
					
	    $get_data_details =DB::table('tbl_stock_adjust_details')
        ->leftJoin('tbl_material_master', 'tbl_stock_adjust_details.material_id', '=', 'tbl_material_master.id')
	    ->leftJoin('tbl_unit_of_measurement', 'tbl_stock_adjust_details.uom_id', '=', 'tbl_unit_of_measurement.id')

	    ->select('tbl_stock_adjust_details.*','tbl_material_master.material_name','tbl_material_master.material_code','tbl_unit_of_measurement.unit_notation')->where('tbl_stock_adjust_details.header_id', '=', $id)->get()->all();
		 /* dd($get_data_details); */   
		
	    return view('Stock_Management.stock_adjustment_view',compact('get_data','get_data_details'));
		 
    }


 public function get_reason($route)
	{ 
        
		$data =ReasonModel::select('reason_name','id')->where('reason_type','=',$route)->where('status', '=', 'active')->get();
		
		$html = '';
      if(count($data) > 0) {
        foreach($data as $reason_name) {
			$html .='<option value=""></option>';
            $html .= '<option class="opt_v1" value="' . $reason_name->id . '">'. $reason_name->reason_name;
            $html .= "</option>";
        }
      return response()->json($html);//then sent this data to ajax success 
	}
		
	}
	
	
	 public function export($id){

		return Excel::download(new StockAdujestmentExport($id),'salesman_adujestment.xlsx');
	  }
	
	 public function pdfexport($id){
		 
		 	$get_data =DB::table('tbl_stock_adjust_header')
		->leftJoin('tbl_warehouse', 'tbl_stock_adjust_header.warehouse', '=', 'tbl_warehouse.id')
		->leftJoin('tbl_reason', 'tbl_stock_adjust_header.adjustment_type', '=', 'tbl_reason.id')
		  
		->select('tbl_stock_adjust_header.*','tbl_warehouse.warehouse_code','tbl_warehouse.warehouse_name','tbl_reason.reason_code','tbl_reason.reason_name')
		 ->where('tbl_stock_adjust_header.id', '=', $id)
		  ->get();
		 $get_data_details =DB::table('tbl_stock_adjust_details')
        ->leftJoin('tbl_material_master', 'tbl_stock_adjust_details.material_id', '=', 'tbl_material_master.id')
	    ->leftJoin('tbl_unit_of_measurement', 'tbl_stock_adjust_details.uom_id', '=', 'tbl_unit_of_measurement.id')

	    ->select('tbl_stock_adjust_details.*','tbl_material_master.material_name','tbl_material_master.material_code','tbl_unit_of_measurement.unit_notation','tbl_unit_of_measurement.uom_code')
		->where('tbl_stock_adjust_details.header_id', '=', $id)
		   ->get();
		   
		   $pdf=PDF::loadView('export.pdf.stock_adujestment_pdf',compact('get_data','get_data_details'));
		   
		             return  $pdf->download('stock_adjustment.pdf'); 
	 
	  }
	
	
	
	
	
 }
 