<?php

namespace App\Http\Controllers;
use Illuminate\Http\Request;
use App\Models\SupplierModel;
use App\Models\CountryTypeModel;
use App\Models\SupplierTypeModel;
use App\Models\CurrencyTypeModel ;
use App\Models\CityTypeModel ;
use App\Models\PaymentTermModel;
use App\Models\ManageCodeModel;
use Illuminate\Support\Facades\DB;
use Session;

class SupplierController extends Controller
 {
   public function list()
	{
		//$get_data = SupplierModel::all()->sortByDesc('id');
		$get_data = DB::table('tbl_supplier')
		->leftJoin('tbl_country', 'tbl_supplier.country_id', '=', 'tbl_country.id')
		->leftJoin('tbl_supplier_type', 'tbl_supplier.supplier_type_id', '=', 'tbl_supplier_type.id')
		->leftJoin('tbl_currency_type', 'tbl_supplier.supplier_currency_id', '=', 'tbl_currency_type.id')
		->leftJoin('tbl_city', 'tbl_supplier.city_id', '=', 'tbl_city.id')
		->select('tbl_supplier.*', 'tbl_country.country_code' ,'tbl_country.country_name','tbl_currency_type.currency_code','tbl_currency_type.currency_name','tbl_supplier_type.supplier_type_name','tbl_supplier_type.supplier_type_code','tbl_city.city_name')
		->orderBy('id', 'DESC')->get();
	
		return view('Master_Configuration.supplier_list',compact('get_data'));
	 }
	
    public function view($id)
	 {    
		//$get_data=SupplierModel::find($id);
		$get_data = DB::table('tbl_supplier')
		->leftJoin('tbl_country', 'tbl_supplier.country_id', '=', 'tbl_country.id')
		->leftJoin('tbl_currency_type', 'tbl_supplier.supplier_currency_id', '=', 'tbl_currency_type.id')
		->leftJoin('tbl_supplier_type', 'tbl_supplier.supplier_type_id', '=', 'tbl_supplier_type.id')
		->leftJoin('tbl_payment_term', 'tbl_supplier.payment_term', '=', 'tbl_payment_term.id')
		->leftJoin('tbl_city', 'tbl_supplier.city_id', '=', 'tbl_city.id')
		
		->select('tbl_supplier.*', 'tbl_country.country_code' ,'tbl_country.country_name','tbl_currency_type.currency_name','tbl_currency_type.currency_code','tbl_payment_term.payment_code','tbl_payment_term.payment_term','tbl_supplier_type.supplier_type_name' ,'tbl_supplier_type.supplier_type_code','tbl_city.city_name','tbl_city.city_code')
		->where('tbl_supplier.id', '=' ,$id)
		->first();
	
		return view('Master_Configuration.supplier_view',compact('get_data'));
	 }
	
	public function add()
	 {
		$result =SupplierModel::get()->sortByDesc('id')->first();
		if($result=='')
		  {
			$getcode = ManageCodeModel::where('id', 1)->first();
			$last_code = $getcode->supplier_code;
		  }
		else
		  {
			$getcode = $result->supplier_code; 
			$last_code = ++$getcode;
		  } 
			$supliertype =SupplierTypeModel::all()->sortByDesc('id')->where('status', '=', 'active');
			$country =CountryTypeModel::all()->sortByDesc('id')->where('status', '=', 'active');
			$currency =CurrencyTypeModel::all()->sortByDesc('id')->where('status', '=', 'active');
			$payment_term =PaymentTermModel::all()->sortByDesc('id')->where('status', '=', 'active');
			
			return view('Master_Configuration.supplier',compact('country','currency','payment_term','last_code','supliertype'));
	}
	
   public function edit($id)
	{
		$get_data=SupplierModel::find($id);
		$currency =CurrencyTypeModel::all()->sortByDesc('id')->where('status', '=', 'active');
		$country =CountryTypeModel::all()->sortByDesc('id')->where('status', '=', 'active');
		$city= CityTypeModel::all()->sortByDesc('id')->where('status', '=', 'active');
		$payment_term =PaymentTermModel::all()->sortByDesc('id')->where('status', '=', 'active');
		
		$last_code = $get_data->supplier_code;
		$supliertype =SupplierTypeModel::all()->sortByDesc('id')->where('status', '=', 'active');
		
		return view('Master_Configuration.supplier',compact('get_data','currency','country','city','payment_term','last_code','supliertype'));
	}
	
   public function save(Request $request)
	{	
		$data=new SupplierModel;			
		if($request->updated_id) 
		  {			
			$data = SupplierModel::find($request->updated_id);		
			$data->supplier_type_id=$request->supplier_type;
			$data->supplier_code=$request->supplier_code;
			$data->supplier_name=$request->supplier_name;
			$data->tin_number=$request->tin_number;
			$data->credit_days=$request->credit_days;
			$data->supplier_currency_id=$request->supplier_currency;
			$data->payment_term=$request->payment_term;
			$data->country_id=$request->country;
			$data->city_id=$request->city;
			$data->address=$request->address;
			$data->email_id=$request->email_id;
			$data->contact_number=$request->contact_number;
			$data->bank_account_number1=$request->bank_account_number1;
			$data->bank_account_number2=$request->bank_account_number2;
			$data->bank_branch=$request->bank_branch;
			$data->bank_name=$request->bank_name;
			$data->bank_address=$request->bank_address;
			$data->bank_code=$request->bank_code;
			$data->erp_material_code=$request->erp_material_code;
			$data->tin_no=$request->tin_no;
			 $data->updated_user= Session::get('user_id');
			$data->company_id= Session::get('company_id');
			$data->status=$request->status;
			$data->save();
			return redirect(route('supplier_list'))->with('successMessage','Supplier Updated Successfully');
	
		 } else
			 {
				$data->supplier_type_id=$request->supplier_type;
				$data->supplier_code=$request->supplier_code;
				$data->supplier_name=$request->supplier_name;
				$data->tin_number=$request->tin_number;
				$data->supplier_currency_id=$request->supplier_currency;
				$data->payment_term=$request->payment_term;
				$data->country_id=$request->country;
				$data->city_id=$request->city;
				$data->address=$request->address;
				$data->email_id=$request->email_id;
				$data->contact_number=$request->contact_number;
				$data->bank_account_number1=$request->bank_account_number1;
				$data->bank_account_number2=$request->bank_account_number2;
				$data->bank_branch=$request->bank_branch;
				$data->bank_name=$request->bank_name;
				$data->bank_address=$request->bank_address;
				$data->bank_code=$request->bank_code;
				$data->erp_material_code=$request->erp_material_code;
				$data->tin_no=$request->tin_no;
				$data->created_user= Session::get('user_id');
				$data->company_id= Session::get('company_id');
				$data->status=$request->status;
				$data->save();
				return redirect(route('supplier_list'))->with('successMessage','Supplier Added Successfully');
		
			 }	
    	
	 }
    public function get_country($id, $city_id)
	 {	
           //dd($city_id);	 
		$get_data=CityTypeModel::all()->sortByDesc('id')->where('country_id', '=', $id)->where('status', '=', 'active');
		 //dd($get_data);
		?>
		<option  value="">     </option>
		<?php
		foreach($get_data as $cityname)
		  {
			?>
			<option value="<?php echo $cityname->id ?>" <?php if($cityname->id == $city_id) { echo "selected"; } ?> ><?php echo $cityname->city_code." - ".$cityname->city_name ?></option>	   
			<?php       
		  }
			
	 }
 }
