<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;
use App\Models\TradingCenterModel;
use App\Models\RouteModel;
use Illuminate\Support\Facades\DB;
use App\Models\ManageCodeModel;
use Session;

class TradingCenterController extends Controller
 {
   public function list()
	{		
		$get_data = TradingCenterModel::all()->sortByDesc('id');
		$get_data = DB::table('tbl_trading_center')
		->leftJoin('tbl_route', 'tbl_trading_center.route_id', '=', 'tbl_route.id')
		
		->select('tbl_trading_center.*', 'tbl_route.route_name', 'tbl_route.route_code')
		->orderBy('id', 'DESC')->get();

		
		
		return view('Master_Configuration.trading_center_list',compact('get_data'));
	}
	

   public function add()
	{ 
		$result =TradingCenterModel::get()->sortByDesc('id')->first();
		if($result=='')
		  {
			$getcode = ManageCodeModel::where('id', 1)->first();
			$last_code = $getcode->trading_center_code;
		  }
		else
		  {
			 $getcode = $result->trading_center_code; 
			 $last_code = ++$getcode;
		  } 

		$route =RouteModel::all()->sortByDesc('id')->where('status', '=', 'active');
	
		return view('Master_Configuration.trading_center',compact('route','last_code'));
	}
	
   public function edit($id)
	{
		$get_data=TradingCenterModel::find($id);
		$route =RouteModel::all()->sortByDesc('id')->where('status', '=', 'active');
		$last_code = $get_data->trading_center_code;
		return view('Master_Configuration.trading_center',compact('get_data','route','last_code'));
	}
		
   public function view($id)
	{    
	    $get_data=TradingCenterModel::find($id);
	    $get_data = DB::table('tbl_trading_center')
		->leftJoin('tbl_route', 'tbl_trading_center.route_id', '=', 'tbl_route.id')
		->select('tbl_trading_center.*', 'tbl_route.route_id','tbl_route.route_name')
		->where('tbl_trading_center.id', '=', $id)
		->first();
	 
		//dd( $get_data);
		return view('Master_Configuration.trading_center_view',compact('get_data')); 
	}  

   public function save(Request $request)
	{
	
	   $data=new TradingCenterModel;			
	   if($request->updated_id) 
		 {
			
			$data = TradingCenterModel::find($request->updated_id);			
			$data->trading_center_code=$request->trading_center_code;
			$data->trading_name=$request->trading_name;
			$data->route_id=$request->route_id;
			$data->updated_user= Session::get('user_id');
			$data->status=$request->status;
			$data->save();
			return redirect(route('trading_center_list'))->with('successMessage','Trading Center Updated Successfully');
	
		 } else 
			 {			
				$data->trading_center_code=$request->trading_center_code;
				$data->trading_name=$request->trading_name;
				$data->route_id=$request->route_id;
				$data->created_user= Session::get('user_id');
				$data->status=$request->status;
				$data->save();
				return redirect(route('trading_center_list'))->with('successMessage','Trading Center Added Successfully');
		
			 }	
     }
 }
