<?php
namespace App\Http\Controllers;
use Illuminate\Http\Request;
use App\Models\WarehouseModel;
use App\Models\RouteModel;
use App\Models\MaterialMasterModel;
use App\Models\ManageCodeModel;
use App\Models\RegionTypeModel;
use App\Models\OutletModel;
use App\Models\SubRegionTypeModel;
use App\Models\CustomerTypeModel;
use App\Models\UnitOfMeasurementModel;
use App\Models\WarehouseStockModel;
use App\Models\CustomerModel;
use App\Models\ClientModel;
use App\Models\MaterialCategoryModel;
use Illuminate\Support\Facades\DB;
use Session;

class WarehouseController extends Controller
 {	
   public function list(Request $request)
	{
	  $where="";		
	  if($request->region!='')
		{
		  $where .= "AND region.id = '".$request->region."'";
		}
		 
	  if($request->subregion!='')
		{
		  $where .= "AND sub_region.id = '".$request->subregion."'";
		}
					
	  if($request->customer!='')
	    {
		  $where .= "AND customer.id = '".$request->customer."'";
	    }
		
			/* $distibutor=CustomerModel::all()->sortByDesc('id')->where('customer_type', '!=', 1)->where('status', '=', 'active'); */
			//$get_data = CurrencyTypeModel::all()->sortByDesc('id');
			$get_data = DB::select("SELECT riheader.*, 
			customer.customer_code,customer.customer_name,
			
			region.region_code,region.region_name,		
			sub_region.sub_region_code,sub_region.sub_region_name		
					
			FROM tbl_warehouse as riheader		
			LEFT JOIN tbl_customer as customer on riheader.distributor=customer.id
			LEFT JOIN tbl_region as region on riheader.region=region.id
			LEFT JOIN tbl_sub_region as sub_region on riheader.sub_region=sub_region.id
				
			WHERE riheader.id IS NOT NULL ".$where." ORDER BY id DESC");
				 /* $get_data = DB::table('tbl_warehouse')
				->leftJoin('tbl_region', 'tbl_warehouse.region', '=', 'tbl_region.id')
				->leftJoin('tbl_sub_region', 'tbl_warehouse.sub_region', '=', 'tbl_sub_region.id')
				
				 ->select('tbl_warehouse.*', 'tbl_region.region_name','tbl_sub_region.sub_region_name')
				 ->get(); */
			         /* dd($get_data); */ 
         $region =RegionTypeModel::all()->sortByDesc('id')->where('status', '=', 'active');		
	     return view('Stock_Management.warehouse_list',compact('get_data','region'));
    }

   public function view($id)
    { 
		  
		//$get_data=CompanyModel::find($id);
		$get_data = DB::table('tbl_warehouse')
		->leftJoin('tbl_region', 'tbl_warehouse.region', '=', 'tbl_region.id')
		->leftJoin('tbl_sub_region', 'tbl_warehouse.sub_region', '=', 'tbl_sub_region.id')
		->leftJoin('tbl_customer', 'tbl_warehouse.distributor', '=', 'tbl_customer.id')
		->leftJoin('tbl_route', 'tbl_warehouse.route', '=', 'tbl_route.id')
		->leftJoin('tbl_outlet', 'tbl_warehouse.outlet', '=', 'tbl_outlet.id')
		
		->select('tbl_warehouse.*','tbl_outlet.outlet_name','tbl_outlet.outlet_code', 'tbl_region.region_name','tbl_sub_region.sub_region_name','tbl_customer.customer_code','tbl_customer.customer_name','tbl_route.route_code','tbl_route.route_name')		
		 ->where('tbl_warehouse.id', $id) 
         ->get()->first();
		
		return view('Stock_Management.warehouse_view',compact('get_data'));
    }
	
   public function add()
    { 
		$result =WarehouseModel::get()->sortByDesc('id')->first();
		if($result=='')
		  {
			$getcode = ManageCodeModel::where('id', 1)->first();
			$last_code = $getcode->warehouse_code;
	      }
	    else
		  {
			$getcode = $result->warehouse_code	; 
			$last_code = ++$getcode;
		  }
		$customer_type =CustomerModel::all()->sortByDesc('id')->where('status', '=', 'active')->where('customer_type', '=', 2);
		
		$customer_types =CustomerTypeModel::all()->sortByDesc('id')->where('status', '=', 'active');
		$region =RegionTypeModel::all()->sortByDesc('id')->where('status', '=', 'active');
		$subregion =SubRegionTypeModel::all()->sortByDesc('id')->where('status', '=', 'active');
        //dd($customer_types);	
		$distibutor_warehouse =WarehouseModel::get()->sortByDesc('id')->where('status', '=', 'active')->where('warehouse_type', '=', 1)->all();
		
		return view('Stock_Management.warehouse',compact('region','subregion','last_code','customer_type','customer_types','distibutor_warehouse'));
     }
	
	public function edit($id)
     {
		  
	    $get_data1 =  DB::table('tbl_warehouse')
			  ->leftJoin('tbl_route', 'tbl_warehouse.route', '=', 'tbl_route.id')
			  ->leftJoin('tbl_region', 'tbl_warehouse.region', '=', 'tbl_region.id')
			  ->leftJoin('tbl_sub_region', 'tbl_warehouse.sub_region', '=', 'tbl_sub_region.id')
			  ->leftJoin('tbl_customer', 'tbl_warehouse.distributor', '=', 'tbl_customer.id')
			  ->select('tbl_region.id as region_id','tbl_region.region_code','tbl_region.region_name','tbl_route.id as route_id','tbl_route.route_code','tbl_route.route_name','tbl_sub_region.id as sub_region_id','tbl_sub_region.sub_region_code','tbl_sub_region.sub_region_name','tbl_customer.customer_code','tbl_customer.customer_name')
			  ->where('tbl_warehouse.id', '=', $id)
			  ->get()->all();
			
        $get_data=WarehouseModel::find($id);
		
		
		$region =RegionTypeModel::all()->sortByDesc('id')->where('status', '=', 'active');
		$subregion =SubRegionTypeModel::all()->sortByDesc('id')->where('status', '=', 'active');
        $customer_types =CustomerTypeModel::all()->sortByDesc('id')->where('status', '=', 'active');
		$last_code = $get_data->warehouse_code;
		$warehouse_id=$get_data->route_warehouse;
		$customer_type =CustomerModel::all()->sortByDesc('id')->where('status', '=', 'active')->where('customer_type', '=', 2);
		
		$distibutor_warehouse =WarehouseModel::get()->sortByDesc('id')->where('status', '=', 'active')->where('warehouse_type', '=',1)->all();
		
    	return view('Stock_Management.warehouse',compact('get_data','region','subregion','last_code','customer_type','customer_types','distibutor_warehouse','get_data1'));
     }
    
	public function save(Request $request)
     { 
	 
	   /* dd($request);  */ 
	    $flag=0;
		$data=new WarehouseModel;			
		if($request->updated_id) 
	      {	
		    $data = WarehouseModel::find($request->updated_id);
					  
            if($request->updated_id==1)
			  {
				    
                $data->distributor=0;
			    $data->region=0;
			    $data->sub_region=0;

			  }
            else
			  {
				if($request->warehouse_type==2)
				  {
				   
				    $data->region=$request->hidden_region_id;
				    $data->sub_region=$request->hidden_sub_region_id;
				    $data->route=$request->route;
				    $data->distributor=$request->hidden_distibutor_id;
				    $data->route_warehouse=$request->hidden_warehouse_id;
				  }
			    else if($request->warehouse_type==3)
				   {
					   $data->region=$request->hidden_region_id;
					   $data->sub_region=$request->hidden_sub_region_id;
					   $data->outlet=$request->outlet;
					   $data->distributor=$request->hidden_distibutor_id;
					   $data->outlet_warehouse=$request->hidden_outlet_warehouse_id;
					  
				   }
                 else
				  {
					  
					  $data->distributor=$request->distributor;
					  $data->region=$request->region;
					  $data->sub_region=$request->sub_region;
					  
				  }
			
			 }
				
				
			
			$data->warehouse_code=$request->warehouse_code;
			$data->warehouse_name=$request->warehouse_name;
			
			
			$data->address=$request->address_customer;
			
			
			$data->customer=$request->customer;
			$data->warehouse_type=$request->warehouse_type;
			$data->address=$request->address_customer;
			$data->company_id= Session::get('company_id');
			$data->updated_user= Session::get('user_id');
			$data->status=$request->status;
			$data->save();
			return redirect(route('warehouse_list'))->with('successMessage','Warehouse Updated Successfully');
		
		  }   
		else 
		  {	

            if($request->warehouse_type==2)
			  {
				   $data->route_warehouse=$request->distibutor_warehouse;
				   $data->region=$request->hidden_region_id;
				   $data->sub_region=$request->hidden_sub_region_id;
				   $data->route=$request->route;
				   $data->distributor=$request->hidden_distibutor_id;

			  }
		    else if($request->warehouse_type==3)
		      {
						  
				   $data->outlet_warehouse=$request->distibutor_warehouse;
				   $data->region=$request->hidden_region_id;
				   $data->sub_region=$request->hidden_sub_region_id;
				   $data->outlet=$request->outlet;
				   $data->distributor=$request->hidden_distibutor_id;
						  
			  }
			else
			  {
				  $data->route_warehouse=$flag;
				  $data->distributor=$request->distributor;
				  $data->region=$request->region;
				  $data->sub_region=$request->sub_region;
				  
			  }	  
			$data->warehouse_code=$request->warehouse_code;
			$data->warehouse_name=$request->warehouse_name;
			$data->warehouse_type=$request->warehouse_type;
			$data->address=$request->address_customer;
		
			$data->customer=$request->customer;
			$data->created_user= Session::get('user_id');
			$data->company_id= Session::get('company_id');
			$data->status=$request->status;
			$data->save();			
		  }
    	return redirect(route('warehouse_list'))->with('successMessage','Warehouse Added Successfully');
    }
	
   public function check_distibutor_exist($id)
    {
	   $check_exist_distibutor =WarehouseModel::all()->sortByDesc('id')->where('distributor', '=', $id);

	   echo count($check_exist_distibutor);
	}
	
   public function check_route_exist($id)
	{
		$check_exist_distibutor =WarehouseModel::all()->sortByDesc('id')
		->where('route', '=', $id)
		->where('route_warehouse', '!=',0)
		->where('warehouse_type', '=',2);

	    echo count($check_exist_distibutor);
    }
			
   public function check_outlet_exist($id)
	{
		$check_exist_distibutor =WarehouseModel::all()->sortByDesc('id')
		->where('outlet_id', '=', $id)
		->where('outlet_warehouse', '!=',0)
		->where('warehouse_type', '=',3);
	
		 echo count($check_exist_distibutor);
		
     }
		 
    public function get_distibutor_region($id)
			
	 {
				
	    $material_master1 = DB::table('tbl_warehouse')
			  ->leftJoin('tbl_region', 'tbl_warehouse.region', '=', 'tbl_region.id')
			  ->leftJoin('tbl_sub_region', 'tbl_warehouse.sub_region', '=', 'tbl_sub_region.id')
			  ->leftJoin('tbl_customer', 'tbl_warehouse.distributor', '=', 'tbl_customer.id')
			  
			  ->select('tbl_customer.id as distibutor_id','tbl_customer.customer_code','tbl_customer.customer_name','tbl_region.id as region_id','tbl_region.region_code','tbl_region.region_name','tbl_sub_region.id as sub_region_id','tbl_sub_region.sub_region_code','tbl_sub_region.sub_region_name')
			  ->where('tbl_warehouse.id', '=', $id)
			  ->get()->all();
			  
		$count= count($material_master1);
		if($count>0)
		  {	
		   echo $material_master1[0]->customer_code.'-'.$material_master1[0]->customer_name.'-'.$material_master1[0]->region_code.'-'.$material_master1[0]->region_name.'-'.$material_master1[0]->sub_region_code.'-'.$material_master1[0]->sub_region_name.'-'.$material_master1[0]->region_id.'-'.$material_master1[0]->sub_region_id.'-'.$material_master1[0]->distibutor_id; 
		  }
		else
		  {
			echo $count;
		  }

	 }
	 
	public function getwarehouse_route($id1,$route_id)
	 {

		$get_data=RouteModel::all()->sortByDesc('id')->where('warehouse_id', '=', $id1)->where('status', '=', 'active');	
		
		?>
		<option  value="">     </option>
		<?php
		foreach($get_data as $route)
	      {
		    ?>
		    <option <?php if($route->id==$route_id) echo "selected"; ?> value="<?php echo $route->id ?>"  ><?php echo $route->route_code." - ".$route->route_name ?></option>	
		    <?php		
	      }
     }
		
    public function getwarehouse_outlet($id1,$route_id)
	 {
		
		$get_data=OutletModel::all()->sortByDesc('id')->where('warehouse_id', '=', $id1)->where('status', '=', 'active');	
		
		?>
		<option  value="">     </option>
		<?php
		foreach($get_data as $outlet)
		  {
			?>
			<option <?php if($outlet->id==$route_id) echo "selected"; ?> value="<?php echo $outlet->id ?>"  ><?php echo $outlet->outlet_code." - ".$outlet->outlet_name ?></option>	
			<?php		
		  }
      }
		   
     public function get_warehouse_region_filter($region,$url_subregion)
	  {
		
		$get_data=SubRegionTypeModel::all()->sortByDesc('id')->where('region_id', '=', $region)->where('status', '=', 'active');	
		
		?>
		<option  value="">     </option>
		<?php
     	foreach($get_data as $subregion)
		  {
			?>
			<option <?php if($subregion->id==$url_subregion) echo "selected"; ?> value="<?php echo $subregion->id ?>"  ><?php echo $subregion->sub_region_code." - ".$subregion->sub_region_name ?></option>	
			<?php		
		  }
    }

   public function get_warehouse_customer_filter($subregion,$url_customer)
	{

		$get_data=CustomerModel::all()->sortByDesc('id')->where('sub_region', '=', $subregion)->where('status', '=', 'active');	
	    /* dd($get_data); */	
		?>
		<option  value="">     </option>
		<?php
		foreach($get_data as $customer)
	      {
			?>
			<option <?php if($customer->id==$url_customer) echo "selected"; ?> value="<?php echo $customer->id ?>"  ><?php echo $customer->customer_code." - ".$customer->customer_name ?></option>	
			<?php		
	      }
     }
		    
    public function get_distibutor_region_subregion($id)
	 {
		$material_master1 = DB::table('tbl_customer')
		  ->leftJoin('tbl_region', 'tbl_customer.region', '=', 'tbl_region.id')
		  ->leftJoin('tbl_sub_region', 'tbl_customer.sub_region', '=', 'tbl_sub_region.id')
		  
		  
		  ->select('tbl_customer.region as region_id','tbl_customer.sub_region as sub_region_id','tbl_region.region_code','tbl_region.region_name','tbl_sub_region.sub_region_code','tbl_sub_region.sub_region_name')
		  ->where('tbl_customer.id', '=', $id)
		  ->get()->all();
		
		 $count= count($material_master1);
		 if($count>0)
		   {	
		     echo $material_master1[0]->region_id.'-'.$material_master1[0]->sub_region_id.'-'.$material_master1[0]->region_code.'-'.$material_master1[0]->region_name.'-'.$material_master1[0]->sub_region_code.'-'.$material_master1[0]->sub_region_name; 
		   }
		else
		  {
			echo $count;
		  }
		
      }
 }
