<?php

use Illuminate\Database\Migrations\Migration;
use Illuminate\Database\Schema\Blueprint;
use Illuminate\Support\Facades\Schema;


class CreateCustomerModelsTable extends Migration
{
    /**
     * Run the migrations.
     *
     * @return void
     */
    public function up()
    {
		
        Schema::create('tbl_customer', function (Blueprint $table) {
            $table->integer('id');
            $table->integer('company_id');
			$table->integer('customer_type');
			$table->integer('customer_category')->nullable();
			$table->string('customer_code',20);
			$table->string('customer_name',100);
			$table->string('tin_no',100);
			$table->string('address',100);
			$table->integer('city_id');
			$table->integer('country_id');
			$table->string('email',50);
			$table->string('contact_no');
			$table->integer('payment_term');
			$table->string('credit_limit',10);
			$table->string('credit_days',20);
			$table->integer('region');
			$table->integer('sub_region');
			$table->integer('route_id')->nullable();
			$table->integer('trading_center_id')->nullable();
			$table->string('bank_account_name1',100)->nullable();;
			$table->string('bank_account_number1',100)->nullable();;
			$table->string('bank_branch1',100)->nullable();;
			$table->string('bank_account_name2',100)->nullable();
			$table->string('bank_account_number2',130)->nullable();
			$table->string('bank_branch2',100)->nullable();
			$table->string('latitude',130)->nullable();
			$table->string('longitude',130)->nullable();
			$table->string('thresold_frequency',30)->nullable();
			$table->string('erp_customer',30)->nullable();
			$table->string('credit_balance',30);
			$table->integer('created_user')->length(11)->nullable();
			$table->integer('updated_user')->length(11)->nullable();
	        $table->enum('status', ['active', 'inactive']); 
            $table->timestamps();
        });
    }

    /**
     * Reverse the migrations.
     *
     * @return void
     */
    public function down()
    {
        Schema::dropIfExists('tbl_customer');
    }
}
