<?php

use Illuminate\Database\Migrations\Migration;
use Illuminate\Database\Schema\Blueprint;
use Illuminate\Support\Facades\Schema;

class CreateWarehouseModelsTable extends Migration
{
    /**
     * Run the migrations.
     *
     * @return void
     */
    public function up()
    {
		
        Schema::create('tbl_warehouse', function (Blueprint $table) {
            $table->integer('id');
			$table->integer('company_id');
			$table->string('warehouse_code',10);
			$table->string('warehouse_name',120);
			$table->string('distributor',120);			 
			$table->string('address',200);
			$table->integer('warehouse_type');
			$table->integer('region');
			$table->integer('route_warehouse');
			$table->integer('outlet_warehouse');
			$table->integer('outlet');
			$table->integer('route');
			$table->integer('sub_region');
			$table->string('warehouse_manager',120);
			$table->bigInteger('contact_no');
			$table->integer('customer');
			$table->integer('created_user')->length(11)->nullable();
			$table->integer('updated_user')->length(11)->nullable();
	        $table->enum('status', ['active', 'inactive']); 
            $table->timestamps();
        });
    }
  
    /**
     * Reverse the migrations.
     *
     * @return void
     */
    public function down()
    {
        Schema::dropIfExists('tbl_warehouse');
    }
}
