<?php

use Illuminate\Database\Migrations\Migration;
use Illuminate\Database\Schema\Blueprint;
use Illuminate\Support\Facades\Schema;

class CreateSalesmanModelsTable extends Migration
{
    /**
     * Run the migrations.
     *
     * @return void
     */
    public function up()
    {
        Schema::create('tbl_salesman', function (Blueprint $table) {
            $table->integer('id');
			$table->integer('company_id');
			$table->string('route_id',50);
			$table->string('warehouse',50);
			$table->integer('salesman_type');
			$table->string('salesman_code',20);
			$table->string('salesman_name',120);
			$table->string('salesman_password',20);
			$table->bigInteger('contact_number');
			$table->string('block_from_date',120)->nullable();
			$table->string('block_to_date',120)->nullable();
			$table->string('salesman_picture',250)->nullable();
			$table->string('erp_employee_code',120)->nullable();
			$table->string('customer_from',20);		
			$table->string('customer_to',20);
			$table->string('invoice_from',20);
			$table->string('invoice_to',20);
			$table->string('order_from',20);
			$table->string('order_to',20);
			$table->string('delivery_from',20);
			$table->string('delivery_to',20);
			$table->string('collection_from',20);
			$table->string('collection_to',20);
			$table->string('return_order_from',20);
			$table->string('return_order_to',20);
			$table->string('exchange_from',20);
			$table->string('exchange_to',20);
			$table->string('load_from',20);
			$table->string('load_to',20);
			$table->string('block_salesman',120)->nullable();
			$table->integer('created_user')->length(11)->nullable();
			$table->integer('updated_user')->length(11)->nullable();
	        $table->enum('status', ['active', 'inactive']); 
            $table->timestamps();
        });
    }

    /**
     * Reverse the migrations.  
     *
     * @return void
     */
    public function down()
    {
        Schema::dropIfExists('tbl_salesman');
    }
}
