<?php

use Illuminate\Database\Migrations\Migration;
use Illuminate\Database\Schema\Blueprint;
use Illuminate\Support\Facades\Schema;

class CreateMaterialMasterModelsTable extends Migration
{
    /**
     * Run the migrations.
     *
     * @return void
     */
    public function up()
    {
        Schema::create('tbl_material_master', function (Blueprint $table) {
            $table->integer('id');
			$table->integer('company_id');
			$table->string('material_code',20);
			$table->string('material_name',120);
			$table->integer('uom_id');
			$table->integer('material_group_name');
			$table->decimal('unit_price',10,2);
			$table->integer('material_category_id');
			$table->string('brand',120);
			$table->string('bar_code',120)->nullable;
			$table->string('material_image',250)->nullable();
			$table->string('net_weight',120);
			$table->string('packing_size',120);
			$table->string('shelf_life',120);
			$table->string('promotional_material',120);
			$table->string('erp_material_code',120)->nullable();
			$table->string('alt_uom',100);
			$table->string('alt_uom_name',100)->nullable();
			$table->string('alt_packing_size',100);
			$table->string('alt_unit_price',100);
			$table->integer('material_types_id');
			$table->integer('created_user')->length(11)->nullable();
			$table->integer('updated_user')->length(11)->nullable();
			$table->integer('vat')->length(11)->nullable();
			$table->integer('excise')->length(11)->nullable();
	        $table->enum('status', ['active', 'inactive']); 
            $table->timestamps();
        });



    }

    /**
     * Reverse the migrations.
     *
     * @return void
     */
    public function down()
    {
        Schema::dropIfExists('tbl_material_master');
    }
}
