<?php

use Illuminate\Database\Migrations\Migration;
use Illuminate\Database\Schema\Blueprint;
use Illuminate\Support\Facades\Schema;

class CreatePricingPlanModelsTable extends Migration
{
    /**
     * Run the migrations.
     *
     * @return void
     */
    public function up()
    {
      Schema::create('tbl_pricing_plan', function (Blueprint $table) {
            $table->integer('id');
            $table->integer('company_id');
            $table->string('plan_name',125);
            $table->string('price_applied_on',25)->nullable();
            $table->date('valid_from');
            $table->integer('customer_category_id',50)->nullable();
            $table->integer('material_category_id',50)->nullable();
            $table->integer('route_id',52)->nullable();  
            $table->date('valid_to'); 
            $table->integer('created_user')->length(11)->nullable();
            $table->integer('updated_user')->length(11)->nullable();
            $table->enum('status', ['active', 'inactive']); 
            $table->timestamps();
        });
         Schema::create('tbl_new_price', function (Blueprint $table) {
            $table->integer('id');
            $table->integer('header_id');
            $table->integer('material_id');
           // $table->integer('material_category_id');
            $table->string('uom_id',25);
            $table->integer('currency');
            $table->string('new_price',25);
            $table->string('current_price',200); 
            $table->timestamps();
        });
    }

    /**
     * Reverse the migrations.
     *
     * @return void
     */
    public function down()
    {
        Schema::dropIfExists('tbl_pricing_plan','tbl_new_price');
    }
}
