<?php

use Illuminate\Database\Migrations\Migration;
use Illuminate\Database\Schema\Blueprint;
use Illuminate\Support\Facades\Schema;

class CreateSalesmanLoadModelsTable extends Migration
{
    /**
     * Run the migrations.
     *
     * @return void
     */
    public function up()
    {
        Schema::create('tbl_route_salesmanload_header', function (Blueprint $table) {
            $table->integer('id');
			$table->string('route_id',20);
			$table->string('salesman_id',20);
			$table->string('load_date',20);
			$table->string('load_number',20);
			$table->string('sign',200);
			$table->decimal('total_load_value',10,2);
			$table->string('currency',25);
			$table->string('reson',25)->nullable();
			$table->enum('pending', 'approved', 'cancel', 'confirm')->default('pending');
		    $table->string('warehouse_id',20);
			$table->timestamps();
        });
		
		Schema::create('tbl_route_salesmanload_details', function (Blueprint $table) {
            $table->integer('id');
			$table->string('header_id',20);
			$table->string('material_id',20);   
			$table->string('uom',20);
			$table->integer('base_qty')->length(11);
			$table->string('quantity',20);
			$table->decimal('price',10,2);
			$table->decimal('total',10,2);
			$table->timestamps();
        });
    }

    /**
     * Reverse the migrations.
     *
     * @return void
     */
    public function down()
    {
        Schema::dropIfExists('tbl_route_salesmanload_header','tbl_route_salesmanload_details');
    }
}
