<?php

use Illuminate\Database\Migrations\Migration;
use Illuminate\Database\Schema\Blueprint;
use Illuminate\Support\Facades\Schema;

class CreateReturnSalesModelsTable extends Migration
{
    /**
     * Run the migrations.
     *
     * @return void
     */
    public function up()
    {
       Schema::create('tbl_return_sales_header', function (Blueprint $table) {
            $table->integer('id');
			$table->string('invoice_number',20);
			$table->string('salesman',20);
			$table->string('warehouse',20);
			$table->string('invoice_date',20);
			$table->string('customer_name',20);
			$table->string('route_id',20);
			$table->string('trading_center_id',20);
			$table->string('remark',200);
			$table->integer('currency');
			$table->decimal('total_gross',10,2);			
			$table->decimal('total_invoice_value',10,2);
			$table->integer('region')->length(11)->nullable();
            $table->integer('subregion')->length(11)->nullable();
			$table->timestamps();
        });
		
		Schema::create('tbl_return_sales_details', function (Blueprint $table) {
            $table->integer('id');
			$table->string('material_id',20);
			$table->string('uom',20);
			$table->string('quantity',20);
			$table->string('header_id',20);
			$table->decimal('unite_price',10,2);
			$table->decimal('gross_total',10,2);
			//$table->string('vat',20);
			$table->string('return_type',20);
			$table->string('resion',100);
			
			//$table->string('net_amount',20);
			//$table->string('discount',20)->nullable();
			//$table->string('discount_id',20)->nullable();
			
			$table->decimal('total',10,2);
			
            $table->timestamps();
        });
    }

    /**
     * Reverse the migrations.
     *
     * @return void
     */
    public function down()
    {
        Schema::dropIfExists('tbl_return_sales_header','tbl_return_sales_details');
    }
}
