<?php

use Illuminate\Database\Migrations\Migration;
use Illuminate\Database\Schema\Blueprint;
use Illuminate\Support\Facades\Schema;

class CreateComplainManagementModelsTable extends Migration
{
    /**
     * Run the migrations.
     *
     * @return void
     */
    public function up()
    {
        Schema::create('tbl_complaint_management', function (Blueprint $table) {
            $table->id();
            $table->string('complaint_type',20);
            $table->string('note',100);
            $table->string('route_id',20);
            $table->string('salesman_id',20);
            $table->string('warehouse_id',20);
            $table->string('date_time',20);
            $table->string('images',250)->nullable();
            $table->enum('flag', ['0', '1']); 
            $table->enum('status', ['pending', 'completed']); 
            $table->timestamps();
        });
    }

    /**
     * Reverse the migrations.
     *
     * @return void
     */
    public function down()
    {
        Schema::dropIfExists('tbl_complaint_management');
    }
}
