<?php

use Illuminate\Database\Migrations\Migration;
use Illuminate\Database\Schema\Blueprint;
use Illuminate\Support\Facades\Schema;

class CreateCounterSalesModelsTable extends Migration
{
    /**
     * Run the migrations.
     *
     * @return void
     */
    public function up()
    {
        Schema::create('tbl_outlet_counter_sales_header', function (Blueprint $table) {
            $table->id();
			$table->string('counter_sales_no',20);
			$table->integer('outlet',20);
			$table->integer('distibutor',20);
			$table->integer('warehouse',20);
			$table->string('remark',200);
			$table->string('currency',20);
			$table->decimal('total_gross',10,2);
			$table->decimal('total_vat',10,2);
			$table->decimal('net_total_amount',10,2);
			$table->decimal('total_discount',10,2)->nullable();
			$table->decimal('total_invoice_value',10,2);
            $table->timestamps();
        });
		
		Schema::create('tbl_outlet_counter_sales_details', function (Blueprint $table) {
            $table->id();
			$table->string('material_code',20);
			$table->string('uom',20);
			$table->string('quantity',20);
			$table->string('header_id',20);
			$table->decimal('unite_price',10,2);
			$table->decimal('gross_total',10,2);
			$table->decimal('vat',10,2);
			$table->decimal('net_amount',10,2);
			$table->decimal('discount',10,2)->nullable();
			$table->string('discount_id',20)->nullable();
			$table->decimal('total',10,2);
			$table->timestamps();
        });
    }

    /**
     * Reverse the migrations.
     *
     * @return void
     */
    public function down()
    {
        Schema::dropIfExists('tbl_outlet_counter_sales_header','tbl_outlet_counter_sales_details');
    }
}
