<?php

use Illuminate\Database\Migrations\Migration;
use Illuminate\Database\Schema\Blueprint;
use Illuminate\Support\Facades\Schema;

class CreateHavePermissionsTable extends Migration
{
    /**
     * Run the migrations.
     *
     * @return void
     */
    public function up()
    {
       Schema::create('tbl_user_permission', function (Blueprint $table) {
            $table->id();
			$table->integer('user_role');
			$table->integer('parent_menu_id');
			$table->integer('sub_menu_id');
			$table->enum('allow_view', ['1', '0'])->default(0); 
			$table->enum('allow_edit', ['1', '0'])->default(0);
			$table->enum('allow_create', ['1', '0'])->default(0);
			$table->enum('allow_list', ['1', '0'])->default(0);
		
            $table->timestamps();
        });
    }

    /**
     * Reverse the migrations.
     *
     * @return void
     */
    public function down()
    {
        Schema::dropIfExists('tbl_user_permission');
    }
}
