<?php

use Illuminate\Database\Migrations\Migration;
use Illuminate\Database\Schema\Blueprint;
use Illuminate\Support\Facades\Schema;

class CreateAdvancePaymentModelsTable extends Migration
{
    /**
     * Run the migrations.
     *
     * @return void
     */
     public function up()
    {
        Schema::create('tbl_advance_payment', function (Blueprint $table) {
            $table->integer('id');   
			$table->tinyint('payment_type', ['cash', 'cheque', 'transfer']); 
			$table->integer('distributor')->length(11);
			//$table->decimal('expense_amount',10,2);
			$table->integer('company_bank')->length(11);
			$table->string('company_bank_name',250);
			$table->string('company_branch_name',250);
			$table->string('company_account_no',250);
			//$table->string('total_amt',250);
			$table->decimal('total_amt',20,2);
			$table->string('cheque_no',250);
			$table->date('cheque_date');
			$table->string('distributor_bank_name',250);
			$table->string('distributor_account_no',250);
			$table->string('receipt_no',250);
			$table->date('receipt_date');
			$table->string('receipt_image',250);
			
			$table->integer('created_user')->length(11)->nullable();
			$table->integer('updated_user')->length(11)->nullable();
	        $table->enum('status', ['rejected', 'in progress', 'approved']); 
            $table->timestamps(); 
		 
        });
    }

    /**
     * Reverse the migrations.
     *
     * @return void
     */
    public function down()
    {
        Schema::dropIfExists('tbl_advance_payment');
    }

}
