<?php

use Illuminate\Database\Migrations\Migration;
use Illuminate\Database\Schema\Blueprint;
use Illuminate\Support\Facades\Schema;

class CreateRouteCollectionModelsTable extends Migration
{
    /**
     * Run the migrations.
     *
     * @return void
     */
    public function up()
    {
        Schema::create('tbl_route_collection_header', function (Blueprint $table) {
            $table->integer('id');
			$table->string('collection_number',50);
			$table->integer('route_id',20);
			$table->integer('customer_id',20);
			$table->integer('warehouse_id',20);
			$table->integer('trading_center_id',20);
			$table->integer('collection_type',20);
			$table->string('cheque_no',20)->nullable();
			$table->string('cheque_date',20)->nullable();
			$table->string('bank_name',70)->nullable();
			$table->string('account_no',30)->nullable();
			$table->string('branch_no',20)->nullable();
			$table->integer('created_user')->default(0);
			$table->integer('updated_user')->default(0);
			$table->timestamps();
          });
		Schema::create('tbl_route_collection_details', function (Blueprint $table) {
            $table->integer('id');
			$table->string('invoice_no',20);
			$table->integer('header_id');
			$table->integer('invoice_id');
			$table->string('outstanding_amt',20);
			$table->string('paid_amt',30);
			$table->integer('created_user',20)->default(0);
			$table->integer('updated_user',20)->default(0);
			$table->timestamps();
        });
    }

    /**
     * Reverse the migrations.
     *
     * @return void
     */
    public function down()
    {
        Schema::dropIfExists('tbl_route_collection_header','tbl_route_collection_details');
    }
}
