<?php

use Illuminate\Database\Migrations\Migration;
use Illuminate\Database\Schema\Blueprint;
use Illuminate\Support\Facades\Schema;

class CreateTempGRNModelsTable extends Migration
{
    /**
     * Run the migrations.
     *
     * @return void
     */
    public function up()
    {
        Schema::create('tbl_temp_grn_header', function (Blueprint $table) {
            $table->id();
			$table->integer('supplier_id');
            $table->string('grn_code');
			$table->integer('purchase_order_id');
			$table->integer('tin_no');
			$table->string('delivery_date',20);
			$table->string('remark',100);
			$table->integer('currency_id');
			$table->decimal('total_gross',10,2);
			$table->decimal('total_excise',10,2);
			$table->decimal('total_vat',10,2);
			$table->decimal('net_total_amount',10,2);
            $table->integer('total_grn_value');
			$table->decimal('total_discount',10,2);
			$table->timestamps();
        });
		
		Schema::create('tbl_temp_grn_details', function (Blueprint $table) {
            $table->id();
			$table->integer('header_id');
			$table->string('uom',20);
            $table->integer('material_id');
			$table->string('quantity',20);
            $table->integer('order_qty');
            $table->integer('pending_qty');
			$table->decimal('unit_price',10,2);
			$table->decimal('gross_total',10,2);
			$table->decimal('vat',10,2);
			$table->decimal('excise',10,2);
			$table->decimal('net_amount',10,2);
			$table->decimal('discount',10,2);
			$table->decimal('total',10,2);
			$table->timestamps();
        });
    }

    /**
     * Reverse the migrations.
     *
     * @return void
     */
    public function down()
    {
        Schema::dropIfExists('tbl_temp_grn_header','tbl_temp_grn_details');
    }
}
