@include('theme_layout/header')
@include('theme_layout/nav')

<div class="app-main__outer">
 <div class="app-main__inner">
  <div class="app-page-title">
   <div class="page-title-wrapper">
    <div class="page-title-heading">
     <div class="page-title-icon">
      <i class="pe-7s-medal icon-gradient bg-tempting-azure"></i>
     </div>  <!--page-title-icon-->
	 
     <div>Vendor Payment List
        @if(Session::has('successMessage')) 
        <input id="toster_id" type="hidden" value="{{ Session::get('successMessage') }}">		  
        @endif 
     </div>
    </div>   <!--page-title-heading-->
	
    <div class="page-title-actions">
     <div class="d-inline-block dropdown">
      <div class="page-title-actions">
       <div class="d-inline-block dropdown">
        <a href="{{route('vendor_payment')}}" class="mt-3 btn btn-primary btn-lg"> <i class="fa fa-plus fa-w-20"></i> Add Vendor Payment</a>
       </div>
      </div> <!--page-title-actions-->
	  
      <div tabindex="-1" role="menu" aria-hidden="true" class="dropdown-menu dropdown-menu-right">
       <ul class="nav flex-column">
        <li class="nav-item">
         <a class="nav-link">
          <i class="nav-link-icon lnr-inbox"></i>
           <span>
            Inbox
           </span>
          <div class="ml-auto badge badge-pill badge-secondary">86</div>
         </a>
        </li>
        <li class="nav-item">
         <a class="nav-link">
          <i class="nav-link-icon lnr-book"></i>
           <span>
            Book
           </span>
          <div class="ml-auto badge badge-pill badge-danger">5</div>
         </a>
        </li>
        <li class="nav-item">
         <a class="nav-link">
          <i class="nav-link-icon lnr-picture"></i>
           <span>
            Picture
           </span>
          </a>
         </li>
        <li class="nav-item">
         <a disabled class="nav-link disabled">
          <i class="nav-link-icon lnr-file-empty"></i>
           <span>
            File Disabled
           </span>
         </a>
        </li>
       </ul>
      </div>
     </div>   <!--d-inline-block dropdown-->
    </div>   <!--page-title-actions-->
   </div>   <!--page-title-wrapper-->
  </div> 	<!--app-page-title-->
  
  <div class="main-card mb-3 card">
   <div class="card-body">
    <!-- date filte-->
    <form method="get" action="{{ route('vendor_payment_list') }}" >
     <div class="form-row"> 
        <div class="col-md-4  date position-relative form-group" id="myDatepicker4">
          <label for="fromdate" class="font-weight-bold ml-2"> From Date</label>
          <input type="date" class="form-control" name="fromdate" id="fromdate" value="<?php if(isset($_GET['fromdate'])) echo $_GET['fromdate']; else echo date("Y-m-d"); ?>" autocomplete="off">
        </div>
      
        <div class="col-md-4  date position-relative form-group" id="myDatepicker5">
          <label for="todate" class="font-weight-bold ml-2"> To Date</label>
          <input type="date" class="form-control" name="todate"  id="todate"  value="<?php if(isset($_GET['todate'])) echo $_GET['todate']; else echo date("Y-m-d"); ?>" autocomplete="off">
        </div>
        <div class="col-md-4" >
            <div class="position-relative form-group">
            <label for="supplier_id" class="font-weight-bold ml-2">Supplier</label>
            <select class="mb-2 form-control" name="supplier" id="supplier_id">
            
                @if(isset($_GET['supplier']))
                <option value=""> </option>
                    @foreach($suppliers as $supplier)
                      <option {{$_GET['supplier'] == $supplier->id ? 'selected' : '' }} value="{{$supplier->id}}">{{$supplier->supplier_name}}</option>
                    @endforeach
                @else
                  <option value=""> </option>
                    @foreach($suppliers as $supplier)
                    <option value="{{$supplier->id}}">{{$supplier->supplier_name}}</option>
                    @endforeach
                @endif	  

          
            </select>
            </div>   <!--position-relative form-group-->
        </div>
      </div> <!-- end form-row -->

      <div class="form-row">
        <div class="col-md-12 text-center">
          <button id="submit" class="mt-3 btn btn-primary btn-lg">Search</button>
          <!-- <input type="hidden" name="type" value="date" id="search_type">
          <input type="button" value="Filter" class="btn btn-sm btn-primary listSearchBtn  filter">
          <button  class="btn btn-sm btn-danger listSearchAllBtn reset">All</button>-->
        </div>
      </div>    <!-- end form-row -->                  
    </form>
    
	<br><br>
                   
    <table style="width: 100%;" id="example" class="table table-hover table-striped table-bordered">
    <thead>
     <tr>
      <th class="text-justify text-left">Supplier</th>
      <th class="text-justify text-left">Vendor Payment Code</th>
      <th class="text-justify text-left">Payment Type</th>
      <th class="text-justify text-left">Pay Date</th>
      <th>Action</th>
     </tr>
    </thead>
                   
    <tbody>
     @foreach($result as $results)
      <tr>

        <td class="font-weight-bold text-justify text-left">{{$results->supplier_name}}</td>
        <td class="font-weight-bold text-justify text-left">{{$results->vendor_payment_code}}</td>
        <td class="font-weight-bold text-justify text-left">{{$results->collection_type == 1 ? "Cash" :
      	  ($results->collection_type == 2 ? "Cheque" :($results->collection_type == 3 ? "Transfer" : "Credit Note"))}}
        </td>
        <td class="font-weight-bold text-justify text-left">{{date("d M Y ", strtotime($results->created_at))}}</td>
        
        <td>
        <div class="dropdown">
        <button type="button" aria-haspopup="true" aria-expanded="false" data-toggle="dropdown" class="mb-2 mr-2 btn btn-outline-primary "><i class="fas fa-ellipsis-v"></i></button>
        <ul class="dropdown-menu " style="min-width: 0px;" aria-labelledby="dropdownMenuButton1">
        <a class="dropdown-item" class= "mb-2 mr-2 btn-hover-shine btn btn-shadow btn-success btn-lg" href=" {{ URL::to('vendor_payment_view/'.$results->id)}}"><i class="fas fa-eye" aria-hidden="true"> View</i> </a>

		<a class="dropdown-item" class= "mb-2 mr-2 btn-hover-shine btn btn-shadow btn-success btn-lg" href=" {{ URL::to('vendor_payment_export/'.$results->id)}}"><i class="fas fa-download" aria-hidden="true"> Export</i> </a> 
			
		<a class="dropdown-item" class= "mb-2 mr-2 btn-hover-shine btn btn-shadow btn-success btn-lg" href=" {{ URL::to('vendor_payment_export_pdf/'.$results->id)}}"><i class="fas fa-download" aria-hidden="true"> PDF</i> </a>  
        </ul>
        </div>
      </td>

      </tr>
     @endforeach
    </tbody>
    
    <tfoot>
     <!--<tr>
     <th>Currency code </th>
     <th>Currency Name</th>
     <th>Currency Notation</th>
     <th>Status</th>
     <th>Action</th>
     </tr>-->
    </tfoot>
    </table>
   </div>   <!--end card body-->
  </div>    <!--end main-card mb-3 card-->
 </div>    <!--app-main__inner-->
        
@include('theme_layout/footer') 

<script>

  var jq = $.noConflict();
    jq(document).ready(function(){
		
		@if(Session::has('successMessage'))
			var toster=jq('#toster_id').val();
			if(toster!=''){
			Swal.fire({
			 
			icon: 'success',
			title: ''+toster,
			showConfirmButton: false,
			timer: 2000
			})
			}
			
			 {{ Session::forget('successMessage') }}
		@endif
		
		

</script>      
                    